int sb_medalCount;

int CG_CalcStars( score_t *score )
{
	int stars;

	if ( !score ) { return 0; }
	if ( score->stars > 0 ) { return score->stars; }

	if ( score->accuracy > 15 ) { stars++; }
	if ( score->accuracy > 30 ) { stars++; }
	if ( score->accuracy > 45 ) { stars++; }

	if ( (score->kills * 2.5) < score->score && score->kills && score->kills && score->kills > 5 ) {
		stars++;
	}
	if ( score->isOnFire ) {
		stars++;
	}
	if ( (score->kills / 2) > score->deaths && score->kills && score->kills && score->kills > 5 ) {
		stars++;
	}
	if ( (score->headshotsFor * 6) > score->kills && score->kills && score->kills && score->kills > 5 ) {
		stars++;
	}
	if ( (score->headshotsFor * 10) > score->kills && score->kills && score->kills && score->kills > 5 ) {
		stars++;
	}

	score->stars = stars;
	return stars;
}

void CG_DrawMedalScore( float x, float y, float w, int medal )
{
	const char* s; 
	const char* d; 
	const char* n;
	float f; 
	int i,stars=0;
	clientInfo_t *ci; 
	score_t* score;

	if ( !cg.medalsRequestTime[medal] ) { cg.medalsRequestTime[medal] = cg.time + ((medal*1000) - 1000); }
	if ( cg.time >= cg.medalsRequestTime[medal] )
	{
		CG_DrawPic ( x - 5, y, w, sb_lineHeight, cgs.media.scoreboardLine );

		switch (medal) {
			case 1:
				i = cgs.medal_mvpID;

				CG_DrawPic (x-3,y+3,24,40,cgs.media.medalMvp);
				s = va("Most Valuable Player");
				d = va("%i points", cgs.medal_mvp);
				break;
			case 2:
				i = cgs.medal_accuracyID;

				CG_DrawPic (x-3,y+3,24,40,cgs.media.medalAccuracy );
				s = va("Best Accuracy");
				d = va("%i%% accuracy", cgs.medal_accuracy);
				break;
			case 3:
				i = cgs.medal_damageID;

				CG_DrawPic (x-3,y+3,24,41,cgs.media.medalDamage );
				s = va("Most Damage");
				d = va("%i damage", cgs.medal_damage);
				break;
			case 4:
				i = cgs.medal_grenadesID;

				CG_DrawPic (x-3,y+3,24,42,cgs.media.medalGrenades );
				s = va("Most Grenade Kills");
				d = va("%i grenade kills", cgs.medal_grenades);
				break;
			case 5:
				i = cgs.medal_knifesID;

				CG_DrawPic (x-3,y+3,24,41,cgs.media.medalKnifes );
				s = va("Most Knife Kills");
				d = va("%i knife kills", cgs.medal_knifes);
				break;
			case 6:	
				i = cgs.medal_headhunterID;

				CG_DrawPic (x-3,y+3,24,44,cgs.media.medalHeadshots );
				s = va("Most Head Shots");
				d = va("%i head kills", cgs.medal_headhunter);
				break;
			case 7:
				i = cgs.medal_sniperID;

				CG_DrawPic (x-3,y+3,24,40,cgs.media.medalSniper );
				s = va("Most Sniper Kills");
				d = va("%i sniper kills",cgs.medal_sniper);
				break;
			case 8:	
				i = cgs.medal_killstreakID;

				CG_DrawPic (x-3,y+3,24,40,cgs.media.medalKillstreak );
				s = va("Highest Killstreak");
				d = va("%i kills in a row",cgs.medal_killstreak);
				break;
			default:	
				break;
		}
		y+=2;

		f = trap_R_GetTextWidth ( s, cgs.media.hudFont, sb_nameFontScale, 0 );
		CG_DrawText( x + w - 10 - f, y, cgs.media.hudFont, sb_nameFontScale, colorLtGrey, s, 0, DT_OUTLINE );

		ci = &cgs.clientinfo[i];
		score = &cg.scores[i];

		if ( i == -1 || !score || !ci ) { 
			CG_DrawText( x+26, y, cgs.media.hudFont, sb_nameFontScale, colorLtGrey, "No winner", 24, DT_OUTLINE );
			CG_DrawText( x+26, y + sb_numberFontScale+20, cgs.media.hudFont, sb_readyFontScale, colorLtGrey, "No runner up", 0, 0 );

			f = trap_R_GetTextWidth ( "none information", cgs.media.hudFont, sb_readyFontScale, 0 );
			CG_DrawText( x + w - 10 - f, y + sb_numberFontScale, cgs.media.hudFont, sb_readyFontScale, colorLtGrey, "none information", 0, 0 );
			if ( !cg.medalsSound[medal] )
			{
				cg.medalsSound[medal] = 1;
				trap_S_StartLocalSound( trap_S_RegisterSound ( "sound/weapons/oicw/fire01.wav" ), CHAN_AUTO );
			}
		}
		else {
			if ( !cg.medalsSound[medal] )
			{
				cg.medalsSound[medal] = 1;
				trap_S_StartLocalSound( trap_S_RegisterSound ( "sound/weapons/oicw/fire01.wav" ), CHAN_AUTO );

			}
			f = trap_R_GetTextWidth ( d, cgs.media.hudFont, sb_readyFontScale, 0 );
			CG_DrawText( x + w - 10 - f, y + sb_numberFontScale, cgs.media.hudFont, sb_readyFontScale, colorLtGrey, d, 0, 0 );
	
			CG_DrawText( x+26, y, cgs.media.hudFont, sb_nameFontScale, colorLtGrey, va("%s",ci->name), 0, DT_OUTLINE );

			CG_DrawText( x+26, y + sb_numberFontScale, cgs.media.hudFont, sb_readyFontScale, colorLtGrey, va("id: %i", score->client ), 0, 0 );
			CG_DrawText( x+66, y + sb_numberFontScale, cgs.media.hudFont, sb_readyFontScale, colorLtGrey, va("ping: %i", score->ping ), 0, 0 );
			CG_DrawText( x+111, y + sb_numberFontScale, cgs.media.hudFont, sb_readyFontScale, colorLtGrey, va("time: %i", score->time ), 0, 0 );
			CG_DrawText( x+156, y + sb_numberFontScale, cgs.media.hudFont, sb_readyFontScale, colorLtGrey, va("points: %i", score->score ), 0, 0 );

			if ( cgs.runnerUp[medal] == -1 || cgs.runnerUp[medal] == i ) {
				CG_DrawText( x+26, y + sb_numberFontScale+20, cgs.media.hudFont, sb_readyFontScale, colorLtGrey, "No runner up", 0, 0 );
			}
			else if ( cgs.runnerUp[medal] >= 0 ) {
				clientInfo_t *runnerUp; 
				runnerUp = &cgs.clientinfo[cgs.runnerUp[medal]];
				CG_DrawText( x+26, y + sb_numberFontScale+20, cgs.media.hudFont, sb_readyFontScale, colorLtGrey, va("Runner up: %s", runnerUp->name), 0, 0 );
			}

			stars = CG_CalcStars(score);

			for ( i = 0; i < 10; i++ ) {

				/* left align CG_DrawPic  ( x+26+(18*i), y + sb_numberFontScale + 12,16,16, cgs.media.starShader); */
				if (stars >= 1) {
					CG_DrawPic  ( x + w - 26 - (18*i), y + sb_numberFontScale + 12,16,16, cgs.media.starShader); // right align with right stars starting
					stars--;
				}
				else {
					i = 10; stars = 0; // end it here
					// CG_DrawPic  ( x + w - 26 - (18*i), y + sb_numberFontScale + 12,16,16, cgs.media.starBlackShader); // right align with right stars starting
				}
			}
			stars = 0;
		}
	}
}

void CG_DrawOspLocationalThings( void )
{
	int total, totalb;
	vec4_t col;

	total = cgs.headHits+cgs.armHits+cgs.torsoHits+cgs.waistHits+cgs.legHits;
	if ( cgs.headHits && total ) { cgs.headHits = (100 / total) * cgs.headHits; }
	if ( cgs.armHits && total ) { cgs.armHits = (100 / total) * cgs.armHits; }
	if ( cgs.torsoHits && total ) { cgs.torsoHits = (100 / total) * cgs.torsoHits; }
	if ( cgs.waistHits && total ) { cgs.waistHits = (100 / total) * cgs.waistHits; }
	if ( cgs.legHits && total ) { cgs.legHits = (100 / total) * cgs.legHits; }

	totalb = cgs.headHitsRecieved+cgs.armHitsRecieved+cgs.torsoHitsRecieved+cgs.waistHitsRecieved+cgs.legHitsRecieved;
	if ( cgs.headHitsRecieved && totalb ) { cgs.headHitsRecieved = (100 / totalb) * cgs.headHitsRecieved; }
	if ( cgs.armHitsRecieved && totalb ) { cgs.armHitsRecieved = (100 / totalb) * cgs.armHitsRecieved; }
	if ( cgs.torsoHitsRecieved && totalb ) { cgs.torsoHitsRecieved = (100 / totalb) * cgs.torsoHitsRecieved; }
	if ( cgs.waistHitsRecieved && totalb ) { cgs.waistHitsRecieved = (100 / totalb) * cgs.waistHitsRecieved; }
	if ( cgs.legHitsRecieved && totalb ) { cgs.legHitsRecieved	= (100 / totalb) * cgs.legHitsRecieved; }

	VectorCopy4 ( colorBlack, col );
	col[3] = 0.40f;
	trap_R_SetColor (col);
	CG_DrawStretchPic(20,144,120,195,0,0,1,1,col,cgs.media.whiteShader);
	CG_DrawStretchPic(500,144,120,195,0,0,1,1,col,cgs.media.whiteShader);
	trap_R_SetColor (NULL);

	CG_DrawPic  ( 20,135,124,210, trap_R_RegisterShaderNoMip( "gfx/misc/locations.png" ));
	CG_DrawPic  ( 500,135,124,210, trap_R_RegisterShaderNoMip( "gfx/misc/locations.png" ));
	CG_DrawText( 40,145, cgs.media.hudFont, 0.40f, colorWhite, "You hit them",0, DT_OUTLINE );
	CG_DrawText( 523,145, cgs.media.hudFont, 0.40f, colorWhite, "They hit you",0, DT_OUTLINE );
	CG_DrawText( 25,325, cgs.media.hudFont, 0.30f, colorWhite, va("Total Hits: %i",(cgs.headHits + cgs.armHits + cgs.torsoHits + cgs.waistHits + cgs.legHits)), 24, DT_OUTLINE );
	CG_DrawText( 505,325, cgs.media.hudFont, 0.30f, colorWhite, va("Total Hits: %i",(cgs.headHitsRecieved + cgs.armHitsRecieved + cgs.torsoHitsRecieved + cgs.waistHitsRecieved + cgs.legHitsRecieved)), 24, DT_OUTLINE );

	CG_DrawText( 95,172, cgs.media.hudFont, 0.30f, colorWhite, va("%i%%",cgs.headHits), 24, DT_OUTLINE );
	CG_DrawText( 574,172, cgs.media.hudFont, 0.30f, colorWhite, va("%i%%",cgs.headHitsRecieved), 24, DT_OUTLINE );

	CG_DrawText( 25,210, cgs.media.hudFont, 0.30f, colorWhite, va("%i%%",cgs.armHits), 24, DT_OUTLINE );
	CG_DrawText( 504,210, cgs.media.hudFont, 0.30f, colorWhite, va("%i%%",cgs.armHitsRecieved), 24, DT_OUTLINE );

	CG_DrawText( 104,210, cgs.media.hudFont, 0.30f, colorWhite, va("%i%%",cgs.torsoHits), 24, DT_OUTLINE );
	CG_DrawText( 584,210, cgs.media.hudFont, 0.30f, colorWhite, va("%i%%",cgs.torsoHitsRecieved), 24, DT_OUTLINE );

	CG_DrawText( 30,245, cgs.media.hudFont, 0.30f, colorWhite, va("%i%%",cgs.waistHits), 24, DT_OUTLINE );
	CG_DrawText( 510,245, cgs.media.hudFont, 0.30f, colorWhite, va("%i%%",cgs.waistHitsRecieved), 24, DT_OUTLINE );

	CG_DrawText( 109,281, cgs.media.hudFont, 0.30f, colorWhite, va("%i%%",cgs.legHits), 24, DT_OUTLINE );
	CG_DrawText( 589,281, cgs.media.hudFont, 0.30f, colorWhite, va("%i%%",cgs.legHitsRecieved), 24, DT_OUTLINE );

}
void CG_DrawMedalScoreboard( void )
{
	float 	x; float y; float w;
	float	color[4];
	int	currentMedal=0;
	int	i,count;

	if ( cg_paused.integer ) { cg.deferredPlayerLoading = 0; return; }
	if ( cg.warmup || cg.predictedPlayerState.pm_type != PM_INTERMISSION ) { return; }

	sb_medalCount	   = 8;
	sb_lineHeight	   = 45;
	sb_nameFontScale   = 0.38f;
	sb_readyFontScale  = 0.25f;
	sb_numberFontScale = trap_R_GetTextHeight ( "W", cgs.media.hudFont, sb_nameFontScale, 0 );

	if ( ui_info_speccount.integer ) {
		CG_FillRect ( 0, 470, 640, 10, colorDkGrey );
		CG_DrawText ( 5, 470, cgs.media.hudFont, 0.28f, colorWhite, va("Specs:   %s", cg.scoreBoardSpectators), 0, DT_OUTLINE );
	}

	CG_DrawOspLocationalThings();

	x = 160; w = 325; y = 60;

	VectorCopy4 ( g_color_table[ColorIndex(COLOR_GREEN)], color );
	color[3] = 0.1f;

	for ( count = 0, i = 0 ; i < sb_medalCount && count < sb_medalCount ; i++ ) {
		currentMedal += 1;
		CG_DrawMedalScore( x, y + sb_lineHeight * count, w, currentMedal );
		count++;
	}
	currentMedal=0;

	if ( cg.time >= cg.medalsRequestTime[8] )
	{ // draw footer only if last medal is drawn
		color[3] = 0.2f;
		CG_DrawPic ( x - 5, y + sb_lineHeight * count, w, sb_lineHeight, cgs.media.scoreboardFooter );
	}
}

