export CG_BuildSolidList
code
proc CG_BuildSolidList 56 4
file "../cg_predict.c"
line 27
;1:// Copyright (C) 2001-2002 Raven Software.
;2://
;3:// cg_predict.c -- this file generates cg.predictedPlayerState by either
;4:// interpolating between snapshots from the server or locally predicting
;5:// ahead the client's movement.
;6:// It also handles local physics interaction, like fragments bouncing off walls
;7:
;8:#include "cg_local.h"
;9:
;10:static	pmove_t		cg_pmove;
;11:
;12:static	int			cg_numSolidEntities;
;13:static	centity_t	*cg_solidEntities[MAX_GENTITIES];
;14:static	int			cg_numTriggerEntities;
;15:static	centity_t	*cg_triggerEntities[MAX_ENTITIES_IN_SNAPSHOT];
;16:
;17:/*
;18:====================
;19:CG_BuildSolidList
;20:
;21:When a new cg.snap has been set, this function builds a sublist
;22:of the entities that are actually solid, to make for more
;23:efficient collision detection
;24:====================
;25:*/
;26:void CG_BuildSolidList( void ) 
;27:{
line 35
;28:	int				i;
;29:	centity_t		*cent;
;30:	snapshot_t		*snap;
;31:	entityState_t	*ent;
;32:	vec3_t			difference;
;33:	float			dsquared;
;34:
;35:	cg_numSolidEntities = 0;
ADDRGP4 cg_numSolidEntities
CNSTI4 0
ASGNI4
line 36
;36:	cg_numTriggerEntities = 0;
ADDRGP4 cg_numTriggerEntities
CNSTI4 0
ASGNI4
line 38
;37:
;38:	if ( cg.nextSnap && !cg.nextFrameTeleport && !cg.thisFrameTeleport ) 
ADDRGP4 cg+40
INDIRP4
CVPU4 4
CNSTU4 0
EQU4 $93
ADDRLP4 32
CNSTI4 0
ASGNI4
ADDRGP4 cg+60
INDIRI4
ADDRLP4 32
INDIRI4
NEI4 $93
ADDRGP4 cg+56
INDIRI4
ADDRLP4 32
INDIRI4
NEI4 $93
line 39
;39:	{
line 40
;40:		snap = cg.nextSnap;
ADDRLP4 20
ADDRGP4 cg+40
INDIRP4
ASGNP4
line 41
;41:	} 
ADDRGP4 $94
JUMPV
LABELV $93
line 43
;42:	else 
;43:	{
line 44
;44:		snap = cg.snap;
ADDRLP4 20
ADDRGP4 cg+36
INDIRP4
ASGNP4
line 45
;45:	}
LABELV $94
line 47
;46:
;47:	for ( i = 0 ; i < snap->numEntities ; i++ ) 
ADDRLP4 16
CNSTI4 0
ASGNI4
ADDRGP4 $103
JUMPV
LABELV $100
line 48
;48:	{
line 49
;49:		cent = CG_GetEntity ( snap->entities[ i ].number );
CNSTI4 216
ADDRLP4 16
INDIRI4
MULI4
ADDRLP4 20
INDIRP4
CNSTI4 916
ADDP4
ADDP4
INDIRI4
ARGI4
ADDRLP4 36
ADDRGP4 CG_GetEntity
CALLP4
ASGNP4
ADDRLP4 0
ADDRLP4 36
INDIRP4
ASGNP4
line 50
;50:		ent = &cent->currentState;
ADDRLP4 24
ADDRLP4 0
INDIRP4
ASGNP4
line 52
;51:
;52:		if ( ent->eType == ET_ITEM || ent->eType == ET_PUSH_TRIGGER || ent->eType == ET_TELEPORT_TRIGGER ) 
ADDRLP4 40
ADDRLP4 24
INDIRP4
CNSTI4 4
ADDP4
INDIRI4
ASGNI4
ADDRLP4 40
INDIRI4
CNSTI4 2
EQI4 $107
ADDRLP4 40
INDIRI4
CNSTI4 8
EQI4 $107
ADDRLP4 40
INDIRI4
CNSTI4 9
NEI4 $104
LABELV $107
line 53
;53:		{
line 54
;54:			cg_triggerEntities[cg_numTriggerEntities] = cent;
ADDRGP4 cg_numTriggerEntities
INDIRI4
CNSTI4 2
LSHI4
ADDRGP4 cg_triggerEntities
ADDP4
ADDRLP4 0
INDIRP4
ASGNP4
line 55
;55:			cg_numTriggerEntities++;
ADDRLP4 44
ADDRGP4 cg_numTriggerEntities
ASGNP4
ADDRLP4 44
INDIRP4
ADDRLP4 44
INDIRP4
INDIRI4
CNSTI4 1
ADDI4
ASGNI4
line 56
;56:			continue;
ADDRGP4 $101
JUMPV
LABELV $104
line 59
;57:		}
;58:
;59:		if ( cent->nextState.solid ) 
ADDRLP4 0
INDIRP4
CNSTI4 392
ADDP4
INDIRI4
CNSTI4 0
EQI4 $108
line 60
;60:		{
line 61
;61:			cg_solidEntities[cg_numSolidEntities] = cent;
ADDRGP4 cg_numSolidEntities
INDIRI4
CNSTI4 2
LSHI4
ADDRGP4 cg_solidEntities
ADDP4
ADDRLP4 0
INDIRP4
ASGNP4
line 62
;62:			cg_numSolidEntities++;
ADDRLP4 44
ADDRGP4 cg_numSolidEntities
ASGNP4
ADDRLP4 44
INDIRP4
ADDRLP4 44
INDIRP4
INDIRI4
CNSTI4 1
ADDI4
ASGNI4
line 63
;63:			continue;
LABELV $108
line 65
;64:		}
;65:	}
LABELV $101
line 47
ADDRLP4 16
ADDRLP4 16
INDIRI4
CNSTI4 1
ADDI4
ASGNI4
LABELV $103
ADDRLP4 16
INDIRI4
ADDRLP4 20
INDIRP4
CNSTI4 912
ADDP4
INDIRI4
LTI4 $100
line 67
;66:
;67:	dsquared = RMG_distancecull.value+500;
ADDRLP4 28
ADDRGP4 RMG_distancecull+8
INDIRF4
CNSTF4 1140457472
ADDF4
ASGNF4
line 68
;68:	dsquared *= dsquared;
ADDRLP4 28
ADDRLP4 28
INDIRF4
ADDRLP4 28
INDIRF4
MULF4
ASGNF4
line 70
;69:
;70:	for(i=0;i<cg_numpermanents;i++)
ADDRLP4 16
CNSTI4 0
ASGNI4
ADDRGP4 $114
JUMPV
LABELV $111
line 71
;71:	{
line 72
;72:		cent = cg_permanents[i];
ADDRLP4 0
ADDRLP4 16
INDIRI4
CNSTI4 2
LSHI4
ADDRGP4 cg_permanents
ADDP4
INDIRP4
ASGNP4
line 73
;73:		VectorSubtract(cent->lerpOrigin, snap->ps.origin, difference);
ADDRLP4 4
ADDRLP4 0
INDIRP4
CNSTI4 660
ADDP4
INDIRF4
ADDRLP4 20
INDIRP4
CNSTI4 68
ADDP4
INDIRF4
SUBF4
ASGNF4
ADDRLP4 4+4
ADDRLP4 0
INDIRP4
CNSTI4 664
ADDP4
INDIRF4
ADDRLP4 20
INDIRP4
CNSTI4 72
ADDP4
INDIRF4
SUBF4
ASGNF4
ADDRLP4 4+8
ADDRLP4 0
INDIRP4
CNSTI4 668
ADDP4
INDIRF4
ADDRLP4 20
INDIRP4
CNSTI4 76
ADDP4
INDIRF4
SUBF4
ASGNF4
line 74
;74:		if (cent->currentState.eType == ET_TERRAIN ||
ADDRLP4 0
INDIRP4
CNSTI4 4
ADDP4
INDIRI4
CNSTI4 14
EQI4 $123
ADDRLP4 48
ADDRLP4 4
INDIRF4
ASGNF4
ADDRLP4 48
INDIRF4
ADDRLP4 48
INDIRF4
MULF4
ADDRLP4 4+4
INDIRF4
ADDRLP4 4+4
INDIRF4
MULF4
ADDF4
ADDRLP4 4+8
INDIRF4
ADDRLP4 4+8
INDIRF4
MULF4
ADDF4
ADDRLP4 28
INDIRF4
GTF4 $117
LABELV $123
line 76
;75:			((difference[0]*difference[0]) + (difference[1]*difference[1]) + (difference[2]*difference[2])) <= dsquared)
;76:		{
line 77
;77:			cent->currentValid = qtrue;
ADDRLP4 0
INDIRP4
CNSTI4 436
ADDP4
CNSTI4 1
ASGNI4
line 78
;78:			if ( cent->nextState.solid ) 
ADDRLP4 0
INDIRP4
CNSTI4 392
ADDP4
INDIRI4
CNSTI4 0
EQI4 $118
line 79
;79:			{
line 80
;80:				cg_solidEntities[cg_numSolidEntities] = cent;
ADDRGP4 cg_numSolidEntities
INDIRI4
CNSTI4 2
LSHI4
ADDRGP4 cg_solidEntities
ADDP4
ADDRLP4 0
INDIRP4
ASGNP4
line 81
;81:				cg_numSolidEntities++;
ADDRLP4 52
ADDRGP4 cg_numSolidEntities
ASGNP4
ADDRLP4 52
INDIRP4
ADDRLP4 52
INDIRP4
INDIRI4
CNSTI4 1
ADDI4
ASGNI4
line 82
;82:			}
line 83
;83:		}
ADDRGP4 $118
JUMPV
LABELV $117
line 85
;84:		else
;85:		{
line 86
;86:			cent->currentValid = qfalse;
ADDRLP4 0
INDIRP4
CNSTI4 436
ADDP4
CNSTI4 0
ASGNI4
line 87
;87:		}
LABELV $118
line 88
;88:	}
LABELV $112
line 70
ADDRLP4 16
ADDRLP4 16
INDIRI4
CNSTI4 1
ADDI4
ASGNI4
LABELV $114
ADDRLP4 16
INDIRI4
ADDRGP4 cg_numpermanents
INDIRI4
LTI4 $111
line 89
;89:}
LABELV $92
endproc CG_BuildSolidList 56 4
proc CG_ClipMoveToEntities 144 36
line 98
;90:
;91:/*
;92:====================
;93:CG_ClipMoveToEntities
;94:
;95:====================
;96:*/
;97:static void CG_ClipMoveToEntities ( const vec3_t start, const vec3_t mins, const vec3_t maxs, const vec3_t end,
;98:							int skipNumber, int mask, trace_t *tr ) {
line 107
;99:	int			i, x, zd, zu;
;100:	trace_t		trace;
;101:	entityState_t	*ent;
;102:	clipHandle_t 	cmodel;
;103:	vec3_t		bmins, bmaxs;
;104:	vec3_t		origin, angles;
;105:	centity_t	*cent;
;106:
;107:	for ( i = 0 ; i < cg_numSolidEntities ; i++ ) {
ADDRLP4 64
CNSTI4 0
ASGNI4
ADDRGP4 $130
JUMPV
LABELV $127
line 108
;108:		cent = cg_solidEntities[ i ];
ADDRLP4 60
ADDRLP4 64
INDIRI4
CNSTI4 2
LSHI4
ADDRGP4 cg_solidEntities
ADDP4
INDIRP4
ASGNP4
line 109
;109:		ent = &cent->currentState;
ADDRLP4 0
ADDRLP4 60
INDIRP4
ASGNP4
line 111
;110:
;111:		if ( ent->number == skipNumber ) {
ADDRLP4 0
INDIRP4
INDIRI4
ADDRFP4 16
INDIRI4
NEI4 $131
line 112
;112:			continue;
ADDRGP4 $128
JUMPV
LABELV $131
line 115
;113:		}
;114:
;115:		if ( ent->solid == SOLID_BMODEL ) {
ADDRLP4 0
INDIRP4
CNSTI4 176
ADDP4
INDIRI4
CNSTI4 16777215
NEI4 $133
line 117
;116:			// special value for bmodel
;117:			cmodel = trap_CM_InlineModel( ent->modelindex );
ADDRLP4 0
INDIRP4
CNSTI4 160
ADDP4
INDIRI4
ARGI4
ADDRLP4 132
ADDRGP4 trap_CM_InlineModel
CALLI4
ASGNI4
ADDRLP4 68
ADDRLP4 132
INDIRI4
ASGNI4
line 118
;118:			VectorCopy( cent->lerpAngles, angles );
ADDRLP4 108
ADDRLP4 60
INDIRP4
CNSTI4 672
ADDP4
INDIRB
ASGNB 12
line 119
;119:			BG_EvaluateTrajectory( &cent->currentState.pos, cg.physicsTime, origin );
ADDRLP4 60
INDIRP4
CNSTI4 12
ADDP4
ARGP4
ADDRGP4 cg+76
INDIRI4
ARGI4
ADDRLP4 96
ARGP4
ADDRGP4 BG_EvaluateTrajectory
CALLV
pop
line 120
;120:		} else {
ADDRGP4 $134
JUMPV
LABELV $133
line 122
;121:			// encoded bbox
;122:			x = (ent->solid & 255);
ADDRLP4 120
ADDRLP4 0
INDIRP4
CNSTI4 176
ADDP4
INDIRI4
CNSTI4 255
BANDI4
ASGNI4
line 123
;123:			zd = ((ent->solid>>8) & 255);
ADDRLP4 124
ADDRLP4 0
INDIRP4
CNSTI4 176
ADDP4
INDIRI4
CNSTI4 8
RSHI4
CNSTI4 255
BANDI4
ASGNI4
line 124
;124:			zu = ((ent->solid>>16) & 255) - 32;
ADDRLP4 128
ADDRLP4 0
INDIRP4
CNSTI4 176
ADDP4
INDIRI4
CNSTI4 16
RSHI4
CNSTI4 255
BANDI4
CNSTI4 32
SUBI4
ASGNI4
line 126
;125:
;126:			bmins[0] = bmins[1] = -x;
ADDRLP4 132
ADDRLP4 120
INDIRI4
NEGI4
CVIF4 4
ASGNF4
ADDRLP4 72+4
ADDRLP4 132
INDIRF4
ASGNF4
ADDRLP4 72
ADDRLP4 132
INDIRF4
ASGNF4
line 127
;127:			bmaxs[0] = bmaxs[1] = x;
ADDRLP4 136
ADDRLP4 120
INDIRI4
CVIF4 4
ASGNF4
ADDRLP4 84+4
ADDRLP4 136
INDIRF4
ASGNF4
ADDRLP4 84
ADDRLP4 136
INDIRF4
ASGNF4
line 128
;128:			bmins[2] = -zd;
ADDRLP4 72+8
ADDRLP4 124
INDIRI4
NEGI4
CVIF4 4
ASGNF4
line 129
;129:			bmaxs[2] = zu;
ADDRLP4 84+8
ADDRLP4 128
INDIRI4
CVIF4 4
ASGNF4
line 131
;130:
;131:			cmodel = trap_CM_TempBoxModel( bmins, bmaxs );
ADDRLP4 72
ARGP4
ADDRLP4 84
ARGP4
ADDRLP4 140
ADDRGP4 trap_CM_TempBoxModel
CALLI4
ASGNI4
ADDRLP4 68
ADDRLP4 140
INDIRI4
ASGNI4
line 132
;132:			VectorCopy( vec3_origin, angles );
ADDRLP4 108
ADDRGP4 vec3_origin
INDIRB
ASGNB 12
line 133
;133:			VectorCopy( cent->lerpOrigin, origin );
ADDRLP4 96
ADDRLP4 60
INDIRP4
CNSTI4 660
ADDP4
INDIRB
ASGNB 12
line 134
;134:		}
LABELV $134
line 137
;135:
;136:
;137:		trap_CM_TransformedBoxTrace ( &trace, start, end,
ADDRLP4 4
ARGP4
ADDRFP4 0
INDIRP4
ARGP4
ADDRFP4 12
INDIRP4
ARGP4
ADDRFP4 4
INDIRP4
ARGP4
ADDRFP4 8
INDIRP4
ARGP4
ADDRLP4 68
INDIRI4
ARGI4
ADDRFP4 20
INDIRI4
ARGI4
ADDRLP4 96
ARGP4
ADDRLP4 108
ARGP4
ADDRGP4 trap_CM_TransformedBoxTrace
CALLV
pop
line 140
;138:			mins, maxs, cmodel,  mask, origin, angles);
;139:
;140:		if (trace.allsolid || trace.fraction < tr->fraction) {
ADDRLP4 4
INDIRI4
CNSTI4 0
NEI4 $143
ADDRLP4 4+8
INDIRF4
ADDRFP4 24
INDIRP4
CNSTI4 8
ADDP4
INDIRF4
GEF4 $140
LABELV $143
line 141
;141:			trace.entityNum = ent->number;
ADDRLP4 4+52
ADDRLP4 0
INDIRP4
INDIRI4
ASGNI4
line 142
;142:			*tr = trace;
ADDRFP4 24
INDIRP4
ADDRLP4 4
INDIRB
ASGNB 56
line 143
;143:		} else if (trace.startsolid) {
ADDRGP4 $141
JUMPV
LABELV $140
ADDRLP4 4+4
INDIRI4
CNSTI4 0
EQI4 $145
line 144
;144:			tr->startsolid = qtrue;
ADDRFP4 24
INDIRP4
CNSTI4 4
ADDP4
CNSTI4 1
ASGNI4
line 145
;145:		}
LABELV $145
LABELV $141
line 146
;146:		if ( tr->allsolid ) {
ADDRFP4 24
INDIRP4
INDIRI4
CNSTI4 0
EQI4 $148
line 147
;147:			return;
ADDRGP4 $126
JUMPV
LABELV $148
line 149
;148:		}
;149:	}
LABELV $128
line 107
ADDRLP4 64
ADDRLP4 64
INDIRI4
CNSTI4 1
ADDI4
ASGNI4
LABELV $130
ADDRLP4 64
INDIRI4
ADDRGP4 cg_numSolidEntities
INDIRI4
LTI4 $127
line 150
;150:}
LABELV $126
endproc CG_ClipMoveToEntities 144 36
export CG_Trace
proc CG_Trace 60 28
line 158
;151:
;152:/*
;153:================
;154:CG_Trace
;155:================
;156:*/
;157:void CG_Trace( trace_t *result, const vec3_t start, const vec3_t mins, const vec3_t maxs, const vec3_t end, int skipNumber, int mask ) 
;158:{
line 161
;159:	trace_t	t;
;160:
;161:	trap_CM_BoxTrace ( &t, start, end, mins, maxs, 0, mask);
ADDRLP4 0
ARGP4
ADDRFP4 4
INDIRP4
ARGP4
ADDRFP4 16
INDIRP4
ARGP4
ADDRFP4 8
INDIRP4
ARGP4
ADDRFP4 12
INDIRP4
ARGP4
CNSTI4 0
ARGI4
ADDRFP4 24
INDIRI4
ARGI4
ADDRGP4 trap_CM_BoxTrace
CALLV
pop
line 162
;162:	t.entityNum = t.fraction != 1.0 ? ENTITYNUM_WORLD : ENTITYNUM_NONE;
ADDRLP4 0+8
INDIRF4
CNSTF4 1065353216
EQF4 $154
ADDRLP4 56
CNSTI4 1022
ASGNI4
ADDRGP4 $155
JUMPV
LABELV $154
ADDRLP4 56
CNSTI4 1023
ASGNI4
LABELV $155
ADDRLP4 0+52
ADDRLP4 56
INDIRI4
ASGNI4
line 164
;163:	// check all other solid models
;164:	CG_ClipMoveToEntities (start, mins, maxs, end, skipNumber, mask, &t);
ADDRFP4 4
INDIRP4
ARGP4
ADDRFP4 8
INDIRP4
ARGP4
ADDRFP4 12
INDIRP4
ARGP4
ADDRFP4 16
INDIRP4
ARGP4
ADDRFP4 20
INDIRI4
ARGI4
ADDRFP4 24
INDIRI4
ARGI4
ADDRLP4 0
ARGP4
ADDRGP4 CG_ClipMoveToEntities
CALLV
pop
line 166
;165:
;166:	*result = t;
ADDRFP4 0
INDIRP4
ADDRLP4 0
INDIRB
ASGNB 56
line 167
;167:}
LABELV $150
endproc CG_Trace 60 28
export CG_PlayerTrace
proc CG_PlayerTrace 1152 44
line 177
;168:
;169:/*
;170:================
;171:CG_PlayerTrace
;172:
;173:Trace against all players in the game and return a precise ghoul location where they were hit
;174:================
;175:*/
;176:void CG_PlayerTrace ( trace_t* tr, const vec3_t start, const vec3_t end, int skipNumber )
;177:{
line 184
;178:	G2Trace_t		G2Trace;
;179:	int				i;
;180:	float			hitlen;
;181:	int				hit;
;182:	vec3_t			hitloc;
;183:
;184:	hit = -1;
ADDRLP4 1044
CNSTI4 -1
ASGNI4
line 186
;185:
;186:	VectorSubtract ( end, start, hitloc );
ADDRLP4 1048
ADDRFP4 8
INDIRP4
ASGNP4
ADDRLP4 1052
ADDRFP4 4
INDIRP4
ASGNP4
ADDRLP4 1032
ADDRLP4 1048
INDIRP4
INDIRF4
ADDRLP4 1052
INDIRP4
INDIRF4
SUBF4
ASGNF4
ADDRLP4 1056
CNSTI4 4
ASGNI4
ADDRLP4 1032+4
ADDRLP4 1048
INDIRP4
ADDRLP4 1056
INDIRI4
ADDP4
INDIRF4
ADDRLP4 1052
INDIRP4
ADDRLP4 1056
INDIRI4
ADDP4
INDIRF4
SUBF4
ASGNF4
ADDRLP4 1060
CNSTI4 8
ASGNI4
ADDRLP4 1032+8
ADDRFP4 8
INDIRP4
ADDRLP4 1060
INDIRI4
ADDP4
INDIRF4
ADDRFP4 4
INDIRP4
ADDRLP4 1060
INDIRI4
ADDP4
INDIRF4
SUBF4
ASGNF4
line 187
;187:	hitlen = VectorLengthSquared ( hitloc );
ADDRLP4 1032
ARGP4
ADDRLP4 1064
ADDRGP4 VectorLengthSquared
CALLF4
ASGNF4
ADDRLP4 1028
ADDRLP4 1064
INDIRF4
ASGNF4
line 189
;188:
;189:	for ( i = 0 ; i < cgs.maxclients ; i++ ) 
ADDRLP4 1024
CNSTI4 0
ASGNI4
ADDRGP4 $162
JUMPV
LABELV $159
line 190
;190:	{
line 194
;191:		centity_t	*cent;
;192:		animation_t	*anim;
;193:
;194:		cent = &cg_entities[i];
ADDRLP4 1068
CNSTI4 880
ADDRLP4 1024
INDIRI4
MULI4
ADDRGP4 cg_entities
ADDP4
ASGNP4
line 197
;195:
;196:		// Look for reasons to not even bother with this client
;197:		if ( !cent->currentValid || cent->currentState.number == skipNumber || cent->currentState.eType != ET_PLAYER )
ADDRLP4 1068
INDIRP4
CNSTI4 436
ADDP4
INDIRI4
CNSTI4 0
EQI4 $167
ADDRLP4 1068
INDIRP4
INDIRI4
ADDRFP4 12
INDIRI4
EQI4 $167
ADDRLP4 1068
INDIRP4
CNSTI4 4
ADDP4
INDIRI4
CNSTI4 1
EQI4 $164
LABELV $167
line 198
;198:		{
line 199
;199:			continue;
ADDRGP4 $160
JUMPV
LABELV $164
line 203
;200:		}
;201:
;202:		// Cant hit dead people
;203:		if ( cent->currentState.eFlags & EF_DEAD )
ADDRLP4 1068
INDIRP4
CNSTI4 8
ADDP4
INDIRI4
CNSTI4 1
BANDI4
CNSTI4 0
EQI4 $168
line 204
;204:		{
line 205
;205:			continue;
ADDRGP4 $160
JUMPV
LABELV $168
line 209
;206:		}
;207:
;208:		// Do a quick test to make sure its even close to the guy
;209:		if ( !Q_TestRaySphere ( cent->lerpOrigin, 50, start, end ) )
ADDRLP4 1068
INDIRP4
CNSTI4 660
ADDP4
ARGP4
CNSTF4 1112014848
ARGF4
ADDRFP4 4
INDIRP4
ARGP4
ADDRFP4 8
INDIRP4
ARGP4
ADDRLP4 1080
ADDRGP4 Q_TestRaySphere
CALLI4
ASGNI4
ADDRLP4 1080
INDIRI4
CNSTI4 0
NEI4 $170
line 210
;210:		{
line 211
;211:			continue;
ADDRGP4 $160
JUMPV
LABELV $170
line 215
;212:		}
;213:
;214:		// See if the shot is even close to the player
;215:		G2Trace[0].mEntityNum = -1;
ADDRLP4 0+4
CNSTI4 -1
ASGNI4
line 217
;216:
;217:		anim = &cg.hitAnimations[ cent->pe.legs.anim &(~ANIM_TOGGLEBIT) ];
ADDRLP4 1072
CNSTI4 28
ADDRLP4 1068
INDIRP4
CNSTI4 512
ADDP4
INDIRI4
CNSTI4 -2049
BANDI4
MULI4
ADDRGP4 cg+181240
ADDP4
ASGNP4
line 218
;218:		trap_G2API_SetBoneAnim(cg.hitModel, 0, "model_root", anim->firstFrame, anim->firstFrame + anim->numFrames, BONE_ANIM_OVERRIDE_LOOP, 50.0f / anim->frameLerp, cent->pe.legs.animTime, -1, 0);
ADDRGP4 cg+184068
INDIRP4
ARGP4
ADDRLP4 1084
CNSTI4 0
ASGNI4
ADDRLP4 1084
INDIRI4
ARGI4
ADDRGP4 $175
ARGP4
ADDRLP4 1092
ADDRLP4 1072
INDIRP4
INDIRI4
ASGNI4
ADDRLP4 1092
INDIRI4
ARGI4
ADDRLP4 1092
INDIRI4
ADDRLP4 1072
INDIRP4
CNSTI4 4
ADDP4
INDIRI4
ADDI4
ARGI4
CNSTI4 16
ARGI4
CNSTF4 1112014848
ADDRLP4 1072
INDIRP4
CNSTI4 12
ADDP4
INDIRI4
CVIF4 4
DIVF4
ARGF4
ADDRLP4 1068
INDIRP4
CNSTI4 516
ADDP4
INDIRI4
ARGI4
CNSTF4 3212836864
ARGF4
ADDRLP4 1084
INDIRI4
ARGI4
ADDRGP4 trap_G2API_SetBoneAnim
CALLI4
pop
line 220
;219:
;220:		anim = &cg.hitAnimations[ cent->pe.torso.anim &(~ANIM_TOGGLEBIT)];
ADDRLP4 1072
CNSTI4 28
ADDRLP4 1068
INDIRP4
CNSTI4 488
ADDP4
INDIRI4
CNSTI4 -2049
BANDI4
MULI4
ADDRGP4 cg+181240
ADDP4
ASGNP4
line 221
;221:		trap_G2API_SetBoneAnim(cg.hitModel, 0, "lower_lumbar", anim->firstFrame, anim->firstFrame + anim->numFrames, BONE_ANIM_OVERRIDE_LOOP, 50.0f / anim->frameLerp, cent->pe.torso.animTime, -1, 0);
ADDRGP4 cg+184068
INDIRP4
ARGP4
ADDRLP4 1096
CNSTI4 0
ASGNI4
ADDRLP4 1096
INDIRI4
ARGI4
ADDRGP4 $178
ARGP4
ADDRLP4 1104
ADDRLP4 1072
INDIRP4
INDIRI4
ASGNI4
ADDRLP4 1104
INDIRI4
ARGI4
ADDRLP4 1104
INDIRI4
ADDRLP4 1072
INDIRP4
CNSTI4 4
ADDP4
INDIRI4
ADDI4
ARGI4
CNSTI4 16
ARGI4
CNSTF4 1112014848
ADDRLP4 1072
INDIRP4
CNSTI4 12
ADDP4
INDIRI4
CVIF4 4
DIVF4
ARGF4
ADDRLP4 1068
INDIRP4
CNSTI4 492
ADDP4
INDIRI4
ARGI4
CNSTF4 3212836864
ARGF4
ADDRLP4 1096
INDIRI4
ARGI4
ADDRGP4 trap_G2API_SetBoneAnim
CALLI4
pop
line 223
;222:
;223:		trap_G2API_SetBoneAngles( cg.hitModel, 0, "upper_lumbar", cent->pe.ghoulUpperTorsoAngles, BONE_ANGLES_POSTMULT, POSITIVE_X, NEGATIVE_Y, NEGATIVE_Z, 0, 0, cg.time ); 
ADDRGP4 cg+184068
INDIRP4
ARGP4
ADDRLP4 1108
CNSTI4 0
ASGNI4
ADDRLP4 1108
INDIRI4
ARGI4
ADDRGP4 $180
ARGP4
ADDRLP4 1068
INDIRP4
CNSTI4 568
ADDP4
ARGP4
CNSTI4 2
ARGI4
CNSTI4 1
ARGI4
CNSTI4 6
ARGI4
CNSTI4 5
ARGI4
CNSTP4 0
ARGP4
ADDRLP4 1108
INDIRI4
ARGI4
ADDRGP4 cg+68
INDIRI4
ARGI4
ADDRGP4 trap_G2API_SetBoneAngles
CALLI4
pop
line 224
;224:		trap_G2API_SetBoneAngles( cg.hitModel, 0, "lower_lumbar", cent->pe.ghoulLowerTorsoAngles, BONE_ANGLES_POSTMULT, POSITIVE_X, NEGATIVE_Y, NEGATIVE_Z, 0, 0, cg.time ); 
ADDRGP4 cg+184068
INDIRP4
ARGP4
ADDRLP4 1112
CNSTI4 0
ASGNI4
ADDRLP4 1112
INDIRI4
ARGI4
ADDRGP4 $178
ARGP4
ADDRLP4 1068
INDIRP4
CNSTI4 556
ADDP4
ARGP4
CNSTI4 2
ARGI4
CNSTI4 1
ARGI4
CNSTI4 6
ARGI4
CNSTI4 5
ARGI4
CNSTP4 0
ARGP4
ADDRLP4 1112
INDIRI4
ARGI4
ADDRGP4 cg+68
INDIRI4
ARGI4
ADDRGP4 trap_G2API_SetBoneAngles
CALLI4
pop
line 225
;225:		trap_G2API_SetBoneAngles( cg.hitModel, 0, "cranium",	  cent->pe.ghoulHeadAngles, BONE_ANGLES_POSTMULT, POSITIVE_Z, NEGATIVE_Y, POSITIVE_X, 0,0, cg.time ); 
ADDRGP4 cg+184068
INDIRP4
ARGP4
ADDRLP4 1116
CNSTI4 0
ASGNI4
ADDRLP4 1116
INDIRI4
ARGI4
ADDRGP4 $185
ARGP4
ADDRLP4 1068
INDIRP4
CNSTI4 580
ADDP4
ARGP4
ADDRLP4 1120
CNSTI4 2
ASGNI4
ADDRLP4 1120
INDIRI4
ARGI4
ADDRLP4 1120
INDIRI4
ARGI4
CNSTI4 6
ARGI4
CNSTI4 1
ARGI4
CNSTP4 0
ARGP4
ADDRLP4 1116
INDIRI4
ARGI4
ADDRGP4 cg+68
INDIRI4
ARGI4
ADDRGP4 trap_G2API_SetBoneAngles
CALLI4
pop
line 227
;226:
;227:		trap_G2API_CollisionDetect ( G2Trace, cg.hitModel, cent->pe.ghoulLegsAngles, cent->lerpOrigin, cg.time, cent->currentState.number, start, end, vec3_identity, 0, 2 );
ADDRLP4 0
ARGP4
ADDRGP4 cg+184068
INDIRP4
ARGP4
ADDRLP4 1068
INDIRP4
CNSTI4 544
ADDP4
ARGP4
ADDRLP4 1068
INDIRP4
CNSTI4 660
ADDP4
ARGP4
ADDRGP4 cg+68
INDIRI4
ARGI4
ADDRLP4 1068
INDIRP4
INDIRI4
ARGI4
ADDRFP4 4
INDIRP4
ARGP4
ADDRFP4 8
INDIRP4
ARGP4
ADDRGP4 vec3_identity
ARGP4
CNSTI4 0
ARGI4
CNSTI4 2
ARGI4
ADDRGP4 trap_G2API_CollisionDetect
CALLV
pop
line 229
;228:
;229:		if ( G2Trace[0].mEntityNum == i )
ADDRLP4 0+4
INDIRI4
ADDRLP4 1024
INDIRI4
NEI4 $189
line 230
;230:		{
line 234
;231:			vec3_t temp;
;232:			float  len;
;233:
;234:			VectorSubtract ( G2Trace[0].mCollisionPosition, start, temp );
ADDRLP4 1144
ADDRFP4 4
INDIRP4
ASGNP4
ADDRLP4 1128
ADDRLP4 0+20
INDIRF4
ADDRLP4 1144
INDIRP4
INDIRF4
SUBF4
ASGNF4
ADDRLP4 1128+4
ADDRLP4 0+20+4
INDIRF4
ADDRLP4 1144
INDIRP4
CNSTI4 4
ADDP4
INDIRF4
SUBF4
ASGNF4
ADDRLP4 1128+8
ADDRLP4 0+20+8
INDIRF4
ADDRFP4 4
INDIRP4
CNSTI4 8
ADDP4
INDIRF4
SUBF4
ASGNF4
line 235
;235:			len = VectorLengthSquared ( temp );
ADDRLP4 1128
ARGP4
ADDRLP4 1148
ADDRGP4 VectorLengthSquared
CALLF4
ASGNF4
ADDRLP4 1140
ADDRLP4 1148
INDIRF4
ASGNF4
line 237
;236:
;237:			if ( len < hitlen )
ADDRLP4 1140
INDIRF4
ADDRLP4 1028
INDIRF4
GEF4 $199
line 238
;238:			{
line 239
;239:				hitlen = len;
ADDRLP4 1028
ADDRLP4 1140
INDIRF4
ASGNF4
line 240
;240:				hit    = i;
ADDRLP4 1044
ADDRLP4 1024
INDIRI4
ASGNI4
line 241
;241:				VectorCopy ( G2Trace[0].mCollisionPosition, hitloc );
ADDRLP4 1032
ADDRLP4 0+20
INDIRB
ASGNB 12
line 242
;242:			}
LABELV $199
line 243
;243:		}
LABELV $189
line 244
;244:	}
LABELV $160
line 189
ADDRLP4 1024
ADDRLP4 1024
INDIRI4
CNSTI4 1
ADDI4
ASGNI4
LABELV $162
ADDRLP4 1024
INDIRI4
ADDRGP4 cgs+33040
INDIRI4
LTI4 $159
line 246
;245:
;246:	if ( hit != -1 )
ADDRLP4 1044
INDIRI4
CNSTI4 -1
EQI4 $202
line 247
;247:	{
line 248
;248:		tr->entityNum = hit;		
ADDRFP4 0
INDIRP4
CNSTI4 52
ADDP4
ADDRLP4 1044
INDIRI4
ASGNI4
line 249
;249:		VectorCopy ( hitloc, tr->endpos );
ADDRFP4 0
INDIRP4
CNSTI4 12
ADDP4
ADDRLP4 1032
INDIRB
ASGNB 12
line 250
;250:	}
LABELV $202
line 251
;251:}
LABELV $156
endproc CG_PlayerTrace 1152 44
export CG_PointContents
proc CG_PointContents 36 16
line 258
;252:
;253:/*
;254:================
;255:CG_PointContents
;256:================
;257:*/
;258:int		CG_PointContents( const vec3_t point, int passEntityNum ) {
line 265
;259:	int			i;
;260:	entityState_t	*ent;
;261:	centity_t	*cent;
;262:	clipHandle_t cmodel;
;263:	int			contents;
;264:
;265:	contents = trap_CM_PointContents (point, 0);
ADDRFP4 0
INDIRP4
ARGP4
CNSTI4 0
ARGI4
ADDRLP4 20
ADDRGP4 trap_CM_PointContents
CALLI4
ASGNI4
ADDRLP4 16
ADDRLP4 20
INDIRI4
ASGNI4
line 267
;266:
;267:	for ( i = 0 ; i < cg_numSolidEntities ; i++ ) {
ADDRLP4 4
CNSTI4 0
ASGNI4
ADDRGP4 $208
JUMPV
LABELV $205
line 268
;268:		cent = cg_solidEntities[ i ];
ADDRLP4 12
ADDRLP4 4
INDIRI4
CNSTI4 2
LSHI4
ADDRGP4 cg_solidEntities
ADDP4
INDIRP4
ASGNP4
line 270
;269:
;270:		ent = &cent->currentState;
ADDRLP4 0
ADDRLP4 12
INDIRP4
ASGNP4
line 272
;271:
;272:		if ( ent->number == passEntityNum ) {
ADDRLP4 0
INDIRP4
INDIRI4
ADDRFP4 4
INDIRI4
NEI4 $209
line 273
;273:			continue;
ADDRGP4 $206
JUMPV
LABELV $209
line 276
;274:		}
;275:
;276:		if (ent->solid != SOLID_BMODEL) { // special value for bmodel
ADDRLP4 0
INDIRP4
CNSTI4 176
ADDP4
INDIRI4
CNSTI4 16777215
EQI4 $211
line 277
;277:			continue;
ADDRGP4 $206
JUMPV
LABELV $211
line 280
;278:		}
;279:
;280:		cmodel = trap_CM_InlineModel( ent->modelindex );
ADDRLP4 0
INDIRP4
CNSTI4 160
ADDP4
INDIRI4
ARGI4
ADDRLP4 24
ADDRGP4 trap_CM_InlineModel
CALLI4
ASGNI4
ADDRLP4 8
ADDRLP4 24
INDIRI4
ASGNI4
line 281
;281:		if ( !cmodel ) {
ADDRLP4 8
INDIRI4
CNSTI4 0
NEI4 $213
line 282
;282:			continue;
ADDRGP4 $206
JUMPV
LABELV $213
line 285
;283:		}
;284:
;285:		contents |= trap_CM_TransformedPointContents( point, cmodel, ent->origin, ent->angles );
ADDRFP4 0
INDIRP4
ARGP4
ADDRLP4 8
INDIRI4
ARGI4
ADDRLP4 0
INDIRP4
CNSTI4 92
ADDP4
ARGP4
ADDRLP4 0
INDIRP4
CNSTI4 116
ADDP4
ARGP4
ADDRLP4 32
ADDRGP4 trap_CM_TransformedPointContents
CALLI4
ASGNI4
ADDRLP4 16
ADDRLP4 16
INDIRI4
ADDRLP4 32
INDIRI4
BORI4
ASGNI4
line 286
;286:	}
LABELV $206
line 267
ADDRLP4 4
ADDRLP4 4
INDIRI4
CNSTI4 1
ADDI4
ASGNI4
LABELV $208
ADDRLP4 4
INDIRI4
ADDRGP4 cg_numSolidEntities
INDIRI4
LTI4 $205
line 288
;287:
;288:	return contents;
ADDRLP4 16
INDIRI4
RETI4
LABELV $204
endproc CG_PointContents 36 16
proc CG_InterpolatePlayerState 60 12
line 300
;289:}
;290:
;291:
;292:/*
;293:========================
;294:CG_InterpolatePlayerState
;295:
;296:Generates cg.predictedPlayerState by interpolating between
;297:cg.snap->player_state and cg.nextFrame->player_state
;298:========================
;299:*/
;300:static void CG_InterpolatePlayerState( qboolean grabAngles ) {
line 306
;301:	float			f;
;302:	int				i;
;303:	playerState_t	*out;
;304:	snapshot_t		*prev, *next;
;305:
;306:	out = &cg.predictedPlayerState;
ADDRLP4 12
ADDRGP4 cg+100
ASGNP4
line 307
;307:	prev = cg.snap;
ADDRLP4 4
ADDRGP4 cg+36
INDIRP4
ASGNP4
line 308
;308:	next = cg.nextSnap;
ADDRLP4 8
ADDRGP4 cg+40
INDIRP4
ASGNP4
line 310
;309:
;310:	*out = cg.snap->ps;
ADDRLP4 12
INDIRP4
ADDRGP4 cg+36
INDIRP4
CNSTI4 44
ADDP4
INDIRB
ASGNB 868
line 313
;311:
;312:	// if we are still allowing local input, short circuit the view angles
;313:	if ( grabAngles ) 
ADDRFP4 0
INDIRI4
CNSTI4 0
EQI4 $220
line 314
;314:	{
line 318
;315:		usercmd_t	cmd;
;316:		int			cmdNum;
;317:
;318:		cmdNum = trap_GetCurrentCmdNumber();
ADDRLP4 48
ADDRGP4 trap_GetCurrentCmdNumber
CALLI4
ASGNI4
ADDRLP4 44
ADDRLP4 48
INDIRI4
ASGNI4
line 319
;319:		trap_GetUserCmd( cmdNum, &cmd );
ADDRLP4 44
INDIRI4
ARGI4
ADDRLP4 20
ARGP4
ADDRGP4 trap_GetUserCmd
CALLI4
pop
line 321
;320:
;321:		PM_UpdateViewAngles( out, &cmd );
ADDRLP4 12
INDIRP4
ARGP4
ADDRLP4 20
ARGP4
ADDRGP4 PM_UpdateViewAngles
CALLV
pop
line 322
;322:	}
LABELV $220
line 325
;323:
;324:	// if the next frame is a teleport, we can't lerp to it
;325:	if ( cg.nextFrameTeleport ) {
ADDRGP4 cg+60
INDIRI4
CNSTI4 0
EQI4 $222
line 326
;326:		return;
ADDRGP4 $215
JUMPV
LABELV $222
line 329
;327:	}
;328:
;329:	if ( !next ) 
ADDRLP4 8
INDIRP4
CVPU4 4
CNSTU4 0
NEU4 $225
line 330
;330:	{
line 331
;331:		return;
ADDRGP4 $215
JUMPV
LABELV $225
line 336
;332:	}
;333:
;334:#ifndef _SNAPSHOT_EXTRAPOLATION
;335:
;336:	if ( next->serverTime <= prev->serverTime )
ADDRLP4 20
CNSTI4 8
ASGNI4
ADDRLP4 8
INDIRP4
ADDRLP4 20
INDIRI4
ADDP4
INDIRI4
ADDRLP4 4
INDIRP4
ADDRLP4 20
INDIRI4
ADDP4
INDIRI4
GTI4 $227
line 337
;337:	{
line 338
;338:		return;
ADDRGP4 $215
JUMPV
LABELV $227
line 343
;339:	}
;340:
;341:#endif
;342:
;343:	f = (float)( cg.time - prev->serverTime ) / (float)( next->serverTime - prev->serverTime );
ADDRLP4 24
CNSTI4 8
ASGNI4
ADDRLP4 28
ADDRLP4 4
INDIRP4
ADDRLP4 24
INDIRI4
ADDP4
INDIRI4
ASGNI4
ADDRLP4 16
ADDRGP4 cg+68
INDIRI4
ADDRLP4 28
INDIRI4
SUBI4
CVIF4 4
ADDRLP4 8
INDIRP4
ADDRLP4 24
INDIRI4
ADDP4
INDIRI4
ADDRLP4 28
INDIRI4
SUBI4
CVIF4 4
DIVF4
ASGNF4
line 345
;344:
;345:	i = next->ps.bobCycle;
ADDRLP4 0
ADDRLP4 8
INDIRP4
CNSTI4 52
ADDP4
INDIRI4
ASGNI4
line 346
;346:	if ( i < prev->ps.bobCycle ) {
ADDRLP4 0
INDIRI4
ADDRLP4 4
INDIRP4
CNSTI4 52
ADDP4
INDIRI4
GEI4 $230
line 347
;347:		i += 256;		// handle wraparound
ADDRLP4 0
ADDRLP4 0
INDIRI4
CNSTI4 256
ADDI4
ASGNI4
line 348
;348:	}
LABELV $230
line 349
;349:	out->bobCycle = prev->ps.bobCycle + f * ( i - prev->ps.bobCycle );
ADDRLP4 32
ADDRLP4 4
INDIRP4
CNSTI4 52
ADDP4
INDIRI4
ASGNI4
ADDRLP4 12
INDIRP4
CNSTI4 8
ADDP4
ADDRLP4 32
INDIRI4
CVIF4 4
ADDRLP4 16
INDIRF4
ADDRLP4 0
INDIRI4
ADDRLP4 32
INDIRI4
SUBI4
CVIF4 4
MULF4
ADDF4
CVFI4 4
ASGNI4
line 351
;350:
;351:	for ( i = 0 ; i < 3 ; i++ ) {
ADDRLP4 0
CNSTI4 0
ASGNI4
LABELV $232
line 352
;352:		out->origin[i] = prev->ps.origin[i] + f * (next->ps.origin[i] - prev->ps.origin[i] );
ADDRLP4 36
ADDRLP4 0
INDIRI4
CNSTI4 2
LSHI4
ASGNI4
ADDRLP4 40
CNSTI4 68
ASGNI4
ADDRLP4 44
ADDRLP4 36
INDIRI4
ADDRLP4 4
INDIRP4
ADDRLP4 40
INDIRI4
ADDP4
ADDP4
INDIRF4
ASGNF4
ADDRLP4 36
INDIRI4
ADDRLP4 12
INDIRP4
CNSTI4 24
ADDP4
ADDP4
ADDRLP4 44
INDIRF4
ADDRLP4 16
INDIRF4
ADDRLP4 36
INDIRI4
ADDRLP4 8
INDIRP4
ADDRLP4 40
INDIRI4
ADDP4
ADDP4
INDIRF4
ADDRLP4 44
INDIRF4
SUBF4
MULF4
ADDF4
ASGNF4
line 353
;353:		if ( !grabAngles ) {
ADDRFP4 0
INDIRI4
CNSTI4 0
NEI4 $236
line 354
;354:			out->viewangles[i] = LerpAngle( 
ADDRLP4 48
ADDRLP4 0
INDIRI4
CNSTI4 2
LSHI4
ASGNI4
ADDRLP4 52
CNSTI4 224
ASGNI4
ADDRLP4 48
INDIRI4
ADDRLP4 4
INDIRP4
ADDRLP4 52
INDIRI4
ADDP4
ADDP4
INDIRF4
ARGF4
ADDRLP4 48
INDIRI4
ADDRLP4 8
INDIRP4
ADDRLP4 52
INDIRI4
ADDP4
ADDP4
INDIRF4
ARGF4
ADDRLP4 16
INDIRF4
ARGF4
ADDRLP4 56
ADDRGP4 LerpAngle
CALLF4
ASGNF4
ADDRLP4 48
INDIRI4
ADDRLP4 12
INDIRP4
CNSTI4 180
ADDP4
ADDP4
ADDRLP4 56
INDIRF4
ASGNF4
line 356
;355:				prev->ps.viewangles[i], next->ps.viewangles[i], f );
;356:		}
LABELV $236
line 357
;357:		out->velocity[i] = prev->ps.velocity[i] + 
ADDRLP4 48
ADDRLP4 0
INDIRI4
CNSTI4 2
LSHI4
ASGNI4
ADDRLP4 52
CNSTI4 80
ASGNI4
ADDRLP4 56
ADDRLP4 48
INDIRI4
ADDRLP4 4
INDIRP4
ADDRLP4 52
INDIRI4
ADDP4
ADDP4
INDIRF4
ASGNF4
ADDRLP4 48
INDIRI4
ADDRLP4 12
INDIRP4
CNSTI4 36
ADDP4
ADDP4
ADDRLP4 56
INDIRF4
ADDRLP4 16
INDIRF4
ADDRLP4 48
INDIRI4
ADDRLP4 8
INDIRP4
ADDRLP4 52
INDIRI4
ADDP4
ADDP4
INDIRF4
ADDRLP4 56
INDIRF4
SUBF4
MULF4
ADDF4
ASGNF4
line 359
;358:			f * (next->ps.velocity[i] - prev->ps.velocity[i] );
;359:	}
LABELV $233
line 351
ADDRLP4 0
ADDRLP4 0
INDIRI4
CNSTI4 1
ADDI4
ASGNI4
ADDRLP4 0
INDIRI4
CNSTI4 3
LTI4 $232
line 361
;360:
;361:}
LABELV $215
endproc CG_InterpolatePlayerState 60 12
proc CG_TouchItem 36 12
line 369
;362:
;363:/*
;364:===================
;365:CG_TouchItem
;366:===================
;367:*/
;368:static void CG_TouchItem( centity_t *cent ) 
;369:{
line 371
;370:	gitem_t		*item;
;371:	qboolean	autoswitch = qfalse;
ADDRLP4 4
CNSTI4 0
ASGNI4
line 374
;372:	int			eventID;
;373:
;374:	if ( !cg_predictItems.integer ) 
ADDRGP4 cg_predictItems+12
INDIRI4
CNSTI4 0
NEI4 $239
line 375
;375:	{
line 376
;376:		return;
ADDRGP4 $238
JUMPV
LABELV $239
line 379
;377:	}
;378:
;379:	if ( !BG_PlayerTouchesItem( &cg.predictedPlayerState, &cent->currentState, cg.time ) )
ADDRGP4 cg+100
ARGP4
ADDRFP4 0
INDIRP4
ARGP4
ADDRGP4 cg+68
INDIRI4
ARGI4
ADDRLP4 12
ADDRGP4 BG_PlayerTouchesItem
CALLI4
ASGNI4
ADDRLP4 12
INDIRI4
CNSTI4 0
NEI4 $242
line 380
;380:	{
line 381
;381:		return;
ADDRGP4 $238
JUMPV
LABELV $242
line 385
;382:	}
;383:
;384:	// never pick an item up twice in a prediction
;385:	if ( cent->miscTime == cg.time ) 
ADDRFP4 0
INDIRP4
CNSTI4 464
ADDP4
INDIRI4
ADDRGP4 cg+68
INDIRI4
NEI4 $246
line 386
;386:	{
line 387
;387:		return;
ADDRGP4 $238
JUMPV
LABELV $246
line 390
;388:	}
;389:
;390:	if ( !BG_CanItemBeGrabbed( cgs.gametype, &cent->currentState, &cg.predictedPlayerState ) ) 
ADDRGP4 cgs+33016
INDIRI4
ARGI4
ADDRFP4 0
INDIRP4
ARGP4
ADDRGP4 cg+100
ARGP4
ADDRLP4 16
ADDRGP4 BG_CanItemBeGrabbed
CALLI4
ASGNI4
ADDRLP4 16
INDIRI4
CNSTI4 0
NEI4 $249
line 391
;391:	{
line 393
;392:		// can't hold it
;393:		return;		
ADDRGP4 $238
JUMPV
LABELV $249
line 396
;394:	}
;395:
;396:	item = &bg_itemlist[ cent->currentState.modelindex ];
ADDRLP4 0
ADDRFP4 0
INDIRP4
CNSTI4 160
ADDP4
INDIRI4
CNSTI4 6
LSHI4
ADDRGP4 bg_itemlist
ADDP4
ASGNP4
line 399
;397:
;398:	// No item prediction on gametype items
;399:	if ( item->giType == IT_GAMETYPE || item->giType == IT_BACKPACK )
ADDRLP4 20
ADDRLP4 0
INDIRP4
CNSTI4 44
ADDP4
INDIRI4
ASGNI4
ADDRLP4 20
INDIRI4
CNSTI4 5
EQI4 $255
ADDRLP4 20
INDIRI4
CNSTI4 6
NEI4 $253
LABELV $255
line 400
;400:	{
line 401
;401:		return;
ADDRGP4 $238
JUMPV
LABELV $253
line 405
;402:	}
;403:
;404:	// See if we should autoswitch
;405:	if ( bg_itemlist[cent->currentState.modelindex].giType == IT_WEAPON )
ADDRFP4 0
INDIRP4
CNSTI4 160
ADDP4
INDIRI4
CNSTI4 6
LSHI4
ADDRGP4 bg_itemlist+44
ADDP4
INDIRI4
CNSTI4 1
NEI4 $256
line 406
;406:	{
line 408
;407:		// Dont autoswitch if the weapon isnt a safe weapon
;408:		if ( cg_autoswitch.integer == 1 || weaponData[bg_itemlist[cent->currentState.modelindex].giTag].safe )
ADDRGP4 cg_autoswitch+12
INDIRI4
CNSTI4 1
EQI4 $264
CNSTI4 1828
ADDRFP4 0
INDIRP4
CNSTI4 160
ADDP4
INDIRI4
CNSTI4 6
LSHI4
ADDRGP4 bg_itemlist+48
ADDP4
INDIRI4
MULI4
ADDRGP4 weaponData+8
ADDP4
INDIRI4
CNSTI4 0
EQI4 $259
LABELV $264
line 409
;409:		{
line 410
;410:			if ( !(cg.predictedPlayerState.stats[STAT_WEAPONS] & (1<<bg_itemlist[cent->currentState.modelindex].giTag)) )			
ADDRGP4 cg+100+220+4
INDIRI4
CNSTI4 1
ADDRFP4 0
INDIRP4
CNSTI4 160
ADDP4
INDIRI4
CNSTI4 6
LSHI4
ADDRGP4 bg_itemlist+48
ADDP4
INDIRI4
LSHI4
BANDI4
CNSTI4 0
NEI4 $265
line 411
;411:			{
line 412
;412:				autoswitch = qtrue;
ADDRLP4 4
CNSTI4 1
ASGNI4
line 413
;413:			}
LABELV $265
line 414
;414:		}
LABELV $259
line 415
;415:	}
LABELV $256
line 417
;416:
;417:	if ( cg.predictedPlayerState.pm_flags & PMF_DUCKED )
ADDRGP4 cg+100+12
INDIRI4
CNSTI4 1
BANDI4
CNSTI4 0
EQI4 $271
line 418
;418:	{
line 419
;419:		eventID = EV_ITEM_PICKUP_QUIET;
ADDRLP4 8
CNSTI4 17
ASGNI4
line 420
;420:	}
ADDRGP4 $272
JUMPV
LABELV $271
line 422
;421:	else
;422:	{
line 423
;423:		eventID = EV_ITEM_PICKUP;
ADDRLP4 8
CNSTI4 16
ASGNI4
line 424
;424:	}
LABELV $272
line 427
;425:
;426:	// grab it
;427:	BG_AddPredictableEventToPlayerstate( eventID, cent->currentState.modelindex|(autoswitch?ITEM_AUTOSWITCHBIT:0) , &cg.predictedPlayerState);
ADDRLP4 8
INDIRI4
ARGI4
ADDRLP4 4
INDIRI4
CNSTI4 0
EQI4 $277
ADDRLP4 24
CNSTI4 -2147483648
ASGNI4
ADDRGP4 $278
JUMPV
LABELV $277
ADDRLP4 24
CNSTI4 0
ASGNI4
LABELV $278
ADDRFP4 0
INDIRP4
CNSTI4 160
ADDP4
INDIRI4
ADDRLP4 24
INDIRI4
BORI4
ARGI4
ADDRGP4 cg+100
ARGP4
ADDRGP4 BG_AddPredictableEventToPlayerstate
CALLV
pop
line 430
;428:
;429:	// remove it from the frame so it won't be drawn
;430:	cent->currentState.eFlags |= EF_NODRAW;
ADDRLP4 28
ADDRFP4 0
INDIRP4
CNSTI4 8
ADDP4
ASGNP4
ADDRLP4 28
INDIRP4
ADDRLP4 28
INDIRP4
INDIRI4
CNSTI4 64
BORI4
ASGNI4
line 433
;431:
;432:	// don't touch it again this prediction
;433:	cent->miscTime = cg.time;
ADDRFP4 0
INDIRP4
CNSTI4 464
ADDP4
ADDRGP4 cg+68
INDIRI4
ASGNI4
line 436
;434:
;435:	// if its a weapon, give them some predicted ammo so the autoswitch will work
;436:	if ( item->giType == IT_WEAPON ) 
ADDRLP4 0
INDIRP4
CNSTI4 44
ADDP4
INDIRI4
CNSTI4 1
NEI4 $280
line 437
;437:	{
line 438
;438:		cg.predictedPlayerState.stats[ STAT_WEAPONS ] |= 1 << item->giTag;
ADDRLP4 32
ADDRGP4 cg+100+220+4
ASGNP4
ADDRLP4 32
INDIRP4
ADDRLP4 32
INDIRP4
INDIRI4
CNSTI4 1
ADDRLP4 0
INDIRP4
CNSTI4 48
ADDP4
INDIRI4
LSHI4
BORI4
ASGNI4
line 439
;439:		if ( !cg.predictedPlayerState.ammo[ item->giTag ] ) 
ADDRLP4 0
INDIRP4
CNSTI4 48
ADDP4
INDIRI4
CNSTI4 2
LSHI4
ADDRGP4 cg+100+348
ADDP4
INDIRI4
CNSTI4 0
NEI4 $285
line 440
;440:		{
line 441
;441:			cg.predictedPlayerState.ammo[ item->giTag ] = 1;
ADDRLP4 0
INDIRP4
CNSTI4 48
ADDP4
INDIRI4
CNSTI4 2
LSHI4
ADDRGP4 cg+100+348
ADDP4
CNSTI4 1
ASGNI4
line 442
;442:		}
LABELV $285
line 443
;443:	}
LABELV $280
line 444
;444:}
LABELV $238
endproc CG_TouchItem 36 12
proc CG_TouchTriggerPrediction 88 28
line 454
;445:
;446:
;447:/*
;448:=========================
;449:CG_TouchTriggerPrediction
;450:
;451:Predict push triggers and items
;452:=========================
;453:*/
;454:static void CG_TouchTriggerPrediction( void ) {
line 463
;455:	int			i;
;456:	trace_t		trace;
;457:	entityState_t	*ent;
;458:	clipHandle_t cmodel;
;459:	centity_t	*cent;
;460:	qboolean	spectator;
;461:
;462:	// dead clients don't activate triggers
;463:	if ( cg.predictedPlayerState.stats[STAT_HEALTH] <= 0 ) {
ADDRGP4 cg+100+220
INDIRI4
CNSTI4 0
GTI4 $292
line 464
;464:		return;
ADDRGP4 $291
JUMPV
LABELV $292
line 467
;465:	}
;466:
;467:	spectator = ( cg.predictedPlayerState.pm_type == PM_SPECTATOR );
ADDRGP4 cg+100+4
INDIRI4
CNSTI4 2
NEI4 $299
ADDRLP4 76
CNSTI4 1
ASGNI4
ADDRGP4 $300
JUMPV
LABELV $299
ADDRLP4 76
CNSTI4 0
ASGNI4
LABELV $300
ADDRLP4 72
ADDRLP4 76
INDIRI4
ASGNI4
line 469
;468:
;469:	if ( cg.predictedPlayerState.pm_type != PM_NORMAL && !spectator ) {
ADDRLP4 80
CNSTI4 0
ASGNI4
ADDRGP4 cg+100+4
INDIRI4
ADDRLP4 80
INDIRI4
EQI4 $301
ADDRLP4 72
INDIRI4
ADDRLP4 80
INDIRI4
NEI4 $301
line 470
;470:		return;
ADDRGP4 $291
JUMPV
LABELV $301
line 473
;471:	}
;472:
;473:	for ( i = 0 ; i < cg_numTriggerEntities ; i++ ) {
ADDRLP4 4
CNSTI4 0
ASGNI4
ADDRGP4 $308
JUMPV
LABELV $305
line 474
;474:		cent = cg_triggerEntities[ i ];
ADDRLP4 12
ADDRLP4 4
INDIRI4
CNSTI4 2
LSHI4
ADDRGP4 cg_triggerEntities
ADDP4
INDIRP4
ASGNP4
line 475
;475:		ent = &cent->currentState;
ADDRLP4 0
ADDRLP4 12
INDIRP4
ASGNP4
line 477
;476:
;477:		if ( ent->eType == ET_ITEM && !spectator ) {
ADDRLP4 0
INDIRP4
CNSTI4 4
ADDP4
INDIRI4
CNSTI4 2
NEI4 $309
ADDRLP4 72
INDIRI4
CNSTI4 0
NEI4 $309
line 478
;478:			CG_TouchItem( cent );
ADDRLP4 12
INDIRP4
ARGP4
ADDRGP4 CG_TouchItem
CALLV
pop
line 479
;479:			continue;
ADDRGP4 $306
JUMPV
LABELV $309
line 482
;480:		}
;481:
;482:		if ( ent->solid != SOLID_BMODEL ) {
ADDRLP4 0
INDIRP4
CNSTI4 176
ADDP4
INDIRI4
CNSTI4 16777215
EQI4 $311
line 483
;483:			continue;
ADDRGP4 $306
JUMPV
LABELV $311
line 486
;484:		}
;485:
;486:		cmodel = trap_CM_InlineModel( ent->modelindex );
ADDRLP4 0
INDIRP4
CNSTI4 160
ADDP4
INDIRI4
ARGI4
ADDRLP4 84
ADDRGP4 trap_CM_InlineModel
CALLI4
ASGNI4
ADDRLP4 8
ADDRLP4 84
INDIRI4
ASGNI4
line 487
;487:		if ( !cmodel ) {
ADDRLP4 8
INDIRI4
CNSTI4 0
NEI4 $313
line 488
;488:			continue;
ADDRGP4 $306
JUMPV
LABELV $313
line 491
;489:		}
;490:
;491:		trap_CM_BoxTrace( &trace, cg.predictedPlayerState.origin, cg.predictedPlayerState.origin, 
ADDRLP4 16
ARGP4
ADDRGP4 cg+100+24
ARGP4
ADDRGP4 cg+100+24
ARGP4
ADDRGP4 cg_pmove+184
ARGP4
ADDRGP4 cg_pmove+196
ARGP4
ADDRLP4 8
INDIRI4
ARGI4
CNSTI4 -1
ARGI4
ADDRGP4 trap_CM_BoxTrace
CALLV
pop
line 494
;492:			cg_pmove.mins, cg_pmove.maxs, cmodel, -1 );
;493:
;494:		if ( !trace.startsolid ) {
ADDRLP4 16+4
INDIRI4
CNSTI4 0
NEI4 $321
line 495
;495:			continue;
ADDRGP4 $306
JUMPV
LABELV $321
line 498
;496:		}
;497:
;498:		if ( ent->eType == ET_TELEPORT_TRIGGER ) 
ADDRLP4 0
INDIRP4
CNSTI4 4
ADDP4
INDIRI4
CNSTI4 9
NEI4 $324
line 499
;499:		{
line 500
;500:			cg.hyperspace = qtrue;
ADDRGP4 cg+96
CNSTI4 1
ASGNI4
line 501
;501:		}
LABELV $324
line 502
;502:	}
LABELV $306
line 473
ADDRLP4 4
ADDRLP4 4
INDIRI4
CNSTI4 1
ADDI4
ASGNI4
LABELV $308
ADDRLP4 4
INDIRI4
ADDRGP4 cg_numTriggerEntities
INDIRI4
LTI4 $305
line 503
;503:}
LABELV $291
endproc CG_TouchTriggerPrediction 88 28
export CG_PredictPlayerState
proc CG_PredictPlayerState 992 20
line 534
;504:
;505:
;506:
;507:/*
;508:=================
;509:CG_PredictPlayerState
;510:
;511:Generates cg.predictedPlayerState for the current cg.time
;512:cg.predictedPlayerState is guaranteed to be valid after exiting.
;513:
;514:For demo playback, this will be an interpolation between two valid
;515:playerState_t.
;516:
;517:For normal gameplay, it will be the result of predicted usercmd_t on
;518:top of the most recent playerState_t received from the server.
;519:
;520:Each new snapshot will usually have one or more new usercmd over the last,
;521:but we simulate all unacknowledged commands each time, not just the new ones.
;522:This means that on an internet connection, quite a few pmoves may be issued
;523:each frame.
;524:
;525:OPTIMIZE: don't re-simulate unless the newly arrived snapshot playerState_t
;526:differs from the predicted one.  Would require saving all intermediate
;527:playerState_t during prediction.
;528:
;529:We detect prediction errors and allow them to be decayed off over several frames
;530:to ease the jerk.
;531:=================
;532:*/
;533:void CG_PredictPlayerState( void ) 
;534:{
line 543
;535:	int				cmdNum;
;536:	int				current;
;537:	playerState_t	oldPlayerState;
;538:	qboolean		moved;
;539:	usercmd_t		oldestCmd;
;540:	usercmd_t		latestCmd;
;541:
;542:	// will be set if touching a trigger_teleport
;543:	cg.hyperspace = qfalse;	
ADDRGP4 cg+96
CNSTI4 0
ASGNI4
line 548
;544:
;545:	// if this is the first frame we must guarantee
;546:	// predictedPlayerState is valid even if there is some
;547:	// other error condition
;548:	if ( !cg.validPPS ) 
ADDRGP4 cg+968
INDIRI4
CNSTI4 0
NEI4 $329
line 549
;549:	{
line 550
;550:		cg.validPPS = qtrue;
ADDRGP4 cg+968
CNSTI4 1
ASGNI4
line 551
;551:		cg.predictedPlayerState = cg.snap->ps;
ADDRGP4 cg+100
ADDRGP4 cg+36
INDIRP4
CNSTI4 44
ADDP4
INDIRB
ASGNB 868
line 552
;552:	}
LABELV $329
line 555
;553:
;554:	// demo playback just copies the moves
;555:	if ( cg.demoPlayback || (cg.snap->ps.pm_flags & PMF_FOLLOW) ) 
ADDRLP4 928
CNSTI4 0
ASGNI4
ADDRGP4 cg+8
INDIRI4
ADDRLP4 928
INDIRI4
NEI4 $339
ADDRGP4 cg+36
INDIRP4
CNSTI4 56
ADDP4
INDIRI4
CNSTI4 512
BANDI4
ADDRLP4 928
INDIRI4
EQI4 $335
LABELV $339
line 556
;556:	{
line 557
;557:		CG_InterpolatePlayerState( qfalse );
CNSTI4 0
ARGI4
ADDRGP4 CG_InterpolatePlayerState
CALLV
pop
line 558
;558:		return;
ADDRGP4 $327
JUMPV
LABELV $335
line 562
;559:	}
;560:
;561:	// non-predicting local movement will grab the latest angles
;562:	if ( cg_nopredict.integer || cg_synchronousClients.integer ) 
ADDRLP4 932
CNSTI4 0
ASGNI4
ADDRGP4 cg_nopredict+12
INDIRI4
ADDRLP4 932
INDIRI4
NEI4 $344
ADDRGP4 cg_synchronousClients+12
INDIRI4
ADDRLP4 932
INDIRI4
EQI4 $340
LABELV $344
line 563
;563:	{
line 564
;564:		CG_InterpolatePlayerState( qtrue );
CNSTI4 1
ARGI4
ADDRGP4 CG_InterpolatePlayerState
CALLV
pop
line 565
;565:		return;
ADDRGP4 $327
JUMPV
LABELV $340
line 572
;566:	}
;567:
;568:	// prepare for pmove
;569:#if _Debug
;570:	cg_pmove.isClient=-1;
;571:#endif
;572:	cg_pmove.ps = &cg.predictedPlayerState;
ADDRGP4 cg_pmove
ADDRGP4 cg+100
ASGNP4
line 573
;573:	cg_pmove.trace = CG_Trace;
ADDRGP4 cg_pmove+232
ADDRGP4 CG_Trace
ASGNP4
line 574
;574:	cg_pmove.pointcontents = CG_PointContents;
ADDRGP4 cg_pmove+236
ADDRGP4 CG_PointContents
ASGNP4
line 575
;575:	if ( cg_pmove.ps->pm_type == PM_DEAD ) 
ADDRGP4 cg_pmove
INDIRP4
CNSTI4 4
ADDP4
INDIRI4
CNSTI4 3
NEI4 $348
line 576
;576:	{
line 577
;577:		cg_pmove.tracemask = MASK_PLAYERSOLID & ~CONTENTS_BODY;
ADDRGP4 cg_pmove+28
CNSTI4 4241
ASGNI4
line 578
;578:	}
ADDRGP4 $349
JUMPV
LABELV $348
line 580
;579:	else 
;580:	{
line 581
;581:		cg_pmove.tracemask = MASK_PLAYERSOLID;
ADDRGP4 cg_pmove+28
CNSTI4 4497
ASGNI4
line 582
;582:	}
LABELV $349
line 583
;583:	if ( cg.snap->ps.persistant[PERS_TEAM] == TEAM_SPECTATOR ) 
ADDRGP4 cg+36
INDIRP4
CNSTI4 336
ADDP4
INDIRI4
CNSTI4 3
NEI4 $352
line 584
;584:	{
line 585
;585:		cg_pmove.tracemask &= ~CONTENTS_BODY;	// spectators can fly through bodies
ADDRLP4 936
ADDRGP4 cg_pmove+28
ASGNP4
ADDRLP4 936
INDIRP4
ADDRLP4 936
INDIRP4
INDIRI4
CNSTI4 -257
BANDI4
ASGNI4
line 586
;586:	}
LABELV $352
line 587
;587:	cg_pmove.noFootsteps = ( cgs.dmflags & DF_NO_FOOTSTEPS ) > 0;
ADDRGP4 cgs+33024
INDIRI4
CNSTI4 32
BANDI4
CNSTI4 0
LEI4 $359
ADDRLP4 936
CNSTI4 1
ASGNI4
ADDRGP4 $360
JUMPV
LABELV $359
ADDRLP4 936
CNSTI4 0
ASGNI4
LABELV $360
ADDRGP4 cg_pmove+36
ADDRLP4 936
INDIRI4
ASGNI4
line 590
;588:
;589:	// save the state before the pmove so we can detect transitions
;590:	oldPlayerState = cg.predictedPlayerState;
ADDRLP4 4
ADDRGP4 cg+100
INDIRB
ASGNB 868
line 592
;591:
;592:	current = trap_GetCurrentCmdNumber();
ADDRLP4 940
ADDRGP4 trap_GetCurrentCmdNumber
CALLI4
ASGNI4
ADDRLP4 872
ADDRLP4 940
INDIRI4
ASGNI4
line 597
;593:
;594:	// if we don't have the commands right after the snapshot, we
;595:	// can't accurately predict a current position, so just freeze at
;596:	// the last good position we had
;597:	cmdNum = current - CMD_BACKUP + 1;
ADDRLP4 0
ADDRLP4 872
INDIRI4
CNSTI4 64
SUBI4
CNSTI4 1
ADDI4
ASGNI4
line 598
;598:	trap_GetUserCmd( cmdNum, &oldestCmd );
ADDRLP4 0
INDIRI4
ARGI4
ADDRLP4 904
ARGP4
ADDRGP4 trap_GetUserCmd
CALLI4
pop
line 599
;599:	if ( oldestCmd.serverTime > cg.snap->ps.commandTime && oldestCmd.serverTime < cg.time ) 
ADDRLP4 944
ADDRLP4 904
INDIRI4
ASGNI4
ADDRLP4 944
INDIRI4
ADDRGP4 cg+36
INDIRP4
CNSTI4 44
ADDP4
INDIRI4
LEI4 $362
ADDRLP4 944
INDIRI4
ADDRGP4 cg+68
INDIRI4
GEI4 $362
line 600
;600:	{	
line 602
;601:		// special check for map_restart
;602:		if ( cg_showmiss.integer ) 
ADDRGP4 cg_showmiss+12
INDIRI4
CNSTI4 0
EQI4 $327
line 603
;603:		{
line 604
;604:			Com_Printf ("exceeded PACKET_BACKUP on commands\n");
ADDRGP4 $369
ARGP4
ADDRGP4 Com_Printf
CALLV
pop
line 605
;605:		}
line 606
;606:		return;
ADDRGP4 $327
JUMPV
LABELV $362
line 610
;607:	}
;608:
;609:	// get the latest command so we can know which commands are from previous map_restarts
;610:	trap_GetUserCmd( current, &latestCmd );
ADDRLP4 872
INDIRI4
ARGI4
ADDRLP4 880
ARGP4
ADDRGP4 trap_GetUserCmd
CALLI4
pop
line 616
;611:
;612:	// get the most recent information we have, even if
;613:	// the server time is beyond our current cg.time,
;614:	// because predicted player positions are going to 
;615:	// be ahead of everything else anyway
;616:	if ( cg.nextSnap && !cg.nextFrameTeleport && !cg.thisFrameTeleport ) 
ADDRGP4 cg+40
INDIRP4
CVPU4 4
CNSTU4 0
EQU4 $370
ADDRLP4 948
CNSTI4 0
ASGNI4
ADDRGP4 cg+60
INDIRI4
ADDRLP4 948
INDIRI4
NEI4 $370
ADDRGP4 cg+56
INDIRI4
ADDRLP4 948
INDIRI4
NEI4 $370
line 617
;617:	{
line 618
;618:		cg.predictedPlayerState = cg.nextSnap->ps;
ADDRGP4 cg+100
ADDRGP4 cg+40
INDIRP4
CNSTI4 44
ADDP4
INDIRB
ASGNB 868
line 619
;619:		cg.physicsTime = cg.nextSnap->serverTime;
ADDRGP4 cg+76
ADDRGP4 cg+40
INDIRP4
CNSTI4 8
ADDP4
INDIRI4
ASGNI4
line 620
;620:	} 
ADDRGP4 $371
JUMPV
LABELV $370
line 622
;621:	else 
;622:	{
line 623
;623:		cg.predictedPlayerState = cg.snap->ps;
ADDRGP4 cg+100
ADDRGP4 cg+36
INDIRP4
CNSTI4 44
ADDP4
INDIRB
ASGNB 868
line 624
;624:		cg.physicsTime = cg.snap->serverTime;
ADDRGP4 cg+76
ADDRGP4 cg+36
INDIRP4
CNSTI4 8
ADDP4
INDIRI4
ASGNI4
line 625
;625:	}
LABELV $371
line 627
;626:
;627:	if ( pmove_msec.integer < 8 ) 
ADDRGP4 pmove_msec+12
INDIRI4
CNSTI4 8
GEI4 $383
line 628
;628:	{
line 629
;629:		trap_Cvar_Set("pmove_msec", "8");
ADDRGP4 $386
ARGP4
ADDRGP4 $387
ARGP4
ADDRGP4 trap_Cvar_Set
CALLV
pop
line 630
;630:	}
ADDRGP4 $384
JUMPV
LABELV $383
line 631
;631:	else if (pmove_msec.integer > 33) 
ADDRGP4 pmove_msec+12
INDIRI4
CNSTI4 33
LEI4 $388
line 632
;632:	{
line 633
;633:		trap_Cvar_Set("pmove_msec", "33");
ADDRGP4 $386
ARGP4
ADDRGP4 $391
ARGP4
ADDRGP4 trap_Cvar_Set
CALLV
pop
line 634
;634:	}
LABELV $388
LABELV $384
line 636
;635:
;636:	cg_pmove.pmove_fixed = pmove_fixed.integer;// | cg_pmove_fixed.integer;
ADDRGP4 cg_pmove+224
ADDRGP4 pmove_fixed+12
INDIRI4
ASGNI4
line 637
;637:	cg_pmove.pmove_msec = pmove_msec.integer;
ADDRGP4 cg_pmove+228
ADDRGP4 pmove_msec+12
INDIRI4
ASGNI4
line 640
;638:
;639:	// run cmds
;640:	moved = qfalse;
ADDRLP4 876
CNSTI4 0
ASGNI4
line 641
;641:	for ( cmdNum = current - CMD_BACKUP + 1 ; cmdNum <= current ; cmdNum++ ) 
ADDRLP4 0
ADDRLP4 872
INDIRI4
CNSTI4 64
SUBI4
CNSTI4 1
ADDI4
ASGNI4
ADDRGP4 $399
JUMPV
LABELV $396
line 642
;642:	{
line 644
;643:		// get the command
;644:		trap_GetUserCmd( cmdNum, &cg_pmove.cmd );
ADDRLP4 0
INDIRI4
ARGI4
ADDRGP4 cg_pmove+4
ARGP4
ADDRGP4 trap_GetUserCmd
CALLI4
pop
line 646
;645:
;646:		if ( cg_pmove.pmove_fixed ) 
ADDRGP4 cg_pmove+224
INDIRI4
CNSTI4 0
EQI4 $401
line 647
;647:		{
line 648
;648:			PM_UpdateViewAngles( cg_pmove.ps, &cg_pmove.cmd );
ADDRGP4 cg_pmove
INDIRP4
ARGP4
ADDRGP4 cg_pmove+4
ARGP4
ADDRGP4 PM_UpdateViewAngles
CALLV
pop
line 649
;649:		}
LABELV $401
line 652
;650:
;651:		// don't do anything if the time is before the snapshot player time
;652:		if ( cg_pmove.cmd.serverTime <= cg.predictedPlayerState.commandTime ) 
ADDRGP4 cg_pmove+4
INDIRI4
ADDRGP4 cg+100
INDIRI4
GTI4 $405
line 653
;653:		{
line 654
;654:			continue;
ADDRGP4 $397
JUMPV
LABELV $405
line 658
;655:		}
;656:
;657:		// don't do anything if the command was from a previous map_restart
;658:		if ( cg_pmove.cmd.serverTime > latestCmd.serverTime ) 
ADDRGP4 cg_pmove+4
INDIRI4
ADDRLP4 880
INDIRI4
LEI4 $409
line 659
;659:		{
line 660
;660:			continue;
ADDRGP4 $397
JUMPV
LABELV $409
line 668
;661:		}
;662:
;663:		// check for a prediction error from last frame
;664:		// on a lan, this will often be the exact value
;665:		// from the snapshot, but on a wan we will have
;666:		// to predict several commands to get to the point
;667:		// we want to compare
;668:		if ( cg.predictedPlayerState.commandTime == oldPlayerState.commandTime ) 
ADDRGP4 cg+100
INDIRI4
ADDRLP4 4
INDIRI4
NEI4 $412
line 669
;669:		{
line 673
;670:			vec3_t	delta;
;671:			float	len;
;672:
;673:			if ( cg.thisFrameTeleport ) 
ADDRGP4 cg+56
INDIRI4
CNSTI4 0
EQI4 $415
line 674
;674:			{
line 676
;675:				// a teleport will not cause an error decay
;676:				VectorClear( cg.predictedError );
ADDRLP4 968
CNSTF4 0
ASGNF4
ADDRGP4 cg+976+8
ADDRLP4 968
INDIRF4
ASGNF4
ADDRGP4 cg+976+4
ADDRLP4 968
INDIRF4
ASGNF4
ADDRGP4 cg+976
ADDRLP4 968
INDIRF4
ASGNF4
line 677
;677:				if ( cg_showmiss.integer ) 
ADDRGP4 cg_showmiss+12
INDIRI4
CNSTI4 0
EQI4 $423
line 678
;678:				{
line 679
;679:					Com_Printf( "PredictionTeleport\n" );
ADDRGP4 $426
ARGP4
ADDRGP4 Com_Printf
CALLV
pop
line 680
;680:				}
LABELV $423
line 681
;681:				cg.thisFrameTeleport = qfalse;
ADDRGP4 cg+56
CNSTI4 0
ASGNI4
line 682
;682:			} 
ADDRGP4 $416
JUMPV
LABELV $415
line 684
;683:			else 
;684:			{
line 686
;685:				vec3_t	adjusted;
;686:				CG_AdjustPositionForMover( cg.predictedPlayerState.origin, 
ADDRGP4 cg+100+24
ARGP4
ADDRGP4 cg+100+96
INDIRI4
ARGI4
ADDRGP4 cg+76
INDIRI4
ARGI4
ADDRGP4 cg+72
INDIRI4
ARGI4
ADDRLP4 968
ARGP4
ADDRGP4 CG_AdjustPositionForMover
CALLV
pop
line 689
;687:					cg.predictedPlayerState.groundEntityNum, cg.physicsTime, cg.oldTime, adjusted );
;688:
;689:				if ( cg_showmiss.integer ) 
ADDRGP4 cg_showmiss+12
INDIRI4
CNSTI4 0
EQI4 $434
line 690
;690:				{
line 691
;691:					if (!VectorCompare( oldPlayerState.origin, adjusted )) 
ADDRLP4 4+24
ARGP4
ADDRLP4 968
ARGP4
ADDRLP4 980
ADDRGP4 VectorCompare
CALLI4
ASGNI4
ADDRLP4 980
INDIRI4
CNSTI4 0
NEI4 $437
line 692
;692:					{
line 693
;693:						Com_Printf("prediction error\n");
ADDRGP4 $440
ARGP4
ADDRGP4 Com_Printf
CALLV
pop
line 694
;694:					}
LABELV $437
line 695
;695:				}
LABELV $434
line 697
;696:				
;697:				VectorSubtract( oldPlayerState.origin, adjusted, delta );
ADDRLP4 952
ADDRLP4 4+24
INDIRF4
ADDRLP4 968
INDIRF4
SUBF4
ASGNF4
ADDRLP4 952+4
ADDRLP4 4+24+4
INDIRF4
ADDRLP4 968+4
INDIRF4
SUBF4
ASGNF4
ADDRLP4 952+8
ADDRLP4 4+24+8
INDIRF4
ADDRLP4 968+8
INDIRF4
SUBF4
ASGNF4
line 698
;698:				len = VectorLength( delta );
ADDRLP4 952
ARGP4
ADDRLP4 980
ADDRGP4 VectorLength
CALLF4
ASGNF4
ADDRLP4 964
ADDRLP4 980
INDIRF4
ASGNF4
line 699
;699:				if ( len > 0.1 ) 
ADDRLP4 964
INDIRF4
CNSTF4 1036831949
LEF4 $450
line 700
;700:				{
line 701
;701:					if ( cg_showmiss.integer ) 
ADDRGP4 cg_showmiss+12
INDIRI4
CNSTI4 0
EQI4 $452
line 702
;702:					{
line 703
;703:						Com_Printf("Prediction miss: %f\n", len);
ADDRGP4 $455
ARGP4
ADDRLP4 964
INDIRF4
ARGF4
ADDRGP4 Com_Printf
CALLV
pop
line 704
;704:					}
LABELV $452
line 706
;705:					
;706:					if ( cg_errorDecay.integer ) 
ADDRGP4 cg_errorDecay+12
INDIRI4
CNSTI4 0
EQI4 $456
line 707
;707:					{
line 711
;708:						int		t;
;709:						float	f;
;710:
;711:						t = cg.time - cg.predictedErrorTime;
ADDRLP4 988
ADDRGP4 cg+68
INDIRI4
ADDRGP4 cg+972
INDIRI4
SUBI4
ASGNI4
line 712
;712:						f = ( cg_errorDecay.value - t ) / cg_errorDecay.value;
ADDRLP4 984
ADDRGP4 cg_errorDecay+8
INDIRF4
ADDRLP4 988
INDIRI4
CVIF4 4
SUBF4
ADDRGP4 cg_errorDecay+8
INDIRF4
DIVF4
ASGNF4
line 713
;713:						if ( f < 0 ) 
ADDRLP4 984
INDIRF4
CNSTF4 0
GEF4 $463
line 714
;714:						{
line 715
;715:							f = 0;
ADDRLP4 984
CNSTF4 0
ASGNF4
line 716
;716:						}
LABELV $463
line 717
;717:						if ( f > 0 && cg_showmiss.integer ) 
ADDRLP4 984
INDIRF4
CNSTF4 0
LEF4 $465
ADDRGP4 cg_showmiss+12
INDIRI4
CNSTI4 0
EQI4 $465
line 718
;718:						{
line 719
;719:							Com_Printf("Double prediction decay: %f\n", f);
ADDRGP4 $468
ARGP4
ADDRLP4 984
INDIRF4
ARGF4
ADDRGP4 Com_Printf
CALLV
pop
line 720
;720:						}
LABELV $465
line 721
;721:						VectorScale( cg.predictedError, f, cg.predictedError );
ADDRGP4 cg+976
ADDRGP4 cg+976
INDIRF4
ADDRLP4 984
INDIRF4
MULF4
ASGNF4
ADDRGP4 cg+976+4
ADDRGP4 cg+976+4
INDIRF4
ADDRLP4 984
INDIRF4
MULF4
ASGNF4
ADDRGP4 cg+976+8
ADDRGP4 cg+976+8
INDIRF4
ADDRLP4 984
INDIRF4
MULF4
ASGNF4
line 722
;722:					} 
ADDRGP4 $457
JUMPV
LABELV $456
line 724
;723:					else 
;724:					{
line 725
;725:						VectorClear( cg.predictedError );
ADDRLP4 984
CNSTF4 0
ASGNF4
ADDRGP4 cg+976+8
ADDRLP4 984
INDIRF4
ASGNF4
ADDRGP4 cg+976+4
ADDRLP4 984
INDIRF4
ASGNF4
ADDRGP4 cg+976
ADDRLP4 984
INDIRF4
ASGNF4
line 726
;726:					}
LABELV $457
line 727
;727:					VectorAdd( delta, cg.predictedError, cg.predictedError );
ADDRGP4 cg+976
ADDRLP4 952
INDIRF4
ADDRGP4 cg+976
INDIRF4
ADDF4
ASGNF4
ADDRGP4 cg+976+4
ADDRLP4 952+4
INDIRF4
ADDRGP4 cg+976+4
INDIRF4
ADDF4
ASGNF4
ADDRGP4 cg+976+8
ADDRLP4 952+8
INDIRF4
ADDRGP4 cg+976+8
INDIRF4
ADDF4
ASGNF4
line 728
;728:					cg.predictedErrorTime = cg.oldTime;
ADDRGP4 cg+972
ADDRGP4 cg+72
INDIRI4
ASGNI4
line 729
;729:				}
LABELV $450
line 730
;730:			}
LABELV $416
line 731
;731:		}
LABELV $412
line 735
;732:
;733:		// don't predict gauntlet firing, which is only supposed to happen
;734:		// when it actually inflicts damage
;735:		cg_pmove.gauntletHit = qfalse;
ADDRGP4 cg_pmove+40
CNSTI4 0
ASGNI4
line 737
;736:
;737:		if ( cg_pmove.pmove_fixed ) 
ADDRGP4 cg_pmove+224
INDIRI4
CNSTI4 0
EQI4 $499
line 738
;738:		{
line 739
;739:			cg_pmove.cmd.serverTime = ((cg_pmove.cmd.serverTime + pmove_msec.integer-1) / pmove_msec.integer) * pmove_msec.integer;
ADDRGP4 cg_pmove+4
ADDRGP4 cg_pmove+4
INDIRI4
ADDRGP4 pmove_msec+12
INDIRI4
ADDI4
CNSTI4 1
SUBI4
ADDRGP4 pmove_msec+12
INDIRI4
DIVI4
ADDRGP4 pmove_msec+12
INDIRI4
MULI4
ASGNI4
line 740
;740:		}
LABELV $499
line 742
;741:
;742:		cg_pmove.animations = cgs.clientinfo[cg.clientNum].animations;
ADDRGP4 cg_pmove+216
CNSTI4 3120
ADDRGP4 cg+4
INDIRI4
MULI4
ADDRGP4 cgs+41808+264
ADDP4
ASGNP4
line 744
;743:		
;744:		Pmove (&cg_pmove);
ADDRGP4 cg_pmove
ARGP4
ADDRGP4 Pmove
CALLV
pop
line 746
;745:
;746:		moved = qtrue;
ADDRLP4 876
CNSTI4 1
ASGNI4
line 749
;747:
;748:		// add push trigger movement effects
;749:		CG_TouchTriggerPrediction();
ADDRGP4 CG_TouchTriggerPrediction
CALLV
pop
line 753
;750:
;751:		// check for predictable events that changed from previous predictions
;752:		//CG_CheckChangedPredictableEvents(&cg.predictedPlayerState);
;753:	}
LABELV $397
line 641
ADDRLP4 0
ADDRLP4 0
INDIRI4
CNSTI4 1
ADDI4
ASGNI4
LABELV $399
ADDRLP4 0
INDIRI4
ADDRLP4 872
INDIRI4
LEI4 $396
line 755
;754:
;755:	if ( cg_showmiss.integer > 1 ) 
ADDRGP4 cg_showmiss+12
INDIRI4
CNSTI4 1
LEI4 $511
line 756
;756:	{
line 757
;757:		Com_Printf( "[%i : %i] ", cg_pmove.cmd.serverTime, cg.time );
ADDRGP4 $514
ARGP4
ADDRGP4 cg_pmove+4
INDIRI4
ARGI4
ADDRGP4 cg+68
INDIRI4
ARGI4
ADDRGP4 Com_Printf
CALLV
pop
line 758
;758:	}
LABELV $511
line 760
;759:	
;760:	if ( !moved ) 
ADDRLP4 876
INDIRI4
CNSTI4 0
NEI4 $517
line 761
;761:	{
line 762
;762:		if ( cg_showmiss.integer ) 
ADDRGP4 cg_showmiss+12
INDIRI4
CNSTI4 0
EQI4 $327
line 763
;763:		{
line 764
;764:			Com_Printf( "not moved\n" );
ADDRGP4 $522
ARGP4
ADDRGP4 Com_Printf
CALLV
pop
line 765
;765:		}
line 766
;766:		return;
ADDRGP4 $327
JUMPV
LABELV $517
line 770
;767:	}
;768:
;769:	// adjust for the movement of the groundentity
;770:	CG_AdjustPositionForMover( cg.predictedPlayerState.origin, 
ADDRGP4 cg+100+24
ARGP4
ADDRGP4 cg+100+96
INDIRI4
ARGI4
ADDRGP4 cg+76
INDIRI4
ARGI4
ADDRGP4 cg+68
INDIRI4
ARGI4
ADDRGP4 cg+100+24
ARGP4
ADDRGP4 CG_AdjustPositionForMover
CALLV
pop
line 774
;771:		cg.predictedPlayerState.groundEntityNum, 
;772:		cg.physicsTime, cg.time, cg.predictedPlayerState.origin );
;773:
;774:	if ( cg_showmiss.integer ) 
ADDRGP4 cg_showmiss+12
INDIRI4
CNSTI4 0
EQI4 $531
line 775
;775:	{
line 776
;776:		if (cg.predictedPlayerState.eventSequence > oldPlayerState.eventSequence + MAX_PS_EVENTS) 
ADDRGP4 cg+100+120
INDIRI4
ADDRLP4 4+120
INDIRI4
CNSTI4 4
ADDI4
LEI4 $534
line 777
;777:		{
line 778
;778:			Com_Printf("WARNING: dropped event\n");
ADDRGP4 $539
ARGP4
ADDRGP4 Com_Printf
CALLV
pop
line 779
;779:		}
LABELV $534
line 780
;780:	}
LABELV $531
line 783
;781:
;782:	// fire events and other transition triggered things
;783:	CG_TransitionPlayerState( &cg.predictedPlayerState, &oldPlayerState );
ADDRGP4 cg+100
ARGP4
ADDRLP4 4
ARGP4
ADDRGP4 CG_TransitionPlayerState
CALLV
pop
line 785
;784:
;785:	if ( cg_showmiss.integer ) 
ADDRGP4 cg_showmiss+12
INDIRI4
CNSTI4 0
EQI4 $541
line 786
;786:	{
line 787
;787:		if (cg.eventSequence > cg.predictedPlayerState.eventSequence) 
ADDRGP4 cg+988
INDIRI4
ADDRGP4 cg+100+120
INDIRI4
LEI4 $544
line 788
;788:		{
line 789
;789:			Com_Printf("WARNING: double event\n");
ADDRGP4 $549
ARGP4
ADDRGP4 Com_Printf
CALLV
pop
line 790
;790:			cg.eventSequence = cg.predictedPlayerState.eventSequence;
ADDRGP4 cg+988
ADDRGP4 cg+100+120
INDIRI4
ASGNI4
line 791
;791:		}
LABELV $544
line 792
;792:	}
LABELV $541
line 793
;793:}
LABELV $327
endproc CG_PredictPlayerState 992 20
export CG_InitHitModel
proc CG_InitHitModel 20508 28
line 801
;794:
;795:/*
;796:===============
;797:CG_InitHitModel
;798:===============
;799:*/
;800:void CG_InitHitModel ( void )
;801:{
line 807
;802:	void*		ghoul2;
;803:	char		temp[20480];
;804:	int			numPairs;
;805:	qhandle_t	handle;
;806:
;807:	ghoul2 = NULL;
ADDRLP4 0
CNSTP4 0
ASGNP4
line 810
;808:
;809:	// Initialize the ghoul2 model
;810:	trap_G2API_InitGhoul2Model ( &ghoul2, 
ADDRLP4 0
ARGP4
ADDRGP4 $554
ARGP4
ADDRLP4 20492
CNSTI4 0
ASGNI4
ADDRLP4 20492
INDIRI4
ARGI4
ADDRLP4 20492
INDIRI4
ARGI4
ADDRLP4 20492
INDIRI4
ARGI4
CNSTI4 16
ARGI4
CNSTI4 2
ARGI4
ADDRGP4 trap_G2API_InitGhoul2Model
CALLI4
pop
line 815
;811:								 "models/characters/average_sleeves/average_sleeves.glm", 
;812:								 0, 0, 0, (1<<4), 2 );
;813:
;814:	// Verify it
;815:	if ( !ghoul2 )
ADDRLP4 0
INDIRP4
CVPU4 4
CNSTU4 0
NEU4 $555
line 816
;816:	{
line 817
;817:		return;
ADDRGP4 $553
JUMPV
LABELV $555
line 821
;818:	}
;819:
;820:	//  Parse the skin file that will be used for hit information
;821:	numPairs = BG_ParseSkin ( "models/characters/skins/col_rebel_h1.g2skin", temp, sizeof(temp) );
ADDRGP4 $557
ARGP4
ADDRLP4 4
ARGP4
CNSTI4 20480
ARGI4
ADDRLP4 20496
ADDRGP4 BG_ParseSkin
CALLI4
ASGNI4
ADDRLP4 20484
ADDRLP4 20496
INDIRI4
ASGNI4
line 822
;822:	if ( !numPairs )
ADDRLP4 20484
INDIRI4
CNSTI4 0
NEI4 $558
line 823
;823:	{
line 824
;824:		trap_G2API_CleanGhoul2Models ( &ghoul2 );
ADDRLP4 0
ARGP4
ADDRGP4 trap_G2API_CleanGhoul2Models
CALLV
pop
line 825
;825:		return;
ADDRGP4 $553
JUMPV
LABELV $558
line 829
;826:	}
;827:
;828:	// Register the skin and attach it to the ghoul model
;829:	handle = trap_G2API_RegisterSkin( "hitmodel", numPairs, temp );
ADDRGP4 $560
ARGP4
ADDRLP4 20484
INDIRI4
ARGI4
ADDRLP4 4
ARGP4
ADDRLP4 20500
ADDRGP4 trap_G2API_RegisterSkin
CALLI4
ASGNI4
ADDRLP4 20488
ADDRLP4 20500
INDIRI4
ASGNI4
line 830
;830:	trap_G2API_SetSkin( ghoul2, 0, handle );
ADDRLP4 0
INDIRP4
ARGP4
CNSTI4 0
ARGI4
ADDRLP4 20488
INDIRI4
ARGI4
ADDRGP4 trap_G2API_SetSkin
CALLI4
pop
line 833
;831:
;832:	// Read in the animations for this model
;833:	trap_G2API_GetAnimFileNameIndex( ghoul2, 0, temp );
ADDRLP4 0
INDIRP4
ARGP4
CNSTI4 0
ARGI4
ADDRLP4 4
ARGP4
ADDRGP4 trap_G2API_GetAnimFileNameIndex
CALLI4
pop
line 834
;834:	BG_ParseAnimationFile ( va("%s_mp.cfg", temp), cg.hitAnimations );
ADDRGP4 $561
ARGP4
ADDRLP4 4
ARGP4
ADDRLP4 20504
ADDRGP4 va
CALLP4
ASGNP4
ADDRLP4 20504
INDIRP4
ARGP4
ADDRGP4 cg+181240
ARGP4
ADDRGP4 BG_ParseAnimationFile
CALLI4
pop
line 837
;835:
;836:	// Hand the hit model back
;837:	cg.hitModel = ghoul2;
ADDRGP4 cg+184068
ADDRLP4 0
INDIRP4
ASGNP4
line 838
;838:}
LABELV $553
endproc CG_InitHitModel 20508 28
bss
align 4
LABELV cg_triggerEntities
skip 1024
align 4
LABELV cg_numTriggerEntities
skip 4
align 4
LABELV cg_solidEntities
skip 4096
align 4
LABELV cg_numSolidEntities
skip 4
align 4
LABELV cg_pmove
skip 372
import CG_ParseGametypeFile
import CG_DrawMiscEnts
import CG_MiscEnt
import G2_PositionEntityOnBolt
import CG_PredictedProcGore
import CG_AddProcGore
import CG_SetGhoul2Info
import CG_Init_CGents
import CG_Init_CG
import trap_UI_SetActiveMenu
import trap_UI_CloseAll
import trap_CG_RegisterSharedMemory
import trap_RE_InitRendererTerrain
import trap_CM_RegisterTerrain
import trap_CM_TM_ConvertPosition
import trap_CM_TM_Upload
import trap_CM_TM_AddTarget
import trap_CM_TM_AddSpot
import trap_CM_TM_AddBuilding
import trap_CM_TM_Create
import trap_MAT_GetDebrisScale
import trap_MAT_GetDebris
import trap_MAT_GetEffect
import trap_MAT_GetDecalScale
import trap_MAT_GetDecal
import trap_MAT_GetSound
import trap_MAT_Reset
import trap_MAT_Init
import trap_G2API_SetSkin
import trap_G2API_RegisterSkin
import trap_G2API_GetBoltIndex
import trap_G2API_FindBoltIndex
import trap_G2API_GetNumModels
import trap_G2API_GetGhoul2ModelFlagsByIndex
import trap_G2API_SetGhoul2ModelFlagsByIndex
import trap_G2API_GetGhoul2ModelFlags
import trap_G2API_SetGhoul2ModelFlags
import trap_G2API_ClearSkinGore
import trap_G2API_AddSkinGore
import trap_G2API_SetNewOrigin
import trap_G2API_SetRootSurface
import trap_G2API_SetSurfaceOnOff
import trap_G2API_GetBoneAnim
import trap_G2API_SetBoneAnim
import trap_G2API_GetGLAName
import trap_G2API_SetBoneAngles
import trap_G2API_CleanGhoul2Models
import trap_G2API_RemoveGhoul2Model
import trap_G2API_DuplicateGhoul2Instance
import trap_G2API_CopySpecificGhoul2Model
import trap_G2API_CopyGhoul2Instance
import trap_G2API_GetAnimFileNameIndex
import trap_G2API_InitGhoul2Model
import trap_G2API_GetBoltMatrix
import trap_G2_HaveWeGhoul2Models
import trap_G2_SetGhoul2ModelIndexes
import trap_G2API_DetachG2Model
import trap_G2API_AttachG2Model
import trap_G2API_RemoveBolt
import trap_G2API_SetBoltInfo
import trap_G2API_AddBolt
import trap_G2_ListModelBones
import trap_G2_ListModelSurfaces
import trap_G2API_CollisionDetect
import trap_R_inPVS
import trap_GetEntityToken
import trap_SnapVector
import trap_RMG_Init
import trap_Key_GetKey
import trap_Key_SetCatcher
import trap_Key_GetCatcher
import trap_Key_IsDown
import trap_MemoryRemaining
import trap_FX_AddLine
import trap_FX_Reset
import trap_FX_AdjustTime
import trap_FX_FreeSystem
import trap_FX_Draw2DEffects
import trap_FX_AddScheduledEffects
import trap_FX_PlayBoltedEffectID
import trap_FX_PlayEntityEffectID
import trap_FX_PlayEffectID
import trap_FX_PlaySimpleEffectID
import trap_FX_PlayEntityEffect
import trap_FX_PlayEffect
import trap_FX_PlaySimpleEffect
import trap_FX_RegisterEffect
import trap_FX_InitSystem
import trap_CIN_SetExtents
import trap_CIN_DrawCinematic
import trap_CIN_RunCinematic
import trap_CIN_StopCinematic
import trap_CIN_PlayCinematic
import testPrintFloat
import testPrintInt
import trap_ResetAutorun
import trap_RW_SetTeam
import trap_SetUserCmdValue
import trap_GetUserCmd
import trap_GetCurrentCmdNumber
import trap_GetServerCommand
import trap_GetDefaultState
import trap_GetSnapshot
import trap_GetCurrentSnapshotNumber
import trap_GetGameState
import trap_GetGlconfig
import trap_R_SetLightStyle
import trap_R_GetLightStyle
import trap_R_RemapShader
import trap_R_DrawRotatePic2
import trap_R_DrawRotatePic
import trap_R_LerpTag
import trap_R_ModelBounds
import trap_R_DrawStretchPic
import trap_R_SetColor
import trap_R_DrawVisualOverlay
import trap_R_RenderScene
import trap_R_LightForPoint
import trap_R_AddLightToScene
import trap_R_AddDecalToScene
import trap_R_AddPolysToScene
import trap_R_AddPolyToScene
import trap_R_DrawTextWithCursor
import trap_R_DrawText
import trap_R_GetTextHeight
import trap_R_GetTextWidth
import trap_R_AddRefEntityToScene
import trap_R_ClearDecals
import trap_R_ClearScene
import trap_R_RegisterFont
import trap_R_RegisterShaderNoMip
import trap_R_RegisterShader
import trap_R_RegisterSkin
import trap_R_RegisterModel
import trap_R_LoadWorldMap
import trap_AS_GetBModelSound
import trap_AS_AddLocalSet
import trap_AS_UpdateAmbientSet
import trap_AS_ParseSets
import trap_AS_AddPrecacheEntry
import trap_S_StopBackgroundTrack
import trap_S_StartBackgroundTrack
import trap_S_RegisterSound
import trap_S_Respatialize
import trap_S_UpdateEntityPosition
import trap_S_AddRealLoopingSound
import trap_S_AddLoopingSound
import trap_S_ClearLoopingSounds
import trap_S_StartLocalSound
import trap_S_StopLoopingSound
import trap_S_StartSound
import trap_S_StopAllSounds
import trap_CM_MarkFragments
import trap_CM_TransformedBoxTrace
import trap_CM_BoxTrace
import trap_CM_TransformedPointContents
import trap_CM_PointContents
import trap_CM_TempBoxModel
import trap_CM_InlineModel
import trap_CM_NumInlineModels
import trap_CM_LoadMap
import trap_UpdateScreen
import trap_SendClientCommand
import trap_AddCommand
import trap_SendConsoleCommand
import trap_FS_FCloseFile
import trap_FS_Write
import trap_FS_Read
import trap_FS_FOpenFile
import trap_Args
import trap_Argv
import trap_Argc
import trap_Cvar_VariableStringBuffer
import trap_Cvar_Set
import trap_Cvar_Update
import trap_Cvar_Register
import trap_Milliseconds
import trap_Error
import trap_Print
import CG_ApplyGore
import CG_ParseGore
import CG_ParseAnimationFile
import CG_CheckChangedPredictableEvents
import CG_TransitionPlayerState
import CG_Respawn
import CG_PlayBufferedVoiceChats
import CG_VoiceChatLocal
import CG_ShaderStateChanged
import CG_LoadVoiceChats
import CG_SetConfigValues
import CG_ParseServerinfo
import CG_ExecuteNewServerCommands
import CG_MapRestart
import CG_InitConsoleCommands
import CG_ConsoleCommand
import CG_DrawScoreboard
import CG_DrawInformation
import CG_LoadingClient
import CG_LoadingItem
import CG_LoadingStage
import CG_LoadingString
import CG_ProcessSnapshots
import CG_TestLine
import CG_GlassShatter
import CG_BulletFlyBySound
import CG_BubbleTrail
import CG_AddLocalEntities
import CG_AllocLocalEntity
import CG_FreeLocalEntity
import CG_InitLocalEntities
import CG_WeaponCallback
import CG_OutOfAmmoChange
import CG_DrawWeaponSelect
import CG_PlayerWeaponEffects
import CG_AddViewWeapon
import CG_AnimateViewWeapon
import CG_Bullet
import CG_HandleStickyMissile
import CG_MissileHitPlayer
import CG_MissileHitWall
import CG_ProjectileThink
import CG_FireWeapon
import CG_SetWeaponAnim
import CG_UpdateViewWeaponSurfaces
import CG_RegisterItemVisuals
import CG_ShutDownWeapons
import CG_RegisterWeapon
import CG_WeaponSelectable
import CG_Weapon_f
import CG_PrevWeapon
import CG_NextWeapon
import CG_ScaleModelAxis
import CG_AdjustPositionForMover
import CG_Beam
import CG_AddPacketEntities
import CG_SetEntitySoundPosition
import CG_PainEvent
import CG_EntityEvent
import CG_PlaceString
import CG_CheckEvents
import CG_LoadDeferredPlayers
import CG_PlayerShadow
import CG_RemoveIdentityItemsOnBack
import CG_RegisterIdentity
import CG_UpdatePlayerModel
import CG_CustomPlayerSound
import CG_CustomSound
import CG_NewClientInfo
import CG_ResetPlayerEntity
import CG_Player
import CG_DrawMapChange
import CG_GameTypeString
import CG_Text_PaintChar
import CG_Draw3DG2Model
import CG_Draw3DModel
import CG_GetGameStatusText
import CG_GetTeamColor
import CG_RunMenuScript
import CG_OwnerDrawDisabled
import CG_OwnerDrawVisible
import CG_GetValue
import CG_OwnerDraw
import CG_DrawActive
import CG_CenterPrint
import CG_AddLagometerSnapshotInfo
import CG_AddLagometerFrameInfo
import CG_DrawTimer
import CG_DrawTextWithCursor
import CG_DrawText
import CG_GetColorForHealth
import CG_DrawTopBottom
import CG_DrawSides
import CG_DrawRect
import CG_TileClear
import CG_TeamColor
import CG_FadeColor
import CG_DrawStrlen
import CG_DrawRotatePic2
import CG_DrawRotatePic
import CG_DrawStretchPic
import CG_DrawPic
import CG_FillRect
import CG_AdjustFrom640
import CG_UpdateCameraShake
import CG_CameraShake
import CG_DrawActiveFrame
import CG_AddBufferedSound
import CG_TestModelPrevSkin_f
import CG_TestModelNextSkin_f
import CG_TestModelPrevFrame_f
import CG_TestModelNextFrame_f
import CG_TestGun_f
import CG_TestModel_f
import CG_TeamCount
import CG_EventHandling
import CG_MouseEvent
import CG_KeyEvent
import CG_LoadMenus
import CG_LastAttacker
import CG_CrosshairPlayer
import CG_UpdateTeamCountCvars
import CG_UpdateCvars
import CG_StartMusic
import CG_GetEntity
import CG_Argv
import CG_ConfigString
import cg_temp4
import cg_temp3
import cg_temp2
import cg_temp1
import cg_drawSmile
import cg_crosshairInfo
import cg_drawClock
import cg_drawWeaponType
import cg_drawTeamInfo
import cg_hudOpacity
import cg_hudBackGround
import cg_hudFiles
import cg_defaultHud
import cg_zoomWeaponChange
import rw_enabled
import cg_bodyTime
import cg_weaponMenuFast
import cg_soundFrag
import cg_soundGlobal
import cg_voiceGlobal
import cg_voiceRadio
import ui_info_seenobjectives
import ui_info_pickupsdisabled
import ui_info_freecount
import ui_info_speccount
import ui_info_bluecount
import ui_info_redcount
import cg_automap_a
import cg_automap_h
import cg_automap_w
import cg_automap_y
import cg_automap_x
import cg_animBlend
import cg_tracerChance
import cg_damageindicator
import RMG_distancecull
import cg_lockDeaths
import cg_lockBlood
import cg_lockSever
import cg_DebugGore
import cg_currentSelectedPlayerName
import cg_currentSelectedPlayer
import cg_noProjectileTrail
import cg_noTaunt
import cg_cameraMode
import cg_timescale
import cg_cameraOrbitDelay
import cg_cameraOrbit
import pmove_msec
import pmove_fixed
import cg_smoothClients
import cg_noVoiceText
import cg_teamChatsOnly
import cg_drawFriend
import cg_deferPlayers
import cg_autoReload
import cg_impactPrediction
import cg_antiLag
import cg_predictItems
import cg_paused
import cg_buildScript
import cg_forceModel
import cg_stats
import cg_chatHeight
import cg_chatTime
import cg_synchronousClients
import cg_lagometer
import cg_stereoSeparation
import cg_thirdPersonHorzOffset
import cg_thirdPersonPitch
import cg_thirdPersonYaw
import cg_thirdPersonRange
import cg_thirdPerson
import cg_goreDetail
import cg_shellEjection
import cg_fov
import cg_simpleItems
import cg_ignore
import cg_autoswitch
import cg_drawGun
import cg_gun_z
import cg_gun_y
import cg_gun_x
import cg_footsteps
import cg_showmiss
import cg_nopredict
import cg_errorDecay
import cg_debugEvents
import cg_draw2D
import cg_crosshairFriendRGBA
import cg_crosshairRGBA
import cg_crosshairGrow
import cg_crosshairSize
import cg_crosshairY
import cg_crosshairX
import cg_drawHUDIcons
import cg_drawTeamScores
import cg_drawRadar
import cg_drawCrosshairNames
import cg_drawCrosshair
import cg_drawSnapshot
import cg_drawFPS
import cg_drawTimer
import cg_shadows
import cg_bobroll
import cg_bobpitch
import cg_bobup
import cg_runroll
import cg_runpitch
import cg_centerY
import cg_centertime
import con_notifyTime
import cg_items
import cg_weapons
import cg
import cgs
import cg_numpermanents
import cg_permanents
import cg_entities
import trap_VM_LocalStringAlloc
import trap_VM_LocalTempFree
import trap_VM_LocalTempAlloc
import trap_VM_LocalAllocUnaligned
import trap_VM_LocalAlloc
import trap_FS_GetFileList
import trap_GPV_GetList
import trap_GPV_GetTopValue
import trap_GPV_IsList
import trap_GPV_GetInOrderPrevious
import trap_GPV_GetInOrderNext
import trap_GPV_GetNext
import trap_GPV_GetName
import trap_GPG_FindPairValue
import trap_GPG_FindPair
import trap_GPG_FindSubGroup
import trap_GPG_GetInOrderSubGroups
import trap_GPG_GetSubGroups
import trap_GPG_GetInOrderPairs
import trap_GPG_GetPairs
import trap_GPG_GetInOrderPrevious
import trap_GPG_GetInOrderNext
import trap_GPG_GetNext
import trap_GPG_GetName
import trap_GP_GetBaseParseGroup
import trap_GP_Delete
import trap_GP_Clean
import trap_GP_ParseFile
import trap_GP_Parse
import BG_ApplyLeanOffset
import BG_FindOutfitting
import BG_ParseOutfittingTemplates
import BG_CompressOutfitting
import BG_DecompressOutfitting
import BG_SetAvailableOutfitting
import BG_IsWeaponAvailableForOutfitting
import BG_ParseSkin
import BG_ParseNPCFiles
import BG_GetModelSound
import BG_FindCharacterTemplate
import BG_FindTeamIdentity
import BG_FindIdentity
import bg_animTable
import bg_weaponNames
import bg_outfittingGroups
import bg_outfittingCount
import bg_outfittings
import bg_identityCount
import bg_identities
import bg_itemTemplates
import bg_characterTemplates
import BG_FindGametype
import BG_BuildGametypeList
import bg_gametypeCount
import bg_gametypeData
import BG_GetWeaponNote
import BG_GetWeaponAnim
import BG_PlayerTouchesItem
import BG_CalculateLeanOffset
import BG_ParseAnimationFile
import BG_PlayerAngles
import BG_PlayerStateToEntityStateExtraPolate
import BG_PlayerStateToEntityState
import BG_AddPredictableEventToPlayerstate
import BG_EvaluateTrajectoryDelta
import BG_EvaluateTrajectory
import BG_FindLadder
import BG_AddLadder
import BG_CanItemBeGrabbed
import BG_FindGametypeItemByID
import BG_FindGametypeItem
import BG_FindWeaponItem
import BG_FindClassnameItem
import BG_FindItem
import bg_numItems
import bg_itemlist
import Pmove
import PM_UpdateViewAngles
import pm
import BG_GetMaxAmmo
import BG_CalculateBulletEndpoint
import BG_FindFireMode
import BG_WeaponHasAlternateAmmo
import BG_GetInviewModelAnim
import BG_GetInviewAnimFromIndex
import BG_GetInviewAnim
import BG_ParseInviewFile
import weaponRightHand
import weaponLeftHand
import weaponParseInfo
import ammoData
import ammoNames
import weaponData
import weaponNames
import GetStringForID
import GetIDForString
import KeywordHash_Find
import KeywordHash_Add
import KeywordHash_Key
import Q_irand
import irand
import flrand
import Rand_Init
import Com_Printf
import Com_Error
import Info_NextPair
import Info_Validate
import Info_SetValueForKey_Big
import Info_SetValueForKey
import Info_RemoveKey_big
import Info_RemoveKey
import Info_ValueForKey
import va
import Q_CleanStr
import Q_PrintStrlen
import Q_strcat
import Q_strncpyz
import Q_strrchr
import Q_strupr
import Q_strlwr
import Q_stricmpn
import Q_strncmp
import Q_stricmp
import Q_isalpha
import Q_isupper
import Q_islower
import Q_isprint
import Com_sprintf
import Parse3DMatrix
import Parse2DMatrix
import Parse1DMatrix
import SkipRestOfLine
import SkipBracedSection
import COM_MatchToken
import COM_ParseWarning
import COM_ParseError
import COM_Compress
import COM_ParseExt
import COM_Parse
import SkipWhitespace
import COM_GetCurrentParseLine
import COM_BeginParseSession
import COM_DefaultExtension
import COM_StripExtension
import COM_SkipPath
import Com_Clamp
import Com_Clampf
import NormalToLatLong
import PerpendicularVector
import AngleVectors
import MatrixMultiply
import MakeNormalVectors
import RotateAroundDirection
import RotatePointAroundVector
import ProjectPointOnPlane
import PlaneFromPoints
import AngleDelta
import AngleNormalize180
import AngleNormalize360
import AnglesSubtract
import AngleSubtract
import LerpVector
import LerpAngle
import AngleMod
import fmod
import BoxOnPlaneSide
import SetPlaneSignbits
import AxisCopy
import AxisClear
import AnglesToAxis
import vectoangles
import Q_crandom
import Q_random
import Q_rand
import Q_asin
import Q_acos
import Q_log2
import Q_TestRaySphere
import VectorRotate
import Vector4Scale
import VectorNormalize2
import VectorNormalize
import CrossProduct
import VectorInverse
import VectorNormalizeFast
import DistanceSquared
import Distance
import VectorLengthSquared
import VectorLength
import VectorCompare
import AddPointToBounds
import ClearBounds
import RadiusFromBounds
import NormalizeColor
import ColorBytes4
import ColorBytes3
import _VectorMA
import _VectorScale
import _VectorCopy
import _VectorAdd
import _VectorSubtract
import _DotProduct
import ByteToDir
import DirToByte
import powf
import ClampShort
import ClampChar
import Q_rsqrt
import Q_fabs
import axisDefault
import vec3_identity
import vec3_origin
import g_color_table
import colorDkBlue
import colorLtBlue
import colorDkGrey
import colorMdGrey
import colorLtGrey
import colorWhite
import colorCyan
import colorMagenta
import colorYellow
import colorBlue
import colorGreen
import colorRed
import colorBlack
import colorTable
import bytedirs
import Com_Memcpy
import Com_Memset
import Hunk_Alloc
import FloatSwap
import LongSwap
import ShortSwap
import asin
import acos
import fabs
import abs
import tan
import atan2
import cos
import sin
import sqrt
import floor
import ceil
import memcpy
import memset
import memmove
import sscanf
import vsprintf
import _atoi
import atoi
import _atof
import atof
import toupper
import tolower
import strncpy
import strstr
import strchr
import strcmp
import strcpy
import strcat
import strlen
import rand
import srand
import qsort
lit
align 1
LABELV $561
char 1 37
char 1 115
char 1 95
char 1 109
char 1 112
char 1 46
char 1 99
char 1 102
char 1 103
char 1 0
align 1
LABELV $560
char 1 104
char 1 105
char 1 116
char 1 109
char 1 111
char 1 100
char 1 101
char 1 108
char 1 0
align 1
LABELV $557
char 1 109
char 1 111
char 1 100
char 1 101
char 1 108
char 1 115
char 1 47
char 1 99
char 1 104
char 1 97
char 1 114
char 1 97
char 1 99
char 1 116
char 1 101
char 1 114
char 1 115
char 1 47
char 1 115
char 1 107
char 1 105
char 1 110
char 1 115
char 1 47
char 1 99
char 1 111
char 1 108
char 1 95
char 1 114
char 1 101
char 1 98
char 1 101
char 1 108
char 1 95
char 1 104
char 1 49
char 1 46
char 1 103
char 1 50
char 1 115
char 1 107
char 1 105
char 1 110
char 1 0
align 1
LABELV $554
char 1 109
char 1 111
char 1 100
char 1 101
char 1 108
char 1 115
char 1 47
char 1 99
char 1 104
char 1 97
char 1 114
char 1 97
char 1 99
char 1 116
char 1 101
char 1 114
char 1 115
char 1 47
char 1 97
char 1 118
char 1 101
char 1 114
char 1 97
char 1 103
char 1 101
char 1 95
char 1 115
char 1 108
char 1 101
char 1 101
char 1 118
char 1 101
char 1 115
char 1 47
char 1 97
char 1 118
char 1 101
char 1 114
char 1 97
char 1 103
char 1 101
char 1 95
char 1 115
char 1 108
char 1 101
char 1 101
char 1 118
char 1 101
char 1 115
char 1 46
char 1 103
char 1 108
char 1 109
char 1 0
align 1
LABELV $549
char 1 87
char 1 65
char 1 82
char 1 78
char 1 73
char 1 78
char 1 71
char 1 58
char 1 32
char 1 100
char 1 111
char 1 117
char 1 98
char 1 108
char 1 101
char 1 32
char 1 101
char 1 118
char 1 101
char 1 110
char 1 116
char 1 10
char 1 0
align 1
LABELV $539
char 1 87
char 1 65
char 1 82
char 1 78
char 1 73
char 1 78
char 1 71
char 1 58
char 1 32
char 1 100
char 1 114
char 1 111
char 1 112
char 1 112
char 1 101
char 1 100
char 1 32
char 1 101
char 1 118
char 1 101
char 1 110
char 1 116
char 1 10
char 1 0
align 1
LABELV $522
char 1 110
char 1 111
char 1 116
char 1 32
char 1 109
char 1 111
char 1 118
char 1 101
char 1 100
char 1 10
char 1 0
align 1
LABELV $514
char 1 91
char 1 37
char 1 105
char 1 32
char 1 58
char 1 32
char 1 37
char 1 105
char 1 93
char 1 32
char 1 0
align 1
LABELV $468
char 1 68
char 1 111
char 1 117
char 1 98
char 1 108
char 1 101
char 1 32
char 1 112
char 1 114
char 1 101
char 1 100
char 1 105
char 1 99
char 1 116
char 1 105
char 1 111
char 1 110
char 1 32
char 1 100
char 1 101
char 1 99
char 1 97
char 1 121
char 1 58
char 1 32
char 1 37
char 1 102
char 1 10
char 1 0
align 1
LABELV $455
char 1 80
char 1 114
char 1 101
char 1 100
char 1 105
char 1 99
char 1 116
char 1 105
char 1 111
char 1 110
char 1 32
char 1 109
char 1 105
char 1 115
char 1 115
char 1 58
char 1 32
char 1 37
char 1 102
char 1 10
char 1 0
align 1
LABELV $440
char 1 112
char 1 114
char 1 101
char 1 100
char 1 105
char 1 99
char 1 116
char 1 105
char 1 111
char 1 110
char 1 32
char 1 101
char 1 114
char 1 114
char 1 111
char 1 114
char 1 10
char 1 0
align 1
LABELV $426
char 1 80
char 1 114
char 1 101
char 1 100
char 1 105
char 1 99
char 1 116
char 1 105
char 1 111
char 1 110
char 1 84
char 1 101
char 1 108
char 1 101
char 1 112
char 1 111
char 1 114
char 1 116
char 1 10
char 1 0
align 1
LABELV $391
char 1 51
char 1 51
char 1 0
align 1
LABELV $387
char 1 56
char 1 0
align 1
LABELV $386
char 1 112
char 1 109
char 1 111
char 1 118
char 1 101
char 1 95
char 1 109
char 1 115
char 1 101
char 1 99
char 1 0
align 1
LABELV $369
char 1 101
char 1 120
char 1 99
char 1 101
char 1 101
char 1 100
char 1 101
char 1 100
char 1 32
char 1 80
char 1 65
char 1 67
char 1 75
char 1 69
char 1 84
char 1 95
char 1 66
char 1 65
char 1 67
char 1 75
char 1 85
char 1 80
char 1 32
char 1 111
char 1 110
char 1 32
char 1 99
char 1 111
char 1 109
char 1 109
char 1 97
char 1 110
char 1 100
char 1 115
char 1 10
char 1 0
align 1
LABELV $185
char 1 99
char 1 114
char 1 97
char 1 110
char 1 105
char 1 117
char 1 109
char 1 0
align 1
LABELV $180
char 1 117
char 1 112
char 1 112
char 1 101
char 1 114
char 1 95
char 1 108
char 1 117
char 1 109
char 1 98
char 1 97
char 1 114
char 1 0
align 1
LABELV $178
char 1 108
char 1 111
char 1 119
char 1 101
char 1 114
char 1 95
char 1 108
char 1 117
char 1 109
char 1 98
char 1 97
char 1 114
char 1 0
align 1
LABELV $175
char 1 109
char 1 111
char 1 100
char 1 101
char 1 108
char 1 95
char 1 114
char 1 111
char 1 111
char 1 116
char 1 0
