export CG_InitLocalEntities
code
proc CG_InitLocalEntities 12 12
file "../cg_localents.c"
line 21
;1:// Copyright (C) 2001-2002 Raven Software.
;2://
;3:// cg_localents.c -- every frame, generate renderer commands for locally
;4:// processed entities, like smoke puffs, shells, etc.
;5:
;6:#include "cg_local.h"
;7:
;8:#define	MAX_LOCAL_ENTITIES	512
;9:localEntity_t	cg_localEntities[MAX_LOCAL_ENTITIES];
;10:localEntity_t	cg_activeLocalEntities;		// double linked list
;11:localEntity_t	*cg_freeLocalEntities;		// single linked list
;12:
;13:/*
;14:===================
;15:CG_InitLocalEntities
;16:
;17:This is called at startup and for map restarts
;18:===================
;19:*/
;20:void CG_InitLocalEntities( void ) 
;21:{
line 24
;22:	int		i;
;23:
;24:	memset( cg_localEntities, 0, sizeof( cg_localEntities ) );
ADDRGP4 cg_localEntities
ARGP4
CNSTI4 0
ARGI4
CNSTI4 188416
ARGI4
ADDRGP4 memset
CALLP4
pop
line 25
;25:	cg_activeLocalEntities.next = &cg_activeLocalEntities;
ADDRGP4 cg_activeLocalEntities+4
ADDRGP4 cg_activeLocalEntities
ASGNP4
line 26
;26:	cg_activeLocalEntities.prev = &cg_activeLocalEntities;
ADDRLP4 4
ADDRGP4 cg_activeLocalEntities
ASGNP4
ADDRLP4 4
INDIRP4
ADDRLP4 4
INDIRP4
ASGNP4
line 27
;27:	cg_freeLocalEntities = cg_localEntities;
ADDRGP4 cg_freeLocalEntities
ADDRGP4 cg_localEntities
ASGNP4
line 29
;28:	
;29:	for ( i = 0 ; i < MAX_LOCAL_ENTITIES - 1 ; i++ ) 
ADDRLP4 0
CNSTI4 0
ASGNI4
LABELV $93
line 30
;30:	{
line 31
;31:		cg_localEntities[i].next = &cg_localEntities[i+1];
ADDRLP4 8
CNSTI4 368
ADDRLP4 0
INDIRI4
MULI4
ASGNI4
ADDRLP4 8
INDIRI4
ADDRGP4 cg_localEntities+4
ADDP4
ADDRLP4 8
INDIRI4
ADDRGP4 cg_localEntities+368
ADDP4
ASGNP4
line 32
;32:	}
LABELV $94
line 29
ADDRLP4 0
ADDRLP4 0
INDIRI4
CNSTI4 1
ADDI4
ASGNI4
ADDRLP4 0
INDIRI4
CNSTI4 511
LTI4 $93
line 33
;33:}
LABELV $91
endproc CG_InitLocalEntities 12 12
export CG_FreeLocalEntity
proc CG_FreeLocalEntity 12 8
line 42
;34:
;35:
;36:/*
;37:==================
;38:CG_FreeLocalEntity
;39:==================
;40:*/
;41:void CG_FreeLocalEntity( localEntity_t *le ) 
;42:{
line 43
;43:	if ( !le->prev ) 
ADDRFP4 0
INDIRP4
INDIRP4
CVPU4 4
CNSTU4 0
NEU4 $100
line 44
;44:	{
line 45
;45:		Com_Error( ERR_FATAL, "CG_FreeLocalEntity: not active" );
CNSTI4 0
ARGI4
ADDRGP4 $102
ARGP4
ADDRGP4 Com_Error
CALLV
pop
line 46
;46:	}
LABELV $100
line 48
;47:
;48:	if (le->refEntity.ghoul2)
ADDRFP4 0
INDIRP4
CNSTI4 364
ADDP4
INDIRP4
CVPU4 4
CNSTU4 0
EQU4 $103
line 49
;49:	{
line 50
;50:		trap_G2API_CleanGhoul2Models(&le->refEntity.ghoul2);
ADDRFP4 0
INDIRP4
CNSTI4 364
ADDP4
ARGP4
ADDRGP4 trap_G2API_CleanGhoul2Models
CALLV
pop
line 51
;51:	}
LABELV $103
line 54
;52:
;53:	// remove from the doubly linked active list
;54:	le->prev->next = le->next;
ADDRLP4 0
ADDRFP4 0
INDIRP4
ASGNP4
ADDRLP4 4
CNSTI4 4
ASGNI4
ADDRLP4 0
INDIRP4
INDIRP4
ADDRLP4 4
INDIRI4
ADDP4
ADDRLP4 0
INDIRP4
ADDRLP4 4
INDIRI4
ADDP4
INDIRP4
ASGNP4
line 55
;55:	le->next->prev = le->prev;
ADDRLP4 8
ADDRFP4 0
INDIRP4
ASGNP4
ADDRLP4 8
INDIRP4
CNSTI4 4
ADDP4
INDIRP4
ADDRLP4 8
INDIRP4
INDIRP4
ASGNP4
line 58
;56:
;57:	// the free list is only singly linked
;58:	le->next = cg_freeLocalEntities;
ADDRFP4 0
INDIRP4
CNSTI4 4
ADDP4
ADDRGP4 cg_freeLocalEntities
INDIRP4
ASGNP4
line 59
;59:	cg_freeLocalEntities = le;
ADDRGP4 cg_freeLocalEntities
ADDRFP4 0
INDIRP4
ASGNP4
line 60
;60:}
LABELV $99
endproc CG_FreeLocalEntity 12 8
export CG_AllocLocalEntity
proc CG_AllocLocalEntity 8 12
line 69
;61:
;62:/*
;63:===================
;64:CG_AllocLocalEntity
;65:
;66:Will allways succeed, even if it requires freeing an old active entity
;67:===================
;68:*/
;69:localEntity_t	*CG_AllocLocalEntity( void ) {
line 72
;70:	localEntity_t	*le;
;71:
;72:	if ( !cg_freeLocalEntities ) {
ADDRGP4 cg_freeLocalEntities
INDIRP4
CVPU4 4
CNSTU4 0
NEU4 $106
line 75
;73:		// no free entities, so free the one at the end of the chain
;74:		// remove the oldest active entity
;75:		CG_FreeLocalEntity( cg_activeLocalEntities.prev );
ADDRGP4 cg_activeLocalEntities
INDIRP4
ARGP4
ADDRGP4 CG_FreeLocalEntity
CALLV
pop
line 76
;76:	}
LABELV $106
line 78
;77:
;78:	le = cg_freeLocalEntities;
ADDRLP4 0
ADDRGP4 cg_freeLocalEntities
INDIRP4
ASGNP4
line 79
;79:	cg_freeLocalEntities = cg_freeLocalEntities->next;
ADDRLP4 4
ADDRGP4 cg_freeLocalEntities
ASGNP4
ADDRLP4 4
INDIRP4
ADDRLP4 4
INDIRP4
INDIRP4
CNSTI4 4
ADDP4
INDIRP4
ASGNP4
line 81
;80:
;81:	memset( le, 0, sizeof( *le ) );
ADDRLP4 0
INDIRP4
ARGP4
CNSTI4 0
ARGI4
CNSTI4 368
ARGI4
ADDRGP4 memset
CALLP4
pop
line 84
;82:
;83:	// link into the active list
;84:	le->next = cg_activeLocalEntities.next;
ADDRLP4 0
INDIRP4
CNSTI4 4
ADDP4
ADDRGP4 cg_activeLocalEntities+4
INDIRP4
ASGNP4
line 85
;85:	le->prev = &cg_activeLocalEntities;
ADDRLP4 0
INDIRP4
ADDRGP4 cg_activeLocalEntities
ASGNP4
line 86
;86:	cg_activeLocalEntities.next->prev = le;
ADDRGP4 cg_activeLocalEntities+4
INDIRP4
ADDRLP4 0
INDIRP4
ASGNP4
line 87
;87:	cg_activeLocalEntities.next = le;
ADDRGP4 cg_activeLocalEntities+4
ADDRLP4 0
INDIRP4
ASGNP4
line 88
;88:	return le;
ADDRLP4 0
INDIRP4
RETP4
LABELV $105
endproc CG_AllocLocalEntity 8 12
export CG_FragmentBounceMark
proc CG_FragmentBounceMark 20 44
line 109
;89:}
;90:
;91:
;92:/*
;93:====================================================================================
;94:
;95:FRAGMENT PROCESSING
;96:
;97:A fragment localentity interacts with the environment in some way (hitting walls),
;98:or generates more localentities along a trail.
;99:
;100:====================================================================================
;101:*/
;102:
;103:
;104:/*
;105:================
;106:CG_FragmentBounceMark
;107:================
;108:*/
;109:void CG_FragmentBounceMark( localEntity_t *le, trace_t *trace ) {
line 112
;110:	int			radius;
;111:
;112:	if ( le->leMarkType == LEMT_BLOOD ) 
ADDRFP4 0
INDIRP4
CNSTI4 152
ADDP4
INDIRI4
CNSTI4 2
NEI4 $112
line 113
;113:	{
line 114
;114:		radius = 16 + (rand()&31);
ADDRLP4 4
ADDRGP4 rand
CALLI4
ASGNI4
ADDRLP4 0
ADDRLP4 4
INDIRI4
CNSTI4 31
BANDI4
CNSTI4 16
ADDI4
ASGNI4
line 116
;115:
;116:		trap_R_AddDecalToScene ( cgs.media.bloodMarkShader, trace->endpos, 
ADDRLP4 8
ADDRGP4 rand
CALLI4
ASGNI4
ADDRGP4 cgs+241076+92
INDIRI4
ARGI4
ADDRLP4 12
ADDRFP4 4
INDIRP4
ASGNP4
ADDRLP4 12
INDIRP4
CNSTI4 12
ADDP4
ARGP4
ADDRLP4 12
INDIRP4
CNSTI4 24
ADDP4
ARGP4
CNSTF4 1135869952
ADDRLP4 8
INDIRI4
CNSTI4 32767
BANDI4
CVIF4 4
CNSTF4 1191181824
DIVF4
MULF4
ARGF4
ADDRLP4 16
CNSTF4 1065353216
ASGNF4
ADDRLP4 16
INDIRF4
ARGF4
ADDRLP4 16
INDIRF4
ARGF4
ADDRLP4 16
INDIRF4
ARGF4
ADDRLP4 16
INDIRF4
ARGF4
CNSTI4 1
ARGI4
ADDRLP4 0
INDIRI4
CVIF4 4
ARGF4
CNSTI4 0
ARGI4
ADDRGP4 trap_R_AddDecalToScene
CALLV
pop
line 120
;117:								 trace->plane.normal, random()*360,
;118:								 1,1,1,1, qtrue, radius, qfalse );
;119:
;120:	} 
ADDRGP4 $113
JUMPV
LABELV $112
line 121
;121:	else if ( le->leMarkType == LEMT_BURN ) 
ADDRFP4 0
INDIRP4
CNSTI4 152
ADDP4
INDIRI4
CNSTI4 1
NEI4 $116
line 122
;122:	{
line 123
;123:		radius = 8 + (rand()&15);
ADDRLP4 4
ADDRGP4 rand
CALLI4
ASGNI4
ADDRLP4 0
ADDRLP4 4
INDIRI4
CNSTI4 15
BANDI4
CNSTI4 8
ADDI4
ASGNI4
line 125
;124:
;125:		trap_R_AddDecalToScene ( cgs.media.burnMarkShader, trace->endpos, 
ADDRLP4 8
ADDRGP4 rand
CALLI4
ASGNI4
ADDRGP4 cgs+241076+96
INDIRI4
ARGI4
ADDRLP4 12
ADDRFP4 4
INDIRP4
ASGNP4
ADDRLP4 12
INDIRP4
CNSTI4 12
ADDP4
ARGP4
ADDRLP4 12
INDIRP4
CNSTI4 24
ADDP4
ARGP4
CNSTF4 1135869952
ADDRLP4 8
INDIRI4
CNSTI4 32767
BANDI4
CVIF4 4
CNSTF4 1191181824
DIVF4
MULF4
ARGF4
ADDRLP4 16
CNSTF4 1065353216
ASGNF4
ADDRLP4 16
INDIRF4
ARGF4
ADDRLP4 16
INDIRF4
ARGF4
ADDRLP4 16
INDIRF4
ARGF4
ADDRLP4 16
INDIRF4
ARGF4
CNSTI4 1
ARGI4
ADDRLP4 0
INDIRI4
CVIF4 4
ARGF4
CNSTI4 0
ARGI4
ADDRGP4 trap_R_AddDecalToScene
CALLV
pop
line 128
;126:								 trace->plane.normal, random()*360,
;127:								 1,1,1,1, qtrue, radius, qfalse );
;128:	}
LABELV $116
LABELV $113
line 133
;129:
;130:
;131:	// don't allow a fragment to make multiple marks, or they
;132:	// pile up while settling
;133:	le->leMarkType = LEMT_NONE;
ADDRFP4 0
INDIRP4
CNSTI4 152
ADDP4
CNSTI4 0
ASGNI4
line 134
;134:}
LABELV $111
endproc CG_FragmentBounceMark 20 44
export CG_FragmentBounceSound
proc CG_FragmentBounceSound 0 0
line 142
;135:
;136:/*
;137:================
;138:CG_FragmentBounceSound
;139:================
;140:*/
;141:void CG_FragmentBounceSound( localEntity_t *le, trace_t *trace ) 
;142:{
line 143
;143:	if ( le->leBounceSoundType == LEBS_BRASS ) 
ADDRFP4 0
INDIRP4
CNSTI4 156
ADDP4
INDIRI4
CNSTI4 1
NEI4 $121
line 144
;144:	{
line 145
;145:	}
LABELV $121
line 149
;146:
;147:	// don't allow a fragment to make multiple bounce sounds,
;148:	// or it gets too noisy as they settle
;149:	le->leBounceSoundType = LEBS_NONE;
ADDRFP4 0
INDIRP4
CNSTI4 156
ADDP4
CNSTI4 0
ASGNI4
line 150
;150:}
LABELV $120
endproc CG_FragmentBounceSound 0 0
export CG_ReflectVelocity
proc CG_ReflectVelocity 56 12
line 158
;151:
;152:
;153:/*
;154:================
;155:CG_ReflectVelocity
;156:================
;157:*/
;158:void CG_ReflectVelocity( localEntity_t *le, trace_t *trace ) {
line 164
;159:	vec3_t	velocity;
;160:	float	dot;
;161:	int		hitTime;
;162:
;163:	// reflect the velocity on the trace plane
;164:	hitTime = cg.time - cg.frametime + cg.frametime * trace->fraction;
ADDRLP4 16
ADDRGP4 cg+68
INDIRI4
ADDRGP4 cg+64
INDIRI4
SUBI4
CVIF4 4
ADDRGP4 cg+64
INDIRI4
CVIF4 4
ADDRFP4 4
INDIRP4
CNSTI4 8
ADDP4
INDIRF4
MULF4
ADDF4
CVFI4 4
ASGNI4
line 165
;165:	BG_EvaluateTrajectoryDelta( &le->pos, hitTime, velocity );
ADDRFP4 0
INDIRP4
CNSTI4 32
ADDP4
ARGP4
ADDRLP4 16
INDIRI4
ARGI4
ADDRLP4 0
ARGP4
ADDRGP4 BG_EvaluateTrajectoryDelta
CALLV
pop
line 166
;166:	dot = DotProduct( velocity, trace->plane.normal );
ADDRLP4 20
ADDRFP4 4
INDIRP4
ASGNP4
ADDRLP4 12
ADDRLP4 0
INDIRF4
ADDRLP4 20
INDIRP4
CNSTI4 24
ADDP4
INDIRF4
MULF4
ADDRLP4 0+4
INDIRF4
ADDRLP4 20
INDIRP4
CNSTI4 28
ADDP4
INDIRF4
MULF4
ADDF4
ADDRLP4 0+8
INDIRF4
ADDRLP4 20
INDIRP4
CNSTI4 32
ADDP4
INDIRF4
MULF4
ADDF4
ASGNF4
line 167
;167:	VectorMA( velocity, -2*dot, trace->plane.normal, le->pos.trDelta );
ADDRFP4 0
INDIRP4
CNSTI4 56
ADDP4
ADDRLP4 0
INDIRF4
ADDRFP4 4
INDIRP4
CNSTI4 24
ADDP4
INDIRF4
CNSTF4 3221225472
ADDRLP4 12
INDIRF4
MULF4
MULF4
ADDF4
ASGNF4
ADDRFP4 0
INDIRP4
CNSTI4 60
ADDP4
ADDRLP4 0+4
INDIRF4
ADDRFP4 4
INDIRP4
CNSTI4 28
ADDP4
INDIRF4
CNSTF4 3221225472
ADDRLP4 12
INDIRF4
MULF4
MULF4
ADDF4
ASGNF4
ADDRFP4 0
INDIRP4
CNSTI4 64
ADDP4
ADDRLP4 0+8
INDIRF4
ADDRFP4 4
INDIRP4
CNSTI4 32
ADDP4
INDIRF4
CNSTF4 3221225472
ADDRLP4 12
INDIRF4
MULF4
MULF4
ADDF4
ASGNF4
line 169
;168:
;169:	VectorScale( le->pos.trDelta, le->bounceFactor, le->pos.trDelta );
ADDRLP4 24
ADDRFP4 0
INDIRP4
ASGNP4
ADDRLP4 28
ADDRLP4 24
INDIRP4
CNSTI4 56
ADDP4
ASGNP4
ADDRLP4 28
INDIRP4
ADDRLP4 28
INDIRP4
INDIRF4
ADDRLP4 24
INDIRP4
CNSTI4 104
ADDP4
INDIRF4
MULF4
ASGNF4
ADDRLP4 32
ADDRFP4 0
INDIRP4
ASGNP4
ADDRLP4 36
ADDRLP4 32
INDIRP4
CNSTI4 60
ADDP4
ASGNP4
ADDRLP4 36
INDIRP4
ADDRLP4 36
INDIRP4
INDIRF4
ADDRLP4 32
INDIRP4
CNSTI4 104
ADDP4
INDIRF4
MULF4
ASGNF4
ADDRLP4 40
ADDRFP4 0
INDIRP4
ASGNP4
ADDRLP4 44
ADDRLP4 40
INDIRP4
CNSTI4 64
ADDP4
ASGNP4
ADDRLP4 44
INDIRP4
ADDRLP4 44
INDIRP4
INDIRF4
ADDRLP4 40
INDIRP4
CNSTI4 104
ADDP4
INDIRF4
MULF4
ASGNF4
line 171
;170:
;171:	VectorCopy( trace->endpos, le->pos.trBase );
ADDRFP4 0
INDIRP4
CNSTI4 44
ADDP4
ADDRFP4 4
INDIRP4
CNSTI4 12
ADDP4
INDIRB
ASGNB 12
line 172
;172:	le->pos.trTime = cg.time;
ADDRFP4 0
INDIRP4
CNSTI4 36
ADDP4
ADDRGP4 cg+68
INDIRI4
ASGNI4
line 176
;173:
;174:
;175:	// check for stop, making sure that even on low FPS systems it doesn't bobble
;176:	if ( trace->allsolid || 
ADDRLP4 48
ADDRFP4 4
INDIRP4
ASGNP4
ADDRLP4 48
INDIRP4
INDIRI4
CNSTI4 0
NEI4 $136
ADDRLP4 48
INDIRP4
CNSTI4 32
ADDP4
INDIRF4
CNSTF4 0
LEF4 $132
ADDRLP4 52
ADDRFP4 0
INDIRP4
CNSTI4 64
ADDP4
INDIRF4
ASGNF4
ADDRLP4 52
INDIRF4
CNSTF4 1109393408
LTF4 $136
ADDRLP4 52
INDIRF4
ADDRGP4 cg+64
INDIRI4
NEGI4
CVIF4 4
ADDRLP4 52
INDIRF4
MULF4
GEF4 $132
LABELV $136
line 178
;177:		( trace->plane.normal[2] > 0 && 
;178:		( le->pos.trDelta[2] < 40 || le->pos.trDelta[2] < -cg.frametime * le->pos.trDelta[2] ) ) ) {
line 179
;179:		le->pos.trType = TR_STATIONARY;
ADDRFP4 0
INDIRP4
CNSTI4 32
ADDP4
CNSTI4 0
ASGNI4
line 180
;180:	} else {
LABELV $132
line 182
;181:
;182:	}
LABELV $133
line 183
;183:}
LABELV $123
endproc CG_ReflectVelocity 56 12
export CG_AddFragment
proc CG_AddFragment 88 28
line 190
;184:
;185:/*
;186:================
;187:CG_AddFragment
;188:================
;189:*/
;190:void CG_AddFragment( localEntity_t *le ) {
line 194
;191:	vec3_t	newOrigin;
;192:	trace_t	trace;
;193:
;194:	if ( le->pos.trType == TR_STATIONARY ) {
ADDRFP4 0
INDIRP4
CNSTI4 32
ADDP4
INDIRI4
CNSTI4 0
NEI4 $138
line 199
;195:		// sink into the ground if near the removal time
;196:		int		t;
;197:		float	oldZ;
;198:		
;199:		t = le->endTime - cg.time;
ADDRLP4 68
ADDRFP4 0
INDIRP4
CNSTI4 20
ADDP4
INDIRI4
ADDRGP4 cg+68
INDIRI4
SUBI4
ASGNI4
line 200
;200:		if ( t < SINK_TIME ) {
ADDRLP4 68
INDIRI4
CNSTI4 1000
GEI4 $141
line 204
;201:			// we must use an explicit lighting origin, otherwise the
;202:			// lighting would be lost as soon as the origin went
;203:			// into the ground
;204:			VectorCopy( le->refEntity.origin, le->refEntity.lightingOrigin );
ADDRLP4 76
ADDRFP4 0
INDIRP4
ASGNP4
ADDRLP4 76
INDIRP4
CNSTI4 272
ADDP4
ADDRLP4 76
INDIRP4
CNSTI4 216
ADDP4
INDIRB
ASGNB 12
line 205
;205:			le->refEntity.renderfx |= RF_LIGHTING_ORIGIN;
ADDRLP4 80
ADDRFP4 0
INDIRP4
CNSTI4 168
ADDP4
ASGNP4
ADDRLP4 80
INDIRP4
ADDRLP4 80
INDIRP4
INDIRI4
CNSTI4 128
BORI4
ASGNI4
line 206
;206:			oldZ = le->refEntity.origin[2];
ADDRLP4 72
ADDRFP4 0
INDIRP4
CNSTI4 224
ADDP4
INDIRF4
ASGNF4
line 207
;207:			le->refEntity.origin[2] -= 16 * ( 1.0 - (float)t / SINK_TIME );
ADDRLP4 84
ADDRFP4 0
INDIRP4
CNSTI4 224
ADDP4
ASGNP4
ADDRLP4 84
INDIRP4
ADDRLP4 84
INDIRP4
INDIRF4
CNSTF4 1098907648
CNSTF4 1065353216
ADDRLP4 68
INDIRI4
CVIF4 4
CNSTF4 1148846080
DIVF4
SUBF4
MULF4
SUBF4
ASGNF4
line 208
;208:			trap_R_AddRefEntityToScene( &le->refEntity );
ADDRFP4 0
INDIRP4
CNSTI4 164
ADDP4
ARGP4
ADDRGP4 trap_R_AddRefEntityToScene
CALLV
pop
line 209
;209:			le->refEntity.origin[2] = oldZ;
ADDRFP4 0
INDIRP4
CNSTI4 224
ADDP4
ADDRLP4 72
INDIRF4
ASGNF4
line 210
;210:		} else {
ADDRGP4 $137
JUMPV
LABELV $141
line 211
;211:			trap_R_AddRefEntityToScene( &le->refEntity );
ADDRFP4 0
INDIRP4
CNSTI4 164
ADDP4
ARGP4
ADDRGP4 trap_R_AddRefEntityToScene
CALLV
pop
line 212
;212:		}
line 214
;213:
;214:		return;
ADDRGP4 $137
JUMPV
LABELV $138
line 218
;215:	}
;216:
;217:	// calculate new position
;218:	BG_EvaluateTrajectory( &le->pos, cg.time, newOrigin );
ADDRFP4 0
INDIRP4
CNSTI4 32
ADDP4
ARGP4
ADDRGP4 cg+68
INDIRI4
ARGI4
ADDRLP4 56
ARGP4
ADDRGP4 BG_EvaluateTrajectory
CALLV
pop
line 221
;219:
;220:	// trace a line from previous position to new position
;221:	CG_Trace( &trace, le->refEntity.origin, NULL, NULL, newOrigin, -1, CONTENTS_SOLID );
ADDRLP4 0
ARGP4
ADDRFP4 0
INDIRP4
CNSTI4 216
ADDP4
ARGP4
ADDRLP4 68
CNSTP4 0
ASGNP4
ADDRLP4 68
INDIRP4
ARGP4
ADDRLP4 68
INDIRP4
ARGP4
ADDRLP4 56
ARGP4
CNSTI4 -1
ARGI4
CNSTI4 1
ARGI4
ADDRGP4 CG_Trace
CALLV
pop
line 223
;222:
;223:	if ( trace.fraction == 1.0 ) {
ADDRLP4 0+8
INDIRF4
CNSTF4 1065353216
NEF4 $144
line 225
;224:		// still in free fall
;225:		VectorCopy( newOrigin, le->refEntity.origin );
ADDRFP4 0
INDIRP4
CNSTI4 216
ADDP4
ADDRLP4 56
INDIRB
ASGNB 12
line 227
;226:
;227:		if ( le->leFlags & LEF_TUMBLE ) {
ADDRFP4 0
INDIRP4
CNSTI4 12
ADDP4
INDIRI4
CNSTI4 2
BANDI4
CNSTI4 0
EQI4 $147
line 230
;228:			vec3_t angles;
;229:
;230:			BG_EvaluateTrajectory( &le->angles, cg.time, angles );
ADDRFP4 0
INDIRP4
CNSTI4 68
ADDP4
ARGP4
ADDRGP4 cg+68
INDIRI4
ARGI4
ADDRLP4 72
ARGP4
ADDRGP4 BG_EvaluateTrajectory
CALLV
pop
line 231
;231:			AnglesToAxis( angles, le->refEntity.axis );
ADDRLP4 72
ARGP4
ADDRFP4 0
INDIRP4
CNSTI4 176
ADDP4
ARGP4
ADDRGP4 AnglesToAxis
CALLV
pop
line 232
;232:		}
LABELV $147
line 234
;233:
;234:		trap_R_AddRefEntityToScene( &le->refEntity );
ADDRFP4 0
INDIRP4
CNSTI4 164
ADDP4
ARGP4
ADDRGP4 trap_R_AddRefEntityToScene
CALLV
pop
line 235
;235:		return;
ADDRGP4 $137
JUMPV
LABELV $144
line 241
;236:	}
;237:
;238:	// if it is in a nodrop zone, remove it
;239:	// this keeps gibs from waiting at the bottom of pits of death
;240:	// and floating levels
;241:	if ( trap_CM_PointContents( trace.endpos, 0 ) & CONTENTS_NODROP ) 
ADDRLP4 0+12
ARGP4
CNSTI4 0
ARGI4
ADDRLP4 72
ADDRGP4 trap_CM_PointContents
CALLI4
ASGNI4
ADDRLP4 72
INDIRI4
CNSTI4 2048
BANDI4
CNSTI4 0
EQI4 $150
line 242
;242:	{
line 243
;243:		CG_FreeLocalEntity( le );
ADDRFP4 0
INDIRP4
ARGP4
ADDRGP4 CG_FreeLocalEntity
CALLV
pop
line 244
;244:		return;
ADDRGP4 $137
JUMPV
LABELV $150
line 247
;245:	}
;246:
;247:	if (!trace.startsolid)
ADDRLP4 0+4
INDIRI4
CNSTI4 0
NEI4 $153
line 248
;248:	{
line 250
;249:		// leave a mark
;250:		CG_FragmentBounceMark( le, &trace );
ADDRFP4 0
INDIRP4
ARGP4
ADDRLP4 0
ARGP4
ADDRGP4 CG_FragmentBounceMark
CALLV
pop
line 253
;251:
;252:		// do a bouncy sound
;253:		CG_FragmentBounceSound( le, &trace );
ADDRFP4 0
INDIRP4
ARGP4
ADDRLP4 0
ARGP4
ADDRGP4 CG_FragmentBounceSound
CALLV
pop
line 256
;254:
;255:		// reflect the velocity on the trace plane
;256:		CG_ReflectVelocity( le, &trace );
ADDRFP4 0
INDIRP4
ARGP4
ADDRLP4 0
ARGP4
ADDRGP4 CG_ReflectVelocity
CALLV
pop
line 258
;257:
;258:		trap_R_AddRefEntityToScene( &le->refEntity );
ADDRFP4 0
INDIRP4
CNSTI4 164
ADDP4
ARGP4
ADDRGP4 trap_R_AddRefEntityToScene
CALLV
pop
line 259
;259:	}
LABELV $153
line 260
;260:}
LABELV $137
endproc CG_AddFragment 88 28
export CG_AddFadeRGB
proc CG_AddFadeRGB 60 4
line 276
;261:
;262:/*
;263:=====================================================================
;264:
;265:TRIVIAL LOCAL ENTITIES
;266:
;267:These only do simple scaling or modulation before passing to the renderer
;268:=====================================================================
;269:*/
;270:
;271:/*
;272:====================
;273:CG_AddFadeRGB
;274:====================
;275:*/
;276:void CG_AddFadeRGB( localEntity_t *le ) {
line 280
;277:	refEntity_t *re;
;278:	float c;
;279:
;280:	re = &le->refEntity;
ADDRLP4 0
ADDRFP4 0
INDIRP4
CNSTI4 164
ADDP4
ASGNP4
line 282
;281:
;282:	c = ( le->endTime - cg.time ) * le->lifeRate;
ADDRLP4 8
ADDRFP4 0
INDIRP4
ASGNP4
ADDRLP4 4
ADDRLP4 8
INDIRP4
CNSTI4 20
ADDP4
INDIRI4
ADDRGP4 cg+68
INDIRI4
SUBI4
CVIF4 4
ADDRLP4 8
INDIRP4
CNSTI4 28
ADDP4
INDIRF4
MULF4
ASGNF4
line 283
;283:	c *= 0xff;
ADDRLP4 4
CNSTF4 1132396544
ADDRLP4 4
INDIRF4
MULF4
ASGNF4
line 285
;284:
;285:	re->shaderRGBA[0] = le->color[0] * c;
ADDRLP4 16
ADDRFP4 0
INDIRP4
CNSTI4 116
ADDP4
INDIRF4
ADDRLP4 4
INDIRF4
MULF4
ASGNF4
ADDRLP4 20
CNSTF4 1325400064
ASGNF4
ADDRLP4 16
INDIRF4
ADDRLP4 20
INDIRF4
LTF4 $159
ADDRLP4 12
ADDRLP4 16
INDIRF4
ADDRLP4 20
INDIRF4
SUBF4
CVFI4 4
CVIU4 4
CNSTU4 2147483648
ADDU4
ASGNU4
ADDRGP4 $160
JUMPV
LABELV $159
ADDRLP4 12
ADDRLP4 16
INDIRF4
CVFI4 4
CVIU4 4
ASGNU4
LABELV $160
ADDRLP4 0
INDIRP4
CNSTI4 80
ADDP4
ADDRLP4 12
INDIRU4
CVUU1 4
ASGNU1
line 286
;286:	re->shaderRGBA[1] = le->color[1] * c;
ADDRLP4 28
ADDRFP4 0
INDIRP4
CNSTI4 120
ADDP4
INDIRF4
ADDRLP4 4
INDIRF4
MULF4
ASGNF4
ADDRLP4 32
CNSTF4 1325400064
ASGNF4
ADDRLP4 28
INDIRF4
ADDRLP4 32
INDIRF4
LTF4 $162
ADDRLP4 24
ADDRLP4 28
INDIRF4
ADDRLP4 32
INDIRF4
SUBF4
CVFI4 4
CVIU4 4
CNSTU4 2147483648
ADDU4
ASGNU4
ADDRGP4 $163
JUMPV
LABELV $162
ADDRLP4 24
ADDRLP4 28
INDIRF4
CVFI4 4
CVIU4 4
ASGNU4
LABELV $163
ADDRLP4 0
INDIRP4
CNSTI4 81
ADDP4
ADDRLP4 24
INDIRU4
CVUU1 4
ASGNU1
line 287
;287:	re->shaderRGBA[2] = le->color[2] * c;
ADDRLP4 40
ADDRFP4 0
INDIRP4
CNSTI4 124
ADDP4
INDIRF4
ADDRLP4 4
INDIRF4
MULF4
ASGNF4
ADDRLP4 44
CNSTF4 1325400064
ASGNF4
ADDRLP4 40
INDIRF4
ADDRLP4 44
INDIRF4
LTF4 $165
ADDRLP4 36
ADDRLP4 40
INDIRF4
ADDRLP4 44
INDIRF4
SUBF4
CVFI4 4
CVIU4 4
CNSTU4 2147483648
ADDU4
ASGNU4
ADDRGP4 $166
JUMPV
LABELV $165
ADDRLP4 36
ADDRLP4 40
INDIRF4
CVFI4 4
CVIU4 4
ASGNU4
LABELV $166
ADDRLP4 0
INDIRP4
CNSTI4 82
ADDP4
ADDRLP4 36
INDIRU4
CVUU1 4
ASGNU1
line 288
;288:	re->shaderRGBA[3] = le->color[3] * c;
ADDRLP4 52
ADDRFP4 0
INDIRP4
CNSTI4 128
ADDP4
INDIRF4
ADDRLP4 4
INDIRF4
MULF4
ASGNF4
ADDRLP4 56
CNSTF4 1325400064
ASGNF4
ADDRLP4 52
INDIRF4
ADDRLP4 56
INDIRF4
LTF4 $168
ADDRLP4 48
ADDRLP4 52
INDIRF4
ADDRLP4 56
INDIRF4
SUBF4
CVFI4 4
CVIU4 4
CNSTU4 2147483648
ADDU4
ASGNU4
ADDRGP4 $169
JUMPV
LABELV $168
ADDRLP4 48
ADDRLP4 52
INDIRF4
CVFI4 4
CVIU4 4
ASGNU4
LABELV $169
ADDRLP4 0
INDIRP4
CNSTI4 83
ADDP4
ADDRLP4 48
INDIRU4
CVUU1 4
ASGNU1
line 290
;289:
;290:	trap_R_AddRefEntityToScene( re );
ADDRLP4 0
INDIRP4
ARGP4
ADDRGP4 trap_R_AddRefEntityToScene
CALLV
pop
line 291
;291:}
LABELV $156
endproc CG_AddFadeRGB 60 4
proc CG_AddMoveScaleFade 52 12
line 298
;292:
;293:/*
;294:==================
;295:CG_AddMoveScaleFade
;296:==================
;297:*/
;298:static void CG_AddMoveScaleFade( localEntity_t *le ) {
line 304
;299:	refEntity_t	*re;
;300:	float		c;
;301:	vec3_t		delta;
;302:	float		len;
;303:
;304:	re = &le->refEntity;
ADDRLP4 0
ADDRFP4 0
INDIRP4
CNSTI4 164
ADDP4
ASGNP4
line 306
;305:
;306:	if ( le->fadeInTime > le->startTime && cg.time < le->fadeInTime ) {
ADDRLP4 24
ADDRFP4 0
INDIRP4
ASGNP4
ADDRLP4 28
ADDRLP4 24
INDIRP4
CNSTI4 24
ADDP4
INDIRI4
ASGNI4
ADDRLP4 28
INDIRI4
ADDRLP4 24
INDIRP4
CNSTI4 16
ADDP4
INDIRI4
LEI4 $171
ADDRGP4 cg+68
INDIRI4
ADDRLP4 28
INDIRI4
GEI4 $171
line 308
;307:		// fade / grow time
;308:		c = 1.0 - (float) ( le->fadeInTime - cg.time ) / ( le->fadeInTime - le->startTime );
ADDRLP4 32
ADDRFP4 0
INDIRP4
ASGNP4
ADDRLP4 36
ADDRLP4 32
INDIRP4
CNSTI4 24
ADDP4
INDIRI4
ASGNI4
ADDRLP4 16
CNSTF4 1065353216
ADDRLP4 36
INDIRI4
ADDRGP4 cg+68
INDIRI4
SUBI4
CVIF4 4
ADDRLP4 36
INDIRI4
ADDRLP4 32
INDIRP4
CNSTI4 16
ADDP4
INDIRI4
SUBI4
CVIF4 4
DIVF4
SUBF4
ASGNF4
line 309
;309:	}
ADDRGP4 $172
JUMPV
LABELV $171
line 310
;310:	else {
line 312
;311:		// fade / grow time
;312:		c = ( le->endTime - cg.time ) * le->lifeRate;
ADDRLP4 32
ADDRFP4 0
INDIRP4
ASGNP4
ADDRLP4 16
ADDRLP4 32
INDIRP4
CNSTI4 20
ADDP4
INDIRI4
ADDRGP4 cg+68
INDIRI4
SUBI4
CVIF4 4
ADDRLP4 32
INDIRP4
CNSTI4 28
ADDP4
INDIRF4
MULF4
ASGNF4
line 313
;313:	}
LABELV $172
line 315
;314:
;315:	re->shaderRGBA[3] = 0xff * c * le->color[3];
ADDRLP4 36
CNSTF4 1132396544
ADDRLP4 16
INDIRF4
MULF4
ADDRFP4 0
INDIRP4
CNSTI4 128
ADDP4
INDIRF4
MULF4
ASGNF4
ADDRLP4 40
CNSTF4 1325400064
ASGNF4
ADDRLP4 36
INDIRF4
ADDRLP4 40
INDIRF4
LTF4 $177
ADDRLP4 32
ADDRLP4 36
INDIRF4
ADDRLP4 40
INDIRF4
SUBF4
CVFI4 4
CVIU4 4
CNSTU4 2147483648
ADDU4
ASGNU4
ADDRGP4 $178
JUMPV
LABELV $177
ADDRLP4 32
ADDRLP4 36
INDIRF4
CVFI4 4
CVIU4 4
ASGNU4
LABELV $178
ADDRLP4 0
INDIRP4
CNSTI4 83
ADDP4
ADDRLP4 32
INDIRU4
CVUU1 4
ASGNU1
line 317
;316:
;317:	if ( !( le->leFlags & LEF_PUFF_DONT_SCALE ) ) {
ADDRFP4 0
INDIRP4
CNSTI4 12
ADDP4
INDIRI4
CNSTI4 1
BANDI4
CNSTI4 0
NEI4 $179
line 318
;318:		re->radius = le->radius * ( 1.0 - c ) + 8;
ADDRLP4 0
INDIRP4
CNSTI4 92
ADDP4
ADDRFP4 0
INDIRP4
CNSTI4 132
ADDP4
INDIRF4
CNSTF4 1065353216
ADDRLP4 16
INDIRF4
SUBF4
MULF4
CNSTF4 1090519040
ADDF4
ASGNF4
line 319
;319:	}
LABELV $179
line 321
;320:
;321:	BG_EvaluateTrajectory( &le->pos, cg.time, re->origin );
ADDRFP4 0
INDIRP4
CNSTI4 32
ADDP4
ARGP4
ADDRGP4 cg+68
INDIRI4
ARGI4
ADDRLP4 0
INDIRP4
CNSTI4 52
ADDP4
ARGP4
ADDRGP4 BG_EvaluateTrajectory
CALLV
pop
line 325
;322:
;323:	// if the view would be "inside" the sprite, kill the sprite
;324:	// so it doesn't add too much overdraw
;325:	VectorSubtract( re->origin, cg.refdef.vieworg, delta );
ADDRLP4 4
ADDRLP4 0
INDIRP4
CNSTI4 52
ADDP4
INDIRF4
ADDRGP4 cg+1200+24
INDIRF4
SUBF4
ASGNF4
ADDRLP4 4+4
ADDRLP4 0
INDIRP4
CNSTI4 56
ADDP4
INDIRF4
ADDRGP4 cg+1200+24+4
INDIRF4
SUBF4
ASGNF4
ADDRLP4 4+8
ADDRLP4 0
INDIRP4
CNSTI4 60
ADDP4
INDIRF4
ADDRGP4 cg+1200+24+8
INDIRF4
SUBF4
ASGNF4
line 326
;326:	len = VectorLength( delta );
ADDRLP4 4
ARGP4
ADDRLP4 48
ADDRGP4 VectorLength
CALLF4
ASGNF4
ADDRLP4 20
ADDRLP4 48
INDIRF4
ASGNF4
line 327
;327:	if ( len < le->radius ) {
ADDRLP4 20
INDIRF4
ADDRFP4 0
INDIRP4
CNSTI4 132
ADDP4
INDIRF4
GEF4 $192
line 328
;328:		CG_FreeLocalEntity( le );
ADDRFP4 0
INDIRP4
ARGP4
ADDRGP4 CG_FreeLocalEntity
CALLV
pop
line 329
;329:		return;
ADDRGP4 $170
JUMPV
LABELV $192
line 332
;330:	}
;331:
;332:	trap_R_AddRefEntityToScene( re );
ADDRLP4 0
INDIRP4
ARGP4
ADDRGP4 trap_R_AddRefEntityToScene
CALLV
pop
line 333
;333:}
LABELV $170
endproc CG_AddMoveScaleFade 52 12
proc CG_AddScaleFade 48 4
line 344
;334:
;335:/*
;336:===================
;337:CG_AddScaleFade
;338:
;339:For rocket smokes that hang in place, fade out, and are
;340:removed if the view passes through them.
;341:There are often many of these, so it needs to be simple.
;342:===================
;343:*/
;344:static void CG_AddScaleFade( localEntity_t *le ) {
line 350
;345:	refEntity_t	*re;
;346:	float		c;
;347:	vec3_t		delta;
;348:	float		len;
;349:
;350:	re = &le->refEntity;
ADDRLP4 0
ADDRFP4 0
INDIRP4
CNSTI4 164
ADDP4
ASGNP4
line 353
;351:
;352:	// fade / grow time
;353:	c = ( le->endTime - cg.time ) * le->lifeRate;
ADDRLP4 24
ADDRFP4 0
INDIRP4
ASGNP4
ADDRLP4 16
ADDRLP4 24
INDIRP4
CNSTI4 20
ADDP4
INDIRI4
ADDRGP4 cg+68
INDIRI4
SUBI4
CVIF4 4
ADDRLP4 24
INDIRP4
CNSTI4 28
ADDP4
INDIRF4
MULF4
ASGNF4
line 355
;354:
;355:	re->shaderRGBA[3] = 0xff * c * le->color[3];
ADDRLP4 32
CNSTF4 1132396544
ADDRLP4 16
INDIRF4
MULF4
ADDRFP4 0
INDIRP4
CNSTI4 128
ADDP4
INDIRF4
MULF4
ASGNF4
ADDRLP4 36
CNSTF4 1325400064
ASGNF4
ADDRLP4 32
INDIRF4
ADDRLP4 36
INDIRF4
LTF4 $197
ADDRLP4 28
ADDRLP4 32
INDIRF4
ADDRLP4 36
INDIRF4
SUBF4
CVFI4 4
CVIU4 4
CNSTU4 2147483648
ADDU4
ASGNU4
ADDRGP4 $198
JUMPV
LABELV $197
ADDRLP4 28
ADDRLP4 32
INDIRF4
CVFI4 4
CVIU4 4
ASGNU4
LABELV $198
ADDRLP4 0
INDIRP4
CNSTI4 83
ADDP4
ADDRLP4 28
INDIRU4
CVUU1 4
ASGNU1
line 356
;356:	re->radius = le->radius * ( 1.0 - c ) + 8;
ADDRLP4 0
INDIRP4
CNSTI4 92
ADDP4
ADDRFP4 0
INDIRP4
CNSTI4 132
ADDP4
INDIRF4
CNSTF4 1065353216
ADDRLP4 16
INDIRF4
SUBF4
MULF4
CNSTF4 1090519040
ADDF4
ASGNF4
line 360
;357:
;358:	// if the view would be "inside" the sprite, kill the sprite
;359:	// so it doesn't add too much overdraw
;360:	VectorSubtract( re->origin, cg.refdef.vieworg, delta );
ADDRLP4 4
ADDRLP4 0
INDIRP4
CNSTI4 52
ADDP4
INDIRF4
ADDRGP4 cg+1200+24
INDIRF4
SUBF4
ASGNF4
ADDRLP4 4+4
ADDRLP4 0
INDIRP4
CNSTI4 56
ADDP4
INDIRF4
ADDRGP4 cg+1200+24+4
INDIRF4
SUBF4
ASGNF4
ADDRLP4 4+8
ADDRLP4 0
INDIRP4
CNSTI4 60
ADDP4
INDIRF4
ADDRGP4 cg+1200+24+8
INDIRF4
SUBF4
ASGNF4
line 361
;361:	len = VectorLength( delta );
ADDRLP4 4
ARGP4
ADDRLP4 44
ADDRGP4 VectorLength
CALLF4
ASGNF4
ADDRLP4 20
ADDRLP4 44
INDIRF4
ASGNF4
line 362
;362:	if ( len < le->radius ) {
ADDRLP4 20
INDIRF4
ADDRFP4 0
INDIRP4
CNSTI4 132
ADDP4
INDIRF4
GEF4 $209
line 363
;363:		CG_FreeLocalEntity( le );
ADDRFP4 0
INDIRP4
ARGP4
ADDRGP4 CG_FreeLocalEntity
CALLV
pop
line 364
;364:		return;
ADDRGP4 $194
JUMPV
LABELV $209
line 367
;365:	}
;366:
;367:	trap_R_AddRefEntityToScene( re );
ADDRLP4 0
INDIRP4
ARGP4
ADDRGP4 trap_R_AddRefEntityToScene
CALLV
pop
line 368
;368:}
LABELV $194
endproc CG_AddScaleFade 48 4
proc CG_AddFallScaleFade 52 4
line 381
;369:
;370:
;371:/*
;372:=================
;373:CG_AddFallScaleFade
;374:
;375:This is just an optimized CG_AddMoveScaleFade
;376:For blood mists that drift down, fade out, and are
;377:removed if the view passes through them.
;378:There are often 100+ of these, so it needs to be simple.
;379:=================
;380:*/
;381:static void CG_AddFallScaleFade( localEntity_t *le ) {
line 387
;382:	refEntity_t	*re;
;383:	float		c;
;384:	vec3_t		delta;
;385:	float		len;
;386:
;387:	re = &le->refEntity;
ADDRLP4 0
ADDRFP4 0
INDIRP4
CNSTI4 164
ADDP4
ASGNP4
line 390
;388:
;389:	// fade time
;390:	c = ( le->endTime - cg.time ) * le->lifeRate;
ADDRLP4 24
ADDRFP4 0
INDIRP4
ASGNP4
ADDRLP4 4
ADDRLP4 24
INDIRP4
CNSTI4 20
ADDP4
INDIRI4
ADDRGP4 cg+68
INDIRI4
SUBI4
CVIF4 4
ADDRLP4 24
INDIRP4
CNSTI4 28
ADDP4
INDIRF4
MULF4
ASGNF4
line 392
;391:
;392:	re->shaderRGBA[3] = 0xff * c * le->color[3];
ADDRLP4 32
CNSTF4 1132396544
ADDRLP4 4
INDIRF4
MULF4
ADDRFP4 0
INDIRP4
CNSTI4 128
ADDP4
INDIRF4
MULF4
ASGNF4
ADDRLP4 36
CNSTF4 1325400064
ASGNF4
ADDRLP4 32
INDIRF4
ADDRLP4 36
INDIRF4
LTF4 $214
ADDRLP4 28
ADDRLP4 32
INDIRF4
ADDRLP4 36
INDIRF4
SUBF4
CVFI4 4
CVIU4 4
CNSTU4 2147483648
ADDU4
ASGNU4
ADDRGP4 $215
JUMPV
LABELV $214
ADDRLP4 28
ADDRLP4 32
INDIRF4
CVFI4 4
CVIU4 4
ASGNU4
LABELV $215
ADDRLP4 0
INDIRP4
CNSTI4 83
ADDP4
ADDRLP4 28
INDIRU4
CVUU1 4
ASGNU1
line 394
;393:
;394:	re->origin[2] = le->pos.trBase[2] - ( 1.0 - c ) * le->pos.trDelta[2];
ADDRLP4 40
ADDRFP4 0
INDIRP4
ASGNP4
ADDRLP4 0
INDIRP4
CNSTI4 60
ADDP4
ADDRLP4 40
INDIRP4
CNSTI4 52
ADDP4
INDIRF4
CNSTF4 1065353216
ADDRLP4 4
INDIRF4
SUBF4
ADDRLP4 40
INDIRP4
CNSTI4 64
ADDP4
INDIRF4
MULF4
SUBF4
ASGNF4
line 396
;395:
;396:	re->radius = le->radius * ( 1.0 - c ) + 16;
ADDRLP4 0
INDIRP4
CNSTI4 92
ADDP4
ADDRFP4 0
INDIRP4
CNSTI4 132
ADDP4
INDIRF4
CNSTF4 1065353216
ADDRLP4 4
INDIRF4
SUBF4
MULF4
CNSTF4 1098907648
ADDF4
ASGNF4
line 400
;397:
;398:	// if the view would be "inside" the sprite, kill the sprite
;399:	// so it doesn't add too much overdraw
;400:	VectorSubtract( re->origin, cg.refdef.vieworg, delta );
ADDRLP4 8
ADDRLP4 0
INDIRP4
CNSTI4 52
ADDP4
INDIRF4
ADDRGP4 cg+1200+24
INDIRF4
SUBF4
ASGNF4
ADDRLP4 8+4
ADDRLP4 0
INDIRP4
CNSTI4 56
ADDP4
INDIRF4
ADDRGP4 cg+1200+24+4
INDIRF4
SUBF4
ASGNF4
ADDRLP4 8+8
ADDRLP4 0
INDIRP4
CNSTI4 60
ADDP4
INDIRF4
ADDRGP4 cg+1200+24+8
INDIRF4
SUBF4
ASGNF4
line 401
;401:	len = VectorLength( delta );
ADDRLP4 8
ARGP4
ADDRLP4 48
ADDRGP4 VectorLength
CALLF4
ASGNF4
ADDRLP4 20
ADDRLP4 48
INDIRF4
ASGNF4
line 402
;402:	if ( len < le->radius ) {
ADDRLP4 20
INDIRF4
ADDRFP4 0
INDIRP4
CNSTI4 132
ADDP4
INDIRF4
GEF4 $226
line 403
;403:		CG_FreeLocalEntity( le );
ADDRFP4 0
INDIRP4
ARGP4
ADDRGP4 CG_FreeLocalEntity
CALLV
pop
line 404
;404:		return;
ADDRGP4 $211
JUMPV
LABELV $226
line 407
;405:	}
;406:
;407:	trap_R_AddRefEntityToScene( re );
ADDRLP4 0
INDIRP4
ARGP4
ADDRGP4 trap_R_AddRefEntityToScene
CALLV
pop
line 408
;408:}
LABELV $211
endproc CG_AddFallScaleFade 52 4
export CG_AddRefEntity
proc CG_AddRefEntity 0 4
line 416
;409:
;410:/*
;411:===================
;412:CG_AddRefEntity
;413:===================
;414:*/
;415:void CG_AddRefEntity( localEntity_t *le ) 
;416:{
line 417
;417:	if (le->endTime < cg.time) 
ADDRFP4 0
INDIRP4
CNSTI4 20
ADDP4
INDIRI4
ADDRGP4 cg+68
INDIRI4
GEI4 $229
line 418
;418:	{
line 419
;419:		CG_FreeLocalEntity( le );
ADDRFP4 0
INDIRP4
ARGP4
ADDRGP4 CG_FreeLocalEntity
CALLV
pop
line 420
;420:		return;
ADDRGP4 $228
JUMPV
LABELV $229
line 422
;421:	}
;422:	trap_R_AddRefEntityToScene( &le->refEntity );
ADDRFP4 0
INDIRP4
CNSTI4 164
ADDP4
ARGP4
ADDRGP4 trap_R_AddRefEntityToScene
CALLV
pop
line 423
;423:}
LABELV $228
endproc CG_AddRefEntity 0 4
export CG_AddLine
proc CG_AddLine 4 4
line 432
;424:
;425:
;426:/*
;427:===================
;428:CG_AddLine
;429:===================
;430:*/
;431:void CG_AddLine( localEntity_t *le )
;432:{
line 435
;433:	refEntity_t	*re;
;434:
;435:	re = &le->refEntity;
ADDRLP4 0
ADDRFP4 0
INDIRP4
CNSTI4 164
ADDP4
ASGNP4
line 437
;436:
;437:	re->reType = RT_LINE;
ADDRLP4 0
INDIRP4
CNSTI4 7
ASGNI4
line 439
;438:
;439:	trap_R_AddRefEntityToScene( re );
ADDRLP4 0
INDIRP4
ARGP4
ADDRGP4 trap_R_AddRefEntityToScene
CALLV
pop
line 440
;440:}
LABELV $232
endproc CG_AddLine 4 4
export CG_AddGib
proc CG_AddGib 96 28
line 447
;441:
;442:/*
;443:================
;444:CG_AddGib
;445:================
;446:*/
;447:void CG_AddGib( localEntity_t *le ) {
line 451
;448:	vec3_t	newOrigin;
;449:	trace_t	trace;
;450:
;451:	if ( le->pos.trType == TR_STATIONARY ) {
ADDRFP4 0
INDIRP4
CNSTI4 32
ADDP4
INDIRI4
CNSTI4 0
NEI4 $234
line 456
;452:		// sink into the ground if near the removal time
;453:		int		t;
;454:		float	oldZ;
;455:		
;456:		le->refEntity.origin[2] += le->zOffset;
ADDRLP4 76
ADDRFP4 0
INDIRP4
ASGNP4
ADDRLP4 80
ADDRLP4 76
INDIRP4
CNSTI4 224
ADDP4
ASGNP4
ADDRLP4 80
INDIRP4
ADDRLP4 80
INDIRP4
INDIRF4
ADDRLP4 76
INDIRP4
CNSTI4 160
ADDP4
INDIRF4
ADDF4
ASGNF4
line 457
;457:		t = le->endTime - cg.time;
ADDRLP4 68
ADDRFP4 0
INDIRP4
CNSTI4 20
ADDP4
INDIRI4
ADDRGP4 cg+68
INDIRI4
SUBI4
ASGNI4
line 458
;458:		if ( t < SINK_TIME ) {
ADDRLP4 68
INDIRI4
CNSTI4 1000
GEI4 $237
line 462
;459:			// we must use an explicit lighting origin, otherwise the
;460:			// lighting would be lost as soon as the origin went
;461:			// into the ground
;462:			VectorCopy( le->refEntity.origin, le->refEntity.lightingOrigin );
ADDRLP4 84
ADDRFP4 0
INDIRP4
ASGNP4
ADDRLP4 84
INDIRP4
CNSTI4 272
ADDP4
ADDRLP4 84
INDIRP4
CNSTI4 216
ADDP4
INDIRB
ASGNB 12
line 463
;463:			le->refEntity.renderfx |= RF_LIGHTING_ORIGIN;
ADDRLP4 88
ADDRFP4 0
INDIRP4
CNSTI4 168
ADDP4
ASGNP4
ADDRLP4 88
INDIRP4
ADDRLP4 88
INDIRP4
INDIRI4
CNSTI4 128
BORI4
ASGNI4
line 464
;464:			oldZ = le->refEntity.origin[2];
ADDRLP4 72
ADDRFP4 0
INDIRP4
CNSTI4 224
ADDP4
INDIRF4
ASGNF4
line 465
;465:			le->refEntity.origin[2] -= 16 * ( 1.0 - (float)t / SINK_TIME );
ADDRLP4 92
ADDRFP4 0
INDIRP4
CNSTI4 224
ADDP4
ASGNP4
ADDRLP4 92
INDIRP4
ADDRLP4 92
INDIRP4
INDIRF4
CNSTF4 1098907648
CNSTF4 1065353216
ADDRLP4 68
INDIRI4
CVIF4 4
CNSTF4 1148846080
DIVF4
SUBF4
MULF4
SUBF4
ASGNF4
line 466
;466:			trap_R_AddRefEntityToScene( &le->refEntity );
ADDRFP4 0
INDIRP4
CNSTI4 164
ADDP4
ARGP4
ADDRGP4 trap_R_AddRefEntityToScene
CALLV
pop
line 467
;467:			le->refEntity.origin[2] = oldZ;
ADDRFP4 0
INDIRP4
CNSTI4 224
ADDP4
ADDRLP4 72
INDIRF4
ASGNF4
line 468
;468:		} else {
ADDRGP4 $238
JUMPV
LABELV $237
line 469
;469:			trap_R_AddRefEntityToScene( &le->refEntity );
ADDRFP4 0
INDIRP4
CNSTI4 164
ADDP4
ARGP4
ADDRGP4 trap_R_AddRefEntityToScene
CALLV
pop
line 470
;470:		}
LABELV $238
line 471
;471:		le->refEntity.origin[2] -= le->zOffset;
ADDRLP4 84
ADDRFP4 0
INDIRP4
ASGNP4
ADDRLP4 88
ADDRLP4 84
INDIRP4
CNSTI4 224
ADDP4
ASGNP4
ADDRLP4 88
INDIRP4
ADDRLP4 88
INDIRP4
INDIRF4
ADDRLP4 84
INDIRP4
CNSTI4 160
ADDP4
INDIRF4
SUBF4
ASGNF4
line 473
;472:
;473:		return;
ADDRGP4 $233
JUMPV
LABELV $234
line 477
;474:	}
;475:
;476:	// calculate new position
;477:	BG_EvaluateTrajectory( &le->pos, cg.time, newOrigin );
ADDRFP4 0
INDIRP4
CNSTI4 32
ADDP4
ARGP4
ADDRGP4 cg+68
INDIRI4
ARGI4
ADDRLP4 56
ARGP4
ADDRGP4 BG_EvaluateTrajectory
CALLV
pop
line 480
;478:
;479:	// trace a line from previous position to new position
;480:	CG_Trace( &trace, le->refEntity.origin, NULL, NULL, newOrigin, -1, CONTENTS_SOLID );
ADDRLP4 0
ARGP4
ADDRFP4 0
INDIRP4
CNSTI4 216
ADDP4
ARGP4
ADDRLP4 68
CNSTP4 0
ASGNP4
ADDRLP4 68
INDIRP4
ARGP4
ADDRLP4 68
INDIRP4
ARGP4
ADDRLP4 56
ARGP4
CNSTI4 -1
ARGI4
CNSTI4 1
ARGI4
ADDRGP4 CG_Trace
CALLV
pop
line 481
;481:	if ( trace.fraction == 1.0 ) {
ADDRLP4 0+8
INDIRF4
CNSTF4 1065353216
NEF4 $240
line 483
;482:		// still in free fall
;483:		VectorCopy( newOrigin, le->refEntity.origin );
ADDRFP4 0
INDIRP4
CNSTI4 216
ADDP4
ADDRLP4 56
INDIRB
ASGNB 12
line 485
;484:
;485:		if ( le->leFlags & LEF_TUMBLE ) {
ADDRFP4 0
INDIRP4
CNSTI4 12
ADDP4
INDIRI4
CNSTI4 2
BANDI4
CNSTI4 0
EQI4 $243
line 488
;486:			vec3_t angles;
;487:
;488:			BG_EvaluateTrajectory( &le->angles, cg.time, angles );
ADDRFP4 0
INDIRP4
CNSTI4 68
ADDP4
ARGP4
ADDRGP4 cg+68
INDIRI4
ARGI4
ADDRLP4 72
ARGP4
ADDRGP4 BG_EvaluateTrajectory
CALLV
pop
line 489
;489:			AnglesToAxis( angles, le->refEntity.axis );
ADDRLP4 72
ARGP4
ADDRFP4 0
INDIRP4
CNSTI4 176
ADDP4
ARGP4
ADDRGP4 AnglesToAxis
CALLV
pop
line 490
;490:		}
LABELV $243
line 492
;491:
;492:		le->refEntity.origin[2] += le->zOffset;
ADDRLP4 72
ADDRFP4 0
INDIRP4
ASGNP4
ADDRLP4 76
ADDRLP4 72
INDIRP4
CNSTI4 224
ADDP4
ASGNP4
ADDRLP4 76
INDIRP4
ADDRLP4 76
INDIRP4
INDIRF4
ADDRLP4 72
INDIRP4
CNSTI4 160
ADDP4
INDIRF4
ADDF4
ASGNF4
line 493
;493:		trap_R_AddRefEntityToScene( &le->refEntity );
ADDRFP4 0
INDIRP4
CNSTI4 164
ADDP4
ARGP4
ADDRGP4 trap_R_AddRefEntityToScene
CALLV
pop
line 494
;494:		le->refEntity.origin[2] -= le->zOffset;
ADDRLP4 80
ADDRFP4 0
INDIRP4
ASGNP4
ADDRLP4 84
ADDRLP4 80
INDIRP4
CNSTI4 224
ADDP4
ASGNP4
ADDRLP4 84
INDIRP4
ADDRLP4 84
INDIRP4
INDIRF4
ADDRLP4 80
INDIRP4
CNSTI4 160
ADDP4
INDIRF4
SUBF4
ASGNF4
line 496
;495:
;496:		return;
ADDRGP4 $233
JUMPV
LABELV $240
line 502
;497:	}
;498:
;499:	// if it is in a nodrop zone, remove it
;500:	// this keeps gibs from waiting at the bottom of pits of death
;501:	// and floating levels
;502:	if ( trap_CM_PointContents( trace.endpos, 0 ) & CONTENTS_NODROP ) 
ADDRLP4 0+12
ARGP4
CNSTI4 0
ARGI4
ADDRLP4 72
ADDRGP4 trap_CM_PointContents
CALLI4
ASGNI4
ADDRLP4 72
INDIRI4
CNSTI4 2048
BANDI4
CNSTI4 0
EQI4 $246
line 503
;503:	{
line 504
;504:		CG_FreeLocalEntity( le );
ADDRFP4 0
INDIRP4
ARGP4
ADDRGP4 CG_FreeLocalEntity
CALLV
pop
line 505
;505:		return;
ADDRGP4 $233
JUMPV
LABELV $246
line 508
;506:	}
;507:
;508:	if (!trace.startsolid)
ADDRLP4 0+4
INDIRI4
CNSTI4 0
NEI4 $249
line 509
;509:	{
line 517
;510:		// leave a mark
;511://		CG_FragmentBounceMark( le, &trace );
;512:
;513:		// do a bouncy sound
;514://		CG_FragmentBounceSound( le, &trace );
;515:
;516:		// reflect the velocity on the trace plane
;517:		CG_ReflectVelocity( le, &trace );
ADDRFP4 0
INDIRP4
ARGP4
ADDRLP4 0
ARGP4
ADDRGP4 CG_ReflectVelocity
CALLV
pop
line 519
;518:
;519:		le->refEntity.origin[2] += le->zOffset;
ADDRLP4 76
ADDRFP4 0
INDIRP4
ASGNP4
ADDRLP4 80
ADDRLP4 76
INDIRP4
CNSTI4 224
ADDP4
ASGNP4
ADDRLP4 80
INDIRP4
ADDRLP4 80
INDIRP4
INDIRF4
ADDRLP4 76
INDIRP4
CNSTI4 160
ADDP4
INDIRF4
ADDF4
ASGNF4
line 520
;520:		trap_R_AddRefEntityToScene( &le->refEntity );
ADDRFP4 0
INDIRP4
CNSTI4 164
ADDP4
ARGP4
ADDRGP4 trap_R_AddRefEntityToScene
CALLV
pop
line 521
;521:		le->refEntity.origin[2] -= le->zOffset;
ADDRLP4 84
ADDRFP4 0
INDIRP4
ASGNP4
ADDRLP4 88
ADDRLP4 84
INDIRP4
CNSTI4 224
ADDP4
ASGNP4
ADDRLP4 88
INDIRP4
ADDRLP4 88
INDIRP4
INDIRF4
ADDRLP4 84
INDIRP4
CNSTI4 160
ADDP4
INDIRF4
SUBF4
ASGNF4
line 522
;522:	}
LABELV $249
line 523
;523:}
LABELV $233
endproc CG_AddGib 96 28
export CG_AddLocalEntities
proc CG_AddLocalEntities 16 12
line 533
;524:
;525://==============================================================================
;526:
;527:/*
;528:===================
;529:CG_AddLocalEntities
;530:===================
;531:*/
;532:void CG_AddLocalEntities( void ) 
;533:{
line 538
;534:	localEntity_t	*le, *next;
;535:
;536:	// walk the list backwards, so any new local entities generated
;537:	// (trails, marks, etc) will be present this frame
;538:	le = cg_activeLocalEntities.prev;
ADDRLP4 0
ADDRGP4 cg_activeLocalEntities
INDIRP4
ASGNP4
line 539
;539:	for ( ; le != &cg_activeLocalEntities ; le = next ) 
ADDRGP4 $256
JUMPV
LABELV $253
line 540
;540:	{
line 543
;541:		// grab next now, so if the local entity is freed we
;542:		// still have it
;543:		next = le->prev;
ADDRLP4 4
ADDRLP4 0
INDIRP4
INDIRP4
ASGNP4
line 545
;544:
;545:		if ( cg.time >= le->endTime ) 
ADDRGP4 cg+68
INDIRI4
ADDRLP4 0
INDIRP4
CNSTI4 20
ADDP4
INDIRI4
LTI4 $257
line 546
;546:		{
line 547
;547:			CG_FreeLocalEntity( le );
ADDRLP4 0
INDIRP4
ARGP4
ADDRGP4 CG_FreeLocalEntity
CALLV
pop
line 548
;548:			continue;
ADDRGP4 $254
JUMPV
LABELV $257
line 551
;549:		}
;550:
;551:		switch ( le->leType ) 
ADDRLP4 8
ADDRLP4 0
INDIRP4
CNSTI4 8
ADDP4
INDIRI4
ASGNI4
ADDRLP4 8
INDIRI4
CNSTI4 0
LTI4 $260
ADDRLP4 8
INDIRI4
CNSTI4 7
GTI4 $260
ADDRLP4 8
INDIRI4
CNSTI4 2
LSHI4
ADDRGP4 $272
ADDP4
INDIRP4
JUMPV
lit
align 4
LABELV $272
address $264
address $265
address $267
address $266
address $268
address $269
address $270
address $271
code
line 552
;552:		{
LABELV $260
line 554
;553:			default:
;554:				Com_Error( ERR_FATAL, "Bad leType: %i", le->leType );
CNSTI4 0
ARGI4
ADDRGP4 $263
ARGP4
ADDRLP4 0
INDIRP4
CNSTI4 8
ADDP4
INDIRI4
ARGI4
ADDRGP4 Com_Error
CALLV
pop
line 555
;555:				break;
ADDRGP4 $261
JUMPV
LABELV $264
line 558
;556:
;557:			case LE_FRAGMENT:
;558:				CG_AddFragment( le );
ADDRLP4 0
INDIRP4
ARGP4
ADDRGP4 CG_AddFragment
CALLV
pop
line 559
;559:				break;
ADDRGP4 $261
JUMPV
LABELV $265
line 562
;560:
;561:			case LE_MOVE_SCALE_FADE:
;562:				CG_AddMoveScaleFade( le );
ADDRLP4 0
INDIRP4
ARGP4
ADDRGP4 CG_AddMoveScaleFade
CALLV
pop
line 563
;563:				break;
ADDRGP4 $261
JUMPV
LABELV $266
line 566
;564:
;565:			case LE_FADE_RGB:
;566:				CG_AddFadeRGB( le );
ADDRLP4 0
INDIRP4
ARGP4
ADDRGP4 CG_AddFadeRGB
CALLV
pop
line 567
;567:				break;
ADDRGP4 $261
JUMPV
LABELV $267
line 570
;568:
;569:			case LE_FALL_SCALE_FADE:
;570:				CG_AddFallScaleFade( le );
ADDRLP4 0
INDIRP4
ARGP4
ADDRGP4 CG_AddFallScaleFade
CALLV
pop
line 571
;571:				break;
ADDRGP4 $261
JUMPV
LABELV $268
line 574
;572:
;573:			case LE_SCALE_FADE:
;574:				CG_AddScaleFade( le );
ADDRLP4 0
INDIRP4
ARGP4
ADDRGP4 CG_AddScaleFade
CALLV
pop
line 575
;575:				break;
ADDRGP4 $261
JUMPV
LABELV $269
line 578
;576:
;577:			case LE_SHOWREFENTITY:
;578:				CG_AddRefEntity( le );
ADDRLP4 0
INDIRP4
ARGP4
ADDRGP4 CG_AddRefEntity
CALLV
pop
line 579
;579:				break;
ADDRGP4 $261
JUMPV
LABELV $270
line 582
;580:
;581:			case LE_LINE:
;582:				CG_AddLine( le );
ADDRLP4 0
INDIRP4
ARGP4
ADDRGP4 CG_AddLine
CALLV
pop
line 583
;583:				break;
ADDRGP4 $261
JUMPV
LABELV $271
line 586
;584:
;585:			case LE_GIB:
;586:				CG_AddGib(le);
ADDRLP4 0
INDIRP4
ARGP4
ADDRGP4 CG_AddGib
CALLV
pop
line 587
;587:				break;
LABELV $261
line 589
;588:		}
;589:	}
LABELV $254
line 539
ADDRLP4 0
ADDRLP4 4
INDIRP4
ASGNP4
LABELV $256
ADDRLP4 0
INDIRP4
CVPU4 4
ADDRGP4 cg_activeLocalEntities
CVPU4 4
NEU4 $253
line 590
;590:}
LABELV $252
endproc CG_AddLocalEntities 16 12
bss
export cg_freeLocalEntities
align 4
LABELV cg_freeLocalEntities
skip 4
export cg_activeLocalEntities
align 4
LABELV cg_activeLocalEntities
skip 368
export cg_localEntities
align 4
LABELV cg_localEntities
skip 188416
import CG_ParseGametypeFile
import CG_DrawMiscEnts
import CG_MiscEnt
import G2_PositionEntityOnBolt
import CG_PredictedProcGore
import CG_AddProcGore
import CG_SetGhoul2Info
import CG_Init_CGents
import CG_Init_CG
import trap_UI_SetActiveMenu
import trap_UI_CloseAll
import trap_CG_RegisterSharedMemory
import trap_RE_InitRendererTerrain
import trap_CM_RegisterTerrain
import trap_CM_TM_ConvertPosition
import trap_CM_TM_Upload
import trap_CM_TM_AddTarget
import trap_CM_TM_AddSpot
import trap_CM_TM_AddBuilding
import trap_CM_TM_Create
import trap_MAT_GetDebrisScale
import trap_MAT_GetDebris
import trap_MAT_GetEffect
import trap_MAT_GetDecalScale
import trap_MAT_GetDecal
import trap_MAT_GetSound
import trap_MAT_Reset
import trap_MAT_Init
import trap_G2API_SetSkin
import trap_G2API_RegisterSkin
import trap_G2API_GetBoltIndex
import trap_G2API_FindBoltIndex
import trap_G2API_GetNumModels
import trap_G2API_GetGhoul2ModelFlagsByIndex
import trap_G2API_SetGhoul2ModelFlagsByIndex
import trap_G2API_GetGhoul2ModelFlags
import trap_G2API_SetGhoul2ModelFlags
import trap_G2API_ClearSkinGore
import trap_G2API_AddSkinGore
import trap_G2API_SetNewOrigin
import trap_G2API_SetRootSurface
import trap_G2API_SetSurfaceOnOff
import trap_G2API_GetBoneAnim
import trap_G2API_SetBoneAnim
import trap_G2API_GetGLAName
import trap_G2API_SetBoneAngles
import trap_G2API_CleanGhoul2Models
import trap_G2API_RemoveGhoul2Model
import trap_G2API_DuplicateGhoul2Instance
import trap_G2API_CopySpecificGhoul2Model
import trap_G2API_CopyGhoul2Instance
import trap_G2API_GetAnimFileNameIndex
import trap_G2API_InitGhoul2Model
import trap_G2API_GetBoltMatrix
import trap_G2_HaveWeGhoul2Models
import trap_G2_SetGhoul2ModelIndexes
import trap_G2API_DetachG2Model
import trap_G2API_AttachG2Model
import trap_G2API_RemoveBolt
import trap_G2API_SetBoltInfo
import trap_G2API_AddBolt
import trap_G2_ListModelBones
import trap_G2_ListModelSurfaces
import trap_G2API_CollisionDetect
import trap_R_inPVS
import trap_GetEntityToken
import trap_SnapVector
import trap_RMG_Init
import trap_Key_GetKey
import trap_Key_SetCatcher
import trap_Key_GetCatcher
import trap_Key_IsDown
import trap_MemoryRemaining
import trap_FX_AddLine
import trap_FX_Reset
import trap_FX_AdjustTime
import trap_FX_FreeSystem
import trap_FX_Draw2DEffects
import trap_FX_AddScheduledEffects
import trap_FX_PlayBoltedEffectID
import trap_FX_PlayEntityEffectID
import trap_FX_PlayEffectID
import trap_FX_PlaySimpleEffectID
import trap_FX_PlayEntityEffect
import trap_FX_PlayEffect
import trap_FX_PlaySimpleEffect
import trap_FX_RegisterEffect
import trap_FX_InitSystem
import trap_CIN_SetExtents
import trap_CIN_DrawCinematic
import trap_CIN_RunCinematic
import trap_CIN_StopCinematic
import trap_CIN_PlayCinematic
import testPrintFloat
import testPrintInt
import trap_ResetAutorun
import trap_RW_SetTeam
import trap_SetUserCmdValue
import trap_GetUserCmd
import trap_GetCurrentCmdNumber
import trap_GetServerCommand
import trap_GetDefaultState
import trap_GetSnapshot
import trap_GetCurrentSnapshotNumber
import trap_GetGameState
import trap_GetGlconfig
import trap_R_SetLightStyle
import trap_R_GetLightStyle
import trap_R_RemapShader
import trap_R_DrawRotatePic2
import trap_R_DrawRotatePic
import trap_R_LerpTag
import trap_R_ModelBounds
import trap_R_DrawStretchPic
import trap_R_SetColor
import trap_R_DrawVisualOverlay
import trap_R_RenderScene
import trap_R_LightForPoint
import trap_R_AddLightToScene
import trap_R_AddDecalToScene
import trap_R_AddPolysToScene
import trap_R_AddPolyToScene
import trap_R_DrawTextWithCursor
import trap_R_DrawText
import trap_R_GetTextHeight
import trap_R_GetTextWidth
import trap_R_AddRefEntityToScene
import trap_R_ClearDecals
import trap_R_ClearScene
import trap_R_RegisterFont
import trap_R_RegisterShaderNoMip
import trap_R_RegisterShader
import trap_R_RegisterSkin
import trap_R_RegisterModel
import trap_R_LoadWorldMap
import trap_AS_GetBModelSound
import trap_AS_AddLocalSet
import trap_AS_UpdateAmbientSet
import trap_AS_ParseSets
import trap_AS_AddPrecacheEntry
import trap_S_StopBackgroundTrack
import trap_S_StartBackgroundTrack
import trap_S_RegisterSound
import trap_S_Respatialize
import trap_S_UpdateEntityPosition
import trap_S_AddRealLoopingSound
import trap_S_AddLoopingSound
import trap_S_ClearLoopingSounds
import trap_S_StartLocalSound
import trap_S_StopLoopingSound
import trap_S_StartSound
import trap_S_StopAllSounds
import trap_CM_MarkFragments
import trap_CM_TransformedBoxTrace
import trap_CM_BoxTrace
import trap_CM_TransformedPointContents
import trap_CM_PointContents
import trap_CM_TempBoxModel
import trap_CM_InlineModel
import trap_CM_NumInlineModels
import trap_CM_LoadMap
import trap_UpdateScreen
import trap_SendClientCommand
import trap_AddCommand
import trap_SendConsoleCommand
import trap_FS_FCloseFile
import trap_FS_Write
import trap_FS_Read
import trap_FS_FOpenFile
import trap_Args
import trap_Argv
import trap_Argc
import trap_Cvar_VariableStringBuffer
import trap_Cvar_Set
import trap_Cvar_Update
import trap_Cvar_Register
import trap_Milliseconds
import trap_Error
import trap_Print
import CG_ApplyGore
import CG_ParseGore
import CG_ParseAnimationFile
import CG_CheckChangedPredictableEvents
import CG_TransitionPlayerState
import CG_Respawn
import CG_PlayBufferedVoiceChats
import CG_VoiceChatLocal
import CG_ShaderStateChanged
import CG_LoadVoiceChats
import CG_SetConfigValues
import CG_ParseServerinfo
import CG_ExecuteNewServerCommands
import CG_MapRestart
import CG_InitConsoleCommands
import CG_ConsoleCommand
import CG_DrawScoreboard
import CG_DrawInformation
import CG_LoadingClient
import CG_LoadingItem
import CG_LoadingStage
import CG_LoadingString
import CG_ProcessSnapshots
import CG_TestLine
import CG_GlassShatter
import CG_BulletFlyBySound
import CG_BubbleTrail
import CG_WeaponCallback
import CG_OutOfAmmoChange
import CG_DrawWeaponSelect
import CG_PlayerWeaponEffects
import CG_AddViewWeapon
import CG_AnimateViewWeapon
import CG_Bullet
import CG_HandleStickyMissile
import CG_MissileHitPlayer
import CG_MissileHitWall
import CG_ProjectileThink
import CG_FireWeapon
import CG_SetWeaponAnim
import CG_UpdateViewWeaponSurfaces
import CG_RegisterItemVisuals
import CG_ShutDownWeapons
import CG_RegisterWeapon
import CG_WeaponSelectable
import CG_Weapon_f
import CG_PrevWeapon
import CG_NextWeapon
import CG_ScaleModelAxis
import CG_AdjustPositionForMover
import CG_Beam
import CG_AddPacketEntities
import CG_SetEntitySoundPosition
import CG_PainEvent
import CG_EntityEvent
import CG_PlaceString
import CG_CheckEvents
import CG_InitHitModel
import CG_LoadDeferredPlayers
import CG_PredictPlayerState
import CG_PlayerTrace
import CG_Trace
import CG_PointContents
import CG_BuildSolidList
import CG_PlayerShadow
import CG_RemoveIdentityItemsOnBack
import CG_RegisterIdentity
import CG_UpdatePlayerModel
import CG_CustomPlayerSound
import CG_CustomSound
import CG_NewClientInfo
import CG_ResetPlayerEntity
import CG_Player
import CG_DrawMapChange
import CG_GameTypeString
import CG_Text_PaintChar
import CG_Draw3DG2Model
import CG_Draw3DModel
import CG_GetGameStatusText
import CG_GetTeamColor
import CG_RunMenuScript
import CG_OwnerDrawDisabled
import CG_OwnerDrawVisible
import CG_GetValue
import CG_OwnerDraw
import CG_DrawActive
import CG_CenterPrint
import CG_AddLagometerSnapshotInfo
import CG_AddLagometerFrameInfo
import CG_DrawTimer
import CG_DrawTextWithCursor
import CG_DrawText
import CG_GetColorForHealth
import CG_DrawTopBottom
import CG_DrawSides
import CG_DrawRect
import CG_TileClear
import CG_TeamColor
import CG_FadeColor
import CG_DrawStrlen
import CG_DrawRotatePic2
import CG_DrawRotatePic
import CG_DrawStretchPic
import CG_DrawPic
import CG_FillRect
import CG_AdjustFrom640
import CG_UpdateCameraShake
import CG_CameraShake
import CG_DrawActiveFrame
import CG_AddBufferedSound
import CG_TestModelPrevSkin_f
import CG_TestModelNextSkin_f
import CG_TestModelPrevFrame_f
import CG_TestModelNextFrame_f
import CG_TestGun_f
import CG_TestModel_f
import CG_EventHandling
import CG_MouseEvent
import CG_KeyEvent
import CG_LoadMenus
import CG_LastAttacker
import CG_CrosshairPlayer
import CG_UpdateTeamCountCvars
import CG_UpdateCvars
import CG_StartMusic
import CG_GetEntity
import CG_Argv
import CG_ConfigString
import cg_drawTeamInfoZero
import cg_drawTeamInfoColor
import cg_drawTeamInfo
import cg_zoomWeaponChange
import cg_drawHPValues
import cg_specInFirst
import cg_thirdPersonCross
import cg_matrixEffect
import g_eliteKnifes
import g_zoomOut
import cg_drawClock
import rw_enabled
import cg_bodyTime
import cg_weaponMenuFast
import cg_soundFrag
import cg_soundGlobal
import cg_voiceGlobal
import cg_voiceRadio
import ui_info_seenobjectives
import ui_info_pickupsdisabled
import ui_info_freecount
import ui_info_speccount
import ui_info_bluecount
import ui_info_redcount
import cg_automap_a
import cg_automap_h
import cg_automap_w
import cg_automap_y
import cg_automap_x
import cg_animBlend
import cg_tracerChance
import cg_damageindicator
import RMG_distancecull
import cg_lockDeaths
import cg_lockBlood
import cg_lockSever
import cg_DebugGore
import cg_currentSelectedPlayerName
import cg_currentSelectedPlayer
import cg_noProjectileTrail
import cg_noTaunt
import cg_cameraMode
import cg_timescale
import cg_cameraOrbitDelay
import cg_cameraOrbit
import pmove_msec
import pmove_fixed
import cg_smoothClients
import cg_noVoiceText
import cg_teamChatsOnly
import cg_drawFriend
import cg_deferPlayers
import cg_autoReload
import cg_impactPrediction
import cg_antiLag
import cg_predictItems
import cg_paused
import cg_buildScript
import cg_forceModel
import cg_stats
import cg_chatHeight
import cg_chatTime
import cg_synchronousClients
import cg_lagometer
import cg_stereoSeparation
import cg_thirdPersonHorzOffset
import cg_thirdPersonPitch
import cg_thirdPersonYaw
import cg_thirdPersonRange
import cg_thirdPerson
import cg_goreDetail
import cg_shellEjection
import cg_fov
import cg_simpleItems
import cg_ignore
import cg_autoswitch
import cg_drawGun
import cg_gun_z
import cg_gun_y
import cg_gun_x
import cg_footsteps
import cg_showmiss
import cg_nopredict
import cg_errorDecay
import cg_debugEvents
import cg_draw2D
import cg_crosshairFriendRGBA
import cg_crosshairRGBA
import cg_crosshairSize
import cg_crosshairY
import cg_crosshairX
import cg_drawTeamScores
import cg_drawRadar
import cg_drawCrosshairNames
import cg_drawCrosshair
import cg_drawSnapshot
import cg_drawFPS
import cg_drawTimer
import cg_shadows
import cg_bobroll
import cg_bobpitch
import cg_bobup
import cg_runroll
import cg_runpitch
import cg_centerY
import cg_centertime
import con_notifyTime
import cg_items
import cg_weapons
import cg
import cgs
import cg_numpermanents
import cg_permanents
import cg_entities
import trap_VM_LocalStringAlloc
import trap_VM_LocalTempFree
import trap_VM_LocalTempAlloc
import trap_VM_LocalAllocUnaligned
import trap_VM_LocalAlloc
import trap_FS_GetFileList
import trap_GPV_GetList
import trap_GPV_GetTopValue
import trap_GPV_IsList
import trap_GPV_GetInOrderPrevious
import trap_GPV_GetInOrderNext
import trap_GPV_GetNext
import trap_GPV_GetName
import trap_GPG_FindPairValue
import trap_GPG_FindPair
import trap_GPG_FindSubGroup
import trap_GPG_GetInOrderSubGroups
import trap_GPG_GetSubGroups
import trap_GPG_GetInOrderPairs
import trap_GPG_GetPairs
import trap_GPG_GetInOrderPrevious
import trap_GPG_GetInOrderNext
import trap_GPG_GetNext
import trap_GPG_GetName
import trap_GP_GetBaseParseGroup
import trap_GP_Delete
import trap_GP_Clean
import trap_GP_ParseFile
import trap_GP_Parse
import BG_FindOutfitting
import BG_ParseOutfittingTemplates
import BG_CompressOutfitting
import BG_DecompressOutfitting
import BG_SetAvailableOutfitting
import BG_IsWeaponAvailableForOutfitting
import BG_ParseSkin
import BG_ParseNPCFiles
import BG_GetModelSound
import BG_FindCharacterTemplate
import BG_FindTeamIdentity
import BG_FindIdentity
import bg_animTable
import bg_weaponNames
import bg_outfittingGroups
import bg_outfittingCount
import bg_outfittings
import bg_identityCount
import bg_identities
import bg_itemTemplates
import bg_characterTemplates
import BG_FindGametype
import BG_BuildGametypeList
import bg_gametypeCount
import bg_gametypeData
import BG_GetWeaponNote
import BG_GetWeaponAnim
import BG_PlayerTouchesItem
import BG_CalculateLeanOffset
import BG_ParseAnimationFile
import BG_PlayerAngles
import BG_PlayerStateToEntityStateExtraPolate
import BG_PlayerStateToEntityState
import BG_AddPredictableEventToPlayerstate
import BG_EvaluateTrajectoryDelta
import BG_EvaluateTrajectory
import BG_FindLadder
import BG_AddLadder
import BG_CanItemBeGrabbed
import BG_FindGametypeItemByID
import BG_FindGametypeItem
import BG_FindWeaponItem
import BG_FindClassnameItem
import BG_FindItem
import bg_numItems
import bg_itemlist
import Pmove
import PM_UpdateViewAngles
import pm
import BG_GetMaxAmmo
import BG_CalculateBulletEndpoint
import BG_FindFireMode
import BG_WeaponHasAlternateAmmo
import BG_GetInviewModelAnim
import BG_GetInviewAnimFromIndex
import BG_GetInviewAnim
import BG_ParseInviewFile
import weaponRightHand
import weaponLeftHand
import weaponParseInfo
import ammoData
import ammoNames
import weaponData
import weaponNames
import GetStringForID
import GetIDForString
import KeywordHash_Find
import KeywordHash_Add
import KeywordHash_Key
import Q_irand
import irand
import flrand
import Rand_Init
import Com_Printf
import Com_Error
import Info_NextPair
import Info_Validate
import Info_SetValueForKey_Big
import Info_SetValueForKey
import Info_RemoveKey_big
import Info_RemoveKey
import Info_ValueForKey
import va
import Q_CleanStr
import Q_PrintStrlen
import Q_strcat
import Q_strncpyz
import Q_strrchr
import Q_strupr
import Q_strlwr
import Q_stricmpn
import Q_strncmp
import Q_stricmp
import Q_isalpha
import Q_isupper
import Q_islower
import Q_isprint
import Com_sprintf
import Parse3DMatrix
import Parse2DMatrix
import Parse1DMatrix
import SkipRestOfLine
import SkipBracedSection
import COM_MatchToken
import COM_ParseWarning
import COM_ParseError
import COM_Compress
import COM_ParseExt
import COM_Parse
import SkipWhitespace
import COM_GetCurrentParseLine
import COM_BeginParseSession
import COM_DefaultExtension
import COM_StripExtension
import COM_SkipPath
import Com_Clamp
import Com_Clampf
import NormalToLatLong
import PerpendicularVector
import AngleVectors
import MatrixMultiply
import MakeNormalVectors
import RotateAroundDirection
import RotatePointAroundVector
import ProjectPointOnPlane
import PlaneFromPoints
import AngleDelta
import AngleNormalize180
import AngleNormalize360
import AnglesSubtract
import AngleSubtract
import LerpVector
import LerpAngle
import AngleMod
import fmod
import BoxOnPlaneSide
import SetPlaneSignbits
import AxisCopy
import AxisClear
import AnglesToAxis
import vectoangles
import Q_crandom
import Q_random
import Q_rand
import Q_asin
import Q_acos
import Q_log2
import Q_TestRaySphere
import VectorRotate
import Vector4Scale
import VectorNormalize2
import VectorNormalize
import CrossProduct
import VectorInverse
import VectorNormalizeFast
import DistanceSquared
import Distance
import VectorLengthSquared
import VectorLength
import VectorCompare
import AddPointToBounds
import ClearBounds
import RadiusFromBounds
import NormalizeColor
import ColorBytes4
import ColorBytes3
import _VectorMA
import _VectorScale
import _VectorCopy
import _VectorAdd
import _VectorSubtract
import _DotProduct
import ByteToDir
import DirToByte
import powf
import ClampShort
import ClampChar
import Q_rsqrt
import Q_fabs
import axisDefault
import vec3_identity
import vec3_origin
import g_color_table
import colorDkBlue
import colorLtBlue
import colorDkGrey
import colorMdGrey
import colorLtGrey
import colorWhite
import colorCyan
import colorMagenta
import colorYellow
import colorBlue
import colorGreen
import colorRed
import colorBlack
import colorTable
import bytedirs
import Com_Memcpy
import Com_Memset
import Hunk_Alloc
import FloatSwap
import LongSwap
import ShortSwap
import asin
import acos
import fabs
import abs
import tan
import atan2
import cos
import sin
import sqrt
import floor
import ceil
import memcpy
import memset
import memmove
import sscanf
import vsprintf
import _atoi
import atoi
import _atof
import atof
import toupper
import tolower
import strncpy
import strstr
import strchr
import strcmp
import strcpy
import strcat
import strlen
import rand
import srand
import qsort
lit
align 1
LABELV $263
char 1 66
char 1 97
char 1 100
char 1 32
char 1 108
char 1 101
char 1 84
char 1 121
char 1 112
char 1 101
char 1 58
char 1 32
char 1 37
char 1 105
char 1 0
align 1
LABELV $102
char 1 67
char 1 71
char 1 95
char 1 70
char 1 114
char 1 101
char 1 101
char 1 76
char 1 111
char 1 99
char 1 97
char 1 108
char 1 69
char 1 110
char 1 116
char 1 105
char 1 116
char 1 121
char 1 58
char 1 32
char 1 110
char 1 111
char 1 116
char 1 32
char 1 97
char 1 99
char 1 116
char 1 105
char 1 118
char 1 101
char 1 0
