export CG_TestModel_f
code
proc CG_TestModel_f 36 12
file "../cg_view.c"
line 55
;1:// Copyright (C) 2001-2002 Raven Software.
;2://
;3:// cg_view.c -- setup all the parameters (position, angle, etc)
;4:// for a 3D rendering
;5:#include "cg_local.h"
;6:
;7:#if !defined(CL_LIGHT_H_INC)
;8:	#include "cg_lights.h"
;9:#endif
;10:
;11:/*
;12:=============================================================================
;13:
;14:  MODEL TESTING
;15:
;16:The viewthing and gun positioning tools from Q2 have been integrated and
;17:enhanced into a single model testing facility.
;18:
;19:Model viewing can begin with either "testmodel <modelname>" or "testgun <modelname>".
;20:
;21:The names must be the full pathname after the basedir, like 
;22:"models/weapons/v_launch/tris.md3" or "players/male/tris.md3"
;23:
;24:Testmodel will create a fake entity 100 units in front of the current view
;25:position, directly facing the viewer.  It will remain immobile, so you can
;26:move around it to view it from different angles.
;27:
;28:Testgun will cause the model to follow the player around and supress the real
;29:view weapon model.  The default frame 0 of most guns is completely off screen,
;30:so you will probably have to cycle a couple frames to see it.
;31:
;32:"nextframe", "prevframe", "nextskin", and "prevskin" commands will change the
;33:frame or skin of the testmodel.  These are bound to F5, F6, F7, and F8 in
;34:q3default.cfg.
;35:
;36:If a gun is being tested, the "gun_x", "gun_y", and "gun_z" variables will let
;37:you adjust the positioning.
;38:
;39:Note that none of the model testing features update while the game is paused, so
;40:it may be convenient to test with deathmatch set to 1 so that bringing down the
;41:console doesn't pause the game.
;42:
;43:=============================================================================
;44:*/
;45:
;46:/*
;47:=================
;48:CG_TestModel_f
;49:
;50:Creates an entity in front of the current position, which
;51:can then be moved around
;52:=================
;53:*/
;54:void CG_TestModel_f (void) 
;55:{
line 58
;56:	vec3_t		angles;
;57:
;58:	memset( &cg.testModelEntity, 0, sizeof(cg.testModelEntity) );
ADDRGP4 cg+9840
ARGP4
CNSTI4 0
ARGI4
CNSTI4 204
ARGI4
ADDRGP4 memset
CALLP4
pop
line 59
;59:	if ( trap_Argc() < 2 ) 
ADDRLP4 12
ADDRGP4 trap_Argc
CALLI4
ASGNI4
ADDRLP4 12
INDIRI4
CNSTI4 2
GEI4 $96
line 60
;60:	{
line 61
;61:		return;
ADDRGP4 $93
JUMPV
LABELV $96
line 64
;62:	}
;63:
;64:	Q_strncpyz (cg.testModelName, CG_Argv( 1 ), MAX_QPATH );
CNSTI4 1
ARGI4
ADDRLP4 16
ADDRGP4 CG_Argv
CALLP4
ASGNP4
ADDRGP4 cg+10044
ARGP4
ADDRLP4 16
INDIRP4
ARGP4
CNSTI4 64
ARGI4
ADDRGP4 Q_strncpyz
CALLV
pop
line 65
;65:	cg.testModelEntity.hModel = trap_R_RegisterModel( cg.testModelName );
ADDRGP4 cg+10044
ARGP4
ADDRLP4 20
ADDRGP4 trap_R_RegisterModel
CALLI4
ASGNI4
ADDRGP4 cg+9840+8
ADDRLP4 20
INDIRI4
ASGNI4
line 67
;66:
;67:	if ( trap_Argc() == 3 ) 
ADDRLP4 24
ADDRGP4 trap_Argc
CALLI4
ASGNI4
ADDRLP4 24
INDIRI4
CNSTI4 3
NEI4 $102
line 68
;68:	{
line 69
;69:		cg.testModelEntity.backlerp = atof( CG_Argv( 2 ) );
CNSTI4 2
ARGI4
ADDRLP4 28
ADDRGP4 CG_Argv
CALLP4
ASGNP4
ADDRLP4 28
INDIRP4
ARGP4
ADDRLP4 32
ADDRGP4 atof
CALLF4
ASGNF4
ADDRGP4 cg+9840+128
ADDRLP4 32
INDIRF4
ASGNF4
line 70
;70:		cg.testModelEntity.frame = 1;
ADDRGP4 cg+9840+104
CNSTI4 1
ASGNI4
line 71
;71:		cg.testModelEntity.oldframe = 0;
ADDRGP4 cg+9840+124
CNSTI4 0
ASGNI4
line 72
;72:	}
LABELV $102
line 74
;73:	
;74:	if (! cg.testModelEntity.hModel ) 
ADDRGP4 cg+9840+8
INDIRI4
CNSTI4 0
NEI4 $110
line 75
;75:	{
line 76
;76:		Com_Printf( "Can't register model\n" );
ADDRGP4 $114
ARGP4
ADDRGP4 Com_Printf
CALLV
pop
line 77
;77:		return;
ADDRGP4 $93
JUMPV
LABELV $110
line 80
;78:	}
;79:
;80:	VectorMA( cg.refdef.vieworg, 100, cg.refdef.viewaxis[0], cg.testModelEntity.origin );
ADDRGP4 cg+9840+52
ADDRGP4 cg+1200+24
INDIRF4
CNSTF4 1120403456
ADDRGP4 cg+1200+36
INDIRF4
MULF4
ADDF4
ASGNF4
ADDRGP4 cg+9840+52+4
ADDRGP4 cg+1200+24+4
INDIRF4
CNSTF4 1120403456
ADDRGP4 cg+1200+36+4
INDIRF4
MULF4
ADDF4
ASGNF4
ADDRGP4 cg+9840+52+8
ADDRGP4 cg+1200+24+8
INDIRF4
CNSTF4 1120403456
ADDRGP4 cg+1200+36+8
INDIRF4
MULF4
ADDF4
ASGNF4
line 82
;81:
;82:	angles[PITCH] = 0;
ADDRLP4 0
CNSTF4 0
ASGNF4
line 83
;83:	angles[YAW] = 180 + cg.refdef.viewangles[1];
ADDRLP4 0+4
ADDRGP4 cg+1200+368+4
INDIRF4
CNSTF4 1127481344
ADDF4
ASGNF4
line 84
;84:	angles[ROLL] = 0;
ADDRLP4 0+8
CNSTF4 0
ASGNF4
line 86
;85:
;86:	AnglesToAxis( angles, cg.testModelEntity.axis );
ADDRLP4 0
ARGP4
ADDRGP4 cg+9840+12
ARGP4
ADDRGP4 AnglesToAxis
CALLV
pop
line 87
;87:}
LABELV $93
endproc CG_TestModel_f 36 12
export CG_TestModelNextFrame_f
proc CG_TestModelNextFrame_f 4 8
line 90
;88:
;89:void CG_TestModelNextFrame_f (void) 
;90:{
line 91
;91:	cg.testModelEntity.frame++;
ADDRLP4 0
ADDRGP4 cg+9840+104
ASGNP4
ADDRLP4 0
INDIRP4
ADDRLP4 0
INDIRP4
INDIRI4
CNSTI4 1
ADDI4
ASGNI4
line 92
;92:	Com_Printf( "frame %i\n", cg.testModelEntity.frame );
ADDRGP4 $149
ARGP4
ADDRGP4 cg+9840+104
INDIRI4
ARGI4
ADDRGP4 Com_Printf
CALLV
pop
line 93
;93:}
LABELV $146
endproc CG_TestModelNextFrame_f 4 8
export CG_TestModelPrevFrame_f
proc CG_TestModelPrevFrame_f 4 8
line 96
;94:
;95:void CG_TestModelPrevFrame_f (void) 
;96:{
line 97
;97:	cg.testModelEntity.frame--;
ADDRLP4 0
ADDRGP4 cg+9840+104
ASGNP4
ADDRLP4 0
INDIRP4
ADDRLP4 0
INDIRP4
INDIRI4
CNSTI4 1
SUBI4
ASGNI4
line 98
;98:	if ( cg.testModelEntity.frame < 0 ) 
ADDRGP4 cg+9840+104
INDIRI4
CNSTI4 0
GEI4 $155
line 99
;99:	{
line 100
;100:		cg.testModelEntity.frame = 0;
ADDRGP4 cg+9840+104
CNSTI4 0
ASGNI4
line 101
;101:	}
LABELV $155
line 103
;102:
;103:	Com_Printf( "frame %i\n", cg.testModelEntity.frame );
ADDRGP4 $149
ARGP4
ADDRGP4 cg+9840+104
INDIRI4
ARGI4
ADDRGP4 Com_Printf
CALLV
pop
line 104
;104:}
LABELV $152
endproc CG_TestModelPrevFrame_f 4 8
export CG_TestModelNextSkin_f
proc CG_TestModelNextSkin_f 4 8
line 107
;105:
;106:void CG_TestModelNextSkin_f (void) 
;107:{
line 108
;108:	cg.testModelEntity.skinNum++;
ADDRLP4 0
ADDRGP4 cg+9840+132
ASGNP4
ADDRLP4 0
INDIRP4
ADDRLP4 0
INDIRP4
INDIRI4
CNSTI4 1
ADDI4
ASGNI4
line 109
;109:	Com_Printf( "skin %i\n", cg.testModelEntity.skinNum );
ADDRGP4 $166
ARGP4
ADDRGP4 cg+9840+132
INDIRI4
ARGI4
ADDRGP4 Com_Printf
CALLV
pop
line 110
;110:}
LABELV $163
endproc CG_TestModelNextSkin_f 4 8
export CG_TestModelPrevSkin_f
proc CG_TestModelPrevSkin_f 4 8
line 113
;111:
;112:void CG_TestModelPrevSkin_f (void) 
;113:{
line 114
;114:	cg.testModelEntity.skinNum--;
ADDRLP4 0
ADDRGP4 cg+9840+132
ASGNP4
ADDRLP4 0
INDIRP4
ADDRLP4 0
INDIRP4
INDIRI4
CNSTI4 1
SUBI4
ASGNI4
line 115
;115:	if ( cg.testModelEntity.skinNum < 0 ) 
ADDRGP4 cg+9840+132
INDIRI4
CNSTI4 0
GEI4 $172
line 116
;116:	{
line 117
;117:		cg.testModelEntity.skinNum = 0;
ADDRGP4 cg+9840+132
CNSTI4 0
ASGNI4
line 118
;118:	}
LABELV $172
line 119
;119:	Com_Printf( "skin %i\n", cg.testModelEntity.skinNum );
ADDRGP4 $166
ARGP4
ADDRGP4 cg+9840+132
INDIRI4
ARGI4
ADDRGP4 Com_Printf
CALLV
pop
line 120
;120:}
LABELV $169
endproc CG_TestModelPrevSkin_f 4 8
proc CG_AddTestModel 4 4
line 123
;121:
;122:static void CG_AddTestModel (void) 
;123:{
line 125
;124:	// re-register the model, because the level may have changed
;125:	cg.testModelEntity.hModel = trap_R_RegisterModel( cg.testModelName );
ADDRGP4 cg+10044
ARGP4
ADDRLP4 0
ADDRGP4 trap_R_RegisterModel
CALLI4
ASGNI4
ADDRGP4 cg+9840+8
ADDRLP4 0
INDIRI4
ASGNI4
line 126
;126:	if (! cg.testModelEntity.hModel ) 
ADDRGP4 cg+9840+8
INDIRI4
CNSTI4 0
NEI4 $184
line 127
;127:	{
line 128
;128:		Com_Printf ("Can't register model\n");
ADDRGP4 $114
ARGP4
ADDRGP4 Com_Printf
CALLV
pop
line 129
;129:		return;
ADDRGP4 $180
JUMPV
LABELV $184
line 132
;130:	}
;131:
;132:	trap_R_AddRefEntityToScene( &cg.testModelEntity );
ADDRGP4 cg+9840
ARGP4
ADDRGP4 trap_R_AddRefEntityToScene
CALLV
pop
line 133
;133:}
LABELV $180
endproc CG_AddTestModel 4 4
proc CG_CalcVrect 12 0
line 143
;134:
;135:/*
;136:=================
;137:CG_CalcVrect
;138:
;139:Sets the coordinates of the rendered window
;140:=================
;141:*/
;142:static void CG_CalcVrect (void) 
;143:{
line 146
;144:	int		size;
;145:
;146:	size = 100;
ADDRLP4 0
CNSTI4 100
ASGNI4
line 148
;147:
;148:	cg.refdef.width = cgs.glconfig.vidWidth*size/100;
ADDRGP4 cg+1200+8
ADDRGP4 cgs+21604+11356
INDIRI4
ADDRLP4 0
INDIRI4
MULI4
CNSTI4 100
DIVI4
ASGNI4
line 149
;149:	cg.refdef.width &= ~1;
ADDRLP4 4
ADDRGP4 cg+1200+8
ASGNP4
ADDRLP4 4
INDIRP4
ADDRLP4 4
INDIRP4
INDIRI4
CNSTI4 -2
BANDI4
ASGNI4
line 151
;150:
;151:	cg.refdef.height = cgs.glconfig.vidHeight*size/100;
ADDRGP4 cg+1200+12
ADDRGP4 cgs+21604+11360
INDIRI4
ADDRLP4 0
INDIRI4
MULI4
CNSTI4 100
DIVI4
ASGNI4
line 152
;152:	cg.refdef.height &= ~1;
ADDRLP4 8
ADDRGP4 cg+1200+12
ASGNP4
ADDRLP4 8
INDIRP4
ADDRLP4 8
INDIRP4
INDIRI4
CNSTI4 -2
BANDI4
ASGNI4
line 154
;153:
;154:	cg.refdef.x = (cgs.glconfig.vidWidth - cg.refdef.width)/2;
ADDRGP4 cg+1200
ADDRGP4 cgs+21604+11356
INDIRI4
ADDRGP4 cg+1200+8
INDIRI4
SUBI4
CNSTI4 2
DIVI4
ASGNI4
line 155
;155:	cg.refdef.y = (cgs.glconfig.vidHeight - cg.refdef.height)/2;
ADDRGP4 cg+1200+4
ADDRGP4 cgs+21604+11360
INDIRI4
ADDRGP4 cg+1200+12
INDIRI4
SUBI4
CNSTI4 2
DIVI4
ASGNI4
line 156
;156:}
LABELV $189
endproc CG_CalcVrect 12 0
proc CG_StepOffset 8 0
line 164
;157:
;158://==============================================================================
;159:
;160://==============================================================================
;161://==============================================================================
;162:// this causes a compiler bug on mac MrC compiler
;163:static void CG_StepOffset( void ) 
;164:{
line 168
;165:	int		timeDelta;
;166:	
;167:	// smooth out stair climbing
;168:	timeDelta = cg.time - cg.stepTime;
ADDRLP4 0
ADDRGP4 cg+68
INDIRI4
ADDRGP4 cg+1060
INDIRI4
SUBI4
ASGNI4
line 169
;169:	if ( timeDelta < STEP_TIME ) 
ADDRLP4 0
INDIRI4
CNSTI4 200
GEI4 $216
line 170
;170:	{
line 171
;171:		cg.refdef.vieworg[2] -= cg.stepChange * (STEP_TIME - timeDelta) / STEP_TIME;
ADDRLP4 4
ADDRGP4 cg+1200+24+8
ASGNP4
ADDRLP4 4
INDIRP4
ADDRLP4 4
INDIRP4
INDIRF4
ADDRGP4 cg+1056
INDIRF4
CNSTI4 200
ADDRLP4 0
INDIRI4
SUBI4
CVIF4 4
MULF4
CNSTF4 1128792064
DIVF4
SUBF4
ASGNF4
line 172
;172:	}
LABELV $216
line 173
;173:}
LABELV $213
endproc CG_StepOffset 8 0
data
align 4
LABELV cameramins
byte 4 3229614080
byte 4 3229614080
byte 4 3229614080
align 4
LABELV cameramaxs
byte 4 1082130432
byte 4 1082130432
byte 4 1082130432
export cameraCurTarget
align 4
LABELV cameraCurTarget
byte 4 0
byte 4 0
byte 4 0
export cameraCurLoc
align 4
LABELV cameraCurLoc
byte 4 0
byte 4 0
byte 4 0
export cameraOldLoc
align 4
LABELV cameraOldLoc
byte 4 0
byte 4 0
byte 4 0
export cameraNewLoc
align 4
LABELV cameraNewLoc
byte 4 0
byte 4 0
byte 4 0
export cameraLastFrame
align 4
LABELV cameraLastFrame
byte 4 0
code
proc CG_CalcIdealThirdPersonViewTarget 8 0
line 208
;174:
;175:#define CAMERA_DAMP_INTERVAL	50
;176:
;177:static vec3_t	cameramins = { -4, -4, -4 };
;178:static vec3_t	cameramaxs = { 4, 4, 4 };
;179:vec3_t	camerafwd, cameraup;
;180:
;181:vec3_t	cameraFocusAngles,			cameraFocusLoc;
;182:vec3_t	cameraIdealTarget,			cameraIdealLoc;
;183:vec3_t	cameraCurTarget={0,0,0},	cameraCurLoc={0,0,0};
;184:vec3_t	cameraOldLoc={0,0,0},		cameraNewLoc={0,0,0};
;185:int		cameraLastFrame=0;
;186:
;187:/*
;188:===============
;189:Notes on the camera viewpoint in and out...
;190:
;191:cg.refdef.vieworg
;192:--at the start of the function holds the player actor's origin (center of player model).
;193:--it is set to the final view location of the camera at the end of the camera code.
;194:cg.refdef.viewangles
;195:--at the start holds the client's view angles
;196:--it is set to the final view angle of the camera at the end of the camera code.
;197:
;198:===============
;199:*/
;200:  
;201:/*
;202:===============
;203:CG_CalcTargetThirdPersonViewLocation
;204:
;205:===============
;206:*/
;207:static void CG_CalcIdealThirdPersonViewTarget(void)
;208:{
line 210
;209:	// Initialize IdealTarget
;210:	VectorCopy(cg.refdef.vieworg, cameraFocusLoc);
ADDRGP4 cameraFocusLoc
ADDRGP4 cg+1200+24
INDIRB
ASGNB 12
line 213
;211:
;212:	// Add in the new viewheight
;213:	cameraFocusLoc[2] += cg.snap->ps.viewheight;
ADDRLP4 0
ADDRGP4 cameraFocusLoc+8
ASGNP4
ADDRLP4 0
INDIRP4
ADDRLP4 0
INDIRP4
INDIRF4
ADDRGP4 cg+36
INDIRP4
CNSTI4 236
ADDP4
INDIRI4
CVIF4 4
ADDF4
ASGNF4
line 216
;214:
;215:	// Add in a vertical offset from the viewpoint, which puts the actual target above the head, regardless of angle.
;216:	VectorMA(cameraFocusLoc, 1, cameraup, cameraIdealTarget);
ADDRLP4 4
CNSTF4 1065353216
ASGNF4
ADDRGP4 cameraIdealTarget
ADDRGP4 cameraFocusLoc
INDIRF4
ADDRLP4 4
INDIRF4
ADDRGP4 cameraup
INDIRF4
MULF4
ADDF4
ASGNF4
ADDRGP4 cameraIdealTarget+4
ADDRGP4 cameraFocusLoc+4
INDIRF4
ADDRLP4 4
INDIRF4
ADDRGP4 cameraup+4
INDIRF4
MULF4
ADDF4
ASGNF4
ADDRGP4 cameraIdealTarget+8
ADDRGP4 cameraFocusLoc+8
INDIRF4
CNSTF4 1065353216
ADDRGP4 cameraup+8
INDIRF4
MULF4
ADDF4
ASGNF4
line 217
;217:}
LABELV $222
endproc CG_CalcIdealThirdPersonViewTarget 8 0
proc CG_CalcIdealThirdPersonViewLocation 0 0
line 228
;218:
;219:	
;220:
;221:/*
;222:===============
;223:CG_CalcTargetThirdPersonViewLocation
;224:
;225:===============
;226:*/
;227:static void CG_CalcIdealThirdPersonViewLocation(void)
;228:{
line 229
;229:	VectorMA(cameraIdealTarget, -(cg_thirdPersonRange.value), camerafwd, cameraIdealLoc);
ADDRGP4 cameraIdealLoc
ADDRGP4 cameraIdealTarget
INDIRF4
ADDRGP4 camerafwd
INDIRF4
ADDRGP4 cg_thirdPersonRange+8
INDIRF4
NEGF4
MULF4
ADDF4
ASGNF4
ADDRGP4 cameraIdealLoc+4
ADDRGP4 cameraIdealTarget+4
INDIRF4
ADDRGP4 camerafwd+4
INDIRF4
ADDRGP4 cg_thirdPersonRange+8
INDIRF4
NEGF4
MULF4
ADDF4
ASGNF4
ADDRGP4 cameraIdealLoc+8
ADDRGP4 cameraIdealTarget+8
INDIRF4
ADDRGP4 camerafwd+8
INDIRF4
ADDRGP4 cg_thirdPersonRange+8
INDIRF4
NEGF4
MULF4
ADDF4
ASGNF4
line 230
;230:}
LABELV $233
endproc CG_CalcIdealThirdPersonViewLocation 0 0
proc CG_ResetThirdPersonViewDamp 56 28
line 235
;231:
;232:
;233:
;234:static void CG_ResetThirdPersonViewDamp(void)
;235:{
line 239
;236:	trace_t trace;
;237:
;238:	// Cap the pitch within reasonable limits
;239:	if (cameraFocusAngles[PITCH] > 89.0)
ADDRGP4 cameraFocusAngles
INDIRF4
CNSTF4 1118961664
LEF4 $244
line 240
;240:	{
line 241
;241:		cameraFocusAngles[PITCH] = 89.0;
ADDRGP4 cameraFocusAngles
CNSTF4 1118961664
ASGNF4
line 242
;242:	}
ADDRGP4 $245
JUMPV
LABELV $244
line 243
;243:	else if (cameraFocusAngles[PITCH] < -89.0)
ADDRGP4 cameraFocusAngles
INDIRF4
CNSTF4 3266445312
GEF4 $246
line 244
;244:	{
line 245
;245:		cameraFocusAngles[PITCH] = -89.0;
ADDRGP4 cameraFocusAngles
CNSTF4 3266445312
ASGNF4
line 246
;246:	}
LABELV $246
LABELV $245
line 248
;247:
;248:	AngleVectors(cameraFocusAngles, camerafwd, NULL, cameraup);
ADDRGP4 cameraFocusAngles
ARGP4
ADDRGP4 camerafwd
ARGP4
CNSTP4 0
ARGP4
ADDRGP4 cameraup
ARGP4
ADDRGP4 AngleVectors
CALLV
pop
line 251
;249:
;250:	// Set the cameraIdealTarget
;251:	CG_CalcIdealThirdPersonViewTarget();
ADDRGP4 CG_CalcIdealThirdPersonViewTarget
CALLV
pop
line 254
;252:
;253:	// Set the cameraIdealLoc
;254:	CG_CalcIdealThirdPersonViewLocation();
ADDRGP4 CG_CalcIdealThirdPersonViewLocation
CALLV
pop
line 257
;255:
;256:	// Now, we just set everything to the new positions.
;257:	VectorCopy(cameraIdealLoc, cameraCurLoc);
ADDRGP4 cameraCurLoc
ADDRGP4 cameraIdealLoc
INDIRB
ASGNB 12
line 258
;258:	VectorCopy(cameraIdealTarget, cameraCurTarget);
ADDRGP4 cameraCurTarget
ADDRGP4 cameraIdealTarget
INDIRB
ASGNB 12
line 261
;259:
;260:	// First thing we do is trace from the first person viewpoint out to the new target location.
;261:	CG_Trace(&trace, cameraFocusLoc, cameramins, cameramaxs, cameraCurTarget, cg.snap->ps.clientNum, MASK_SOLID|CONTENTS_PLAYERCLIP);
ADDRLP4 0
ARGP4
ADDRGP4 cameraFocusLoc
ARGP4
ADDRGP4 cameramins
ARGP4
ADDRGP4 cameramaxs
ARGP4
ADDRGP4 cameraCurTarget
ARGP4
ADDRGP4 cg+36
INDIRP4
CNSTI4 212
ADDP4
INDIRI4
ARGI4
CNSTI4 4113
ARGI4
ADDRGP4 CG_Trace
CALLV
pop
line 262
;262:	if (trace.fraction <= 1.0)
ADDRLP4 0+8
INDIRF4
CNSTF4 1065353216
GTF4 $249
line 263
;263:	{
line 264
;264:		VectorCopy(trace.endpos, cameraCurTarget);
ADDRGP4 cameraCurTarget
ADDRLP4 0+12
INDIRB
ASGNB 12
line 265
;265:	}
LABELV $249
line 268
;266:
;267:	// Now we trace from the new target location to the new view location, to make sure there is nothing in the way.
;268:	CG_Trace(&trace, cameraCurTarget, cameramins, cameramaxs, cameraCurLoc, cg.snap->ps.clientNum, MASK_SOLID|CONTENTS_PLAYERCLIP);
ADDRLP4 0
ARGP4
ADDRGP4 cameraCurTarget
ARGP4
ADDRGP4 cameramins
ARGP4
ADDRGP4 cameramaxs
ARGP4
ADDRGP4 cameraCurLoc
ARGP4
ADDRGP4 cg+36
INDIRP4
CNSTI4 212
ADDP4
INDIRI4
ARGI4
CNSTI4 4113
ARGI4
ADDRGP4 CG_Trace
CALLV
pop
line 269
;269:	if (trace.fraction <= 1.0)
ADDRLP4 0+8
INDIRF4
CNSTF4 1065353216
GTF4 $254
line 270
;270:	{
line 271
;271:		VectorCopy(trace.endpos, cameraCurLoc);
ADDRGP4 cameraCurLoc
ADDRLP4 0+12
INDIRB
ASGNB 12
line 272
;272:	}
LABELV $254
line 274
;273:
;274:	cameraLastFrame = cg.time;
ADDRGP4 cameraLastFrame
ADDRGP4 cg+68
INDIRI4
ASGNI4
line 275
;275:}
LABELV $243
endproc CG_ResetThirdPersonViewDamp 56 28
proc CG_UpdateThirdPersonTargetDamp 92 28
line 279
;276:
;277:// This is called every frame.
;278:static void CG_UpdateThirdPersonTargetDamp(void)
;279:{
line 283
;280:	trace_t trace;
;281:	vec3_t	targetdiff;
;282:	float	dampfactor, dtime, ratio;
;283:	float	damp = 1.0f;
ADDRLP4 0
CNSTF4 1065353216
ASGNF4
line 287
;284:
;285:	// Set the cameraIdealTarget
;286:	// Automatically get the ideal target, to avoid jittering.
;287:	CG_CalcIdealThirdPersonViewTarget();
ADDRGP4 CG_CalcIdealThirdPersonViewTarget
CALLV
pop
line 289
;288:
;289:	if ( damp >=1.0)
ADDRLP4 0
INDIRF4
CNSTF4 1065353216
LTF4 $260
line 290
;290:	{	// No damping.
line 291
;291:		VectorCopy(cameraIdealTarget, cameraCurTarget);
ADDRGP4 cameraCurTarget
ADDRGP4 cameraIdealTarget
INDIRB
ASGNB 12
line 292
;292:	}
ADDRGP4 $261
JUMPV
LABELV $260
line 293
;293:	else if ( damp >=0.0)
ADDRLP4 0
INDIRF4
CNSTF4 0
LTF4 $262
line 294
;294:	{	
line 296
;295:		// Calculate the difference from the current position to the new one.
;296:		VectorSubtract(cameraIdealTarget, cameraCurTarget, targetdiff);
ADDRLP4 60
ADDRGP4 cameraIdealTarget
INDIRF4
ADDRGP4 cameraCurTarget
INDIRF4
SUBF4
ASGNF4
ADDRLP4 60+4
ADDRGP4 cameraIdealTarget+4
INDIRF4
ADDRGP4 cameraCurTarget+4
INDIRF4
SUBF4
ASGNF4
ADDRLP4 60+8
ADDRGP4 cameraIdealTarget+8
INDIRF4
ADDRGP4 cameraCurTarget+8
INDIRF4
SUBF4
ASGNF4
line 300
;297:
;298:		// Now we calculate how much of the difference we cover in the time allotted.
;299:		// The equation is (Damp)^(time)
;300:		dampfactor = 1.0-damp;	// We must exponent the amount LEFT rather than the amount bled off
ADDRLP4 76
CNSTF4 1065353216
ADDRLP4 0
INDIRF4
SUBF4
ASGNF4
line 301
;301:		dtime = (float)(cg.time-cameraLastFrame) * (1.0/(float)CAMERA_DAMP_INTERVAL);	// Our dampfactor is geared towards a time interval equal to "1".
ADDRLP4 80
CNSTF4 1017370378
ADDRGP4 cg+68
INDIRI4
ADDRGP4 cameraLastFrame
INDIRI4
SUBI4
CVIF4 4
MULF4
ASGNF4
line 305
;302:
;303:		// Note that since there are a finite number of "practical" delta millisecond values possible, 
;304:		// the ratio should be initialized into a chart ultimately.
;305:		ratio = powf(dampfactor, (int)dtime);
ADDRLP4 76
INDIRF4
ARGF4
ADDRLP4 80
INDIRF4
CVFI4 4
ARGI4
ADDRLP4 84
ADDRGP4 powf
CALLF4
ASGNF4
ADDRLP4 72
ADDRLP4 84
INDIRF4
ASGNF4
line 308
;306:		
;307:		// This value is how much distance is "left" from the ideal.
;308:		VectorMA(cameraIdealTarget, -ratio, targetdiff, cameraCurTarget);
ADDRLP4 88
ADDRLP4 72
INDIRF4
NEGF4
ASGNF4
ADDRGP4 cameraCurTarget
ADDRGP4 cameraIdealTarget
INDIRF4
ADDRLP4 60
INDIRF4
ADDRLP4 88
INDIRF4
MULF4
ADDF4
ASGNF4
ADDRGP4 cameraCurTarget+4
ADDRGP4 cameraIdealTarget+4
INDIRF4
ADDRLP4 60+4
INDIRF4
ADDRLP4 88
INDIRF4
MULF4
ADDF4
ASGNF4
ADDRGP4 cameraCurTarget+8
ADDRGP4 cameraIdealTarget+8
INDIRF4
ADDRLP4 60+8
INDIRF4
ADDRLP4 72
INDIRF4
NEGF4
MULF4
ADDF4
ASGNF4
line 310
;309:		/////////////////////////////////////////////////////////////////////////////////////////////////////////
;310:	}
LABELV $262
LABELV $261
line 315
;311:
;312:	// Now we trace to see if the new location is cool or not.
;313:
;314:	// First thing we do is trace from the first person viewpoint out to the new target location.
;315:	CG_Trace(&trace, cameraFocusLoc, cameramins, cameramaxs, cameraCurTarget, cg.snap->ps.clientNum, MASK_SOLID|CONTENTS_PLAYERCLIP);
ADDRLP4 4
ARGP4
ADDRGP4 cameraFocusLoc
ARGP4
ADDRGP4 cameramins
ARGP4
ADDRGP4 cameramaxs
ARGP4
ADDRGP4 cameraCurTarget
ARGP4
ADDRGP4 cg+36
INDIRP4
CNSTI4 212
ADDP4
INDIRI4
ARGI4
CNSTI4 4113
ARGI4
ADDRGP4 CG_Trace
CALLV
pop
line 316
;316:	if (trace.fraction < 1.0)
ADDRLP4 4+8
INDIRF4
CNSTF4 1065353216
GEF4 $278
line 317
;317:	{
line 318
;318:		VectorCopy(trace.endpos, cameraCurTarget);
ADDRGP4 cameraCurTarget
ADDRLP4 4+12
INDIRB
ASGNB 12
line 319
;319:	}
LABELV $278
line 325
;320:
;321:	// Note that previously there was an upper limit to the number of physics traces that are done through the world
;322:	// for the sake of camera collision, since it wasn't calced per frame.  Now it is calculated every frame.
;323:	// This has the benefit that the camera is a lot smoother now (before it lerped between tested points),
;324:	// however two full volume traces each frame is a bit scary to think about.
;325:}
LABELV $259
endproc CG_UpdateThirdPersonTargetDamp 92 28
proc CG_UpdateThirdPersonCameraDamp 96 28
line 329
;326:
;327:// This can be called every interval, at the user's discretion.
;328:static void CG_UpdateThirdPersonCameraDamp(void)
;329:{
line 333
;330:	trace_t trace;
;331:	vec3_t	locdiff;
;332:	float dampfactor, dtime, ratio;
;333:	float damp = 1.0f;
ADDRLP4 4
CNSTF4 1065353216
ASGNF4
line 336
;334:
;335:	// Set the cameraIdealLoc
;336:	CG_CalcIdealThirdPersonViewLocation();
ADDRGP4 CG_CalcIdealThirdPersonViewLocation
CALLV
pop
line 340
;337:	
;338:	
;339:	// First thing we do is calculate the appropriate damping factor for the camera.
;340:	dampfactor=0.0;
ADDRLP4 0
CNSTF4 0
ASGNF4
line 341
;341:	if (damp != 0.0)
ADDRLP4 4
INDIRF4
CNSTF4 0
EQF4 $283
line 342
;342:	{
line 346
;343:		double pitch;
;344:
;345:		// Note that the camera pitch has already been capped off to 89.
;346:		pitch = Q_fabs(cameraFocusAngles[PITCH]);
ADDRGP4 cameraFocusAngles
INDIRF4
ARGF4
ADDRLP4 88
ADDRGP4 Q_fabs
CALLF4
ASGNF4
ADDRLP4 84
ADDRLP4 88
INDIRF4
ASGNF4
line 349
;347:
;348:		// The higher the pitch, the larger the factor, so as you look up, it damps a lot less.
;349:		pitch /= 89.0;	
ADDRLP4 84
ADDRLP4 84
INDIRF4
CNSTF4 1118961664
DIVF4
ASGNF4
line 350
;350:		dampfactor = (1.0-damp)*(pitch*pitch);
ADDRLP4 92
ADDRLP4 84
INDIRF4
ASGNF4
ADDRLP4 0
CNSTF4 1065353216
ADDRLP4 4
INDIRF4
SUBF4
ADDRLP4 92
INDIRF4
ADDRLP4 92
INDIRF4
MULF4
MULF4
ASGNF4
line 352
;351:
;352:		dampfactor += damp;
ADDRLP4 0
ADDRLP4 0
INDIRF4
ADDRLP4 4
INDIRF4
ADDF4
ASGNF4
line 353
;353:	}
LABELV $283
line 355
;354:
;355:	if (dampfactor>=1.0)
ADDRLP4 0
INDIRF4
CNSTF4 1065353216
LTF4 $285
line 356
;356:	{	// No damping.
line 357
;357:		VectorCopy(cameraIdealLoc, cameraCurLoc);
ADDRGP4 cameraCurLoc
ADDRGP4 cameraIdealLoc
INDIRB
ASGNB 12
line 358
;358:	}
ADDRGP4 $286
JUMPV
LABELV $285
line 359
;359:	else if (dampfactor>=0.0)
ADDRLP4 0
INDIRF4
CNSTF4 0
LTF4 $287
line 360
;360:	{	
line 362
;361:		// Calculate the difference from the current position to the new one.
;362:		VectorSubtract(cameraIdealLoc, cameraCurLoc, locdiff);
ADDRLP4 64
ADDRGP4 cameraIdealLoc
INDIRF4
ADDRGP4 cameraCurLoc
INDIRF4
SUBF4
ASGNF4
ADDRLP4 64+4
ADDRGP4 cameraIdealLoc+4
INDIRF4
ADDRGP4 cameraCurLoc+4
INDIRF4
SUBF4
ASGNF4
ADDRLP4 64+8
ADDRGP4 cameraIdealLoc+8
INDIRF4
ADDRGP4 cameraCurLoc+8
INDIRF4
SUBF4
ASGNF4
line 366
;363:
;364:		// Now we calculate how much of the difference we cover in the time allotted.
;365:		// The equation is (Damp)^(time)
;366:		dampfactor = 1.0-dampfactor;	// We must exponent the amount LEFT rather than the amount bled off
ADDRLP4 0
CNSTF4 1065353216
ADDRLP4 0
INDIRF4
SUBF4
ASGNF4
line 367
;367:		dtime = (float)(cg.time-cameraLastFrame) * (1.0/(float)CAMERA_DAMP_INTERVAL);	// Our dampfactor is geared towards a time interval equal to "1".
ADDRLP4 80
CNSTF4 1017370378
ADDRGP4 cg+68
INDIRI4
ADDRGP4 cameraLastFrame
INDIRI4
SUBI4
CVIF4 4
MULF4
ASGNF4
line 371
;368:
;369:		// Note that since there are a finite number of "practical" delta millisecond values possible, 
;370:		// the ratio should be initialized into a chart ultimately.
;371:		ratio = powf(dampfactor, (int)dtime);
ADDRLP4 0
INDIRF4
ARGF4
ADDRLP4 80
INDIRF4
CVFI4 4
ARGI4
ADDRLP4 84
ADDRGP4 powf
CALLF4
ASGNF4
ADDRLP4 76
ADDRLP4 84
INDIRF4
ASGNF4
line 374
;372:		
;373:		// This value is how much distance is "left" from the ideal.
;374:		VectorMA(cameraIdealLoc, -ratio, locdiff, cameraCurLoc);
ADDRLP4 88
ADDRLP4 76
INDIRF4
NEGF4
ASGNF4
ADDRGP4 cameraCurLoc
ADDRGP4 cameraIdealLoc
INDIRF4
ADDRLP4 64
INDIRF4
ADDRLP4 88
INDIRF4
MULF4
ADDF4
ASGNF4
ADDRGP4 cameraCurLoc+4
ADDRGP4 cameraIdealLoc+4
INDIRF4
ADDRLP4 64+4
INDIRF4
ADDRLP4 88
INDIRF4
MULF4
ADDF4
ASGNF4
ADDRGP4 cameraCurLoc+8
ADDRGP4 cameraIdealLoc+8
INDIRF4
ADDRLP4 64+8
INDIRF4
ADDRLP4 76
INDIRF4
NEGF4
MULF4
ADDF4
ASGNF4
line 376
;375:		/////////////////////////////////////////////////////////////////////////////////////////////////////////
;376:	}
LABELV $287
LABELV $286
line 379
;377:
;378:	// Now we trace from the new target location to the new view location, to make sure there is nothing in the way.
;379:	CG_Trace(&trace, cameraCurTarget, cameramins, cameramaxs, cameraCurLoc, cg.snap->ps.clientNum, MASK_SOLID|CONTENTS_PLAYERCLIP);
ADDRLP4 8
ARGP4
ADDRGP4 cameraCurTarget
ARGP4
ADDRGP4 cameramins
ARGP4
ADDRGP4 cameramaxs
ARGP4
ADDRGP4 cameraCurLoc
ARGP4
ADDRGP4 cg+36
INDIRP4
CNSTI4 212
ADDP4
INDIRI4
ARGI4
CNSTI4 4113
ARGI4
ADDRGP4 CG_Trace
CALLV
pop
line 380
;380:	if (trace.fraction < 1.0)
ADDRLP4 8+8
INDIRF4
CNSTF4 1065353216
GEF4 $303
line 381
;381:	{
line 382
;382:		VectorCopy( trace.endpos, cameraCurLoc );
ADDRGP4 cameraCurLoc
ADDRLP4 8+12
INDIRB
ASGNB 12
line 401
;383:		//FIXME: when the trace hits movers, it gets very very jaggy... ?
;384:		/*
;385:		//this doesn't actually help any
;386:		if ( trace.entityNum != ENTITYNUM_WORLD )
;387:		{
;388:			centity_t *cent = &cg_entities[trace.entityNum];
;389:			gentity_t *gent = &g_entities[trace.entityNum];
;390:			if ( cent != NULL && gent != NULL )
;391:			{
;392:				if ( cent->currentState.pos.trType == TR_LINEAR || cent->currentState.pos.trType == TR_LINEAR_STOP )
;393:				{
;394:					vec3_t	diff;
;395:					VectorSubtract( cent->lerpOrigin, gent->currentOrigin, diff );
;396:					VectorAdd( cameraCurLoc, diff, cameraCurLoc );
;397:				}
;398:			}
;399:		}
;400:		*/
;401:	}
LABELV $303
line 407
;402:
;403:	// Note that previously there was an upper limit to the number of physics traces that are done through the world
;404:	// for the sake of camera collision, since it wasn't calced per frame.  Now it is calculated every frame.
;405:	// This has the benefit that the camera is a lot smoother now (before it lerped between tested points),
;406:	// however two full volume traces each frame is a bit scary to think about.
;407:}
LABELV $282
endproc CG_UpdateThirdPersonCameraDamp 96 28
proc CG_OffsetThirdPersonView 20 16
line 417
;408:
;409:/*
;410:===============`
;411:CG_OffsetThirdPersonView
;412:
;413:===============
;414:*/
;415:extern vmCvar_t cg_thirdPersonHorzOffset;
;416:static void CG_OffsetThirdPersonView( void ) 
;417:{
line 421
;418:	vec3_t diff;
;419:
;420:	// Set camera viewing direction.
;421:	VectorCopy( cg.refdef.viewangles, cameraFocusAngles );
ADDRGP4 cameraFocusAngles
ADDRGP4 cg+1200+368
INDIRB
ASGNB 12
line 424
;422:
;423:	// if dead, look at killer
;424:	if ( 0 && cg.snap->ps.stats[STAT_HEALTH] <= 0 ) 
ADDRGP4 $310
JUMPV
line 425
;425:	{
line 426
;426:		cameraFocusAngles[YAW] = cg.snap->ps.stats[STAT_DEAD_YAW];
ADDRGP4 cameraFocusAngles+4
ADDRGP4 cg+36
INDIRP4
CNSTI4 276
ADDP4
INDIRI4
CVIF4 4
ASGNF4
line 427
;427:		cameraFocusAngles[PITCH] = 90;
ADDRGP4 cameraFocusAngles
CNSTF4 1119092736
ASGNF4
line 428
;428:	}
ADDRGP4 $311
JUMPV
LABELV $310
line 430
;429:	else
;430:	{	// Add in the third Person Angle.
line 431
;431:		cameraFocusAngles[YAW] += cg_thirdPersonYaw.value;
ADDRLP4 12
ADDRGP4 cameraFocusAngles+4
ASGNP4
ADDRLP4 12
INDIRP4
ADDRLP4 12
INDIRP4
INDIRF4
ADDRGP4 cg_thirdPersonYaw+8
INDIRF4
ADDF4
ASGNF4
line 432
;432:		cameraFocusAngles[PITCH] += cg_thirdPersonPitch.value;
ADDRLP4 16
ADDRGP4 cameraFocusAngles
ASGNP4
ADDRLP4 16
INDIRP4
ADDRLP4 16
INDIRP4
INDIRF4
ADDRGP4 cg_thirdPersonPitch+8
INDIRF4
ADDF4
ASGNF4
line 433
;433:	}
LABELV $311
line 438
;434:
;435:	// The next thing to do is to see if we need to calculate a new camera target location.
;436:
;437:	// If we went back in time for some reason, or if we just started, reset the sample.
;438:	if (cameraLastFrame == 0 || cameraLastFrame > cg.time)
ADDRLP4 12
ADDRGP4 cameraLastFrame
INDIRI4
ASGNI4
ADDRLP4 12
INDIRI4
CNSTI4 0
EQI4 $321
ADDRLP4 12
INDIRI4
ADDRGP4 cg+68
INDIRI4
LEI4 $318
LABELV $321
line 439
;439:	{
line 440
;440:		CG_ResetThirdPersonViewDamp();
ADDRGP4 CG_ResetThirdPersonViewDamp
CALLV
pop
line 441
;441:	}
ADDRGP4 $319
JUMPV
LABELV $318
line 443
;442:	else
;443:	{
line 445
;444:		// Cap the pitch within reasonable limits
;445:		if (cameraFocusAngles[PITCH] > 89.0)
ADDRGP4 cameraFocusAngles
INDIRF4
CNSTF4 1118961664
LEF4 $322
line 446
;446:		{
line 447
;447:			cameraFocusAngles[PITCH] = 89.0;
ADDRGP4 cameraFocusAngles
CNSTF4 1118961664
ASGNF4
line 448
;448:		}
ADDRGP4 $323
JUMPV
LABELV $322
line 449
;449:		else if (cameraFocusAngles[PITCH] < -89.0)
ADDRGP4 cameraFocusAngles
INDIRF4
CNSTF4 3266445312
GEF4 $324
line 450
;450:		{
line 451
;451:			cameraFocusAngles[PITCH] = -89.0;
ADDRGP4 cameraFocusAngles
CNSTF4 3266445312
ASGNF4
line 452
;452:		}
LABELV $324
LABELV $323
line 454
;453:
;454:		AngleVectors(cameraFocusAngles, camerafwd, NULL, cameraup);
ADDRGP4 cameraFocusAngles
ARGP4
ADDRGP4 camerafwd
ARGP4
CNSTP4 0
ARGP4
ADDRGP4 cameraup
ARGP4
ADDRGP4 AngleVectors
CALLV
pop
line 457
;455:
;456:		// Move the target to the new location.
;457:		CG_UpdateThirdPersonTargetDamp();
ADDRGP4 CG_UpdateThirdPersonTargetDamp
CALLV
pop
line 458
;458:		CG_UpdateThirdPersonCameraDamp();
ADDRGP4 CG_UpdateThirdPersonCameraDamp
CALLV
pop
line 459
;459:	}
LABELV $319
line 465
;460:
;461:	// Now interestingly, the Quake method is to calculate a target focus point above the player, and point the camera at it.
;462:	// We won't do that for now.
;463:
;464:	// We must now take the angle taken from the camera target and location.
;465:	VectorSubtract(cameraCurTarget, cameraCurLoc, diff);
ADDRLP4 0
ADDRGP4 cameraCurTarget
INDIRF4
ADDRGP4 cameraCurLoc
INDIRF4
SUBF4
ASGNF4
ADDRLP4 0+4
ADDRGP4 cameraCurTarget+4
INDIRF4
ADDRGP4 cameraCurLoc+4
INDIRF4
SUBF4
ASGNF4
ADDRLP4 0+8
ADDRGP4 cameraCurTarget+8
INDIRF4
ADDRGP4 cameraCurLoc+8
INDIRF4
SUBF4
ASGNF4
line 466
;466:	VectorNormalize(diff);
ADDRLP4 0
ARGP4
ADDRGP4 VectorNormalize
CALLF4
pop
line 467
;467:	vectoangles(diff, cg.refdef.viewangles);
ADDRLP4 0
ARGP4
ADDRGP4 cg+1200+368
ARGP4
ADDRGP4 vectoangles
CALLV
pop
line 470
;468:
;469:	// Temp: just move the camera to the side a bit
;470:	if ( cg_thirdPersonHorzOffset.value != 0.0f )
ADDRGP4 cg_thirdPersonHorzOffset+8
INDIRF4
CNSTF4 0
EQF4 $334
line 471
;471:	{
line 472
;472:		AnglesToAxis( cg.refdef.viewangles, cg.refdef.viewaxis );
ADDRGP4 cg+1200+368
ARGP4
ADDRGP4 cg+1200+36
ARGP4
ADDRGP4 AnglesToAxis
CALLV
pop
line 473
;473:		VectorMA( cameraCurLoc, cg_thirdPersonHorzOffset.value, cg.refdef.viewaxis[1], cameraCurLoc );
ADDRLP4 16
ADDRGP4 cameraCurLoc
ASGNP4
ADDRLP4 16
INDIRP4
ADDRLP4 16
INDIRP4
INDIRF4
ADDRGP4 cg+1200+36+12
INDIRF4
ADDRGP4 cg_thirdPersonHorzOffset+8
INDIRF4
MULF4
ADDF4
ASGNF4
ADDRGP4 cameraCurLoc+4
ADDRGP4 cameraCurLoc+4
INDIRF4
ADDRGP4 cg+1200+36+12+4
INDIRF4
ADDRGP4 cg_thirdPersonHorzOffset+8
INDIRF4
MULF4
ADDF4
ASGNF4
ADDRGP4 cameraCurLoc+8
ADDRGP4 cameraCurLoc+8
INDIRF4
ADDRGP4 cg+1200+36+12+8
INDIRF4
ADDRGP4 cg_thirdPersonHorzOffset+8
INDIRF4
MULF4
ADDF4
ASGNF4
line 474
;474:	}
LABELV $334
line 477
;475:
;476:	// ...and of course we should copy the new view location to the proper spot too.
;477:	VectorCopy(cameraCurLoc, cg.refdef.vieworg);
ADDRGP4 cg+1200+24
ADDRGP4 cameraCurLoc
INDIRB
ASGNB 12
line 479
;478:
;479:	cameraLastFrame=cg.time;
ADDRGP4 cameraLastFrame
ADDRGP4 cg+68
INDIRI4
ASGNI4
line 480
;480:}
LABELV $307
endproc CG_OffsetThirdPersonView 20 16
proc CG_OffsetFirstPersonView 84 12
line 581
;481:
;482:
;483:
;484:/*
;485:===============
;486:CG_OffsetThirdPersonView
;487:
;488:===============
;489:*//*
;490:#define	FOCUS_DISTANCE	512
;491:static void CG_OffsetThirdPersonView( void ) {
;492:	vec3_t		forward, right, up;
;493:	vec3_t		view;
;494:	vec3_t		focusAngles;
;495:	trace_t		trace;
;496:	static vec3_t	mins = { -4, -4, -4 };
;497:	static vec3_t	maxs = { 4, 4, 4 };
;498:	vec3_t		focusPoint;
;499:	float		focusDist;
;500:	float		forwardScale, sideScale;
;501:
;502:	cg.refdef.vieworg[2] += cg.predictedPlayerState.viewheight;
;503:
;504:	VectorCopy( cg.refdef.viewangles, focusAngles );
;505:
;506:	// if dead, look at killer
;507:	if ( cg.predictedPlayerState.stats[STAT_HEALTH] <= 0 ) {
;508:		focusAngles[YAW] = cg.predictedPlayerState.stats[STAT_DEAD_YAW];
;509:		cg.refdef.viewangles[YAW] = cg.predictedPlayerState.stats[STAT_DEAD_YAW];
;510:	}
;511:
;512:	if ( focusAngles[PITCH] > 45 ) {
;513:		focusAngles[PITCH] = 45;		// don't go too far overhead
;514:	}
;515:	AngleVectors( focusAngles, forward, NULL, NULL );
;516:
;517:	VectorMA( cg.refdef.vieworg, FOCUS_DISTANCE, forward, focusPoint );
;518:
;519:	VectorCopy( cg.refdef.vieworg, view );
;520:
;521:	view[2] += 8;
;522:
;523:	cg.refdef.viewangles[PITCH] *= 0.5;
;524:
;525:	AngleVectors( cg.refdef.viewangles, forward, right, up );
;526:
;527:	forwardScale = cos( cg_thirdPersonAngle.value / 180 * M_PI );
;528:	sideScale = sin( cg_thirdPersonAngle.value / 180 * M_PI );
;529:	VectorMA( view, -cg_thirdPersonRange.value * forwardScale, forward, view );
;530:	VectorMA( view, -cg_thirdPersonRange.value * sideScale, right, view );
;531:
;532:	// trace a ray from the origin to the viewpoint to make sure the view isn't
;533:	// in a solid block.  Use an 8 by 8 block to prevent the view from near clipping anything
;534:
;535:	if (!cg_cameraMode.integer) {
;536:		CG_Trace( &trace, cg.refdef.vieworg, mins, maxs, view, cg.predictedPlayerState.clientNum, MASK_SOLID );
;537:
;538:		if ( trace.fraction != 1.0 ) {
;539:			VectorCopy( trace.endpos, view );
;540:			view[2] += (1.0 - trace.fraction) * 32;
;541:			// try another trace to this position, because a tunnel may have the ceiling
;542:			// close enogh that this is poking out
;543:
;544:			CG_Trace( &trace, cg.refdef.vieworg, mins, maxs, view, cg.predictedPlayerState.clientNum, MASK_SOLID );
;545:			VectorCopy( trace.endpos, view );
;546:		}
;547:	}
;548:
;549:
;550:	VectorCopy( view, cg.refdef.vieworg );
;551:
;552:	// select pitch to look at focus point from vieword
;553:	VectorSubtract( focusPoint, cg.refdef.vieworg, focusPoint );
;554:	focusDist = sqrt( focusPoint[0] * focusPoint[0] + focusPoint[1] * focusPoint[1] );
;555:	if ( focusDist < 1 ) {
;556:		focusDist = 1;	// should never happen
;557:	}
;558:	cg.refdef.viewangles[PITCH] = -180 / M_PI * atan2( focusPoint[2], focusDist );
;559:	cg.refdef.viewangles[YAW] -= cg_thirdPersonAngle.value;
;560:}
;561:
;562:
;563:// this causes a compiler bug on mac MrC compiler
;564:static void CG_StepOffset( void ) {
;565:	int		timeDelta;
;566:	
;567:	// smooth out stair climbing
;568:	timeDelta = cg.time - cg.stepTime;
;569:	if ( timeDelta < STEP_TIME ) {
;570:		cg.refdef.vieworg[2] -= cg.stepChange 
;571:			* (STEP_TIME - timeDelta) / STEP_TIME;
;572:	}
;573:}*/
;574:
;575:/*
;576:===============
;577:CG_OffsetFirstPersonView
;578:===============
;579:*/
;580:static void CG_OffsetFirstPersonView( void ) 
;581:{
line 592
;582:	float	*origin;
;583:	float	*angles;
;584:	float	bob;
;585:	float	ratio;
;586:	float	delta;
;587:	float	speed;
;588:	float	f;
;589:	vec3_t	predictedVelocity;
;590:	int		timeDelta;
;591:
;592:	if ( cg.snap->ps.pm_type == PM_INTERMISSION ) {
ADDRGP4 cg+36
INDIRP4
CNSTI4 48
ADDP4
INDIRI4
CNSTI4 5
NEI4 $363
line 593
;593:		return;
ADDRGP4 $362
JUMPV
LABELV $363
line 596
;594:	}
;595:
;596:	origin = cg.refdef.vieworg;
ADDRLP4 20
ADDRGP4 cg+1200+24
ASGNP4
line 597
;597:	angles = cg.refdef.viewangles;
ADDRLP4 4
ADDRGP4 cg+1200+368
ASGNP4
line 600
;598:
;599:	// If dead, fall to the ground
;600:	if ( cg.snap->ps.pm_type == PM_DEAD )
ADDRGP4 cg+36
INDIRP4
CNSTI4 48
ADDP4
INDIRI4
CNSTI4 3
NEI4 $370
line 601
;601:	{
line 606
;602:		int		atime;
;603:		int		htime;
;604:		float	f;
;605:		
;606:		atime = (cg.time - cg.deathTime);
ADDRLP4 48
ADDRGP4 cg+68
INDIRI4
ADDRGP4 cg+1080
INDIRI4
SUBI4
ASGNI4
line 607
;607:		if ( atime > 450)
ADDRLP4 48
INDIRI4
CNSTI4 450
LEI4 $375
line 608
;608:		{
line 609
;609:			atime = 450;
ADDRLP4 48
CNSTI4 450
ASGNI4
line 610
;610:		}
LABELV $375
line 612
;611:
;612:		htime = (cg.time - cg.deathTime);
ADDRLP4 52
ADDRGP4 cg+68
INDIRI4
ADDRGP4 cg+1080
INDIRI4
SUBI4
ASGNI4
line 613
;613:		if ( htime > 350)
ADDRLP4 52
INDIRI4
CNSTI4 350
LEI4 $379
line 614
;614:		{
line 615
;615:			htime = 350;
ADDRLP4 52
CNSTI4 350
ASGNI4
line 616
;616:		}
LABELV $379
line 618
;617:
;618:		f = (float)atime / 450.0f;
ADDRLP4 44
ADDRLP4 48
INDIRI4
CVIF4 4
CNSTF4 1138819072
DIVF4
ASGNF4
line 619
;619:		cg.refdef.viewangles[ROLL] += ((cg.deathTime&0x100)?-1:1) * 40 * f;
ADDRGP4 cg+1080
INDIRI4
CNSTI4 256
BANDI4
CNSTI4 0
EQI4 $386
ADDRLP4 56
CNSTI4 -1
ASGNI4
ADDRGP4 $387
JUMPV
LABELV $386
ADDRLP4 56
CNSTI4 1
ASGNI4
LABELV $387
ADDRLP4 60
ADDRGP4 cg+1200+368+8
ASGNP4
ADDRLP4 60
INDIRP4
ADDRLP4 60
INDIRP4
INDIRF4
CNSTI4 40
ADDRLP4 56
INDIRI4
MULI4
CVIF4 4
ADDRLP4 44
INDIRF4
MULF4
ADDF4
ASGNF4
line 620
;620:		cg.refdef.viewangles[PITCH] -= ((cg.deathTime&0x010)?-1:1) * 20 * f;
ADDRGP4 cg+1080
INDIRI4
CNSTI4 16
BANDI4
CNSTI4 0
EQI4 $392
ADDRLP4 64
CNSTI4 -1
ASGNI4
ADDRGP4 $393
JUMPV
LABELV $392
ADDRLP4 64
CNSTI4 1
ASGNI4
LABELV $393
ADDRLP4 68
ADDRGP4 cg+1200+368
ASGNP4
ADDRLP4 68
INDIRP4
ADDRLP4 68
INDIRP4
INDIRF4
CNSTI4 20
ADDRLP4 64
INDIRI4
MULI4
CVIF4 4
ADDRLP4 44
INDIRF4
MULF4
SUBF4
ASGNF4
line 621
;621:		cg.refdef.viewangles[YAW] -= ((cg.deathTime&0x001)?-1:1) * 40 * f;
ADDRGP4 cg+1080
INDIRI4
CNSTI4 1
BANDI4
CNSTI4 0
EQI4 $399
ADDRLP4 72
CNSTI4 -1
ASGNI4
ADDRGP4 $400
JUMPV
LABELV $399
ADDRLP4 72
CNSTI4 1
ASGNI4
LABELV $400
ADDRLP4 76
ADDRGP4 cg+1200+368+4
ASGNP4
ADDRLP4 76
INDIRP4
ADDRLP4 76
INDIRP4
INDIRF4
CNSTI4 40
ADDRLP4 72
INDIRI4
MULI4
CVIF4 4
ADDRLP4 44
INDIRF4
MULF4
SUBF4
ASGNF4
line 623
;622:
;623:		f = (float)htime / 400.0f;
ADDRLP4 44
ADDRLP4 52
INDIRI4
CVIF4 4
CNSTF4 1137180672
DIVF4
ASGNF4
line 624
;624:		cg.refdef.vieworg[2] += (f * cg.predictedPlayerState.viewheight * 0.90f);
ADDRLP4 80
ADDRGP4 cg+1200+24+8
ASGNP4
ADDRLP4 80
INDIRP4
ADDRLP4 80
INDIRP4
INDIRF4
CNSTF4 1063675494
ADDRLP4 44
INDIRF4
ADDRGP4 cg+100+192
INDIRI4
CVIF4 4
MULF4
MULF4
ADDF4
ASGNF4
line 626
;625:
;626:		return;
ADDRGP4 $362
JUMPV
LABELV $370
line 630
;627:	}
;628:
;629:	// add angles based on damage kick
;630:	if ( cg.damageTime ) 
ADDRGP4 cg+9800
INDIRF4
CNSTF4 0
EQF4 $406
line 631
;631:	{
line 632
;632:		ratio = cg.time - cg.damageTime;
ADDRLP4 32
ADDRGP4 cg+68
INDIRI4
CVIF4 4
ADDRGP4 cg+9800
INDIRF4
SUBF4
ASGNF4
line 633
;633:		if ( ratio < DAMAGE_DEFLECT_TIME ) 
ADDRLP4 32
INDIRF4
CNSTF4 1120403456
GEF4 $411
line 634
;634:		{
line 635
;635:			ratio /= DAMAGE_DEFLECT_TIME;
ADDRLP4 32
ADDRLP4 32
INDIRF4
CNSTF4 1120403456
DIVF4
ASGNF4
line 636
;636:			angles[PITCH] += ratio * cg.v_dmg_pitch;
ADDRLP4 4
INDIRP4
ADDRLP4 4
INDIRP4
INDIRF4
ADDRLP4 32
INDIRF4
ADDRGP4 cg+9812
INDIRF4
MULF4
ADDF4
ASGNF4
line 638
;637:
;638:			if ( cg.v_dmg_roll != 255 )
ADDRGP4 cg+9816
INDIRF4
CNSTF4 1132396544
EQF4 $412
line 639
;639:			{
line 640
;640:				angles[ROLL] += ratio * cg.v_dmg_roll;
ADDRLP4 48
ADDRLP4 4
INDIRP4
CNSTI4 8
ADDP4
ASGNP4
ADDRLP4 48
INDIRP4
ADDRLP4 48
INDIRP4
INDIRF4
ADDRLP4 32
INDIRF4
ADDRGP4 cg+9816
INDIRF4
MULF4
ADDF4
ASGNF4
line 641
;641:			}
line 642
;642:		} 
ADDRGP4 $412
JUMPV
LABELV $411
line 644
;643:		else 
;644:		{
line 645
;645:			ratio = 1.0 - ( ratio - DAMAGE_DEFLECT_TIME ) / DAMAGE_RETURN_TIME;
ADDRLP4 32
CNSTF4 1065353216
ADDRLP4 32
INDIRF4
CNSTF4 1120403456
SUBF4
CNSTF4 1137180672
DIVF4
SUBF4
ASGNF4
line 646
;646:			if ( ratio > 0 ) 
ADDRLP4 32
INDIRF4
CNSTF4 0
LEF4 $418
line 647
;647:			{
line 648
;648:				angles[PITCH] += ratio * cg.v_dmg_pitch;
ADDRLP4 4
INDIRP4
ADDRLP4 4
INDIRP4
INDIRF4
ADDRLP4 32
INDIRF4
ADDRGP4 cg+9812
INDIRF4
MULF4
ADDF4
ASGNF4
line 650
;649:
;650:				if ( cg.v_dmg_roll != 255 )
ADDRGP4 cg+9816
INDIRF4
CNSTF4 1132396544
EQF4 $421
line 651
;651:				{
line 652
;652:					angles[ROLL] += ratio * cg.v_dmg_roll;
ADDRLP4 48
ADDRLP4 4
INDIRP4
CNSTI4 8
ADDP4
ASGNP4
ADDRLP4 48
INDIRP4
ADDRLP4 48
INDIRP4
INDIRF4
ADDRLP4 32
INDIRF4
ADDRGP4 cg+9816
INDIRF4
MULF4
ADDF4
ASGNF4
line 653
;653:				}
LABELV $421
line 654
;654:			}
LABELV $418
line 655
;655:		}
LABELV $412
line 656
;656:	}
LABELV $406
line 667
;657:
;658:	// add pitch based on fall kick
;659:#if 0
;660:	ratio = ( cg.time - cg.landTime) / FALL_TIME;
;661:	if (ratio < 0)
;662:		ratio = 0;
;663:	angles[PITCH] += ratio * cg.fall_value;
;664:#endif
;665:
;666:	// add angles based on velocity
;667:	VectorCopy( cg.predictedPlayerState.velocity, predictedVelocity );
ADDRLP4 8
ADDRGP4 cg+100+36
INDIRB
ASGNB 12
line 669
;668:
;669:	delta = DotProduct ( predictedVelocity, cg.refdef.viewaxis[0]);
ADDRLP4 0
ADDRLP4 8
INDIRF4
ADDRGP4 cg+1200+36
INDIRF4
MULF4
ADDRLP4 8+4
INDIRF4
ADDRGP4 cg+1200+36+4
INDIRF4
MULF4
ADDF4
ADDRLP4 8+8
INDIRF4
ADDRGP4 cg+1200+36+8
INDIRF4
MULF4
ADDF4
ASGNF4
line 670
;670:	angles[PITCH] += delta * cg_runpitch.value;
ADDRLP4 4
INDIRP4
ADDRLP4 4
INDIRP4
INDIRF4
ADDRLP4 0
INDIRF4
ADDRGP4 cg_runpitch+8
INDIRF4
MULF4
ADDF4
ASGNF4
line 672
;671:	
;672:	delta = DotProduct ( predictedVelocity, cg.refdef.viewaxis[1]);
ADDRLP4 0
ADDRLP4 8
INDIRF4
ADDRGP4 cg+1200+36+12
INDIRF4
MULF4
ADDRLP4 8+4
INDIRF4
ADDRGP4 cg+1200+36+12+4
INDIRF4
MULF4
ADDF4
ADDRLP4 8+8
INDIRF4
ADDRGP4 cg+1200+36+12+8
INDIRF4
MULF4
ADDF4
ASGNF4
line 673
;673:	angles[ROLL] -= delta * cg_runroll.value;
ADDRLP4 48
ADDRLP4 4
INDIRP4
CNSTI4 8
ADDP4
ASGNP4
ADDRLP4 48
INDIRP4
ADDRLP4 48
INDIRP4
INDIRF4
ADDRLP4 0
INDIRF4
ADDRGP4 cg_runroll+8
INDIRF4
MULF4
SUBF4
ASGNF4
line 678
;674:
;675:	// add angles based on bob
;676:
;677:	// make sure the bob is visible even at low speeds
;678:	speed = cg.xyspeed > 200 ? cg.xyspeed : 200;
ADDRGP4 cg+9828
INDIRF4
CNSTF4 1128792064
LEF4 $455
ADDRLP4 52
ADDRGP4 cg+9828
INDIRF4
ASGNF4
ADDRGP4 $456
JUMPV
LABELV $455
ADDRLP4 52
CNSTF4 1128792064
ASGNF4
LABELV $456
ADDRLP4 28
ADDRLP4 52
INDIRF4
ASGNF4
line 680
;679:
;680:	delta = cg.bobfracsin * cg_bobpitch.value * speed;
ADDRLP4 0
ADDRGP4 cg+9820
INDIRF4
ADDRGP4 cg_bobpitch+8
INDIRF4
MULF4
ADDRLP4 28
INDIRF4
MULF4
ASGNF4
line 681
;681:	if ((cg.predictedPlayerState.pm_flags & PMF_DUCKED) && (cg.predictedPlayerState.groundEntityNum!=ENTITYNUM_NONE))
ADDRGP4 cg+100+12
INDIRI4
CNSTI4 1
BANDI4
CNSTI4 0
EQI4 $459
ADDRGP4 cg+100+96
INDIRI4
CNSTI4 1023
EQI4 $459
line 682
;682:		delta *= 3;		// crouching
ADDRLP4 0
CNSTF4 1077936128
ADDRLP4 0
INDIRF4
MULF4
ASGNF4
LABELV $459
line 683
;683:	angles[PITCH] += delta;
ADDRLP4 4
INDIRP4
ADDRLP4 4
INDIRP4
INDIRF4
ADDRLP4 0
INDIRF4
ADDF4
ASGNF4
line 684
;684:	delta = cg.bobfracsin * cg_bobroll.value * speed;
ADDRLP4 0
ADDRGP4 cg+9820
INDIRF4
ADDRGP4 cg_bobroll+8
INDIRF4
MULF4
ADDRLP4 28
INDIRF4
MULF4
ASGNF4
line 685
;685:	if ((cg.predictedPlayerState.pm_flags & PMF_DUCKED) && (cg.predictedPlayerState.groundEntityNum!=ENTITYNUM_NONE))
ADDRGP4 cg+100+12
INDIRI4
CNSTI4 1
BANDI4
CNSTI4 0
EQI4 $467
ADDRGP4 cg+100+96
INDIRI4
CNSTI4 1023
EQI4 $467
line 686
;686:		delta *= 3;		// crouching accentuates roll
ADDRLP4 0
CNSTF4 1077936128
ADDRLP4 0
INDIRF4
MULF4
ASGNF4
LABELV $467
line 687
;687:	if (cg.bobcycle & 1)
ADDRGP4 cg+9824
INDIRI4
CNSTI4 1
BANDI4
CNSTI4 0
EQI4 $473
line 688
;688:		delta = -delta;
ADDRLP4 0
ADDRLP4 0
INDIRF4
NEGF4
ASGNF4
LABELV $473
line 689
;689:	angles[ROLL] += delta;
ADDRLP4 60
ADDRLP4 4
INDIRP4
CNSTI4 8
ADDP4
ASGNP4
ADDRLP4 60
INDIRP4
ADDRLP4 60
INDIRP4
INDIRF4
ADDRLP4 0
INDIRF4
ADDF4
ASGNF4
line 694
;690:
;691://===================================
;692:
;693:	// add view height
;694:	origin[2] += cg.predictedPlayerState.viewheight;
ADDRLP4 64
ADDRLP4 20
INDIRP4
CNSTI4 8
ADDP4
ASGNP4
ADDRLP4 64
INDIRP4
ADDRLP4 64
INDIRP4
INDIRF4
ADDRGP4 cg+100+192
INDIRI4
CVIF4 4
ADDF4
ASGNF4
line 697
;695:
;696:	// smooth out duck height changes
;697:	timeDelta = cg.time - cg.duckTime;
ADDRLP4 36
ADDRGP4 cg+68
INDIRI4
ADDRGP4 cg+1068
INDIRI4
SUBI4
ASGNI4
line 698
;698:	if ( timeDelta < DUCK_TIME) {
ADDRLP4 36
INDIRI4
CNSTI4 100
GEI4 $480
line 699
;699:		cg.refdef.vieworg[2] -= cg.duckChange 
ADDRLP4 68
ADDRGP4 cg+1200+24+8
ASGNP4
ADDRLP4 68
INDIRP4
ADDRLP4 68
INDIRP4
INDIRF4
ADDRGP4 cg+1064
INDIRF4
CNSTI4 100
ADDRLP4 36
INDIRI4
SUBI4
CVIF4 4
MULF4
CNSTF4 1120403456
DIVF4
SUBF4
ASGNF4
line 701
;700:			* (DUCK_TIME - timeDelta) / DUCK_TIME;
;701:	}
LABELV $480
line 704
;702:
;703:	// add bob height
;704:	bob = cg.bobfracsin * cg.xyspeed * cg_bobup.value;
ADDRLP4 24
ADDRGP4 cg+9820
INDIRF4
ADDRGP4 cg+9828
INDIRF4
MULF4
ADDRGP4 cg_bobup+8
INDIRF4
MULF4
ASGNF4
line 705
;705:	if (bob > 6) {
ADDRLP4 24
INDIRF4
CNSTF4 1086324736
LEF4 $489
line 706
;706:		bob = 6;
ADDRLP4 24
CNSTF4 1086324736
ASGNF4
line 707
;707:	}
LABELV $489
line 709
;708:
;709:	origin[2] += bob;
ADDRLP4 68
ADDRLP4 20
INDIRP4
CNSTI4 8
ADDP4
ASGNP4
ADDRLP4 68
INDIRP4
ADDRLP4 68
INDIRP4
INDIRF4
ADDRLP4 24
INDIRF4
ADDF4
ASGNF4
line 713
;710:
;711:
;712:	// add fall height
;713:	delta = cg.time - cg.landTime;
ADDRLP4 0
ADDRGP4 cg+68
INDIRI4
ADDRGP4 cg+1076
INDIRI4
SUBI4
CVIF4 4
ASGNF4
line 714
;714:	if ( delta < LAND_DEFLECT_TIME ) {
ADDRLP4 0
INDIRF4
CNSTF4 1125515264
GEF4 $493
line 715
;715:		f = delta / LAND_DEFLECT_TIME;
ADDRLP4 40
ADDRLP4 0
INDIRF4
CNSTF4 1125515264
DIVF4
ASGNF4
line 716
;716:		cg.refdef.vieworg[2] += cg.landChange * f;
ADDRLP4 72
ADDRGP4 cg+1200+24+8
ASGNP4
ADDRLP4 72
INDIRP4
ADDRLP4 72
INDIRP4
INDIRF4
ADDRGP4 cg+1072
INDIRF4
ADDRLP4 40
INDIRF4
MULF4
ADDF4
ASGNF4
line 717
;717:	} else if ( delta < LAND_DEFLECT_TIME + LAND_RETURN_TIME ) {
ADDRGP4 $494
JUMPV
LABELV $493
ADDRLP4 0
INDIRF4
CNSTF4 1138819072
GEF4 $499
line 718
;718:		delta -= LAND_DEFLECT_TIME;
ADDRLP4 0
ADDRLP4 0
INDIRF4
CNSTF4 1125515264
SUBF4
ASGNF4
line 719
;719:		f = 1.0 - ( delta / LAND_RETURN_TIME );
ADDRLP4 40
CNSTF4 1065353216
ADDRLP4 0
INDIRF4
CNSTF4 1133903872
DIVF4
SUBF4
ASGNF4
line 720
;720:		cg.refdef.vieworg[2] += cg.landChange * f;
ADDRLP4 72
ADDRGP4 cg+1200+24+8
ASGNP4
ADDRLP4 72
INDIRP4
ADDRLP4 72
INDIRP4
INDIRF4
ADDRGP4 cg+1072
INDIRF4
ADDRLP4 40
INDIRF4
MULF4
ADDF4
ASGNF4
line 721
;721:	}
LABELV $499
LABELV $494
line 724
;722:
;723:	// add step offset
;724:	CG_StepOffset();
ADDRGP4 CG_StepOffset
CALLV
pop
line 728
;725:
;726:	// add kick offset
;727:
;728:	if( cg.predictedPlayerState.pm_flags & PMF_LEANING )
ADDRGP4 cg+100+12
INDIRI4
CNSTI4 2097152
BANDI4
CNSTI4 0
EQI4 $505
line 729
;729:	{
line 732
;730:		float leanOffset;
;731:
;732:		leanOffset = (float)(cg.predictedPlayerState.leanTime - LEAN_TIME) / LEAN_TIME * LEAN_OFFSET;
ADDRLP4 72
CNSTF4 1106247680
ADDRGP4 cg+100+856
INDIRI4
CNSTI4 250
SUBI4
CVIF4 4
CNSTF4 1132068864
DIVF4
MULF4
ASGNF4
line 733
;733:		angles[ROLL] += leanOffset / 4;
ADDRLP4 76
ADDRLP4 4
INDIRP4
CNSTI4 8
ADDP4
ASGNP4
ADDRLP4 76
INDIRP4
ADDRLP4 76
INDIRP4
INDIRF4
ADDRLP4 72
INDIRF4
CNSTF4 1082130432
DIVF4
ADDF4
ASGNF4
line 735
;734:
;735:		BG_ApplyLeanOffset ( &cg.predictedPlayerState, origin );
ADDRGP4 cg+100
ARGP4
ADDRLP4 20
INDIRP4
ARGP4
ADDRGP4 BG_ApplyLeanOffset
CALLV
pop
line 736
;736:	}
LABELV $505
line 739
;737:
;738:	// Make sure view doesnt invert on itself
;739:	angles[PITCH] = Com_Clampf ( -89, 89, angles[PITCH] );
CNSTF4 3266445312
ARGF4
CNSTF4 1118961664
ARGF4
ADDRLP4 4
INDIRP4
INDIRF4
ARGF4
ADDRLP4 76
ADDRGP4 Com_Clampf
CALLF4
ASGNF4
ADDRLP4 4
INDIRP4
ADDRLP4 76
INDIRF4
ASGNF4
line 740
;740:}
LABELV $362
endproc CG_OffsetFirstPersonView 84 12
export CG_CalcFOVFromX
proc CG_CalcFOVFromX 20 8
line 754
;741:
;742:
;743:/*
;744:====================
;745:CG_CalcFovFromX
;746:
;747:Calcs Y FOV from given X FOV
;748:====================
;749:*/
;750:#define	WAVE_AMPLITUDE	1
;751:#define	WAVE_FREQUENCY	0.4
;752:
;753:qboolean CG_CalcFOVFromX( float fov_x ) 
;754:{
line 762
;755:	float	x;
;756://	float	phase;
;757://	float	v;
;758://	int		contents;
;759:	float	fov_y;
;760:	qboolean	inwater;
;761:
;762:	x = cg.refdef.width / tan( fov_x / 360 * M_PI );
CNSTF4 1078530011
ADDRFP4 0
INDIRF4
CNSTF4 1135869952
DIVF4
MULF4
ARGF4
ADDRLP4 12
ADDRGP4 tan
CALLF4
ASGNF4
ADDRLP4 4
ADDRGP4 cg+1200+8
INDIRI4
CVIF4 4
ADDRLP4 12
INDIRF4
DIVF4
ASGNF4
line 763
;763:	fov_y = atan2( cg.refdef.height, x );
ADDRGP4 cg+1200+12
INDIRI4
CVIF4 4
ARGF4
ADDRLP4 4
INDIRF4
ARGF4
ADDRLP4 16
ADDRGP4 atan2
CALLF4
ASGNF4
ADDRLP4 0
ADDRLP4 16
INDIRF4
ASGNF4
line 764
;764:	fov_y = fov_y * 360 / M_PI;
ADDRLP4 0
CNSTF4 1135869952
ADDRLP4 0
INDIRF4
MULF4
CNSTF4 1078530011
DIVF4
ASGNF4
line 787
;765:
;766:	// there's a problem with this, it only takes the leafbrushes into account, not the entity brushes,
;767:	//	so if you give slime/water etc properties to a func_door area brush in order to move the whole water 
;768:	//	level up/down this doesn't take into account the door position, so warps the view the whole time
;769:	//	whether the water is up or not. Fortunately there's only one slime area in Trek that you can be under,
;770:	//	so lose it...
;771:#if 0
;772:/*
;773:	// warp if underwater
;774:	contents = CG_PointContents( cg.refdef.vieworg, -1 );
;775:	if ( contents & ( CONTENTS_WATER | CONTENTS_LAVA ) ){
;776:		phase = cg.time / 1000.0 * WAVE_FREQUENCY * M_PI * 2;
;777:		v = WAVE_AMPLITUDE * sin( phase );
;778:		fov_x += v;
;779:		fov_y -= v;
;780:		inwater = qtrue;
;781:	}
;782:	else {
;783:		inwater = qfalse;
;784:	}
;785:*/
;786:#else
;787:	inwater = qfalse;
ADDRLP4 8
CNSTI4 0
ASGNI4
line 792
;788:#endif
;789:
;790:
;791:	// set it
;792:	cg.refdef.fov_x = fov_x;
ADDRGP4 cg+1200+16
ADDRFP4 0
INDIRF4
ASGNF4
line 793
;793:	cg.refdef.fov_y = fov_y;
ADDRGP4 cg+1200+20
ADDRLP4 0
INDIRF4
ASGNF4
line 795
;794:
;795:	return (inwater);
ADDRLP4 8
INDIRI4
RETI4
LABELV $512
endproc CG_CalcFOVFromX 20 8
data
align 4
LABELV $564
byte 4 0
code
proc CG_CalcFov 52 8
line 808
;796:}
;797:
;798:/*
;799:====================
;800:CG_CalcFov
;801:
;802:Fixed fov at intermissions, otherwise account for fov variable and zooms.
;803:====================
;804:*/
;805:#define	WAVE_AMPLITUDE	1
;806:#define	WAVE_FREQUENCY	0.4
;807:
;808:static int CG_CalcFov( void ) {
line 818
;809:	float	x;
;810:	float	phase;
;811:	float	v;
;812:	int		contents;
;813:	float	fov_x, fov_y;
;814:	float	zoomFov;
;815:	float	f;
;816:	int		inwater;
;817:
;818:	if ( cg.predictedPlayerState.pm_type == PM_INTERMISSION ) {
ADDRGP4 cg+100+4
INDIRI4
CNSTI4 5
NEI4 $522
line 820
;819:		// if in intermission, use a fixed value
;820:		fov_x = 90;
ADDRLP4 0
CNSTF4 1119092736
ASGNF4
line 821
;821:	}
ADDRGP4 $523
JUMPV
LABELV $522
line 823
;822:	else
;823:	{
line 825
;824:		// user selectable
;825:		if ( cgs.dmflags & DF_FIXED_FOV )
ADDRGP4 cgs+33024
INDIRI4
CNSTI4 16
BANDI4
CNSTI4 0
EQI4 $526
line 826
;826:		{
line 828
;827:			// dmflag to prevent wide fov for all clients
;828:			fov_x = 90;
ADDRLP4 0
CNSTF4 1119092736
ASGNF4
line 829
;829:		}
ADDRGP4 $527
JUMPV
LABELV $526
line 831
;830:		else
;831:		{
line 832
;832:			fov_x = cg_fov.value;
ADDRLP4 0
ADDRGP4 cg_fov+8
INDIRF4
ASGNF4
line 833
;833:			if ( fov_x < 1 )
ADDRLP4 0
INDIRF4
CNSTF4 1065353216
GEF4 $530
line 834
;834:			{
line 835
;835:				fov_x = 1;
ADDRLP4 0
CNSTF4 1065353216
ASGNF4
line 836
;836:			}
ADDRGP4 $531
JUMPV
LABELV $530
line 837
;837:			else if ( fov_x > 160 )
ADDRLP4 0
INDIRF4
CNSTF4 1126170624
LEF4 $532
line 838
;838:			{
line 839
;839:				fov_x = 160;
ADDRLP4 0
CNSTF4 1126170624
ASGNF4
line 840
;840:			}
LABELV $532
LABELV $531
line 841
;841:		}
LABELV $527
line 844
;842:
;843:		// If cheats arent enabled then 80 is the lowest and 100 is the highest
;844:		if ( !cg.cheats )
ADDRGP4 cg+178880
INDIRI4
CNSTI4 0
NEI4 $534
line 845
;845:		{
line 846
;846:			if ( fov_x < 80 )
ADDRLP4 0
INDIRF4
CNSTF4 1117782016
GEF4 $537
line 847
;847:			{
line 848
;848:				fov_x = 80;
ADDRLP4 0
CNSTF4 1117782016
ASGNF4
line 849
;849:			}
ADDRGP4 $538
JUMPV
LABELV $537
line 850
;850:			else if ( fov_x > 100 )
ADDRLP4 0
INDIRF4
CNSTF4 1120403456
LEF4 $539
line 851
;851:			{
line 852
;852:				fov_x = 100;
ADDRLP4 0
CNSTF4 1120403456
ASGNF4
line 853
;853:			}
LABELV $539
LABELV $538
line 854
;854:		}
LABELV $534
line 856
;855:
;856:		if ( cg.predictedPlayerState.pm_flags & PMF_ZOOMED )
ADDRGP4 cg+100+12
INDIRI4
CNSTI4 16384
BANDI4
CNSTI4 0
EQI4 $541
line 857
;857:		{
line 858
;858:			zoomFov = (float)weaponData[cg.predictedPlayerState.weapon].zoom[cg.predictedPlayerState.zoomFov].fov;
ADDRLP4 24
CNSTI4 12
ADDRGP4 cg+100+848
INDIRI4
MULI4
CNSTI4 1828
ADDRGP4 cg+100+172
INDIRI4
MULI4
ADDRGP4 weaponData+1792
ADDP4
ADDP4
INDIRI4
CVIF4 4
ASGNF4
line 860
;859:
;860:			if (!cg.predictedPlayerState.pm_flags & PMF_ZOOM_LOCKED )
ADDRGP4 cg+100+12
INDIRI4
CNSTI4 0
NEI4 $555
ADDRLP4 36
CNSTI4 1
ASGNI4
ADDRGP4 $556
JUMPV
LABELV $555
ADDRLP4 36
CNSTI4 0
ASGNI4
LABELV $556
ADDRLP4 36
INDIRI4
CNSTI4 32768
BANDI4
CNSTI4 0
EQI4 $550
line 861
;861:			{
line 862
;862:				zoomFov -= cg.frametime * 0.05f;
ADDRLP4 24
ADDRLP4 24
INDIRF4
CNSTF4 1028443341
ADDRGP4 cg+64
INDIRI4
CVIF4 4
MULF4
SUBF4
ASGNF4
line 864
;863:
;864:				if (zoomFov < MAX_ZOOM_FOV)
ADDRLP4 24
INDIRF4
CNSTF4 1077936128
GEF4 $558
line 865
;865:				{
line 866
;866:					zoomFov = MAX_ZOOM_FOV;
ADDRLP4 24
CNSTF4 1077936128
ASGNF4
line 867
;867:				}
ADDRGP4 $559
JUMPV
LABELV $558
line 868
;868:				else if (zoomFov > cg_fov.value)
ADDRLP4 24
INDIRF4
ADDRGP4 cg_fov+8
INDIRF4
LEF4 $560
line 869
;869:				{
line 870
;870:					zoomFov = cg_fov.value;
ADDRLP4 24
ADDRGP4 cg_fov+8
INDIRF4
ASGNF4
line 871
;871:				}
ADDRGP4 $561
JUMPV
LABELV $560
line 873
;872:				else
;873:				{	// Still zooming
line 876
;874:					static zoomSoundTime = 0;
;875:
;876:					if (zoomSoundTime < cg.time || zoomSoundTime > cg.time + 10000)
ADDRLP4 40
ADDRGP4 $564
INDIRI4
ASGNI4
ADDRLP4 40
INDIRI4
ADDRGP4 cg+68
INDIRI4
LTI4 $569
ADDRLP4 40
INDIRI4
ADDRGP4 cg+68
INDIRI4
CNSTI4 10000
ADDI4
LEI4 $565
LABELV $569
line 877
;877:					{
line 878
;878:						zoomSoundTime = cg.time + 300;
ADDRGP4 $564
ADDRGP4 cg+68
INDIRI4
CNSTI4 300
ADDI4
ASGNI4
line 879
;879:					}
LABELV $565
line 880
;880:				}
LABELV $561
LABELV $559
line 881
;881:			}
LABELV $550
line 883
;882:
;883:			fov_x = zoomFov;
ADDRLP4 0
ADDRLP4 24
INDIRF4
ASGNF4
line 884
;884:		}
ADDRGP4 $542
JUMPV
LABELV $541
line 886
;885:		else 
;886:		{
line 887
;887:			zoomFov = (float)weaponData[cg.predictedPlayerState.weapon].zoom[cg.predictedPlayerState.zoomFov].fov;
ADDRLP4 24
CNSTI4 12
ADDRGP4 cg+100+848
INDIRI4
MULI4
CNSTI4 1828
ADDRGP4 cg+100+172
INDIRI4
MULI4
ADDRGP4 weaponData+1792
ADDP4
ADDP4
INDIRI4
CVIF4 4
ASGNF4
line 889
;888:
;889:			f = ( cg.time - cg.predictedPlayerState.zoomTime ) / ZOOM_OUT_TIME;
ADDRLP4 32
ADDRGP4 cg+68
INDIRI4
ADDRGP4 cg+100+844
INDIRI4
SUBI4
CVIF4 4
CNSTF4 1120403456
DIVF4
ASGNF4
line 890
;890:			if ( f > 1.0 ) 
ADDRLP4 32
INDIRF4
CNSTF4 1065353216
LEF4 $579
line 891
;891:			{
line 892
;892:				fov_x = fov_x;
ADDRLP4 0
ADDRLP4 0
INDIRF4
ASGNF4
line 893
;893:			} 
ADDRGP4 $580
JUMPV
LABELV $579
line 895
;894:			else 
;895:			{
line 896
;896:				fov_x = zoomFov + f * ( fov_x - zoomFov );
ADDRLP4 36
ADDRLP4 24
INDIRF4
ASGNF4
ADDRLP4 0
ADDRLP4 36
INDIRF4
ADDRLP4 32
INDIRF4
ADDRLP4 0
INDIRF4
ADDRLP4 36
INDIRF4
SUBF4
MULF4
ADDF4
ASGNF4
line 897
;897:			}
LABELV $580
line 898
;898:		}
LABELV $542
line 899
;899:	}
LABELV $523
line 901
;900:
;901:	x = cg.refdef.width / tan( fov_x / 360 * M_PI );
CNSTF4 1078530011
ADDRLP4 0
INDIRF4
CNSTF4 1135869952
DIVF4
MULF4
ARGF4
ADDRLP4 36
ADDRGP4 tan
CALLF4
ASGNF4
ADDRLP4 8
ADDRGP4 cg+1200+8
INDIRI4
CVIF4 4
ADDRLP4 36
INDIRF4
DIVF4
ASGNF4
line 902
;902:	fov_y = atan2( cg.refdef.height, x );
ADDRGP4 cg+1200+12
INDIRI4
CVIF4 4
ARGF4
ADDRLP4 8
INDIRF4
ARGF4
ADDRLP4 40
ADDRGP4 atan2
CALLF4
ASGNF4
ADDRLP4 4
ADDRLP4 40
INDIRF4
ASGNF4
line 903
;903:	fov_y = fov_y * 360 / M_PI;
ADDRLP4 4
CNSTF4 1135869952
ADDRLP4 4
INDIRF4
MULF4
CNSTF4 1078530011
DIVF4
ASGNF4
line 906
;904:
;905:	// warp if underwater
;906:	contents = CG_PointContents( cg.refdef.vieworg, -1 );
ADDRGP4 cg+1200+24
ARGP4
CNSTI4 -1
ARGI4
ADDRLP4 44
ADDRGP4 CG_PointContents
CALLI4
ASGNI4
ADDRLP4 12
ADDRLP4 44
INDIRI4
ASGNI4
line 907
;907:	if ( contents & ( CONTENTS_WATER | CONTENTS_LAVA ) ){
ADDRLP4 12
INDIRI4
CNSTI4 6
BANDI4
CNSTI4 0
EQI4 $587
line 908
;908:		phase = cg.time / 1000.0 * WAVE_FREQUENCY * M_PI * 2;
ADDRLP4 28
CNSTF4 1073741824
CNSTF4 1078530011
CNSTF4 1053609165
ADDRGP4 cg+68
INDIRI4
CVIF4 4
CNSTF4 1148846080
DIVF4
MULF4
MULF4
MULF4
ASGNF4
line 909
;909:		v = WAVE_AMPLITUDE * sin( phase );
ADDRLP4 28
INDIRF4
ARGF4
ADDRLP4 48
ADDRGP4 sin
CALLF4
ASGNF4
ADDRLP4 20
CNSTF4 1065353216
ADDRLP4 48
INDIRF4
MULF4
ASGNF4
line 910
;910:		fov_x += v;
ADDRLP4 0
ADDRLP4 0
INDIRF4
ADDRLP4 20
INDIRF4
ADDF4
ASGNF4
line 911
;911:		fov_y -= v;
ADDRLP4 4
ADDRLP4 4
INDIRF4
ADDRLP4 20
INDIRF4
SUBF4
ASGNF4
line 912
;912:		inwater = qtrue;
ADDRLP4 16
CNSTI4 1
ASGNI4
line 913
;913:	}
ADDRGP4 $588
JUMPV
LABELV $587
line 914
;914:	else {
line 915
;915:		inwater = qfalse;
ADDRLP4 16
CNSTI4 0
ASGNI4
line 916
;916:	}
LABELV $588
line 919
;917:
;918:	// set it
;919:	cg.refdef.fov_x = fov_x;
ADDRGP4 cg+1200+16
ADDRLP4 0
INDIRF4
ASGNF4
line 920
;920:	cg.refdef.fov_y = fov_y;
ADDRGP4 cg+1200+20
ADDRLP4 4
INDIRF4
ASGNF4
line 922
;921:
;922:	if ( !(cg.predictedPlayerState.pm_flags&PMF_ZOOMED) )
ADDRGP4 cg+100+12
INDIRI4
CNSTI4 16384
BANDI4
CNSTI4 0
NEI4 $594
line 923
;923:	{
line 924
;924:		cg.zoomSensitivity = 1;
ADDRGP4 cg+1584
CNSTF4 1065353216
ASGNF4
line 925
;925:	} 
ADDRGP4 $595
JUMPV
LABELV $594
line 927
;926:	else
;927:	{
line 928
;928:		cg.zoomSensitivity = cg.refdef.fov_y / 75.0;
ADDRGP4 cg+1584
ADDRGP4 cg+1200+20
INDIRF4
CNSTF4 1117126656
DIVF4
ASGNF4
line 929
;929:	}
LABELV $595
line 931
;930:
;931:	return inwater;
ADDRLP4 16
INDIRI4
RETI4
LABELV $521
endproc CG_CalcFov 52 8
proc CG_DamageBlendBlob 148 56
line 935
;932:}
;933:
;934:static void CG_DamageBlendBlob( void )
;935:{
line 936
;936:	int			t = 250;
ADDRLP4 36
CNSTI4 250
ASGNI4
line 937
;937:	int			maxTime = DAMAGE_TIME;
ADDRLP4 72
CNSTI4 500
ASGNI4
line 948
;938:	vec3_t		lineStart;
;939:	vec3_t		lineEnd;
;940:	vec3_t		rgb1;
;941:	vec3_t		rgb2;
;942:	qboolean	dmgIsToTheLeft;
;943:	qboolean	dmgIsAbove;
;944:	qboolean	unknownDir;
;945:	float		alphaVal;
;946:	float		cvarScale;
;947:
;948:	if (cg_damageindicator.value <= 0) 
ADDRGP4 cg_damageindicator+8
INDIRF4
CNSTF4 0
GTF4 $603
line 949
;949:	{
line 950
;950:		return;
ADDRGP4 $602
JUMPV
LABELV $603
line 953
;951:	}
;952:
;953:	t = cg.time - cg.damageTime;
ADDRLP4 36
ADDRGP4 cg+68
INDIRI4
CVIF4 4
ADDRGP4 cg+9800
INDIRF4
SUBF4
CVFI4 4
ASGNI4
line 954
;954:	if ( t <= 0 || t >= maxTime )
ADDRLP4 36
INDIRI4
CNSTI4 0
LEI4 $610
ADDRLP4 36
INDIRI4
ADDRLP4 72
INDIRI4
LTI4 $608
LABELV $610
line 955
;955:	{
line 956
;956:		return;
ADDRGP4 $602
JUMPV
LABELV $608
line 963
;957:	}
;958:
;959:	// here we use cg.damageY as a value to indicate how much above you the damage is and
;960:	//cg.damageX as a value to indicate how much to your left the damage is
;961:
;962:	// draw a "line" using the cgs.media.damageDirShader
;963:	dmgIsToTheLeft  = (cg.damageX > 0);
ADDRGP4 cg+9804
INDIRF4
CNSTF4 0
LEF4 $613
ADDRLP4 80
CNSTI4 1
ASGNI4
ADDRGP4 $614
JUMPV
LABELV $613
ADDRLP4 80
CNSTI4 0
ASGNI4
LABELV $614
ADDRLP4 28
ADDRLP4 80
INDIRI4
ASGNI4
line 964
;964:	dmgIsAbove		= (cg.damageY < 0);
ADDRGP4 cg+9808
INDIRF4
CNSTF4 0
GEF4 $617
ADDRLP4 84
CNSTI4 1
ASGNI4
ADDRGP4 $618
JUMPV
LABELV $617
ADDRLP4 84
CNSTI4 0
ASGNI4
LABELV $618
ADDRLP4 32
ADDRLP4 84
INDIRI4
ASGNI4
line 965
;965:	unknownDir		= (cg.v_dmg_roll == 255);
ADDRGP4 cg+9816
INDIRF4
CNSTF4 1132396544
NEF4 $621
ADDRLP4 88
CNSTI4 1
ASGNI4
ADDRGP4 $622
JUMPV
LABELV $621
ADDRLP4 88
CNSTI4 0
ASGNI4
LABELV $622
ADDRLP4 64
ADDRLP4 88
INDIRI4
ASGNI4
line 966
;966:	alphaVal		= ( 1.0 - ((float)t / maxTime) );
ADDRLP4 68
CNSTF4 1065353216
ADDRLP4 36
INDIRI4
CVIF4 4
ADDRLP4 72
INDIRI4
CVIF4 4
DIVF4
SUBF4
ASGNF4
line 967
;967:	cvarScale		= 1.0f * cg_damageindicator.value;
ADDRLP4 12
CNSTF4 1065353216
ADDRGP4 cg_damageindicator+8
INDIRF4
MULF4
ASGNF4
line 969
;968:
;969:	VectorSet(rgb1, 1, 1, 1);
ADDRLP4 92
CNSTF4 1065353216
ASGNF4
ADDRLP4 40
ADDRLP4 92
INDIRF4
ASGNF4
ADDRLP4 40+4
ADDRLP4 92
INDIRF4
ASGNF4
ADDRLP4 40+8
CNSTF4 1065353216
ASGNF4
line 970
;970:	VectorSet(rgb2, 1, 1, 1);
ADDRLP4 96
CNSTF4 1065353216
ASGNF4
ADDRLP4 52
ADDRLP4 96
INDIRF4
ASGNF4
ADDRLP4 52+4
ADDRLP4 96
INDIRF4
ASGNF4
ADDRLP4 52+8
CNSTF4 1065353216
ASGNF4
line 973
;971:
;972:	// draw the left/right indicator if it's far enough from center
;973:	if ( (fabs(cg.damageX) > 25) || unknownDir)
ADDRGP4 cg+9804
INDIRF4
ARGF4
ADDRLP4 100
ADDRGP4 fabs
CALLF4
ASGNF4
ADDRLP4 100
INDIRF4
CNSTF4 1103626240
GTF4 $631
ADDRLP4 64
INDIRI4
CNSTI4 0
EQI4 $628
LABELV $631
line 974
;974:	{
line 975
;975:		VectorMA(cg.refdef.vieworg, 20, cg.refdef.viewaxis[0], lineStart);
ADDRLP4 104
CNSTF4 1101004800
ASGNF4
ADDRLP4 0
ADDRGP4 cg+1200+24
INDIRF4
ADDRLP4 104
INDIRF4
ADDRGP4 cg+1200+36
INDIRF4
MULF4
ADDF4
ASGNF4
ADDRLP4 0+4
ADDRGP4 cg+1200+24+4
INDIRF4
ADDRLP4 104
INDIRF4
ADDRGP4 cg+1200+36+4
INDIRF4
MULF4
ADDF4
ASGNF4
ADDRLP4 0+8
ADDRGP4 cg+1200+24+8
INDIRF4
CNSTF4 1101004800
ADDRGP4 cg+1200+36+8
INDIRF4
MULF4
ADDF4
ASGNF4
line 976
;976:		VectorMA(lineStart, (dmgIsToTheLeft?6:-6), cg.refdef.viewaxis[1], lineStart);
ADDRLP4 28
INDIRI4
CNSTI4 0
EQI4 $668
ADDRLP4 108
CNSTI4 6
ASGNI4
ADDRGP4 $669
JUMPV
LABELV $668
ADDRLP4 108
CNSTI4 -6
ASGNI4
LABELV $669
ADDRLP4 0
ADDRLP4 0
INDIRF4
ADDRGP4 cg+1200+36+12
INDIRF4
ADDRLP4 108
INDIRI4
CVIF4 4
MULF4
ADDF4
ASGNF4
ADDRLP4 28
INDIRI4
CNSTI4 0
EQI4 $670
ADDRLP4 112
CNSTI4 6
ASGNI4
ADDRGP4 $671
JUMPV
LABELV $670
ADDRLP4 112
CNSTI4 -6
ASGNI4
LABELV $671
ADDRLP4 0+4
ADDRLP4 0+4
INDIRF4
ADDRGP4 cg+1200+36+12+4
INDIRF4
ADDRLP4 112
INDIRI4
CVIF4 4
MULF4
ADDF4
ASGNF4
ADDRLP4 28
INDIRI4
CNSTI4 0
EQI4 $672
ADDRLP4 116
CNSTI4 6
ASGNI4
ADDRGP4 $673
JUMPV
LABELV $672
ADDRLP4 116
CNSTI4 -6
ASGNI4
LABELV $673
ADDRLP4 0+8
ADDRLP4 0+8
INDIRF4
ADDRGP4 cg+1200+36+12+8
INDIRF4
ADDRLP4 116
INDIRI4
CVIF4 4
MULF4
ADDF4
ASGNF4
line 977
;977:		VectorMA(lineStart, (dmgIsToTheLeft?2:-2)*cvarScale, cg.refdef.viewaxis[1], lineEnd);
ADDRLP4 28
INDIRI4
CNSTI4 0
EQI4 $692
ADDRLP4 120
CNSTI4 2
ASGNI4
ADDRGP4 $693
JUMPV
LABELV $692
ADDRLP4 120
CNSTI4 -2
ASGNI4
LABELV $693
ADDRLP4 16
ADDRLP4 0
INDIRF4
ADDRGP4 cg+1200+36+12
INDIRF4
ADDRLP4 120
INDIRI4
CVIF4 4
ADDRLP4 12
INDIRF4
MULF4
MULF4
ADDF4
ASGNF4
ADDRLP4 28
INDIRI4
CNSTI4 0
EQI4 $694
ADDRLP4 124
CNSTI4 2
ASGNI4
ADDRGP4 $695
JUMPV
LABELV $694
ADDRLP4 124
CNSTI4 -2
ASGNI4
LABELV $695
ADDRLP4 16+4
ADDRLP4 0+4
INDIRF4
ADDRGP4 cg+1200+36+12+4
INDIRF4
ADDRLP4 124
INDIRI4
CVIF4 4
ADDRLP4 12
INDIRF4
MULF4
MULF4
ADDF4
ASGNF4
ADDRLP4 28
INDIRI4
CNSTI4 0
EQI4 $696
ADDRLP4 128
CNSTI4 2
ASGNI4
ADDRGP4 $697
JUMPV
LABELV $696
ADDRLP4 128
CNSTI4 -2
ASGNI4
LABELV $697
ADDRLP4 16+8
ADDRLP4 0+8
INDIRF4
ADDRGP4 cg+1200+36+12+8
INDIRF4
ADDRLP4 128
INDIRI4
CVIF4 4
ADDRLP4 12
INDIRF4
MULF4
MULF4
ADDF4
ASGNF4
line 979
;978:
;979:		trap_FX_AddLine( lineStart, lineEnd, 
ADDRLP4 0
ARGP4
ADDRLP4 16
ARGP4
ADDRLP4 132
CNSTF4 1084227584
ADDRLP4 12
INDIRF4
MULF4
ASGNF4
ADDRLP4 132
INDIRF4
ARGF4
ADDRLP4 132
INDIRF4
ARGF4
ADDRLP4 136
CNSTF4 0
ASGNF4
ADDRLP4 136
INDIRF4
ARGF4
ADDRLP4 68
INDIRF4
ARGF4
ADDRLP4 68
INDIRF4
ARGF4
ADDRLP4 136
INDIRF4
ARGF4
ADDRLP4 40
ARGP4
ADDRLP4 52
ARGP4
ADDRLP4 136
INDIRF4
ARGF4
CNSTI4 1
ARGI4
ADDRGP4 cgs+243476+288
INDIRI4
ARGI4
CNSTI4 1048576
ARGI4
ADDRGP4 trap_FX_AddLine
CALLV
pop
line 984
;980:							5.0f*cvarScale, 5.0f*cvarScale, 0.0f,
;981:							alphaVal, alphaVal, 0.0f,
;982:							rgb1, rgb2, 0.0f,
;983:							1, cgs.media.damageDirShader, FX_DEPTH_HACK );
;984:	}
LABELV $628
line 985
;985:	if (unknownDir)
ADDRLP4 64
INDIRI4
CNSTI4 0
EQI4 $700
line 986
;986:	{
line 988
;987:		// dmg from unknown direction...display all four directions
;988:		VectorMA(cg.refdef.vieworg, 20, cg.refdef.viewaxis[0], lineStart);
ADDRLP4 104
CNSTF4 1101004800
ASGNF4
ADDRLP4 0
ADDRGP4 cg+1200+24
INDIRF4
ADDRLP4 104
INDIRF4
ADDRGP4 cg+1200+36
INDIRF4
MULF4
ADDF4
ASGNF4
ADDRLP4 0+4
ADDRGP4 cg+1200+24+4
INDIRF4
ADDRLP4 104
INDIRF4
ADDRGP4 cg+1200+36+4
INDIRF4
MULF4
ADDF4
ASGNF4
ADDRLP4 0+8
ADDRGP4 cg+1200+24+8
INDIRF4
CNSTF4 1101004800
ADDRGP4 cg+1200+36+8
INDIRF4
MULF4
ADDF4
ASGNF4
line 989
;989:		VectorMA(lineStart, (dmgIsToTheLeft?-6:6), cg.refdef.viewaxis[1], lineStart);
ADDRLP4 28
INDIRI4
CNSTI4 0
EQI4 $738
ADDRLP4 108
CNSTI4 -6
ASGNI4
ADDRGP4 $739
JUMPV
LABELV $738
ADDRLP4 108
CNSTI4 6
ASGNI4
LABELV $739
ADDRLP4 0
ADDRLP4 0
INDIRF4
ADDRGP4 cg+1200+36+12
INDIRF4
ADDRLP4 108
INDIRI4
CVIF4 4
MULF4
ADDF4
ASGNF4
ADDRLP4 28
INDIRI4
CNSTI4 0
EQI4 $740
ADDRLP4 112
CNSTI4 -6
ASGNI4
ADDRGP4 $741
JUMPV
LABELV $740
ADDRLP4 112
CNSTI4 6
ASGNI4
LABELV $741
ADDRLP4 0+4
ADDRLP4 0+4
INDIRF4
ADDRGP4 cg+1200+36+12+4
INDIRF4
ADDRLP4 112
INDIRI4
CVIF4 4
MULF4
ADDF4
ASGNF4
ADDRLP4 28
INDIRI4
CNSTI4 0
EQI4 $742
ADDRLP4 116
CNSTI4 -6
ASGNI4
ADDRGP4 $743
JUMPV
LABELV $742
ADDRLP4 116
CNSTI4 6
ASGNI4
LABELV $743
ADDRLP4 0+8
ADDRLP4 0+8
INDIRF4
ADDRGP4 cg+1200+36+12+8
INDIRF4
ADDRLP4 116
INDIRI4
CVIF4 4
MULF4
ADDF4
ASGNF4
line 990
;990:		VectorMA(lineStart, (dmgIsToTheLeft?-2:2)*cvarScale, cg.refdef.viewaxis[1], lineEnd);
ADDRLP4 28
INDIRI4
CNSTI4 0
EQI4 $762
ADDRLP4 120
CNSTI4 -2
ASGNI4
ADDRGP4 $763
JUMPV
LABELV $762
ADDRLP4 120
CNSTI4 2
ASGNI4
LABELV $763
ADDRLP4 16
ADDRLP4 0
INDIRF4
ADDRGP4 cg+1200+36+12
INDIRF4
ADDRLP4 120
INDIRI4
CVIF4 4
ADDRLP4 12
INDIRF4
MULF4
MULF4
ADDF4
ASGNF4
ADDRLP4 28
INDIRI4
CNSTI4 0
EQI4 $764
ADDRLP4 124
CNSTI4 -2
ASGNI4
ADDRGP4 $765
JUMPV
LABELV $764
ADDRLP4 124
CNSTI4 2
ASGNI4
LABELV $765
ADDRLP4 16+4
ADDRLP4 0+4
INDIRF4
ADDRGP4 cg+1200+36+12+4
INDIRF4
ADDRLP4 124
INDIRI4
CVIF4 4
ADDRLP4 12
INDIRF4
MULF4
MULF4
ADDF4
ASGNF4
ADDRLP4 28
INDIRI4
CNSTI4 0
EQI4 $766
ADDRLP4 128
CNSTI4 -2
ASGNI4
ADDRGP4 $767
JUMPV
LABELV $766
ADDRLP4 128
CNSTI4 2
ASGNI4
LABELV $767
ADDRLP4 16+8
ADDRLP4 0+8
INDIRF4
ADDRGP4 cg+1200+36+12+8
INDIRF4
ADDRLP4 128
INDIRI4
CVIF4 4
ADDRLP4 12
INDIRF4
MULF4
MULF4
ADDF4
ASGNF4
line 992
;991:
;992:		trap_FX_AddLine( lineStart, lineEnd, 
ADDRLP4 0
ARGP4
ADDRLP4 16
ARGP4
ADDRLP4 132
CNSTF4 1084227584
ADDRLP4 12
INDIRF4
MULF4
ASGNF4
ADDRLP4 132
INDIRF4
ARGF4
ADDRLP4 132
INDIRF4
ARGF4
ADDRLP4 136
CNSTF4 0
ASGNF4
ADDRLP4 136
INDIRF4
ARGF4
ADDRLP4 68
INDIRF4
ARGF4
ADDRLP4 68
INDIRF4
ARGF4
ADDRLP4 136
INDIRF4
ARGF4
ADDRLP4 40
ARGP4
ADDRLP4 52
ARGP4
ADDRLP4 136
INDIRF4
ARGF4
CNSTI4 1
ARGI4
ADDRGP4 cgs+243476+288
INDIRI4
ARGI4
CNSTI4 1048576
ARGI4
ADDRGP4 trap_FX_AddLine
CALLV
pop
line 997
;993:							5.0f*cvarScale, 5.0f*cvarScale, 0.0f,
;994:							alphaVal, alphaVal, 0.0f,
;995:							rgb1, rgb2, 0.0f,
;996:							1, cgs.media.damageDirShader, FX_DEPTH_HACK );
;997:	}
LABELV $700
line 1000
;998:
;999:	// draw the above/below indicator
;1000:	if ( (fabs(cg.damageY) > 15) || unknownDir)
ADDRGP4 cg+9808
INDIRF4
ARGF4
ADDRLP4 104
ADDRGP4 fabs
CALLF4
ASGNF4
ADDRLP4 104
INDIRF4
CNSTF4 1097859072
GTF4 $773
ADDRLP4 64
INDIRI4
CNSTI4 0
EQI4 $770
LABELV $773
line 1001
;1001:	{
line 1002
;1002:		VectorMA(cg.refdef.vieworg, 20, cg.refdef.viewaxis[0], lineStart);
ADDRLP4 108
CNSTF4 1101004800
ASGNF4
ADDRLP4 0
ADDRGP4 cg+1200+24
INDIRF4
ADDRLP4 108
INDIRF4
ADDRGP4 cg+1200+36
INDIRF4
MULF4
ADDF4
ASGNF4
ADDRLP4 0+4
ADDRGP4 cg+1200+24+4
INDIRF4
ADDRLP4 108
INDIRF4
ADDRGP4 cg+1200+36+4
INDIRF4
MULF4
ADDF4
ASGNF4
ADDRLP4 0+8
ADDRGP4 cg+1200+24+8
INDIRF4
CNSTF4 1101004800
ADDRGP4 cg+1200+36+8
INDIRF4
MULF4
ADDF4
ASGNF4
line 1003
;1003:		VectorMA(lineStart, (dmgIsAbove?6:-6), cg.refdef.viewaxis[2], lineStart);
ADDRLP4 32
INDIRI4
CNSTI4 0
EQI4 $810
ADDRLP4 112
CNSTI4 6
ASGNI4
ADDRGP4 $811
JUMPV
LABELV $810
ADDRLP4 112
CNSTI4 -6
ASGNI4
LABELV $811
ADDRLP4 0
ADDRLP4 0
INDIRF4
ADDRGP4 cg+1200+36+24
INDIRF4
ADDRLP4 112
INDIRI4
CVIF4 4
MULF4
ADDF4
ASGNF4
ADDRLP4 32
INDIRI4
CNSTI4 0
EQI4 $812
ADDRLP4 116
CNSTI4 6
ASGNI4
ADDRGP4 $813
JUMPV
LABELV $812
ADDRLP4 116
CNSTI4 -6
ASGNI4
LABELV $813
ADDRLP4 0+4
ADDRLP4 0+4
INDIRF4
ADDRGP4 cg+1200+36+24+4
INDIRF4
ADDRLP4 116
INDIRI4
CVIF4 4
MULF4
ADDF4
ASGNF4
ADDRLP4 32
INDIRI4
CNSTI4 0
EQI4 $814
ADDRLP4 120
CNSTI4 6
ASGNI4
ADDRGP4 $815
JUMPV
LABELV $814
ADDRLP4 120
CNSTI4 -6
ASGNI4
LABELV $815
ADDRLP4 0+8
ADDRLP4 0+8
INDIRF4
ADDRGP4 cg+1200+36+24+8
INDIRF4
ADDRLP4 120
INDIRI4
CVIF4 4
MULF4
ADDF4
ASGNF4
line 1004
;1004:		VectorMA(lineStart, (dmgIsAbove?2:-2)*cvarScale, cg.refdef.viewaxis[2], lineEnd);
ADDRLP4 32
INDIRI4
CNSTI4 0
EQI4 $834
ADDRLP4 124
CNSTI4 2
ASGNI4
ADDRGP4 $835
JUMPV
LABELV $834
ADDRLP4 124
CNSTI4 -2
ASGNI4
LABELV $835
ADDRLP4 16
ADDRLP4 0
INDIRF4
ADDRGP4 cg+1200+36+24
INDIRF4
ADDRLP4 124
INDIRI4
CVIF4 4
ADDRLP4 12
INDIRF4
MULF4
MULF4
ADDF4
ASGNF4
ADDRLP4 32
INDIRI4
CNSTI4 0
EQI4 $836
ADDRLP4 128
CNSTI4 2
ASGNI4
ADDRGP4 $837
JUMPV
LABELV $836
ADDRLP4 128
CNSTI4 -2
ASGNI4
LABELV $837
ADDRLP4 16+4
ADDRLP4 0+4
INDIRF4
ADDRGP4 cg+1200+36+24+4
INDIRF4
ADDRLP4 128
INDIRI4
CVIF4 4
ADDRLP4 12
INDIRF4
MULF4
MULF4
ADDF4
ASGNF4
ADDRLP4 32
INDIRI4
CNSTI4 0
EQI4 $838
ADDRLP4 132
CNSTI4 2
ASGNI4
ADDRGP4 $839
JUMPV
LABELV $838
ADDRLP4 132
CNSTI4 -2
ASGNI4
LABELV $839
ADDRLP4 16+8
ADDRLP4 0+8
INDIRF4
ADDRGP4 cg+1200+36+24+8
INDIRF4
ADDRLP4 132
INDIRI4
CVIF4 4
ADDRLP4 12
INDIRF4
MULF4
MULF4
ADDF4
ASGNF4
line 1006
;1005:
;1006:		trap_FX_AddLine( lineStart, lineEnd, 
ADDRLP4 0
ARGP4
ADDRLP4 16
ARGP4
ADDRLP4 136
CNSTF4 1084227584
ADDRLP4 12
INDIRF4
MULF4
ASGNF4
ADDRLP4 136
INDIRF4
ARGF4
ADDRLP4 136
INDIRF4
ARGF4
ADDRLP4 140
CNSTF4 0
ASGNF4
ADDRLP4 140
INDIRF4
ARGF4
ADDRLP4 68
INDIRF4
ARGF4
ADDRLP4 68
INDIRF4
ARGF4
ADDRLP4 140
INDIRF4
ARGF4
ADDRLP4 40
ARGP4
ADDRLP4 52
ARGP4
ADDRLP4 140
INDIRF4
ARGF4
CNSTI4 1
ARGI4
ADDRGP4 cgs+243476+288
INDIRI4
ARGI4
CNSTI4 1048576
ARGI4
ADDRGP4 trap_FX_AddLine
CALLV
pop
line 1011
;1007:							5.0f*cvarScale, 5.0f*cvarScale, 0.0f,
;1008:							alphaVal, alphaVal, 0.0f,
;1009:							rgb1, rgb2, 0.0f,
;1010:							1, cgs.media.damageDirShader, FX_DEPTH_HACK );
;1011:	}
LABELV $770
line 1012
;1012:	if (unknownDir)
ADDRLP4 64
INDIRI4
CNSTI4 0
EQI4 $842
line 1013
;1013:	{
line 1014
;1014:		VectorMA(cg.refdef.vieworg, 20, cg.refdef.viewaxis[0], lineStart);
ADDRLP4 108
CNSTF4 1101004800
ASGNF4
ADDRLP4 0
ADDRGP4 cg+1200+24
INDIRF4
ADDRLP4 108
INDIRF4
ADDRGP4 cg+1200+36
INDIRF4
MULF4
ADDF4
ASGNF4
ADDRLP4 0+4
ADDRGP4 cg+1200+24+4
INDIRF4
ADDRLP4 108
INDIRF4
ADDRGP4 cg+1200+36+4
INDIRF4
MULF4
ADDF4
ASGNF4
ADDRLP4 0+8
ADDRGP4 cg+1200+24+8
INDIRF4
CNSTF4 1101004800
ADDRGP4 cg+1200+36+8
INDIRF4
MULF4
ADDF4
ASGNF4
line 1015
;1015:		VectorMA(lineStart, (dmgIsAbove?-6:6), cg.refdef.viewaxis[2], lineStart);
ADDRLP4 32
INDIRI4
CNSTI4 0
EQI4 $880
ADDRLP4 112
CNSTI4 -6
ASGNI4
ADDRGP4 $881
JUMPV
LABELV $880
ADDRLP4 112
CNSTI4 6
ASGNI4
LABELV $881
ADDRLP4 0
ADDRLP4 0
INDIRF4
ADDRGP4 cg+1200+36+24
INDIRF4
ADDRLP4 112
INDIRI4
CVIF4 4
MULF4
ADDF4
ASGNF4
ADDRLP4 32
INDIRI4
CNSTI4 0
EQI4 $882
ADDRLP4 116
CNSTI4 -6
ASGNI4
ADDRGP4 $883
JUMPV
LABELV $882
ADDRLP4 116
CNSTI4 6
ASGNI4
LABELV $883
ADDRLP4 0+4
ADDRLP4 0+4
INDIRF4
ADDRGP4 cg+1200+36+24+4
INDIRF4
ADDRLP4 116
INDIRI4
CVIF4 4
MULF4
ADDF4
ASGNF4
ADDRLP4 32
INDIRI4
CNSTI4 0
EQI4 $884
ADDRLP4 120
CNSTI4 -6
ASGNI4
ADDRGP4 $885
JUMPV
LABELV $884
ADDRLP4 120
CNSTI4 6
ASGNI4
LABELV $885
ADDRLP4 0+8
ADDRLP4 0+8
INDIRF4
ADDRGP4 cg+1200+36+24+8
INDIRF4
ADDRLP4 120
INDIRI4
CVIF4 4
MULF4
ADDF4
ASGNF4
line 1016
;1016:		VectorMA(lineStart, (dmgIsAbove?-2:2)*cvarScale, cg.refdef.viewaxis[2], lineEnd);
ADDRLP4 32
INDIRI4
CNSTI4 0
EQI4 $904
ADDRLP4 124
CNSTI4 -2
ASGNI4
ADDRGP4 $905
JUMPV
LABELV $904
ADDRLP4 124
CNSTI4 2
ASGNI4
LABELV $905
ADDRLP4 16
ADDRLP4 0
INDIRF4
ADDRGP4 cg+1200+36+24
INDIRF4
ADDRLP4 124
INDIRI4
CVIF4 4
ADDRLP4 12
INDIRF4
MULF4
MULF4
ADDF4
ASGNF4
ADDRLP4 32
INDIRI4
CNSTI4 0
EQI4 $906
ADDRLP4 128
CNSTI4 -2
ASGNI4
ADDRGP4 $907
JUMPV
LABELV $906
ADDRLP4 128
CNSTI4 2
ASGNI4
LABELV $907
ADDRLP4 16+4
ADDRLP4 0+4
INDIRF4
ADDRGP4 cg+1200+36+24+4
INDIRF4
ADDRLP4 128
INDIRI4
CVIF4 4
ADDRLP4 12
INDIRF4
MULF4
MULF4
ADDF4
ASGNF4
ADDRLP4 32
INDIRI4
CNSTI4 0
EQI4 $908
ADDRLP4 132
CNSTI4 -2
ASGNI4
ADDRGP4 $909
JUMPV
LABELV $908
ADDRLP4 132
CNSTI4 2
ASGNI4
LABELV $909
ADDRLP4 16+8
ADDRLP4 0+8
INDIRF4
ADDRGP4 cg+1200+36+24+8
INDIRF4
ADDRLP4 132
INDIRI4
CVIF4 4
ADDRLP4 12
INDIRF4
MULF4
MULF4
ADDF4
ASGNF4
line 1018
;1017:
;1018:		trap_FX_AddLine( lineStart, lineEnd, 
ADDRLP4 0
ARGP4
ADDRLP4 16
ARGP4
ADDRLP4 136
CNSTF4 1084227584
ADDRLP4 12
INDIRF4
MULF4
ASGNF4
ADDRLP4 136
INDIRF4
ARGF4
ADDRLP4 136
INDIRF4
ARGF4
ADDRLP4 140
CNSTF4 0
ASGNF4
ADDRLP4 140
INDIRF4
ARGF4
ADDRLP4 68
INDIRF4
ARGF4
ADDRLP4 68
INDIRF4
ARGF4
ADDRLP4 140
INDIRF4
ARGF4
ADDRLP4 40
ARGP4
ADDRLP4 52
ARGP4
ADDRLP4 140
INDIRF4
ARGF4
CNSTI4 1
ARGI4
ADDRGP4 cgs+243476+288
INDIRI4
ARGI4
CNSTI4 1048576
ARGI4
ADDRGP4 trap_FX_AddLine
CALLV
pop
line 1023
;1019:							5.0f*cvarScale, 5.0f*cvarScale, 0.0f,
;1020:							alphaVal, alphaVal, 0.0f,
;1021:							rgb1, rgb2, 0.0f,
;1022:							1, cgs.media.damageDirShader, FX_DEPTH_HACK );
;1023:	}
LABELV $842
line 1024
;1024:}
LABELV $602
endproc CG_DamageBlendBlob 148 56
proc CG_CalcViewValues 40 12
line 1034
;1025:
;1026:/*
;1027:===============
;1028:CG_CalcViewValues
;1029:
;1030:Sets cg.refdef view values
;1031:===============
;1032:*/
;1033:static int CG_CalcViewValues( void ) 
;1034:{
line 1037
;1035:	playerState_t	*ps;
;1036:
;1037:	memset( &cg.refdef, 0, sizeof( cg.refdef ) );
ADDRGP4 cg+1200
ARGP4
CNSTI4 0
ARGI4
CNSTI4 380
ARGI4
ADDRGP4 memset
CALLP4
pop
line 1044
;1038:
;1039:	// strings for in game rendering
;1040:	// Q_strncpyz( cg.refdef.text[0], "Park Ranger", sizeof(cg.refdef.text[0]) );
;1041:	// Q_strncpyz( cg.refdef.text[1], "19", sizeof(cg.refdef.text[1]) );
;1042:
;1043:	// calculate size of 3D view
;1044:	CG_CalcVrect();
ADDRGP4 CG_CalcVrect
CALLV
pop
line 1046
;1045:
;1046:	ps = &cg.predictedPlayerState;
ADDRLP4 0
ADDRGP4 cg+100
ASGNP4
line 1062
;1047:/*
;1048:	if (cg.cameraMode) {
;1049:		vec3_t origin, angles;
;1050:		if (trap_getCameraInfo(cg.time, &origin, &angles)) {
;1051:			VectorCopy(origin, cg.refdef.vieworg);
;1052:			angles[ROLL] = 0;
;1053:			VectorCopy(angles, cg.refdef.viewangles);
;1054:			AnglesToAxis( cg.refdef.viewangles, cg.refdef.viewaxis );
;1055:			return CG_CalcFov();
;1056:		} else {
;1057:			cg.cameraMode = qfalse;
;1058:		}
;1059:	}
;1060:*/
;1061:	// intermission view
;1062:	if ( ps->pm_type == PM_INTERMISSION ) 
ADDRLP4 0
INDIRP4
CNSTI4 4
ADDP4
INDIRI4
CNSTI4 5
NEI4 $916
line 1063
;1063:	{
line 1064
;1064:		VectorCopy( ps->origin, cg.refdef.vieworg );
ADDRGP4 cg+1200+24
ADDRLP4 0
INDIRP4
CNSTI4 24
ADDP4
INDIRB
ASGNB 12
line 1065
;1065:		VectorCopy( ps->viewangles, cg.refdef.viewangles );
ADDRGP4 cg+1200+368
ADDRLP4 0
INDIRP4
CNSTI4 180
ADDP4
INDIRB
ASGNB 12
line 1066
;1066:		AnglesToAxis( cg.refdef.viewangles, cg.refdef.viewaxis );
ADDRGP4 cg+1200+368
ARGP4
ADDRGP4 cg+1200+36
ARGP4
ADDRGP4 AnglesToAxis
CALLV
pop
line 1067
;1067:		return CG_CalcFov();
ADDRLP4 4
ADDRGP4 CG_CalcFov
CALLI4
ASGNI4
ADDRLP4 4
INDIRI4
RETI4
ADDRGP4 $912
JUMPV
LABELV $916
line 1070
;1068:	}
;1069:
;1070:	cg.bobcycle = ( ps->bobCycle & 128 ) >> 7;
ADDRGP4 cg+9824
ADDRLP4 0
INDIRP4
CNSTI4 8
ADDP4
INDIRI4
CNSTI4 128
BANDI4
CNSTI4 7
RSHI4
ASGNI4
line 1071
;1071:	cg.bobfracsin = fabs( sin( ( ps->bobCycle & 127 ) / 127.0 * M_PI ) );
CNSTF4 1078530011
ADDRLP4 0
INDIRP4
CNSTI4 8
ADDP4
INDIRI4
CNSTI4 127
BANDI4
CVIF4 4
CNSTF4 1123942400
DIVF4
MULF4
ARGF4
ADDRLP4 4
ADDRGP4 sin
CALLF4
ASGNF4
ADDRLP4 4
INDIRF4
ARGF4
ADDRLP4 8
ADDRGP4 fabs
CALLF4
ASGNF4
ADDRGP4 cg+9820
ADDRLP4 8
INDIRF4
ASGNF4
line 1072
;1072:	cg.xyspeed = sqrt( ps->velocity[0] * ps->velocity[0] +
ADDRLP4 16
ADDRLP4 0
INDIRP4
CNSTI4 36
ADDP4
INDIRF4
ASGNF4
ADDRLP4 20
ADDRLP4 0
INDIRP4
CNSTI4 40
ADDP4
INDIRF4
ASGNF4
ADDRLP4 16
INDIRF4
ADDRLP4 16
INDIRF4
MULF4
ADDRLP4 20
INDIRF4
ADDRLP4 20
INDIRF4
MULF4
ADDF4
ARGF4
ADDRLP4 24
ADDRGP4 sqrt
CALLF4
ASGNF4
ADDRGP4 cg+9828
ADDRLP4 24
INDIRF4
ASGNF4
line 1076
;1073:		ps->velocity[1] * ps->velocity[1] );
;1074:
;1075:
;1076:	VectorCopy( ps->origin, cg.refdef.vieworg );
ADDRGP4 cg+1200+24
ADDRLP4 0
INDIRP4
CNSTI4 24
ADDP4
INDIRB
ASGNB 12
line 1077
;1077:	VectorCopy( ps->viewangles, cg.refdef.viewangles );
ADDRGP4 cg+1200+368
ADDRLP4 0
INDIRP4
CNSTI4 180
ADDP4
INDIRB
ASGNB 12
line 1079
;1078:
;1079:	if (cg_cameraOrbit.integer) 
ADDRGP4 cg_cameraOrbit+12
INDIRI4
CNSTI4 0
EQI4 $933
line 1080
;1080:	{
line 1081
;1081:		if (cg.time > cg.nextOrbitTime) 
ADDRGP4 cg+68
INDIRI4
ADDRGP4 cg+9832
INDIRI4
LEI4 $936
line 1082
;1082:		{
line 1083
;1083:			cg.nextOrbitTime = cg.time + cg_cameraOrbitDelay.integer;
ADDRGP4 cg+9832
ADDRGP4 cg+68
INDIRI4
ADDRGP4 cg_cameraOrbitDelay+12
INDIRI4
ADDI4
ASGNI4
line 1084
;1084:			cg_thirdPersonYaw.value += cg_cameraOrbit.value;
ADDRLP4 28
ADDRGP4 cg_thirdPersonYaw+8
ASGNP4
ADDRLP4 28
INDIRP4
ADDRLP4 28
INDIRP4
INDIRF4
ADDRGP4 cg_cameraOrbit+8
INDIRF4
ADDF4
ASGNF4
line 1085
;1085:		}
LABELV $936
line 1086
;1086:	}
LABELV $933
line 1089
;1087:
;1088:	// add error decay
;1089:	if ( cg_errorDecay.value > 0 ) 
ADDRGP4 cg_errorDecay+8
INDIRF4
CNSTF4 0
LEF4 $945
line 1090
;1090:	{
line 1094
;1091:		int		t;
;1092:		float	f;
;1093:
;1094:		t = cg.time - cg.predictedErrorTime;
ADDRLP4 32
ADDRGP4 cg+68
INDIRI4
ADDRGP4 cg+972
INDIRI4
SUBI4
ASGNI4
line 1095
;1095:		f = ( cg_errorDecay.value - t ) / cg_errorDecay.value;
ADDRLP4 28
ADDRGP4 cg_errorDecay+8
INDIRF4
ADDRLP4 32
INDIRI4
CVIF4 4
SUBF4
ADDRGP4 cg_errorDecay+8
INDIRF4
DIVF4
ASGNF4
line 1096
;1096:		if ( f > 0 && f < 1 ) {
ADDRLP4 36
ADDRLP4 28
INDIRF4
ASGNF4
ADDRLP4 36
INDIRF4
CNSTF4 0
LEF4 $952
ADDRLP4 36
INDIRF4
CNSTF4 1065353216
GEF4 $952
line 1097
;1097:			VectorMA( cg.refdef.vieworg, f, cg.predictedError, cg.refdef.vieworg );
ADDRGP4 cg+1200+24
ADDRGP4 cg+1200+24
INDIRF4
ADDRGP4 cg+976
INDIRF4
ADDRLP4 28
INDIRF4
MULF4
ADDF4
ASGNF4
ADDRGP4 cg+1200+24+4
ADDRGP4 cg+1200+24+4
INDIRF4
ADDRGP4 cg+976+4
INDIRF4
ADDRLP4 28
INDIRF4
MULF4
ADDF4
ASGNF4
ADDRGP4 cg+1200+24+8
ADDRGP4 cg+1200+24+8
INDIRF4
ADDRGP4 cg+976+8
INDIRF4
ADDRLP4 28
INDIRF4
MULF4
ADDF4
ASGNF4
line 1098
;1098:		} else {
ADDRGP4 $953
JUMPV
LABELV $952
line 1099
;1099:			cg.predictedErrorTime = 0;
ADDRGP4 cg+972
CNSTI4 0
ASGNI4
line 1100
;1100:		}
LABELV $953
line 1101
;1101:	}
LABELV $945
line 1103
;1102:
;1103:	if ( cg.renderingThirdPerson && !(cg.snap->ps.pm_flags & PMF_ZOOMED) ) 
ADDRLP4 28
CNSTI4 0
ASGNI4
ADDRGP4 cg+92
INDIRI4
ADDRLP4 28
INDIRI4
EQI4 $976
ADDRGP4 cg+36
INDIRP4
CNSTI4 56
ADDP4
INDIRI4
CNSTI4 16384
BANDI4
ADDRLP4 28
INDIRI4
NEI4 $976
line 1104
;1104:	{
line 1106
;1105:		// back away from character
;1106:		CG_OffsetThirdPersonView();
ADDRGP4 CG_OffsetThirdPersonView
CALLV
pop
line 1107
;1107:	} 
ADDRGP4 $977
JUMPV
LABELV $976
line 1109
;1108:	else 
;1109:	{
line 1111
;1110:		// offset for local bobbing and kicks
;1111:		CG_OffsetFirstPersonView();
ADDRGP4 CG_OffsetFirstPersonView
CALLV
pop
line 1112
;1112:	}
LABELV $977
line 1114
;1113:
;1114:	CG_UpdateCameraShake ( cg.refdef.vieworg, cg.refdef.viewangles );
ADDRGP4 cg+1200+24
ARGP4
ADDRGP4 cg+1200+368
ARGP4
ADDRGP4 CG_UpdateCameraShake
CALLV
pop
line 1117
;1115:
;1116:	// position eye reletive to origin
;1117:	AnglesToAxis( cg.refdef.viewangles, cg.refdef.viewaxis );
ADDRGP4 cg+1200+368
ARGP4
ADDRGP4 cg+1200+36
ARGP4
ADDRGP4 AnglesToAxis
CALLV
pop
line 1119
;1118:
;1119:	if ( cg.hyperspace ) {
ADDRGP4 cg+96
INDIRI4
CNSTI4 0
EQI4 $988
line 1120
;1120:		cg.refdef.rdflags |= RDF_NOWORLDMODEL | RDF_HYPERSPACE;
ADDRLP4 32
ADDRGP4 cg+1200+76
ASGNP4
ADDRLP4 32
INDIRP4
ADDRLP4 32
INDIRP4
INDIRI4
CNSTI4 5
BORI4
ASGNI4
line 1121
;1121:	}
LABELV $988
line 1124
;1122:
;1123:	// field of view
;1124:	return CG_CalcFov();
ADDRLP4 32
ADDRGP4 CG_CalcFov
CALLI4
ASGNI4
ADDRLP4 32
INDIRI4
RETI4
LABELV $912
endproc CG_CalcViewValues 40 12
export CG_AddBufferedSound
proc CG_AddBufferedSound 4 0
line 1132
;1125:}
;1126:
;1127:/*
;1128:=====================
;1129:CG_AddBufferedSound
;1130:=====================
;1131:*/
;1132:void CG_AddBufferedSound( sfxHandle_t sfx ) {
line 1133
;1133:	if ( !sfx )
ADDRFP4 0
INDIRI4
CNSTI4 0
NEI4 $994
line 1134
;1134:		return;
ADDRGP4 $993
JUMPV
LABELV $994
line 1135
;1135:	cg.soundBuffer[cg.soundBufferIn] = sfx;
ADDRGP4 cg+9672
INDIRI4
CNSTI4 2
LSHI4
ADDRGP4 cg+9684
ADDP4
ADDRFP4 0
INDIRI4
ASGNI4
line 1136
;1136:	cg.soundBufferIn = (cg.soundBufferIn + 1) % MAX_SOUNDBUFFER;
ADDRGP4 cg+9672
ADDRGP4 cg+9672
INDIRI4
CNSTI4 1
ADDI4
CNSTI4 20
MODI4
ASGNI4
line 1137
;1137:	if (cg.soundBufferIn == cg.soundBufferOut) {
ADDRGP4 cg+9672
INDIRI4
ADDRGP4 cg+9676
INDIRI4
NEI4 $1000
line 1138
;1138:		cg.soundBufferOut++;
ADDRLP4 0
ADDRGP4 cg+9676
ASGNP4
ADDRLP4 0
INDIRP4
ADDRLP4 0
INDIRP4
INDIRI4
CNSTI4 1
ADDI4
ASGNI4
line 1139
;1139:	}
LABELV $1000
line 1140
;1140:}
LABELV $993
endproc CG_AddBufferedSound 4 0
proc CG_PlayBufferedSounds 0 8
line 1147
;1141:
;1142:/*
;1143:=====================
;1144:CG_PlayBufferedSounds
;1145:=====================
;1146:*/
;1147:static void CG_PlayBufferedSounds( void ) {
line 1148
;1148:	if ( cg.soundTime < cg.time ) {
ADDRGP4 cg+9680
INDIRI4
ADDRGP4 cg+68
INDIRI4
GEI4 $1006
line 1149
;1149:		if (cg.soundBufferOut != cg.soundBufferIn && cg.soundBuffer[cg.soundBufferOut]) {
ADDRGP4 cg+9676
INDIRI4
ADDRGP4 cg+9672
INDIRI4
EQI4 $1010
ADDRGP4 cg+9676
INDIRI4
CNSTI4 2
LSHI4
ADDRGP4 cg+9684
ADDP4
INDIRI4
CNSTI4 0
EQI4 $1010
line 1150
;1150:			trap_S_StartLocalSound(cg.soundBuffer[cg.soundBufferOut], CHAN_ANNOUNCER);
ADDRGP4 cg+9676
INDIRI4
CNSTI4 2
LSHI4
ADDRGP4 cg+9684
ADDP4
INDIRI4
ARGI4
CNSTI4 7
ARGI4
ADDRGP4 trap_S_StartLocalSound
CALLV
pop
line 1151
;1151:			cg.soundBuffer[cg.soundBufferOut] = 0;
ADDRGP4 cg+9676
INDIRI4
CNSTI4 2
LSHI4
ADDRGP4 cg+9684
ADDP4
CNSTI4 0
ASGNI4
line 1152
;1152:			cg.soundBufferOut = (cg.soundBufferOut + 1) % MAX_SOUNDBUFFER;
ADDRGP4 cg+9676
ADDRGP4 cg+9676
INDIRI4
CNSTI4 1
ADDI4
CNSTI4 20
MODI4
ASGNI4
line 1153
;1153:			cg.soundTime = cg.time + 750;
ADDRGP4 cg+9680
ADDRGP4 cg+68
INDIRI4
CNSTI4 750
ADDI4
ASGNI4
line 1154
;1154:		}
LABELV $1010
line 1155
;1155:	}
LABELV $1006
line 1156
;1156:}
LABELV $1005
endproc CG_PlayBufferedSounds 0 8
export CG_UpdateRogerWilco
proc CG_UpdateRogerWilco 4 8
line 1168
;1157:
;1158://=========================================================================
;1159:
;1160:/*
;1161:=================
;1162:CG_UpdateRogerWilco
;1163:
;1164:Updates the roger wilco team you are on
;1165:=================
;1166:*/
;1167:void CG_UpdateRogerWilco ( void )
;1168:{
line 1169
;1169:	qboolean dead = qfalse;
ADDRLP4 0
CNSTI4 0
ASGNI4
line 1171
;1170:
;1171:	if ( !rw_enabled.integer )
ADDRGP4 rw_enabled+12
INDIRI4
CNSTI4 0
NEI4 $1025
line 1172
;1172:	{
line 1173
;1173:		return;
ADDRGP4 $1024
JUMPV
LABELV $1025
line 1176
;1174:	}
;1175:
;1176:	if ( cgs.clientinfo[cg.clientNum].team != TEAM_SPECTATOR )
CNSTI4 3120
ADDRGP4 cg+4
INDIRI4
MULI4
ADDRGP4 cgs+41808+72
ADDP4
INDIRI4
CNSTI4 3
EQI4 $1028
line 1177
;1177:	{
line 1178
;1178:		if ( cgs.gametypeData->respawnType == RT_NONE )
ADDRGP4 cgs+33020
INDIRP4
CNSTI4 20
ADDP4
INDIRI4
CNSTI4 3
NEI4 $1033
line 1179
;1179:		{
line 1180
;1180:			if ( cg.predictedPlayerState.pm_flags & (PMF_GHOST|PMF_FOLLOW) || cg.predictedPlayerState.pm_type == PM_DEAD )
ADDRGP4 cg+100+12
INDIRI4
CNSTI4 2560
BANDI4
CNSTI4 0
NEI4 $1042
ADDRGP4 cg+100+4
INDIRI4
CNSTI4 3
NEI4 $1036
LABELV $1042
line 1181
;1181:			{
line 1182
;1182:				dead = qtrue;
ADDRLP4 0
CNSTI4 1
ASGNI4
line 1183
;1183:			}
LABELV $1036
line 1184
;1184:		}		
LABELV $1033
line 1185
;1185:	}
LABELV $1028
line 1187
;1186:
;1187:	trap_RW_SetTeam(cgs.clientinfo[cg.clientNum].team, dead);
CNSTI4 3120
ADDRGP4 cg+4
INDIRI4
MULI4
ADDRGP4 cgs+41808+72
ADDP4
INDIRI4
ARGI4
ADDRLP4 0
INDIRI4
ARGI4
ADDRGP4 trap_RW_SetTeam
CALLV
pop
line 1188
;1188:}
LABELV $1024
endproc CG_UpdateRogerWilco 4 8
export CG_DrawActiveFrame
proc CG_DrawActiveFrame 16 16
line 1197
;1189:
;1190:/*
;1191:=================
;1192:CG_DrawActiveFrame
;1193:
;1194:Generates and draws a game scene and status information at the given time.
;1195:=================
;1196:*/
;1197:void CG_DrawActiveFrame( int serverTime, stereoFrame_t stereoView, qboolean demoPlayback ) {
line 1200
;1198:	int		inwater;
;1199:
;1200:	cg.time = serverTime;
ADDRGP4 cg+68
ADDRFP4 0
INDIRI4
ASGNI4
line 1201
;1201:	cg.demoPlayback = demoPlayback;
ADDRGP4 cg+8
ADDRFP4 8
INDIRI4
ASGNI4
line 1204
;1202:
;1203:	// update cvars
;1204:	CG_UpdateCvars();
ADDRGP4 CG_UpdateCvars
CALLV
pop
line 1208
;1205:
;1206:	// if we are only updating the screen as a loading
;1207:	// pacifier, don't even try to read snapshots
;1208:	if ( cg.infoScreenText[0] != 0 ) {
ADDRGP4 cg+1588
INDIRI1
CVII4 1
CNSTI4 0
EQI4 $1049
line 1209
;1209:		CG_DrawInformation();
ADDRGP4 CG_DrawInformation
CALLV
pop
line 1210
;1210:		return;
ADDRGP4 $1046
JUMPV
LABELV $1049
line 1213
;1211:	}
;1212:
;1213:	trap_FX_AdjustTime( cg.time );
ADDRGP4 cg+68
INDIRI4
ARGI4
ADDRGP4 trap_FX_AdjustTime
CALLV
pop
line 1215
;1214:
;1215:	CG_UpdateRogerWilco ( );
ADDRGP4 CG_UpdateRogerWilco
CALLV
pop
line 1217
;1216:
;1217:	CG_RunLightStyles();
ADDRGP4 CG_RunLightStyles
CALLV
pop
line 1221
;1218:
;1219:	// any looped sounds will be respecified as entities
;1220:	// are added to the render list
;1221:	trap_S_ClearLoopingSounds(qfalse);
CNSTI4 0
ARGI4
ADDRGP4 trap_S_ClearLoopingSounds
CALLV
pop
line 1224
;1222:
;1223:	// clear all the render lists
;1224:	trap_R_ClearScene();
ADDRGP4 trap_R_ClearScene
CALLV
pop
line 1227
;1225:
;1226:	// set up cg.snap and possibly cg.nextSnap
;1227:	CG_ProcessSnapshots();
ADDRGP4 CG_ProcessSnapshots
CALLV
pop
line 1231
;1228:
;1229:	// if we haven't received any snapshots yet, all
;1230:	// we can draw is the information screen
;1231:	if ( !cg.snap || ( cg.snap->snapFlags & SNAPFLAG_NOT_ACTIVE ) ) {
ADDRGP4 cg+36
INDIRP4
CVPU4 4
CNSTU4 0
EQU4 $1057
ADDRGP4 cg+36
INDIRP4
INDIRI4
CNSTI4 2
BANDI4
CNSTI4 0
EQI4 $1053
LABELV $1057
line 1232
;1232:		CG_DrawInformation();
ADDRGP4 CG_DrawInformation
CALLV
pop
line 1233
;1233:		return;
ADDRGP4 $1046
JUMPV
LABELV $1053
line 1237
;1234:	}
;1235:
;1236:	// Handle last weapon selection
;1237:	if ( cg.weaponSelect != cg.weaponOldSelect )
ADDRGP4 cg+1084
INDIRI4
ADDRGP4 cg+1092
INDIRI4
EQI4 $1058
line 1238
;1238:	{
line 1239
;1239:		cg.weaponLastSelect = cg.weaponOldSelect;
ADDRGP4 cg+1088
ADDRGP4 cg+1092
INDIRI4
ASGNI4
line 1240
;1240:		cg.weaponOldSelect = cg.weaponSelect;
ADDRGP4 cg+1092
ADDRGP4 cg+1084
INDIRI4
ASGNI4
line 1241
;1241:	}
LABELV $1058
line 1244
;1242:
;1243:	// let the client system know what our weapon and zoom settings are
;1244:	if ( cg.weaponMenuUp )
ADDRGP4 cg+1100
INDIRI4
CNSTI4 0
EQI4 $1066
line 1245
;1245:	{
line 1246
;1246:		trap_SetUserCmdValue( (cg.weaponMenuSelect | WP_DELAYED_CHANGE_BIT), cg.zoomSensitivity );
ADDRGP4 cg+1096
INDIRI4
CNSTI4 32
BORI4
ARGI4
ADDRGP4 cg+1584
INDIRF4
ARGF4
ADDRGP4 trap_SetUserCmdValue
CALLV
pop
line 1247
;1247:	}
ADDRGP4 $1067
JUMPV
LABELV $1066
line 1249
;1248:	else
;1249:	{
line 1250
;1250:		trap_SetUserCmdValue( cg.weaponSelect, cg.zoomSensitivity );
ADDRGP4 cg+1084
INDIRI4
ARGI4
ADDRGP4 cg+1584
INDIRF4
ARGF4
ADDRGP4 trap_SetUserCmdValue
CALLV
pop
line 1251
;1251:	}
LABELV $1067
line 1254
;1252:
;1253:	// this counter will be bumped for every valid scene we generate
;1254:	cg.clientFrame++;
ADDRLP4 4
ADDRGP4 cg
ASGNP4
ADDRLP4 4
INDIRP4
ADDRLP4 4
INDIRP4
INDIRI4
CNSTI4 1
ADDI4
ASGNI4
line 1257
;1255:
;1256:	// update cg.predictedPlayerState
;1257:	CG_PredictPlayerState();
ADDRGP4 CG_PredictPlayerState
CALLV
pop
line 1260
;1258:
;1259:	// update the scores from the playerstate
;1260:	if ( cgs.scores1 != cg.predictedPlayerState.persistant[PERS_RED_SCORE] )
ADDRGP4 cgs+35268
INDIRI4
ADDRGP4 cg+100+284+24
INDIRI4
EQI4 $1073
line 1261
;1261:	{		
line 1262
;1262:		cgs.scores1 = cg.predictedPlayerState.persistant[PERS_RED_SCORE];
ADDRGP4 cgs+35268
ADDRGP4 cg+100+284+24
INDIRI4
ASGNI4
line 1263
;1263:		trap_Cvar_Set ( "ui_info_redscore", va("%d", cgs.scores1 ) );
ADDRGP4 $1084
ARGP4
ADDRGP4 cgs+35268
INDIRI4
ARGI4
ADDRLP4 8
ADDRGP4 va
CALLP4
ASGNP4
ADDRGP4 $1083
ARGP4
ADDRLP4 8
INDIRP4
ARGP4
ADDRGP4 trap_Cvar_Set
CALLV
pop
line 1264
;1264:	}
LABELV $1073
line 1266
;1265:
;1266:	if ( cgs.scores2 != cg.predictedPlayerState.persistant[PERS_BLUE_SCORE] )
ADDRGP4 cgs+35272
INDIRI4
ADDRGP4 cg+100+284+28
INDIRI4
EQI4 $1086
line 1267
;1267:	{
line 1268
;1268:		cgs.scores2 = cg.predictedPlayerState.persistant[PERS_BLUE_SCORE];
ADDRGP4 cgs+35272
ADDRGP4 cg+100+284+28
INDIRI4
ASGNI4
line 1269
;1269:		trap_Cvar_Set ( "ui_info_bluescore", va("%d", cgs.scores2 ) );
ADDRGP4 $1084
ARGP4
ADDRGP4 cgs+35272
INDIRI4
ARGI4
ADDRLP4 8
ADDRGP4 va
CALLP4
ASGNP4
ADDRGP4 $1096
ARGP4
ADDRLP4 8
INDIRP4
ARGP4
ADDRGP4 trap_Cvar_Set
CALLV
pop
line 1270
;1270:	}
LABELV $1086
line 1273
;1271:
;1272:	// decide on third person view
;1273:	if ( cg.snap->ps.persistant[PERS_TEAM] == TEAM_SPECTATOR || (cg.snap->ps.pm_flags & PMF_GHOST))
ADDRGP4 cg+36
INDIRP4
CNSTI4 336
ADDP4
INDIRI4
CNSTI4 3
EQI4 $1102
ADDRGP4 cg+36
INDIRP4
CNSTI4 56
ADDP4
INDIRI4
CNSTI4 2048
BANDI4
CNSTI4 0
EQI4 $1098
LABELV $1102
line 1274
;1274:	{
line 1275
;1275:		cg.renderingThirdPerson = qfalse;
ADDRGP4 cg+92
CNSTI4 0
ASGNI4
line 1276
;1276:	}
ADDRGP4 $1099
JUMPV
LABELV $1098
line 1277
;1277:	else if ( cg.snap->ps.pm_type == PM_DEAD )
ADDRGP4 cg+36
INDIRP4
CNSTI4 48
ADDP4
INDIRI4
CNSTI4 3
NEI4 $1104
line 1278
;1278:	{
line 1279
;1279:		cg.renderingThirdPerson = cg_thirdPerson.integer;
ADDRGP4 cg+92
ADDRGP4 cg_thirdPerson+12
INDIRI4
ASGNI4
line 1280
;1280:	}
ADDRGP4 $1105
JUMPV
LABELV $1104
line 1282
;1281:	else
;1282:	{
line 1283
;1283:		if ( cg.snap->ps.pm_flags & PMF_ZOOMED )
ADDRGP4 cg+36
INDIRP4
CNSTI4 56
ADDP4
INDIRI4
CNSTI4 16384
BANDI4
CNSTI4 0
EQI4 $1109
line 1284
;1284:		{
line 1285
;1285:			cg.renderingThirdPerson = qfalse;
ADDRGP4 cg+92
CNSTI4 0
ASGNI4
line 1286
;1286:		}
ADDRGP4 $1110
JUMPV
LABELV $1109
line 1287
;1287:		else if ( cg.snap->ps.pm_flags & PMF_FOLLOW )
ADDRGP4 cg+36
INDIRP4
CNSTI4 56
ADDP4
INDIRI4
CNSTI4 512
BANDI4
CNSTI4 0
EQI4 $1113
line 1288
;1288:		{
line 1289
;1289:			if ( cg.snap->ps.pm_flags & PMF_FOLLOWFIRST )
ADDRGP4 cg+36
INDIRP4
CNSTI4 56
ADDP4
INDIRI4
CNSTI4 16777216
BANDI4
CNSTI4 0
EQI4 $1116
line 1290
;1290:			{
line 1291
;1291:				cg.renderingThirdPerson = qfalse;
ADDRGP4 cg+92
CNSTI4 0
ASGNI4
line 1292
;1292:			}
ADDRGP4 $1114
JUMPV
LABELV $1116
line 1294
;1293:			else
;1294:			{
line 1295
;1295:				cg.renderingThirdPerson = qtrue;
ADDRGP4 cg+92
CNSTI4 1
ASGNI4
line 1296
;1296:			}
line 1297
;1297:		}
ADDRGP4 $1114
JUMPV
LABELV $1113
line 1299
;1298:		else
;1299:		{
line 1300
;1300:			cg.renderingThirdPerson = cg_thirdPerson.integer || (cg.snap->ps.stats[STAT_HEALTH] <= 0);
ADDRLP4 12
CNSTI4 0
ASGNI4
ADDRGP4 cg_thirdPerson+12
INDIRI4
ADDRLP4 12
INDIRI4
NEI4 $1127
ADDRGP4 cg+36
INDIRP4
CNSTI4 264
ADDP4
INDIRI4
ADDRLP4 12
INDIRI4
GTI4 $1125
LABELV $1127
ADDRLP4 8
CNSTI4 1
ASGNI4
ADDRGP4 $1126
JUMPV
LABELV $1125
ADDRLP4 8
CNSTI4 0
ASGNI4
LABELV $1126
ADDRGP4 cg+92
ADDRLP4 8
INDIRI4
ASGNI4
line 1301
;1301:		}
LABELV $1114
LABELV $1110
line 1302
;1302:	}
LABELV $1105
LABELV $1099
line 1305
;1303:
;1304:	// build cg.refdef
;1305:	inwater = CG_CalcViewValues();
ADDRLP4 8
ADDRGP4 CG_CalcViewValues
CALLI4
ASGNI4
ADDRLP4 0
ADDRLP4 8
INDIRI4
ASGNI4
line 1308
;1306:	
;1307:	// first person blend blobs, done after AnglesToAxis
;1308:	if ( !cg.renderingThirdPerson ) {
ADDRGP4 cg+92
INDIRI4
CNSTI4 0
NEI4 $1128
line 1309
;1309:		CG_DamageBlendBlob();
ADDRGP4 CG_DamageBlendBlob
CALLV
pop
line 1310
;1310:	}
LABELV $1128
line 1313
;1311:
;1312:	// Load deferred models
;1313:	if ( cg.deferredPlayerLoading > 10 ) 
ADDRGP4 cg+16
INDIRI4
CNSTI4 10
LEI4 $1131
line 1314
;1314:	{
line 1315
;1315:		CG_LoadDeferredPlayers();
ADDRGP4 CG_LoadDeferredPlayers
CALLV
pop
line 1316
;1316:		cg.deferredPlayerLoading = 0;
ADDRGP4 cg+16
CNSTI4 0
ASGNI4
line 1317
;1317:	}
LABELV $1131
line 1320
;1318:
;1319:	// build the render lists
;1320:	if ( !cg.hyperspace ) 
ADDRGP4 cg+96
INDIRI4
CNSTI4 0
NEI4 $1135
line 1321
;1321:	{
line 1322
;1322:		CG_AddPacketEntities();			// adter calcViewValues, so predicted player state is correct
ADDRGP4 CG_AddPacketEntities
CALLV
pop
line 1323
;1323:		CG_AddLocalEntities();
ADDRGP4 CG_AddLocalEntities
CALLV
pop
line 1324
;1324:		CG_DrawMiscEnts();
ADDRGP4 CG_DrawMiscEnts
CALLV
pop
line 1325
;1325:	}
LABELV $1135
line 1327
;1326:
;1327:	if ( cg.snap->ps.stats[STAT_HEALTH] > 0 )
ADDRGP4 cg+36
INDIRP4
CNSTI4 264
ADDP4
INDIRI4
CNSTI4 0
LEI4 $1138
line 1328
;1328:	{
line 1329
;1329:		CG_AnimateViewWeapon(&cg.predictedPlayerState);
ADDRGP4 cg+100
ARGP4
ADDRGP4 CG_AnimateViewWeapon
CALLV
pop
line 1330
;1330:		CG_AddViewWeapon( &cg.predictedPlayerState );
ADDRGP4 cg+100
ARGP4
ADDRGP4 CG_AddViewWeapon
CALLV
pop
line 1331
;1331:	}
LABELV $1138
line 1333
;1332:
;1333:	if ( !cg.hyperspace ) 
ADDRGP4 cg+96
INDIRI4
CNSTI4 0
NEI4 $1143
line 1334
;1334:	{
line 1335
;1335:		trap_FX_AddScheduledEffects();
ADDRGP4 trap_FX_AddScheduledEffects
CALLV
pop
line 1336
;1336:	}
LABELV $1143
line 1339
;1337:
;1338:	// add buffered sounds
;1339:	CG_PlayBufferedSounds();
ADDRGP4 CG_PlayBufferedSounds
CALLV
pop
line 1342
;1340:
;1341:	// play buffered voice chats
;1342:	CG_PlayBufferedVoiceChats();
ADDRGP4 CG_PlayBufferedVoiceChats
CALLV
pop
line 1345
;1343:
;1344:	// finish up the rest of the refdef
;1345:	if ( cg.testModelEntity.hModel ) {
ADDRGP4 cg+9840+8
INDIRI4
CNSTI4 0
EQI4 $1146
line 1346
;1346:		CG_AddTestModel();
ADDRGP4 CG_AddTestModel
CALLV
pop
line 1347
;1347:	}
LABELV $1146
line 1348
;1348:	cg.refdef.time = cg.time;
ADDRGP4 cg+1200+72
ADDRGP4 cg+68
INDIRI4
ASGNI4
line 1349
;1349:	memcpy( cg.refdef.areamask, cg.snap->areamask, sizeof( cg.refdef.areamask ) );
ADDRGP4 cg+1200+80
ARGP4
ADDRGP4 cg+36
INDIRP4
CNSTI4 12
ADDP4
ARGP4
CNSTI4 32
ARGI4
ADDRGP4 memcpy
CALLP4
pop
line 1352
;1350:
;1351:	// update audio positions
;1352:	if ( !cg.mMapChange )
ADDRGP4 cg+52
INDIRI4
CNSTI4 0
NEI4 $1158
line 1353
;1353:	{
line 1354
;1354:		trap_AS_UpdateAmbientSet( CG_ConfigString( CS_AMBIENT_SOUNDSETS ), cg.refdef.vieworg );	// MUST be before trap_S_Respatialize()!	-ste
CNSTI4 1083
ARGI4
ADDRLP4 12
ADDRGP4 CG_ConfigString
CALLP4
ASGNP4
ADDRLP4 12
INDIRP4
ARGP4
ADDRGP4 cg+1200+24
ARGP4
ADDRGP4 trap_AS_UpdateAmbientSet
CALLV
pop
line 1355
;1355:		trap_S_Respatialize( cg.snap->ps.clientNum, cg.refdef.vieworg, cg.refdef.viewaxis, inwater );
ADDRGP4 cg+36
INDIRP4
CNSTI4 212
ADDP4
INDIRI4
ARGI4
ADDRGP4 cg+1200+24
ARGP4
ADDRGP4 cg+1200+36
ARGP4
ADDRLP4 0
INDIRI4
ARGI4
ADDRGP4 trap_S_Respatialize
CALLV
pop
line 1356
;1356:	}
LABELV $1158
line 1359
;1357:
;1358:	// make sure the lagometerSample and frame timing isn't done twice when in stereo
;1359:	if ( stereoView != STEREO_RIGHT ) {
ADDRFP4 4
INDIRI4
CNSTI4 2
EQI4 $1168
line 1360
;1360:		cg.frametime = cg.time - cg.oldTime;
ADDRGP4 cg+64
ADDRGP4 cg+68
INDIRI4
ADDRGP4 cg+72
INDIRI4
SUBI4
ASGNI4
line 1361
;1361:		if ( cg.frametime < 0 ) {
ADDRGP4 cg+64
INDIRI4
CNSTI4 0
GEI4 $1173
line 1362
;1362:			cg.frametime = 0;
ADDRGP4 cg+64
CNSTI4 0
ASGNI4
line 1363
;1363:		}
LABELV $1173
line 1364
;1364:		cg.oldTime = cg.time;
ADDRGP4 cg+72
ADDRGP4 cg+68
INDIRI4
ASGNI4
line 1365
;1365:		CG_AddLagometerFrameInfo();
ADDRGP4 CG_AddLagometerFrameInfo
CALLV
pop
line 1366
;1366:	}
LABELV $1168
line 1369
;1367:
;1368:	// actually issue the rendering calls
;1369:	CG_DrawActive( stereoView );
ADDRFP4 4
INDIRI4
ARGI4
ADDRGP4 CG_DrawActive
CALLV
pop
line 1371
;1370:
;1371:	if ( cg_stats.integer ) 
ADDRGP4 cg_stats+12
INDIRI4
CNSTI4 0
EQI4 $1179
line 1372
;1372:	{
line 1373
;1373:		Com_Printf( "cg.clientFrame:%i\n", cg.clientFrame );
ADDRGP4 $1182
ARGP4
ADDRGP4 cg
INDIRI4
ARGI4
ADDRGP4 Com_Printf
CALLV
pop
line 1374
;1374:	}
LABELV $1179
line 1375
;1375:}
LABELV $1046
endproc CG_DrawActiveFrame 16 16
export CG_CameraShake
proc CG_CameraShake 32 4
line 1388
;1376:
;1377:/*
;1378:=================
;1379:CG_CameraShake
;1380:
;1381:Shakes the camera a bit (used in grenades)
;1382:=================
;1383:*/
;1384:#define MAX_SHAKE_INTENSITY			2.0f
;1385:#define DEFAULT_EXPLOSION_RADIUS	400
;1386:
;1387:void CG_CameraShake ( float* origin, float intensity, int radius, int time )
;1388:{
line 1393
;1389:	vec3_t	dir;
;1390:	float	dist, intensityScale;
;1391:	float	realIntensity;
;1392:
;1393:	VectorSubtract( cg.refdef.vieworg, origin, dir );
ADDRLP4 24
ADDRFP4 0
INDIRP4
ASGNP4
ADDRLP4 0
ADDRGP4 cg+1200+24
INDIRF4
ADDRLP4 24
INDIRP4
INDIRF4
SUBF4
ASGNF4
ADDRLP4 0+4
ADDRGP4 cg+1200+24+4
INDIRF4
ADDRLP4 24
INDIRP4
CNSTI4 4
ADDP4
INDIRF4
SUBF4
ASGNF4
ADDRLP4 0+8
ADDRGP4 cg+1200+24+8
INDIRF4
ADDRFP4 0
INDIRP4
CNSTI4 8
ADDP4
INDIRF4
SUBF4
ASGNF4
line 1394
;1394:	dist = VectorNormalize( dir );
ADDRLP4 0
ARGP4
ADDRLP4 28
ADDRGP4 VectorNormalize
CALLF4
ASGNF4
ADDRLP4 16
ADDRLP4 28
INDIRF4
ASGNF4
line 1398
;1395:
;1396:	// Apparently the SoF2 camera shake function takes a time, but not a radius.
;1397:	//	when someone feels like fixing this, we can be a bit more flexible
;1398:	radius = DEFAULT_EXPLOSION_RADIUS;
ADDRFP4 8
CNSTI4 400
ASGNI4
line 1401
;1399:
;1400:	//Use the dir to add kick to the explosion
;1401:	if ( dist > radius )
ADDRLP4 16
INDIRF4
ADDRFP4 8
INDIRI4
CVIF4 4
LEF4 $1194
line 1402
;1402:		return;
ADDRGP4 $1183
JUMPV
LABELV $1194
line 1404
;1403:
;1404:	intensityScale = 1 - ( dist / (float) radius );
ADDRLP4 20
CNSTF4 1065353216
ADDRLP4 16
INDIRF4
ADDRFP4 8
INDIRI4
CVIF4 4
DIVF4
SUBF4
ASGNF4
line 1405
;1405:	realIntensity = intensity * intensityScale;
ADDRLP4 12
ADDRFP4 4
INDIRF4
ADDRLP4 20
INDIRF4
MULF4
ASGNF4
line 1407
;1406:
;1407:	if ( realIntensity > MAX_SHAKE_INTENSITY )
ADDRLP4 12
INDIRF4
CNSTF4 1073741824
LEF4 $1196
line 1408
;1408:		realIntensity = MAX_SHAKE_INTENSITY;
ADDRLP4 12
CNSTF4 1073741824
ASGNF4
LABELV $1196
line 1410
;1409:
;1410:	cg.shakeIntensity = realIntensity;
ADDRGP4 cg+178888
ADDRLP4 12
INDIRF4
ASGNF4
line 1411
;1411:	cg.shakeDuration = time;
ADDRGP4 cg+178892
ADDRFP4 12
INDIRI4
ASGNI4
line 1412
;1412:	cg.shakeStart = cg.time;
ADDRGP4 cg+178896
ADDRGP4 cg+68
INDIRI4
ASGNI4
line 1413
;1413:}
LABELV $1183
endproc CG_CameraShake 32 4
export CG_UpdateCameraShake
proc CG_UpdateCameraShake 48 8
line 1423
;1414:
;1415:/*
;1416:=================
;1417:CG_UpdateCameraShake
;1418:
;1419:Updates the camera shake
;1420:=================
;1421:*/
;1422:void CG_UpdateCameraShake ( vec3_t origin, vec3_t angles )
;1423:{
line 1429
;1424:	vec3_t	moveDir;
;1425:	float	intensity_scale;
;1426:	float	intensity;
;1427:	int		i;
;1428:
;1429:	if ( cg.shakeDuration <= 0 )
ADDRGP4 cg+178892
INDIRI4
CNSTI4 0
GTI4 $1203
line 1430
;1430:		return;
ADDRGP4 $1202
JUMPV
LABELV $1203
line 1432
;1431:
;1432:	if ( cg.time > ( cg.shakeStart + cg.shakeDuration ) )
ADDRGP4 cg+68
INDIRI4
ADDRGP4 cg+178896
INDIRI4
ADDRGP4 cg+178892
INDIRI4
ADDI4
LEI4 $1206
line 1433
;1433:	{
line 1434
;1434:		cg.shakeIntensity = 0;
ADDRGP4 cg+178888
CNSTF4 0
ASGNF4
line 1435
;1435:		cg.shakeDuration = 0;
ADDRGP4 cg+178892
CNSTI4 0
ASGNI4
line 1436
;1436:		cg.shakeStart = 0;
ADDRGP4 cg+178896
CNSTI4 0
ASGNI4
line 1437
;1437:		return;
ADDRGP4 $1202
JUMPV
LABELV $1206
line 1441
;1438:	}
;1439:
;1440:	//intensity_scale now also takes into account FOV with 90.0 as normal
;1441:	intensity_scale = 1.0f - ( (float) ( cg.time - cg.shakeStart ) / (float) cg.shakeDuration ) * (((cg.refdef.fov_x+cg.refdef.fov_y)/2.0f)/90.0f);
ADDRLP4 20
CNSTF4 1065353216
ADDRGP4 cg+68
INDIRI4
ADDRGP4 cg+178896
INDIRI4
SUBI4
CVIF4 4
ADDRGP4 cg+178892
INDIRI4
CVIF4 4
DIVF4
ADDRGP4 cg+1200+16
INDIRF4
ADDRGP4 cg+1200+20
INDIRF4
ADDF4
CNSTF4 1073741824
DIVF4
CNSTF4 1119092736
DIVF4
MULF4
SUBF4
ASGNF4
line 1442
;1442:	intensity = cg.shakeIntensity * intensity_scale;
ADDRLP4 4
ADDRGP4 cg+178888
INDIRF4
ADDRLP4 20
INDIRF4
MULF4
ASGNF4
line 1444
;1443:
;1444:	for ( i = 0; i < 3; i++ )
ADDRLP4 0
CNSTI4 0
ASGNI4
LABELV $1222
line 1445
;1445:	{
line 1446
;1446:		moveDir[i] = flrand(-intensity, intensity );
ADDRLP4 4
INDIRF4
NEGF4
ARGF4
ADDRLP4 4
INDIRF4
ARGF4
ADDRLP4 28
ADDRGP4 flrand
CALLF4
ASGNF4
ADDRLP4 0
INDIRI4
CNSTI4 2
LSHI4
ADDRLP4 8
ADDP4
ADDRLP4 28
INDIRF4
ASGNF4
line 1447
;1447:	}
LABELV $1223
line 1444
ADDRLP4 0
ADDRLP4 0
INDIRI4
CNSTI4 1
ADDI4
ASGNI4
ADDRLP4 0
INDIRI4
CNSTI4 3
LTI4 $1222
line 1452
;1448:
;1449:	//FIXME: Lerp
;1450:
;1451:	//Move the camera
;1452:	VectorAdd( origin, moveDir, origin );
ADDRLP4 24
ADDRFP4 0
INDIRP4
ASGNP4
ADDRLP4 24
INDIRP4
ADDRLP4 24
INDIRP4
INDIRF4
ADDRLP4 8
INDIRF4
ADDF4
ASGNF4
ADDRLP4 28
ADDRFP4 0
INDIRP4
CNSTI4 4
ADDP4
ASGNP4
ADDRLP4 28
INDIRP4
ADDRLP4 28
INDIRP4
INDIRF4
ADDRLP4 8+4
INDIRF4
ADDF4
ASGNF4
ADDRLP4 32
ADDRFP4 0
INDIRP4
CNSTI4 8
ADDP4
ASGNP4
ADDRLP4 32
INDIRP4
ADDRLP4 32
INDIRP4
INDIRF4
ADDRLP4 8+8
INDIRF4
ADDF4
ASGNF4
line 1454
;1453:
;1454:	for ( i = 0; i < 3; i++ )
ADDRLP4 0
CNSTI4 0
ASGNI4
LABELV $1228
line 1455
;1455:	{
line 1456
;1456:		moveDir[i] = flrand(-intensity, intensity );
ADDRLP4 4
INDIRF4
NEGF4
ARGF4
ADDRLP4 4
INDIRF4
ARGF4
ADDRLP4 40
ADDRGP4 flrand
CALLF4
ASGNF4
ADDRLP4 0
INDIRI4
CNSTI4 2
LSHI4
ADDRLP4 8
ADDP4
ADDRLP4 40
INDIRF4
ASGNF4
line 1457
;1457:	}
LABELV $1229
line 1454
ADDRLP4 0
ADDRLP4 0
INDIRI4
CNSTI4 1
ADDI4
ASGNI4
ADDRLP4 0
INDIRI4
CNSTI4 3
LTI4 $1228
line 1462
;1458:
;1459:	//FIXME: Lerp
;1460:
;1461:	//Move the angles
;1462:	VectorAdd( angles, moveDir, angles );
ADDRLP4 36
ADDRFP4 4
INDIRP4
ASGNP4
ADDRLP4 36
INDIRP4
ADDRLP4 36
INDIRP4
INDIRF4
ADDRLP4 8
INDIRF4
ADDF4
ASGNF4
ADDRLP4 40
ADDRFP4 4
INDIRP4
CNSTI4 4
ADDP4
ASGNP4
ADDRLP4 40
INDIRP4
ADDRLP4 40
INDIRP4
INDIRF4
ADDRLP4 8+4
INDIRF4
ADDF4
ASGNF4
ADDRLP4 44
ADDRFP4 4
INDIRP4
CNSTI4 8
ADDP4
ASGNP4
ADDRLP4 44
INDIRP4
ADDRLP4 44
INDIRP4
INDIRF4
ADDRLP4 8+8
INDIRF4
ADDF4
ASGNF4
line 1463
;1463:}
LABELV $1202
endproc CG_UpdateCameraShake 48 8
bss
export cameraIdealLoc
align 4
LABELV cameraIdealLoc
skip 12
export cameraIdealTarget
align 4
LABELV cameraIdealTarget
skip 12
export cameraFocusLoc
align 4
LABELV cameraFocusLoc
skip 12
export cameraFocusAngles
align 4
LABELV cameraFocusAngles
skip 12
export cameraup
align 4
LABELV cameraup
skip 12
export camerafwd
align 4
LABELV camerafwd
skip 12
import CG_SetLightstyle
import CG_RunLightStyles
import CG_ClearLightStyles
import CG_ParseGametypeFile
import CG_DrawMiscEnts
import CG_MiscEnt
import G2_PositionEntityOnBolt
import CG_PredictedProcGore
import CG_AddProcGore
import CG_SetGhoul2Info
import CG_Init_CGents
import CG_Init_CG
import trap_UI_SetActiveMenu
import trap_UI_CloseAll
import trap_CG_RegisterSharedMemory
import trap_RE_InitRendererTerrain
import trap_CM_RegisterTerrain
import trap_CM_TM_ConvertPosition
import trap_CM_TM_Upload
import trap_CM_TM_AddTarget
import trap_CM_TM_AddSpot
import trap_CM_TM_AddBuilding
import trap_CM_TM_Create
import trap_MAT_GetDebrisScale
import trap_MAT_GetDebris
import trap_MAT_GetEffect
import trap_MAT_GetDecalScale
import trap_MAT_GetDecal
import trap_MAT_GetSound
import trap_MAT_Reset
import trap_MAT_Init
import trap_G2API_SetSkin
import trap_G2API_RegisterSkin
import trap_G2API_GetBoltIndex
import trap_G2API_FindBoltIndex
import trap_G2API_GetNumModels
import trap_G2API_GetGhoul2ModelFlagsByIndex
import trap_G2API_SetGhoul2ModelFlagsByIndex
import trap_G2API_GetGhoul2ModelFlags
import trap_G2API_SetGhoul2ModelFlags
import trap_G2API_ClearSkinGore
import trap_G2API_AddSkinGore
import trap_G2API_SetNewOrigin
import trap_G2API_SetRootSurface
import trap_G2API_SetSurfaceOnOff
import trap_G2API_GetBoneAnim
import trap_G2API_SetBoneAnim
import trap_G2API_GetGLAName
import trap_G2API_SetBoneAngles
import trap_G2API_CleanGhoul2Models
import trap_G2API_RemoveGhoul2Model
import trap_G2API_DuplicateGhoul2Instance
import trap_G2API_CopySpecificGhoul2Model
import trap_G2API_CopyGhoul2Instance
import trap_G2API_GetAnimFileNameIndex
import trap_G2API_InitGhoul2Model
import trap_G2API_GetBoltMatrix
import trap_G2_HaveWeGhoul2Models
import trap_G2_SetGhoul2ModelIndexes
import trap_G2API_DetachG2Model
import trap_G2API_AttachG2Model
import trap_G2API_RemoveBolt
import trap_G2API_SetBoltInfo
import trap_G2API_AddBolt
import trap_G2_ListModelBones
import trap_G2_ListModelSurfaces
import trap_G2API_CollisionDetect
import trap_R_inPVS
import trap_GetEntityToken
import trap_SnapVector
import trap_RMG_Init
import trap_Key_GetKey
import trap_Key_SetCatcher
import trap_Key_GetCatcher
import trap_Key_IsDown
import trap_MemoryRemaining
import trap_FX_AddLine
import trap_FX_Reset
import trap_FX_AdjustTime
import trap_FX_FreeSystem
import trap_FX_Draw2DEffects
import trap_FX_AddScheduledEffects
import trap_FX_PlayBoltedEffectID
import trap_FX_PlayEntityEffectID
import trap_FX_PlayEffectID
import trap_FX_PlaySimpleEffectID
import trap_FX_PlayEntityEffect
import trap_FX_PlayEffect
import trap_FX_PlaySimpleEffect
import trap_FX_RegisterEffect
import trap_FX_InitSystem
import trap_CIN_SetExtents
import trap_CIN_DrawCinematic
import trap_CIN_RunCinematic
import trap_CIN_StopCinematic
import trap_CIN_PlayCinematic
import testPrintFloat
import testPrintInt
import trap_ResetAutorun
import trap_RW_SetTeam
import trap_SetUserCmdValue
import trap_GetUserCmd
import trap_GetCurrentCmdNumber
import trap_GetServerCommand
import trap_GetDefaultState
import trap_GetSnapshot
import trap_GetCurrentSnapshotNumber
import trap_GetGameState
import trap_GetGlconfig
import trap_R_SetLightStyle
import trap_R_GetLightStyle
import trap_R_RemapShader
import trap_R_DrawRotatePic2
import trap_R_DrawRotatePic
import trap_R_LerpTag
import trap_R_ModelBounds
import trap_R_DrawStretchPic
import trap_R_SetColor
import trap_R_DrawVisualOverlay
import trap_R_RenderScene
import trap_R_LightForPoint
import trap_R_AddLightToScene
import trap_R_AddDecalToScene
import trap_R_AddPolysToScene
import trap_R_AddPolyToScene
import trap_R_DrawTextWithCursor
import trap_R_DrawText
import trap_R_GetTextHeight
import trap_R_GetTextWidth
import trap_R_AddRefEntityToScene
import trap_R_ClearDecals
import trap_R_ClearScene
import trap_R_RegisterFont
import trap_R_RegisterShaderNoMip
import trap_R_RegisterShader
import trap_R_RegisterSkin
import trap_R_RegisterModel
import trap_R_LoadWorldMap
import trap_AS_GetBModelSound
import trap_AS_AddLocalSet
import trap_AS_UpdateAmbientSet
import trap_AS_ParseSets
import trap_AS_AddPrecacheEntry
import trap_S_StopBackgroundTrack
import trap_S_StartBackgroundTrack
import trap_S_RegisterSound
import trap_S_Respatialize
import trap_S_UpdateEntityPosition
import trap_S_AddRealLoopingSound
import trap_S_AddLoopingSound
import trap_S_ClearLoopingSounds
import trap_S_StartLocalSound
import trap_S_StopLoopingSound
import trap_S_StartSound
import trap_S_StopAllSounds
import trap_CM_MarkFragments
import trap_CM_TransformedBoxTrace
import trap_CM_BoxTrace
import trap_CM_TransformedPointContents
import trap_CM_PointContents
import trap_CM_TempBoxModel
import trap_CM_InlineModel
import trap_CM_NumInlineModels
import trap_CM_LoadMap
import trap_UpdateScreen
import trap_SendClientCommand
import trap_AddCommand
import trap_SendConsoleCommand
import trap_FS_FCloseFile
import trap_FS_Write
import trap_FS_Read
import trap_FS_FOpenFile
import trap_Args
import trap_Argv
import trap_Argc
import trap_Cvar_VariableStringBuffer
import trap_Cvar_Set
import trap_Cvar_Update
import trap_Cvar_Register
import trap_Milliseconds
import trap_Error
import trap_Print
import CG_ApplyGore
import CG_ParseGore
import CG_ParseAnimationFile
import CG_CheckChangedPredictableEvents
import CG_TransitionPlayerState
import CG_Respawn
import CG_PlayBufferedVoiceChats
import CG_VoiceChatLocal
import CG_ShaderStateChanged
import CG_LoadVoiceChats
import CG_SetConfigValues
import CG_ParseServerinfo
import CG_ExecuteNewServerCommands
import CG_MapRestart
import CG_InitConsoleCommands
import CG_ConsoleCommand
import CG_DrawScoreboard
import CG_DrawInformation
import CG_LoadingClient
import CG_LoadingItem
import CG_LoadingStage
import CG_LoadingString
import CG_ProcessSnapshots
import CG_TestLine
import CG_GlassShatter
import CG_BulletFlyBySound
import CG_BubbleTrail
import CG_AddLocalEntities
import CG_AllocLocalEntity
import CG_FreeLocalEntity
import CG_InitLocalEntities
import CG_WeaponCallback
import CG_OutOfAmmoChange
import CG_DrawWeaponSelect
import CG_PlayerWeaponEffects
import CG_AddViewWeapon
import CG_AnimateViewWeapon
import CG_Bullet
import CG_HandleStickyMissile
import CG_MissileHitPlayer
import CG_MissileHitWall
import CG_ProjectileThink
import CG_FireWeapon
import CG_SetWeaponAnim
import CG_UpdateViewWeaponSurfaces
import CG_RegisterItemVisuals
import CG_ShutDownWeapons
import CG_RegisterWeapon
import CG_WeaponSelectable
import CG_Weapon_f
import CG_PrevWeapon
import CG_NextWeapon
import CG_ScaleModelAxis
import CG_AdjustPositionForMover
import CG_Beam
import CG_AddPacketEntities
import CG_SetEntitySoundPosition
import CG_PainEvent
import CG_EntityEvent
import CG_PlaceString
import CG_CheckEvents
import CG_InitHitModel
import CG_LoadDeferredPlayers
import CG_PredictPlayerState
import CG_PlayerTrace
import CG_Trace
import CG_PointContents
import CG_BuildSolidList
import CG_PlayerShadow
import CG_RemoveIdentityItemsOnBack
import CG_RegisterIdentity
import CG_UpdatePlayerModel
import CG_CustomPlayerSound
import CG_CustomSound
import CG_NewClientInfo
import CG_ResetPlayerEntity
import CG_Player
import CG_DrawMapChange
import CG_GameTypeString
import CG_Text_PaintChar
import CG_Draw3DG2Model
import CG_Draw3DModel
import CG_GetGameStatusText
import CG_GetTeamColor
import CG_RunMenuScript
import CG_OwnerDrawDisabled
import CG_OwnerDrawVisible
import CG_GetValue
import CG_OwnerDraw
import CG_DrawActive
import CG_CenterPrint
import CG_AddLagometerSnapshotInfo
import CG_AddLagometerFrameInfo
import CG_DrawTimer
import CG_DrawTextWithCursor
import CG_DrawText
import CG_GetColorForHealth
import CG_DrawTopBottom
import CG_DrawSides
import CG_DrawRect
import CG_TileClear
import CG_TeamColor
import CG_FadeColor
import CG_DrawStrlen
import CG_DrawRotatePic2
import CG_DrawRotatePic
import CG_DrawStretchPic
import CG_DrawPic
import CG_FillRect
import CG_AdjustFrom640
import CG_TestGun_f
import CG_TeamCount
import CG_EventHandling
import CG_MouseEvent
import CG_KeyEvent
import CG_LoadMenus
import CG_LastAttacker
import CG_CrosshairPlayer
import CG_UpdateTeamCountCvars
import CG_UpdateCvars
import CG_StartMusic
import CG_GetEntity
import CG_Argv
import CG_ConfigString
import cg_temp4
import cg_temp3
import cg_temp2
import cg_temp1
import cg_drawSmile
import cg_crosshairInfo
import cg_drawClock
import cg_drawWeaponType
import cg_drawTeamInfo
import cg_hudOpacity
import cg_hudBackGround
import cg_hudFiles
import cg_defaultHud
import cg_zoomWeaponChange
import rw_enabled
import cg_bodyTime
import cg_weaponMenuFast
import cg_soundFrag
import cg_soundGlobal
import cg_voiceGlobal
import cg_voiceRadio
import ui_info_seenobjectives
import ui_info_pickupsdisabled
import ui_info_freecount
import ui_info_speccount
import ui_info_bluecount
import ui_info_redcount
import cg_automap_a
import cg_automap_h
import cg_automap_w
import cg_automap_y
import cg_automap_x
import cg_animBlend
import cg_tracerChance
import cg_damageindicator
import RMG_distancecull
import cg_lockDeaths
import cg_lockBlood
import cg_lockSever
import cg_DebugGore
import cg_currentSelectedPlayerName
import cg_currentSelectedPlayer
import cg_noProjectileTrail
import cg_noTaunt
import cg_cameraMode
import cg_timescale
import cg_cameraOrbitDelay
import cg_cameraOrbit
import pmove_msec
import pmove_fixed
import cg_smoothClients
import cg_noVoiceText
import cg_teamChatsOnly
import cg_drawFriend
import cg_deferPlayers
import cg_autoReload
import cg_impactPrediction
import cg_antiLag
import cg_predictItems
import cg_paused
import cg_buildScript
import cg_forceModel
import cg_stats
import cg_chatHeight
import cg_chatTime
import cg_synchronousClients
import cg_lagometer
import cg_stereoSeparation
import cg_thirdPersonHorzOffset
import cg_thirdPersonPitch
import cg_thirdPersonYaw
import cg_thirdPersonRange
import cg_thirdPerson
import cg_goreDetail
import cg_shellEjection
import cg_fov
import cg_simpleItems
import cg_ignore
import cg_autoswitch
import cg_drawGun
import cg_gun_z
import cg_gun_y
import cg_gun_x
import cg_footsteps
import cg_showmiss
import cg_nopredict
import cg_errorDecay
import cg_debugEvents
import cg_draw2D
import cg_crosshairFriendRGBA
import cg_crosshairRGBA
import cg_crosshairGrow
import cg_crosshairSize
import cg_crosshairY
import cg_crosshairX
import cg_drawHUDIcons
import cg_drawTeamScores
import cg_drawRadar
import cg_drawCrosshairNames
import cg_drawCrosshair
import cg_drawSnapshot
import cg_drawFPS
import cg_drawTimer
import cg_shadows
import cg_bobroll
import cg_bobpitch
import cg_bobup
import cg_runroll
import cg_runpitch
import cg_centerY
import cg_centertime
import con_notifyTime
import cg_items
import cg_weapons
import cg
import cgs
import cg_numpermanents
import cg_permanents
import cg_entities
import trap_VM_LocalStringAlloc
import trap_VM_LocalTempFree
import trap_VM_LocalTempAlloc
import trap_VM_LocalAllocUnaligned
import trap_VM_LocalAlloc
import trap_FS_GetFileList
import trap_GPV_GetList
import trap_GPV_GetTopValue
import trap_GPV_IsList
import trap_GPV_GetInOrderPrevious
import trap_GPV_GetInOrderNext
import trap_GPV_GetNext
import trap_GPV_GetName
import trap_GPG_FindPairValue
import trap_GPG_FindPair
import trap_GPG_FindSubGroup
import trap_GPG_GetInOrderSubGroups
import trap_GPG_GetSubGroups
import trap_GPG_GetInOrderPairs
import trap_GPG_GetPairs
import trap_GPG_GetInOrderPrevious
import trap_GPG_GetInOrderNext
import trap_GPG_GetNext
import trap_GPG_GetName
import trap_GP_GetBaseParseGroup
import trap_GP_Delete
import trap_GP_Clean
import trap_GP_ParseFile
import trap_GP_Parse
import BG_ApplyLeanOffset
import BG_FindOutfitting
import BG_ParseOutfittingTemplates
import BG_CompressOutfitting
import BG_DecompressOutfitting
import BG_SetAvailableOutfitting
import BG_IsWeaponAvailableForOutfitting
import BG_ParseSkin
import BG_ParseNPCFiles
import BG_GetModelSound
import BG_FindCharacterTemplate
import BG_FindTeamIdentity
import BG_FindIdentity
import bg_animTable
import bg_weaponNames
import bg_outfittingGroups
import bg_outfittingCount
import bg_outfittings
import bg_identityCount
import bg_identities
import bg_itemTemplates
import bg_characterTemplates
import BG_FindGametype
import BG_BuildGametypeList
import bg_gametypeCount
import bg_gametypeData
import BG_GetWeaponNote
import BG_GetWeaponAnim
import BG_PlayerTouchesItem
import BG_CalculateLeanOffset
import BG_ParseAnimationFile
import BG_PlayerAngles
import BG_PlayerStateToEntityStateExtraPolate
import BG_PlayerStateToEntityState
import BG_AddPredictableEventToPlayerstate
import BG_EvaluateTrajectoryDelta
import BG_EvaluateTrajectory
import BG_FindLadder
import BG_AddLadder
import BG_CanItemBeGrabbed
import BG_FindGametypeItemByID
import BG_FindGametypeItem
import BG_FindWeaponItem
import BG_FindClassnameItem
import BG_FindItem
import bg_numItems
import bg_itemlist
import Pmove
import PM_UpdateViewAngles
import pm
import BG_GetMaxAmmo
import BG_CalculateBulletEndpoint
import BG_FindFireMode
import BG_WeaponHasAlternateAmmo
import BG_GetInviewModelAnim
import BG_GetInviewAnimFromIndex
import BG_GetInviewAnim
import BG_ParseInviewFile
import weaponRightHand
import weaponLeftHand
import weaponParseInfo
import ammoData
import ammoNames
import weaponData
import weaponNames
import GetStringForID
import GetIDForString
import KeywordHash_Find
import KeywordHash_Add
import KeywordHash_Key
import Q_irand
import irand
import flrand
import Rand_Init
import Com_Printf
import Com_Error
import Info_NextPair
import Info_Validate
import Info_SetValueForKey_Big
import Info_SetValueForKey
import Info_RemoveKey_big
import Info_RemoveKey
import Info_ValueForKey
import va
import Q_CleanStr
import Q_PrintStrlen
import Q_strcat
import Q_strncpyz
import Q_strrchr
import Q_strupr
import Q_strlwr
import Q_stricmpn
import Q_strncmp
import Q_stricmp
import Q_isalpha
import Q_isupper
import Q_islower
import Q_isprint
import Com_sprintf
import Parse3DMatrix
import Parse2DMatrix
import Parse1DMatrix
import SkipRestOfLine
import SkipBracedSection
import COM_MatchToken
import COM_ParseWarning
import COM_ParseError
import COM_Compress
import COM_ParseExt
import COM_Parse
import SkipWhitespace
import COM_GetCurrentParseLine
import COM_BeginParseSession
import COM_DefaultExtension
import COM_StripExtension
import COM_SkipPath
import Com_Clamp
import Com_Clampf
import NormalToLatLong
import PerpendicularVector
import AngleVectors
import MatrixMultiply
import MakeNormalVectors
import RotateAroundDirection
import RotatePointAroundVector
import ProjectPointOnPlane
import PlaneFromPoints
import AngleDelta
import AngleNormalize180
import AngleNormalize360
import AnglesSubtract
import AngleSubtract
import LerpVector
import LerpAngle
import AngleMod
import fmod
import BoxOnPlaneSide
import SetPlaneSignbits
import AxisCopy
import AxisClear
import AnglesToAxis
import vectoangles
import Q_crandom
import Q_random
import Q_rand
import Q_asin
import Q_acos
import Q_log2
import Q_TestRaySphere
import VectorRotate
import Vector4Scale
import VectorNormalize2
import VectorNormalize
import CrossProduct
import VectorInverse
import VectorNormalizeFast
import DistanceSquared
import Distance
import VectorLengthSquared
import VectorLength
import VectorCompare
import AddPointToBounds
import ClearBounds
import RadiusFromBounds
import NormalizeColor
import ColorBytes4
import ColorBytes3
import _VectorMA
import _VectorScale
import _VectorCopy
import _VectorAdd
import _VectorSubtract
import _DotProduct
import ByteToDir
import DirToByte
import powf
import ClampShort
import ClampChar
import Q_rsqrt
import Q_fabs
import axisDefault
import vec3_identity
import vec3_origin
import g_color_table
import colorDkBlue
import colorLtBlue
import colorDkGrey
import colorMdGrey
import colorLtGrey
import colorWhite
import colorCyan
import colorMagenta
import colorYellow
import colorBlue
import colorGreen
import colorRed
import colorBlack
import colorTable
import bytedirs
import Com_Memcpy
import Com_Memset
import Hunk_Alloc
import FloatSwap
import LongSwap
import ShortSwap
import asin
import acos
import fabs
import abs
import tan
import atan2
import cos
import sin
import sqrt
import floor
import ceil
import memcpy
import memset
import memmove
import sscanf
import vsprintf
import _atoi
import atoi
import _atof
import atof
import toupper
import tolower
import strncpy
import strstr
import strchr
import strcmp
import strcpy
import strcat
import strlen
import rand
import srand
import qsort
lit
align 1
LABELV $1182
char 1 99
char 1 103
char 1 46
char 1 99
char 1 108
char 1 105
char 1 101
char 1 110
char 1 116
char 1 70
char 1 114
char 1 97
char 1 109
char 1 101
char 1 58
char 1 37
char 1 105
char 1 10
char 1 0
align 1
LABELV $1096
char 1 117
char 1 105
char 1 95
char 1 105
char 1 110
char 1 102
char 1 111
char 1 95
char 1 98
char 1 108
char 1 117
char 1 101
char 1 115
char 1 99
char 1 111
char 1 114
char 1 101
char 1 0
align 1
LABELV $1084
char 1 37
char 1 100
char 1 0
align 1
LABELV $1083
char 1 117
char 1 105
char 1 95
char 1 105
char 1 110
char 1 102
char 1 111
char 1 95
char 1 114
char 1 101
char 1 100
char 1 115
char 1 99
char 1 111
char 1 114
char 1 101
char 1 0
align 1
LABELV $166
char 1 115
char 1 107
char 1 105
char 1 110
char 1 32
char 1 37
char 1 105
char 1 10
char 1 0
align 1
LABELV $149
char 1 102
char 1 114
char 1 97
char 1 109
char 1 101
char 1 32
char 1 37
char 1 105
char 1 10
char 1 0
align 1
LABELV $114
char 1 67
char 1 97
char 1 110
char 1 39
char 1 116
char 1 32
char 1 114
char 1 101
char 1 103
char 1 105
char 1 115
char 1 116
char 1 101
char 1 114
char 1 32
char 1 109
char 1 111
char 1 100
char 1 101
char 1 108
char 1 10
char 1 0
